# 一级标题
## 二级标题
### 三级标题
#### 四级标题
##### 五级标题
###### 六级标题  

# 一.字体

**这个是粗体**

*这个是斜体*

***这个是粗体加斜体***

~~这里想用删除线~~

注：如果想给字体换颜色、字体或者居中显示，需要使用内嵌HTML来实现。

# 二
## 分隔线
***

* * *

*****

- - -

----------

## 下划线
<u>带下划线文本</u>

## 脚注
```
链接：[链接名称](链接)
或者：<链接地址>

脚注：[文字](脚注解释 "脚注名字")
```
1.1 链接：有人认为在[大前端时代](https://en.wikipedia.org/wiki/Front-end_web_development "Front-end web development")的背景下，移动端开发（Android、IOS）将逐步退出历史舞台。
1.2 <https://en.wikipedia.org/wiki/Front-end_web_development>

2. 脚注：[全栈工程师](是指掌握多种技能，并能利用多种技能独立完成产品的人。 "什么是全栈工程师")在业务开发流程中起到了至关重要的作用。
或
创建脚注格式类似这样全栈工程师 [^全栈工程师]。

[^全栈工程师]: 菜鸟教程 -- 学的不仅是技术，更是梦想！！！
脚注内容请拉到最下面观看。
## 列表
- 第一项
- 第二项
- 第三项

1. 第一项
2. 第二项
3. 第三项

- 无序列表 1
- 无序列表 2
  - 无序列表 2.1
  - 无序列表 2.2

1. 第一项：
    - 第一项嵌套的第一个元素
    - 第一项嵌套的第二个元素
2. 第二项：
    - 第二项嵌套的第一个元素
    - 第二项嵌套的第二个元素

## 引用
引用的格式是在符号`>`后面书写文字。如下：
> 读一本好书，就是在和高尚的人谈话。 ——歌德

> 读一本好书
> > 就是在和
> > > 高尚的人谈话。 ——歌德

### 区块中使用列表
> 1. 第一项
> 2. 第二项: 
>     - 第一项
> + 第一项
> + 第二项
> + 第三项

### 列表中使用区块
* 第一项
    > 菜鸟教程
    > 学的不仅是技术更是梦想
* 第二项

# 代码
如果在一个行内需要引用代码，只要用反引号引起来就好，如下：
Use the `printf()` function.

在需要高亮的代码块的前一行及后一行使用三个反引号，同时**第一行反引号后面表示代码块所使用的语言**，如下：
```java
// FileName: HelloWorld.java
public class HelloWorld {
  // Java 入口程序，程序从此入口
  public static void main(String[] args) {
    System.out.println("Hello,World!"); // 向控制台打印一条语句
  }
}
```
# 表格
|  表头   | 表头  |
|  ----  | ----  |
| 单元格  | 单元格 |
| 单元格  | 单元格 |

| 左对齐 | 右对齐 | 居中对齐 |
| :-----| ----: | :----: |
| 单元格 | 单元格 | 单元格 |
| 单元格 | 单元格 | 单元格 |

-: 设置内容和标题栏居右对齐。
:- 设置内容和标题栏居左对齐。
:-: 设置内容和标题栏居中对齐

# 高级
使用反斜杠转义特殊字符：
\*\* 正常显示星号 \*
\\   反斜线
\   反斜线
`   反引号
_   下划线
{}  花括号
[]  方括号
()  小括号
、#   井字号
\# 井字号
\+   加号
\-   减号
.   英文句点
!   感叹号

## 数学公式
- 一是行内公式（inline），用一对美元符号“\$”包裹。二是整行公式，用一对紧挨的两个美元符号“ $$ ”包裹。

$(W_1-W_2)x+b_1-b_2=0$

$$(W_1-W_2)x+b_1-b_2=0$$
- 上标和下标分别使用^和_来实现。例如:
$x_i^2$      
$log_2^x$ 
- ​小括号与方括号：使用原始的()和[]即可
- 大括号：由于大括号{}被用来分组，因此需要使用"\\"转义字符\{和\}表示大括号
- \sum用来表示求和符号，其下标表示求和下限，上标表示上线。如$\sum_1^n$
- \int用来表示积分符号，同样地，其上下标表示积分的上下限。如$\int_1^\infty$
- 分式
  - 第一种：使用$\frac ab$。如果分子或分母不是单个字符，需要使用{}来分组。
  - 使用\over来分隔一个组的前后两部分，如${a+1\over b+1}$
- 根式使用$\sqrt[a]b$来表示
- 向下取整 $\lfloor x \rfloor$
 向上取整 $\lceil x \rceil$