# 运行环境配置
---
## 一、下载RISC-V工具链
命令如下：
```
- sudo apt-get update 
- sudo apt-get install git build-essential gdb-multiarch qemu-system-misc gcc-riscv64-linux-gnu binutils-riscv64-linux-gnu libncurses5-dev python2 python2-dev texinfo libreadline-dev make libgmp-dev // 安装所有依赖
- wget https://mirrors.tuna.tsinghua.edu.cn/gnu/gdb/gdb-13.2.tar.xz //下载gdb源码安装
- tar -xvf gdb-13.2.tar.xz && cd gdb-13.2 && mkdir build && cd build // 解压
- ../configure --prefix=/usr/local --target=riscv64-unknown-elf --enable-tui=yes
- sudo make -j$(nproc) && sudo make install // 编译安装
- riscv64-unknown-elf-gdb -v //验证安装
```
## 二、安装qemu
命令如下：
```
- sudo apt-get install qemu
- sudo apt install qemu-system-x86
- qemu-system-i386 //验证安装
```
## 三、下载xv6源代码文件
命令如下：
```
- git clone https://gitee.com/chenlu-guan/xv6-riscv.git
- cd xv6-riscv
- sudo apt install make
- make
- make qemu
```
能进入xv6的shell则表示实验环境已搭建成功，退出时先按Ctrl+a，松手后再按x。

详细参考：<https://github.com/riscv/riscv-gnu-toolchain>


