# 机器启动
---
## 一、内核启动过程概述
xv6启动过程涉及多个关键的源文件，这些文件通过不同的方式设置了启动流程。
- kernel.ld：链接脚本（linker script），它的主要功能是定义内核映像的内存布局和各个段的放置位置，确保在内核启动时各个部分被正确地加载到内存中的指定位置。在使用QEMU模拟器时，确保内核的入口点位于指定的地址（0x80000000）。
- entry.S：内核的入口汇编文件，该文件定义了内核启动时的最初步骤，即设置CPU的栈、进入M-mode（机器模式），然后跳转到start函数。
- start.c：内核启动的核心，负责关闭分页、设置处理器的中断控制以及跳转到main函数。
- main.c：内核执行的起点，进行系统初始化，创建进程、调度等。
- uart.c、printf.c：这些文件涉及串口输出和打印功能，printf用于调试和显示信息。
## 二、从启动到main函数的流程
- 机器启动时，CPU会执行以下几个阶段，逐步进入 main 函数：

![alt text](image-3.png)

- main函数负责进行内核的系统初始化，通常包括：初始化内存管理；初始化进程调度器；启动第一个用户进程等。
- 表示已经进入main函数：

![alt text](image-4.png)
