# 第一个用户进程的诞生
---
## 一、内核启动与隐式进程
在系统启动时，CPU首先执行内核代码（如start()），这个过程在内核栈上进行，但它并不是一个**显式的用户进程**。
这个阶段的代码相当于一个**内核态的隐式进程**。
随后，内核启动并执行main()函数，进行必要的**初始化工作**，如设置中断、虚拟内存、内核堆栈等。
![alt text](image-3.png)
## 二、内核态与用户态的切换
在用户模式与内核模式之间进行**切换**时，内核需要保存进程的状态并恢复。这一过程涉及：
- **保存寄存器状态**：通过将寄存器值保存在trapframe和context中，确保在切换时能够恢复正确的执行状态。
- **切换到用户模式**：在用户进程开始执行时，内核设置适当的状态（如通过sret指令）将CPU切换到用户模式，允许用户进程执行。
- **从用户模式切换回内核模式**：当用户进程发生系统调用或中断时，进程切换回内核模式，系统通过usertrap()等函数来处理。
![alt text](image-4.png)
## 三、中断与系统调用处理
- 用户进程在运行时可能会发生**系统调用**（如fork()、exit()等），这些调用会触发从用户模式切换到内核模式的过程。
- 当系统触发中断（如时钟中断、外部设备中断等）时，内核会通过trap()函数来处理中断，并根据需要决定是否切换回用户模式。
- 内核处理完毕后，系统通过恢复trapframe并调用usertrapret()跳回用户模式，继续执行用户进程。
## 四、第一个用户进程的执行
第一个用户进程在完成初始化后，会通过设置好的trapframe开始执行。
进程进入用户模式后，如果发生中断或系统调用，它会切换回内核模式进行处理，然后返回继续执行用户程序。

