# 从单进程到多进程

proc.c与sleeplock.c共同解决了在内核中从单进程到多进程管理的关键问题：**进程的创建、调度、资源管理**以及**同步机制**。
这些功能使得操作系统能够有效地管理多个进程，并在多核处理器或多任务环境下实现并**发执行**。
其中，exit（）和wait（）机制确保进程的资源能够得到有效管理和回收，而sleeplock提供了高效的同步机制，避免了CPU的浪费和进程间的冲突。
这些功能协同工作，使得操作系统能够有效地处理多个进程的执行、资源共享和同步问题，最终实现了一个**多进程操作系统**的设计。

---
## 一、进程生命周期
进程生命周期是指一个进程从创建到终止的整个过程。
- 每个进程在操作系统中都有一系列的状态，这些状态随着时间的推移不断变化，形成了一个生命周期。
- 一般来说，进程生命周期可以分为几个主要的阶段，每个阶段会经历不同的状态。

当进程获取某种资源但是失败时的三种做法：
- 循环检查，直到获取这种资源
- 循环检测，失败则让出CPU进入RUNNABLE
- 进入睡眠状态，标记自己在等待哪种资源

![alt text](image-7.png)

## 二、睡眠锁（sleeplock）的设计
睡眠锁是内核中对共享资源进行同步管理的重要工具。
它使得进程能够在等待资源时有效地进入睡眠，避免无意义的CPU消耗。
这对于内核中的多进程管理至关重要，尤其在处理共享资源（如文件系统、内存分配等）时，能够避免**死锁**和**资源竞争**。

![alt text](image-8.png)
 
## 三、从单进程到多进程的过渡：进程管理和调度
下图中的函数共同实现了进程的生命周期管理（**创建、执行、退出、回收**）。
内核能够通过**调度器**动态选择运行进程、回收已结束进程的资源、并允许进程之间的切换和同步。
这是从单进程到多进程管理的关键转变，使得内核能够处理多个并发进程。
 
![alt text](image-9.png)

