# 文件系统的上层接口
---
## 一、文件类型
文件是文件系统为上层系统调用接口和内核其他模块提供的统一抽象。
除了普通文件和目录文件这两类常见文件，还存在设备文件、管道文件这两类特殊文件。
- 普通文件：基于inode，可以在磁盘里持久保持。是最常见的文件类型，用来存储数据或信息。
在文件系统中，普通文件可以包含文本、二进制数据、图像、音频、视频等内容。普通文件不关心其内容类型，它仅仅是存储数据的一个容器。
- 目录文件：基于inode，可以在磁盘里持久保持。可用于组织和管理其他文件的特殊文件，本质上是一个包含其他文件和子目录的文件。
目录文件中存储着文件名与文件索引节点（inode）之间的映射关系。
- 设备文件：基于inode，可以在磁盘里持久保持。是操作系统用来与硬件设备进行交互的特殊文件。
- 管道文件：基于pipe。是一种特殊的文件类型，通常用于进程间通信（IPC，Inter-Process Communication）。

![alt text](image-13.png)

## 二、进程中的文件管理
进程的文件管理通过**文件描述符（file descriptors）**实现，每个进程维护一个文件描述符表，表中的每个条目指向一个file结构体，该结构体包含文件的inode、文件操作的读写指针以及操作函数。
文件的打开通过filealloc()分配一个空闲的文件结构，并通过filedup()增加引用计数。
进程可以通过系统调用如open(), read(), write(), 和close()来操作文件。每当进程打开文件时，文件描述符表会记录该文件的信息，而关闭文件时，引用计数会减少，最终当计数为零时，文件结构会被释放。
在进程执行期间，文件的元数据（如inode）由文件系统管理，文件内容的读取和写入则由readi()和writei()实现。

![alt text](image-14.png) 

![alt text](image-15.png)

## 三、文件系统中系统调用的实现
文件系统相关的系统调用有很多，所以系统调用层并不执行具体的处理逻辑，只负责三件事情：**读取用户参数**、**检查参数**、**调用底层处理函数**。
 
![alt text](image-16.png)
