#include "types.h"
#include "stat.h"
#include "user.h"

#define N 5 // Number of processes to test priority scheduling

void spin(int ticks) {
    uint start = uptime();
    while (uptime() - start < ticks);
}

int main(void) {
    printf("MLFQ Test: Creating %d processes\n", N);
    for (int i = 0; i < N; i++) {
        int pid = fork();
        if (pid < 0) {
            printf("fork failed\n");
            exit(1);
        }
        if (pid == 0) {
            printf("Child %d started\n", i);
            for (int j = 0; j < 5; j++) {
                printf("Child %d: Tick %d\n", i, j);
                spin(10); // Simulate workload
            }
            exit(0);
        }
    }
    for (int i = 0; i < N; i++) {
        wait(0);
    }
    printf("MLFQ Test: Finished\n");
    exit(0);
}
