// 测试共享内存的分配和映射。
#include "kernel/types.h"
#include "kernel/stat.h"
#include "user/user.h"

#define SHM_KEY 1234
#define SHM_SIZE 4

int
main(void)
{
    int key = SHM_KEY;
    int size = SHM_SIZE;
    void *addr = (void *)0x40000000;

    if (shm_alloc(key, size) < 0) {
        printf("shm_alloc failed\n");
        exit(1);
    }

    if (shm_map(key, addr) < 0) {
        printf("shm_map failed\n");
        exit(1);
    }

    printf("Shared memory mapped at %p\n", addr);
    char *p = (char *)addr;
    p[0] = 'A'; // 写入共享内存
    printf("Written to shared memory: %c\n", p[0]);

    exit(0);
}
