
kernel/kernel:     file format elf64-littleriscv


Disassembly of section .text:

0000000080000000 <_entry>:
    80000000:	00009117          	auipc	sp,0x9
    80000004:	b0013103          	ld	sp,-1280(sp) # 80008b00 <_GLOBAL_OFFSET_TABLE_+0x8>
    80000008:	6505                	lui	a0,0x1
    8000000a:	f14025f3          	csrr	a1,mhartid
    8000000e:	0585                	addi	a1,a1,1
    80000010:	02b50533          	mul	a0,a0,a1
    80000014:	912a                	add	sp,sp,a0
    80000016:	078000ef          	jal	ra,8000008e <start>

000000008000001a <spin>:
    8000001a:	a001                	j	8000001a <spin>

000000008000001c <timerinit>:
// at timervec in kernelvec.S,
// which turns them into software interrupts for
// devintr() in trap.c.
void
timerinit()
{
    8000001c:	1141                	addi	sp,sp,-16
    8000001e:	e422                	sd	s0,8(sp)
    80000020:	0800                	addi	s0,sp,16
// which hart (core) is this?
static inline uint64
r_mhartid()
{
  uint64 x;
  asm volatile("csrr %0, mhartid" : "=r" (x) );
    80000022:	f14027f3          	csrr	a5,mhartid
  // each CPU has a separate source of timer interrupts.
  int id = r_mhartid();
    80000026:	0007869b          	sext.w	a3,a5

  // ask the CLINT for a timer interrupt.
  int interval = 1000000; // cycles; about 1/10th second in qemu.
  *(uint64*)CLINT_MTIMECMP(id) = *(uint64*)CLINT_MTIME + interval;
    8000002a:	0037979b          	slliw	a5,a5,0x3
    8000002e:	02004737          	lui	a4,0x2004
    80000032:	97ba                	add	a5,a5,a4
    80000034:	0200c737          	lui	a4,0x200c
    80000038:	ff873583          	ld	a1,-8(a4) # 200bff8 <_entry-0x7dff4008>
    8000003c:	000f4637          	lui	a2,0xf4
    80000040:	24060613          	addi	a2,a2,576 # f4240 <_entry-0x7ff0bdc0>
    80000044:	95b2                	add	a1,a1,a2
    80000046:	e38c                	sd	a1,0(a5)

  // prepare information in scratch[] for timervec.
  // scratch[0..2] : space for timervec to save registers.
  // scratch[3] : address of CLINT MTIMECMP register.
  // scratch[4] : desired interval (in cycles) between timer interrupts.
  uint64 *scratch = &timer_scratch[id][0];
    80000048:	00269713          	slli	a4,a3,0x2
    8000004c:	9736                	add	a4,a4,a3
    8000004e:	00371693          	slli	a3,a4,0x3
    80000052:	00009717          	auipc	a4,0x9
    80000056:	b0e70713          	addi	a4,a4,-1266 # 80008b60 <timer_scratch>
    8000005a:	9736                	add	a4,a4,a3
  scratch[3] = CLINT_MTIMECMP(id);
    8000005c:	ef1c                	sd	a5,24(a4)
  scratch[4] = interval;
    8000005e:	f310                	sd	a2,32(a4)
}

static inline void 
w_mscratch(uint64 x)
{
  asm volatile("csrw mscratch, %0" : : "r" (x));
    80000060:	34071073          	csrw	mscratch,a4
  asm volatile("csrw mtvec, %0" : : "r" (x));
    80000064:	00006797          	auipc	a5,0x6
    80000068:	fcc78793          	addi	a5,a5,-52 # 80006030 <timervec>
    8000006c:	30579073          	csrw	mtvec,a5
  asm volatile("csrr %0, mstatus" : "=r" (x) );
    80000070:	300027f3          	csrr	a5,mstatus

  // set the machine-mode trap handler.
  w_mtvec((uint64)timervec);

  // enable machine-mode interrupts.
  w_mstatus(r_mstatus() | MSTATUS_MIE);
    80000074:	0087e793          	ori	a5,a5,8
  asm volatile("csrw mstatus, %0" : : "r" (x));
    80000078:	30079073          	csrw	mstatus,a5
  asm volatile("csrr %0, mie" : "=r" (x) );
    8000007c:	304027f3          	csrr	a5,mie

  // enable machine-mode timer interrupts.
  w_mie(r_mie() | MIE_MTIE);
    80000080:	0807e793          	ori	a5,a5,128
  asm volatile("csrw mie, %0" : : "r" (x));
    80000084:	30479073          	csrw	mie,a5
}
    80000088:	6422                	ld	s0,8(sp)
    8000008a:	0141                	addi	sp,sp,16
    8000008c:	8082                	ret

000000008000008e <start>:
{
    8000008e:	1141                	addi	sp,sp,-16
    80000090:	e406                	sd	ra,8(sp)
    80000092:	e022                	sd	s0,0(sp)
    80000094:	0800                	addi	s0,sp,16
  asm volatile("csrr %0, mstatus" : "=r" (x) );
    80000096:	300027f3          	csrr	a5,mstatus
  x &= ~MSTATUS_MPP_MASK;
    8000009a:	7779                	lui	a4,0xffffe
    8000009c:	7ff70713          	addi	a4,a4,2047 # ffffffffffffe7ff <end+0xffffffff7ffdbf47>
    800000a0:	8ff9                	and	a5,a5,a4
  x |= MSTATUS_MPP_S;
    800000a2:	6705                	lui	a4,0x1
    800000a4:	80070713          	addi	a4,a4,-2048 # 800 <_entry-0x7ffff800>
    800000a8:	8fd9                	or	a5,a5,a4
  asm volatile("csrw mstatus, %0" : : "r" (x));
    800000aa:	30079073          	csrw	mstatus,a5
  asm volatile("csrw mepc, %0" : : "r" (x));
    800000ae:	00001797          	auipc	a5,0x1
    800000b2:	eb678793          	addi	a5,a5,-330 # 80000f64 <main>
    800000b6:	34179073          	csrw	mepc,a5
  asm volatile("csrw satp, %0" : : "r" (x));
    800000ba:	4781                	li	a5,0
    800000bc:	18079073          	csrw	satp,a5
  asm volatile("csrw medeleg, %0" : : "r" (x));
    800000c0:	67c1                	lui	a5,0x10
    800000c2:	17fd                	addi	a5,a5,-1
    800000c4:	30279073          	csrw	medeleg,a5
  asm volatile("csrw mideleg, %0" : : "r" (x));
    800000c8:	30379073          	csrw	mideleg,a5
  asm volatile("csrr %0, sie" : "=r" (x) );
    800000cc:	104027f3          	csrr	a5,sie
  w_sie(r_sie() | SIE_SEIE | SIE_STIE | SIE_SSIE);
    800000d0:	2227e793          	ori	a5,a5,546
  asm volatile("csrw sie, %0" : : "r" (x));
    800000d4:	10479073          	csrw	sie,a5
  asm volatile("csrw pmpaddr0, %0" : : "r" (x));
    800000d8:	57fd                	li	a5,-1
    800000da:	83a9                	srli	a5,a5,0xa
    800000dc:	3b079073          	csrw	pmpaddr0,a5
  asm volatile("csrw pmpcfg0, %0" : : "r" (x));
    800000e0:	47bd                	li	a5,15
    800000e2:	3a079073          	csrw	pmpcfg0,a5
  timerinit();
    800000e6:	00000097          	auipc	ra,0x0
    800000ea:	f36080e7          	jalr	-202(ra) # 8000001c <timerinit>
  asm volatile("csrr %0, mhartid" : "=r" (x) );
    800000ee:	f14027f3          	csrr	a5,mhartid
  w_tp(id);
    800000f2:	2781                	sext.w	a5,a5
}

static inline void 
w_tp(uint64 x)
{
  asm volatile("mv tp, %0" : : "r" (x));
    800000f4:	823e                	mv	tp,a5
  asm volatile("mret");
    800000f6:	30200073          	mret
}
    800000fa:	60a2                	ld	ra,8(sp)
    800000fc:	6402                	ld	s0,0(sp)
    800000fe:	0141                	addi	sp,sp,16
    80000100:	8082                	ret

0000000080000102 <consolewrite>:
//
// user write()s to the console go here.
//
int
consolewrite(int user_src, uint64 src, int n)
{
    80000102:	715d                	addi	sp,sp,-80
    80000104:	e486                	sd	ra,72(sp)
    80000106:	e0a2                	sd	s0,64(sp)
    80000108:	fc26                	sd	s1,56(sp)
    8000010a:	f84a                	sd	s2,48(sp)
    8000010c:	f44e                	sd	s3,40(sp)
    8000010e:	f052                	sd	s4,32(sp)
    80000110:	ec56                	sd	s5,24(sp)
    80000112:	0880                	addi	s0,sp,80
  int i;

  for(i = 0; i < n; i++){
    80000114:	04c05663          	blez	a2,80000160 <consolewrite+0x5e>
    80000118:	8a2a                	mv	s4,a0
    8000011a:	84ae                	mv	s1,a1
    8000011c:	89b2                	mv	s3,a2
    8000011e:	4901                	li	s2,0
    char c;
    if(either_copyin(&c, user_src, src+i, 1) == -1)
    80000120:	5afd                	li	s5,-1
    80000122:	4685                	li	a3,1
    80000124:	8626                	mv	a2,s1
    80000126:	85d2                	mv	a1,s4
    80000128:	fbf40513          	addi	a0,s0,-65
    8000012c:	00002097          	auipc	ra,0x2
    80000130:	5b2080e7          	jalr	1458(ra) # 800026de <either_copyin>
    80000134:	01550c63          	beq	a0,s5,8000014c <consolewrite+0x4a>
      break;
    uartputc(c);
    80000138:	fbf44503          	lbu	a0,-65(s0)
    8000013c:	00000097          	auipc	ra,0x0
    80000140:	794080e7          	jalr	1940(ra) # 800008d0 <uartputc>
  for(i = 0; i < n; i++){
    80000144:	2905                	addiw	s2,s2,1
    80000146:	0485                	addi	s1,s1,1
    80000148:	fd299de3          	bne	s3,s2,80000122 <consolewrite+0x20>
  }

  return i;
}
    8000014c:	854a                	mv	a0,s2
    8000014e:	60a6                	ld	ra,72(sp)
    80000150:	6406                	ld	s0,64(sp)
    80000152:	74e2                	ld	s1,56(sp)
    80000154:	7942                	ld	s2,48(sp)
    80000156:	79a2                	ld	s3,40(sp)
    80000158:	7a02                	ld	s4,32(sp)
    8000015a:	6ae2                	ld	s5,24(sp)
    8000015c:	6161                	addi	sp,sp,80
    8000015e:	8082                	ret
  for(i = 0; i < n; i++){
    80000160:	4901                	li	s2,0
    80000162:	b7ed                	j	8000014c <consolewrite+0x4a>

0000000080000164 <consoleread>:
// user_dist indicates whether dst is a user
// or kernel address.
//
int
consoleread(int user_dst, uint64 dst, int n)
{
    80000164:	7119                	addi	sp,sp,-128
    80000166:	fc86                	sd	ra,120(sp)
    80000168:	f8a2                	sd	s0,112(sp)
    8000016a:	f4a6                	sd	s1,104(sp)
    8000016c:	f0ca                	sd	s2,96(sp)
    8000016e:	ecce                	sd	s3,88(sp)
    80000170:	e8d2                	sd	s4,80(sp)
    80000172:	e4d6                	sd	s5,72(sp)
    80000174:	e0da                	sd	s6,64(sp)
    80000176:	fc5e                	sd	s7,56(sp)
    80000178:	f862                	sd	s8,48(sp)
    8000017a:	f466                	sd	s9,40(sp)
    8000017c:	f06a                	sd	s10,32(sp)
    8000017e:	ec6e                	sd	s11,24(sp)
    80000180:	0100                	addi	s0,sp,128
    80000182:	8b2a                	mv	s6,a0
    80000184:	8aae                	mv	s5,a1
    80000186:	8a32                	mv	s4,a2
  uint target;
  int c;
  char cbuf;

  target = n;
    80000188:	00060b9b          	sext.w	s7,a2
  acquire(&cons.lock);
    8000018c:	00011517          	auipc	a0,0x11
    80000190:	b1450513          	addi	a0,a0,-1260 # 80010ca0 <cons>
    80000194:	00001097          	auipc	ra,0x1
    80000198:	a7a080e7          	jalr	-1414(ra) # 80000c0e <acquire>
  while(n > 0){
    // wait until interrupt handler has put some
    // input into cons.buffer.
    while(cons.r == cons.w){
    8000019c:	00011497          	auipc	s1,0x11
    800001a0:	b0448493          	addi	s1,s1,-1276 # 80010ca0 <cons>
      if(killed(myproc())){
        release(&cons.lock);
        return -1;
      }
      sleep(&cons.r, &cons.lock);
    800001a4:	89a6                	mv	s3,s1
    800001a6:	00011917          	auipc	s2,0x11
    800001aa:	b9a90913          	addi	s2,s2,-1126 # 80010d40 <cons+0xa0>
    }

    c = cons.buf[cons.r++ % INPUT_BUF_SIZE];

    if(c == C('D')){  // end-of-file
    800001ae:	4c91                	li	s9,4
      break;
    }

    // copy the input byte to the user-space buffer.
    cbuf = c;
    if(either_copyout(user_dst, dst, &cbuf, 1) == -1)
    800001b0:	5d7d                	li	s10,-1
      break;

    dst++;
    --n;

    if(c == '\n'){
    800001b2:	4da9                	li	s11,10
  while(n > 0){
    800001b4:	07405b63          	blez	s4,8000022a <consoleread+0xc6>
    while(cons.r == cons.w){
    800001b8:	0a04a783          	lw	a5,160(s1)
    800001bc:	0a44a703          	lw	a4,164(s1)
    800001c0:	02f71763          	bne	a4,a5,800001ee <consoleread+0x8a>
      if(killed(myproc())){
    800001c4:	00002097          	auipc	ra,0x2
    800001c8:	8d2080e7          	jalr	-1838(ra) # 80001a96 <myproc>
    800001cc:	00002097          	auipc	ra,0x2
    800001d0:	35c080e7          	jalr	860(ra) # 80002528 <killed>
    800001d4:	e535                	bnez	a0,80000240 <consoleread+0xdc>
      sleep(&cons.r, &cons.lock);
    800001d6:	85ce                	mv	a1,s3
    800001d8:	854a                	mv	a0,s2
    800001da:	00002097          	auipc	ra,0x2
    800001de:	0a6080e7          	jalr	166(ra) # 80002280 <sleep>
    while(cons.r == cons.w){
    800001e2:	0a04a783          	lw	a5,160(s1)
    800001e6:	0a44a703          	lw	a4,164(s1)
    800001ea:	fcf70de3          	beq	a4,a5,800001c4 <consoleread+0x60>
    c = cons.buf[cons.r++ % INPUT_BUF_SIZE];
    800001ee:	0017871b          	addiw	a4,a5,1
    800001f2:	0ae4a023          	sw	a4,160(s1)
    800001f6:	07f7f713          	andi	a4,a5,127
    800001fa:	9726                	add	a4,a4,s1
    800001fc:	02074703          	lbu	a4,32(a4)
    80000200:	00070c1b          	sext.w	s8,a4
    if(c == C('D')){  // end-of-file
    80000204:	079c0663          	beq	s8,s9,80000270 <consoleread+0x10c>
    cbuf = c;
    80000208:	f8e407a3          	sb	a4,-113(s0)
    if(either_copyout(user_dst, dst, &cbuf, 1) == -1)
    8000020c:	4685                	li	a3,1
    8000020e:	f8f40613          	addi	a2,s0,-113
    80000212:	85d6                	mv	a1,s5
    80000214:	855a                	mv	a0,s6
    80000216:	00002097          	auipc	ra,0x2
    8000021a:	472080e7          	jalr	1138(ra) # 80002688 <either_copyout>
    8000021e:	01a50663          	beq	a0,s10,8000022a <consoleread+0xc6>
    dst++;
    80000222:	0a85                	addi	s5,s5,1
    --n;
    80000224:	3a7d                	addiw	s4,s4,-1
    if(c == '\n'){
    80000226:	f9bc17e3          	bne	s8,s11,800001b4 <consoleread+0x50>
      // a whole line has arrived, return to
      // the user-level read().
      break;
    }
  }
  release(&cons.lock);
    8000022a:	00011517          	auipc	a0,0x11
    8000022e:	a7650513          	addi	a0,a0,-1418 # 80010ca0 <cons>
    80000232:	00001097          	auipc	ra,0x1
    80000236:	b36080e7          	jalr	-1226(ra) # 80000d68 <release>

  return target - n;
    8000023a:	414b853b          	subw	a0,s7,s4
    8000023e:	a811                	j	80000252 <consoleread+0xee>
        release(&cons.lock);
    80000240:	00011517          	auipc	a0,0x11
    80000244:	a6050513          	addi	a0,a0,-1440 # 80010ca0 <cons>
    80000248:	00001097          	auipc	ra,0x1
    8000024c:	b20080e7          	jalr	-1248(ra) # 80000d68 <release>
        return -1;
    80000250:	557d                	li	a0,-1
}
    80000252:	70e6                	ld	ra,120(sp)
    80000254:	7446                	ld	s0,112(sp)
    80000256:	74a6                	ld	s1,104(sp)
    80000258:	7906                	ld	s2,96(sp)
    8000025a:	69e6                	ld	s3,88(sp)
    8000025c:	6a46                	ld	s4,80(sp)
    8000025e:	6aa6                	ld	s5,72(sp)
    80000260:	6b06                	ld	s6,64(sp)
    80000262:	7be2                	ld	s7,56(sp)
    80000264:	7c42                	ld	s8,48(sp)
    80000266:	7ca2                	ld	s9,40(sp)
    80000268:	7d02                	ld	s10,32(sp)
    8000026a:	6de2                	ld	s11,24(sp)
    8000026c:	6109                	addi	sp,sp,128
    8000026e:	8082                	ret
      if(n < target){
    80000270:	000a071b          	sext.w	a4,s4
    80000274:	fb777be3          	bgeu	a4,s7,8000022a <consoleread+0xc6>
        cons.r--;
    80000278:	00011717          	auipc	a4,0x11
    8000027c:	acf72423          	sw	a5,-1336(a4) # 80010d40 <cons+0xa0>
    80000280:	b76d                	j	8000022a <consoleread+0xc6>

0000000080000282 <consputc>:
{
    80000282:	1141                	addi	sp,sp,-16
    80000284:	e406                	sd	ra,8(sp)
    80000286:	e022                	sd	s0,0(sp)
    80000288:	0800                	addi	s0,sp,16
  if(c == BACKSPACE){
    8000028a:	10000793          	li	a5,256
    8000028e:	00f50a63          	beq	a0,a5,800002a2 <consputc+0x20>
    uartputc_sync(c);
    80000292:	00000097          	auipc	ra,0x0
    80000296:	564080e7          	jalr	1380(ra) # 800007f6 <uartputc_sync>
}
    8000029a:	60a2                	ld	ra,8(sp)
    8000029c:	6402                	ld	s0,0(sp)
    8000029e:	0141                	addi	sp,sp,16
    800002a0:	8082                	ret
    uartputc_sync('\b'); uartputc_sync(' '); uartputc_sync('\b');
    800002a2:	4521                	li	a0,8
    800002a4:	00000097          	auipc	ra,0x0
    800002a8:	552080e7          	jalr	1362(ra) # 800007f6 <uartputc_sync>
    800002ac:	02000513          	li	a0,32
    800002b0:	00000097          	auipc	ra,0x0
    800002b4:	546080e7          	jalr	1350(ra) # 800007f6 <uartputc_sync>
    800002b8:	4521                	li	a0,8
    800002ba:	00000097          	auipc	ra,0x0
    800002be:	53c080e7          	jalr	1340(ra) # 800007f6 <uartputc_sync>
    800002c2:	bfe1                	j	8000029a <consputc+0x18>

00000000800002c4 <consoleintr>:
// do erase/kill processing, append to cons.buf,
// wake up consoleread() if a whole line has arrived.
//
void
consoleintr(int c)
{
    800002c4:	1101                	addi	sp,sp,-32
    800002c6:	ec06                	sd	ra,24(sp)
    800002c8:	e822                	sd	s0,16(sp)
    800002ca:	e426                	sd	s1,8(sp)
    800002cc:	e04a                	sd	s2,0(sp)
    800002ce:	1000                	addi	s0,sp,32
    800002d0:	84aa                	mv	s1,a0
  acquire(&cons.lock);
    800002d2:	00011517          	auipc	a0,0x11
    800002d6:	9ce50513          	addi	a0,a0,-1586 # 80010ca0 <cons>
    800002da:	00001097          	auipc	ra,0x1
    800002de:	934080e7          	jalr	-1740(ra) # 80000c0e <acquire>

  switch(c){
    800002e2:	47d5                	li	a5,21
    800002e4:	0af48663          	beq	s1,a5,80000390 <consoleintr+0xcc>
    800002e8:	0297ca63          	blt	a5,s1,8000031c <consoleintr+0x58>
    800002ec:	47a1                	li	a5,8
    800002ee:	0ef48763          	beq	s1,a5,800003dc <consoleintr+0x118>
    800002f2:	47c1                	li	a5,16
    800002f4:	10f49a63          	bne	s1,a5,80000408 <consoleintr+0x144>
  case C('P'):  // Print process list.
    procdump();
    800002f8:	00002097          	auipc	ra,0x2
    800002fc:	43c080e7          	jalr	1084(ra) # 80002734 <procdump>
      }
    }
    break;
  }
  
  release(&cons.lock);
    80000300:	00011517          	auipc	a0,0x11
    80000304:	9a050513          	addi	a0,a0,-1632 # 80010ca0 <cons>
    80000308:	00001097          	auipc	ra,0x1
    8000030c:	a60080e7          	jalr	-1440(ra) # 80000d68 <release>
}
    80000310:	60e2                	ld	ra,24(sp)
    80000312:	6442                	ld	s0,16(sp)
    80000314:	64a2                	ld	s1,8(sp)
    80000316:	6902                	ld	s2,0(sp)
    80000318:	6105                	addi	sp,sp,32
    8000031a:	8082                	ret
  switch(c){
    8000031c:	07f00793          	li	a5,127
    80000320:	0af48e63          	beq	s1,a5,800003dc <consoleintr+0x118>
    if(c != 0 && cons.e-cons.r < INPUT_BUF_SIZE){
    80000324:	00011717          	auipc	a4,0x11
    80000328:	97c70713          	addi	a4,a4,-1668 # 80010ca0 <cons>
    8000032c:	0a872783          	lw	a5,168(a4)
    80000330:	0a072703          	lw	a4,160(a4)
    80000334:	9f99                	subw	a5,a5,a4
    80000336:	07f00713          	li	a4,127
    8000033a:	fcf763e3          	bltu	a4,a5,80000300 <consoleintr+0x3c>
      c = (c == '\r') ? '\n' : c;
    8000033e:	47b5                	li	a5,13
    80000340:	0cf48763          	beq	s1,a5,8000040e <consoleintr+0x14a>
      consputc(c);
    80000344:	8526                	mv	a0,s1
    80000346:	00000097          	auipc	ra,0x0
    8000034a:	f3c080e7          	jalr	-196(ra) # 80000282 <consputc>
      cons.buf[cons.e++ % INPUT_BUF_SIZE] = c;
    8000034e:	00011797          	auipc	a5,0x11
    80000352:	95278793          	addi	a5,a5,-1710 # 80010ca0 <cons>
    80000356:	0a87a683          	lw	a3,168(a5)
    8000035a:	0016871b          	addiw	a4,a3,1
    8000035e:	0007061b          	sext.w	a2,a4
    80000362:	0ae7a423          	sw	a4,168(a5)
    80000366:	07f6f693          	andi	a3,a3,127
    8000036a:	97b6                	add	a5,a5,a3
    8000036c:	02978023          	sb	s1,32(a5)
      if(c == '\n' || c == C('D') || cons.e-cons.r == INPUT_BUF_SIZE){
    80000370:	47a9                	li	a5,10
    80000372:	0cf48563          	beq	s1,a5,8000043c <consoleintr+0x178>
    80000376:	4791                	li	a5,4
    80000378:	0cf48263          	beq	s1,a5,8000043c <consoleintr+0x178>
    8000037c:	00011797          	auipc	a5,0x11
    80000380:	9c47a783          	lw	a5,-1596(a5) # 80010d40 <cons+0xa0>
    80000384:	9f1d                	subw	a4,a4,a5
    80000386:	08000793          	li	a5,128
    8000038a:	f6f71be3          	bne	a4,a5,80000300 <consoleintr+0x3c>
    8000038e:	a07d                	j	8000043c <consoleintr+0x178>
    while(cons.e != cons.w &&
    80000390:	00011717          	auipc	a4,0x11
    80000394:	91070713          	addi	a4,a4,-1776 # 80010ca0 <cons>
    80000398:	0a872783          	lw	a5,168(a4)
    8000039c:	0a472703          	lw	a4,164(a4)
          cons.buf[(cons.e-1) % INPUT_BUF_SIZE] != '\n'){
    800003a0:	00011497          	auipc	s1,0x11
    800003a4:	90048493          	addi	s1,s1,-1792 # 80010ca0 <cons>
    while(cons.e != cons.w &&
    800003a8:	4929                	li	s2,10
    800003aa:	f4f70be3          	beq	a4,a5,80000300 <consoleintr+0x3c>
          cons.buf[(cons.e-1) % INPUT_BUF_SIZE] != '\n'){
    800003ae:	37fd                	addiw	a5,a5,-1
    800003b0:	07f7f713          	andi	a4,a5,127
    800003b4:	9726                	add	a4,a4,s1
    while(cons.e != cons.w &&
    800003b6:	02074703          	lbu	a4,32(a4)
    800003ba:	f52703e3          	beq	a4,s2,80000300 <consoleintr+0x3c>
      cons.e--;
    800003be:	0af4a423          	sw	a5,168(s1)
      consputc(BACKSPACE);
    800003c2:	10000513          	li	a0,256
    800003c6:	00000097          	auipc	ra,0x0
    800003ca:	ebc080e7          	jalr	-324(ra) # 80000282 <consputc>
    while(cons.e != cons.w &&
    800003ce:	0a84a783          	lw	a5,168(s1)
    800003d2:	0a44a703          	lw	a4,164(s1)
    800003d6:	fcf71ce3          	bne	a4,a5,800003ae <consoleintr+0xea>
    800003da:	b71d                	j	80000300 <consoleintr+0x3c>
    if(cons.e != cons.w){
    800003dc:	00011717          	auipc	a4,0x11
    800003e0:	8c470713          	addi	a4,a4,-1852 # 80010ca0 <cons>
    800003e4:	0a872783          	lw	a5,168(a4)
    800003e8:	0a472703          	lw	a4,164(a4)
    800003ec:	f0f70ae3          	beq	a4,a5,80000300 <consoleintr+0x3c>
      cons.e--;
    800003f0:	37fd                	addiw	a5,a5,-1
    800003f2:	00011717          	auipc	a4,0x11
    800003f6:	94f72b23          	sw	a5,-1706(a4) # 80010d48 <cons+0xa8>
      consputc(BACKSPACE);
    800003fa:	10000513          	li	a0,256
    800003fe:	00000097          	auipc	ra,0x0
    80000402:	e84080e7          	jalr	-380(ra) # 80000282 <consputc>
    80000406:	bded                	j	80000300 <consoleintr+0x3c>
    if(c != 0 && cons.e-cons.r < INPUT_BUF_SIZE){
    80000408:	ee048ce3          	beqz	s1,80000300 <consoleintr+0x3c>
    8000040c:	bf21                	j	80000324 <consoleintr+0x60>
      consputc(c);
    8000040e:	4529                	li	a0,10
    80000410:	00000097          	auipc	ra,0x0
    80000414:	e72080e7          	jalr	-398(ra) # 80000282 <consputc>
      cons.buf[cons.e++ % INPUT_BUF_SIZE] = c;
    80000418:	00011797          	auipc	a5,0x11
    8000041c:	88878793          	addi	a5,a5,-1912 # 80010ca0 <cons>
    80000420:	0a87a703          	lw	a4,168(a5)
    80000424:	0017069b          	addiw	a3,a4,1
    80000428:	0006861b          	sext.w	a2,a3
    8000042c:	0ad7a423          	sw	a3,168(a5)
    80000430:	07f77713          	andi	a4,a4,127
    80000434:	97ba                	add	a5,a5,a4
    80000436:	4729                	li	a4,10
    80000438:	02e78023          	sb	a4,32(a5)
        cons.w = cons.e;
    8000043c:	00011797          	auipc	a5,0x11
    80000440:	90c7a423          	sw	a2,-1784(a5) # 80010d44 <cons+0xa4>
        wakeup(&cons.r);
    80000444:	00011517          	auipc	a0,0x11
    80000448:	8fc50513          	addi	a0,a0,-1796 # 80010d40 <cons+0xa0>
    8000044c:	00002097          	auipc	ra,0x2
    80000450:	e98080e7          	jalr	-360(ra) # 800022e4 <wakeup>
    80000454:	b575                	j	80000300 <consoleintr+0x3c>

0000000080000456 <consoleinit>:

void
consoleinit(void)
{
    80000456:	1141                	addi	sp,sp,-16
    80000458:	e406                	sd	ra,8(sp)
    8000045a:	e022                	sd	s0,0(sp)
    8000045c:	0800                	addi	s0,sp,16
  initlock(&cons.lock, "cons");
    8000045e:	00008597          	auipc	a1,0x8
    80000462:	bb258593          	addi	a1,a1,-1102 # 80008010 <etext+0x10>
    80000466:	00011517          	auipc	a0,0x11
    8000046a:	83a50513          	addi	a0,a0,-1990 # 80010ca0 <cons>
    8000046e:	00000097          	auipc	ra,0x0
    80000472:	736080e7          	jalr	1846(ra) # 80000ba4 <initlock>

  uartinit();
    80000476:	00000097          	auipc	ra,0x0
    8000047a:	330080e7          	jalr	816(ra) # 800007a6 <uartinit>

  // connect read and write system calls
  // to consoleread and consolewrite.
  devsw[CONSOLE].read = consoleread;
    8000047e:	00021797          	auipc	a5,0x21
    80000482:	29278793          	addi	a5,a5,658 # 80021710 <devsw>
    80000486:	00000717          	auipc	a4,0x0
    8000048a:	cde70713          	addi	a4,a4,-802 # 80000164 <consoleread>
    8000048e:	eb98                	sd	a4,16(a5)
  devsw[CONSOLE].write = consolewrite;
    80000490:	00000717          	auipc	a4,0x0
    80000494:	c7270713          	addi	a4,a4,-910 # 80000102 <consolewrite>
    80000498:	ef98                	sd	a4,24(a5)
}
    8000049a:	60a2                	ld	ra,8(sp)
    8000049c:	6402                	ld	s0,0(sp)
    8000049e:	0141                	addi	sp,sp,16
    800004a0:	8082                	ret

00000000800004a2 <printint>:

static char digits[] = "0123456789abcdef";

static void
printint(int xx, int base, int sign)
{
    800004a2:	7179                	addi	sp,sp,-48
    800004a4:	f406                	sd	ra,40(sp)
    800004a6:	f022                	sd	s0,32(sp)
    800004a8:	ec26                	sd	s1,24(sp)
    800004aa:	e84a                	sd	s2,16(sp)
    800004ac:	1800                	addi	s0,sp,48
  char buf[16];
  int i;
  uint x;

  if(sign && (sign = xx < 0))
    800004ae:	c219                	beqz	a2,800004b4 <printint+0x12>
    800004b0:	08054663          	bltz	a0,8000053c <printint+0x9a>
    x = -xx;
  else
    x = xx;
    800004b4:	2501                	sext.w	a0,a0
    800004b6:	4881                	li	a7,0
    800004b8:	fd040693          	addi	a3,s0,-48

  i = 0;
    800004bc:	4701                	li	a4,0
  do {
    buf[i++] = digits[x % base];
    800004be:	2581                	sext.w	a1,a1
    800004c0:	00008617          	auipc	a2,0x8
    800004c4:	b8060613          	addi	a2,a2,-1152 # 80008040 <digits>
    800004c8:	883a                	mv	a6,a4
    800004ca:	2705                	addiw	a4,a4,1
    800004cc:	02b577bb          	remuw	a5,a0,a1
    800004d0:	1782                	slli	a5,a5,0x20
    800004d2:	9381                	srli	a5,a5,0x20
    800004d4:	97b2                	add	a5,a5,a2
    800004d6:	0007c783          	lbu	a5,0(a5)
    800004da:	00f68023          	sb	a5,0(a3)
  } while((x /= base) != 0);
    800004de:	0005079b          	sext.w	a5,a0
    800004e2:	02b5553b          	divuw	a0,a0,a1
    800004e6:	0685                	addi	a3,a3,1
    800004e8:	feb7f0e3          	bgeu	a5,a1,800004c8 <printint+0x26>

  if(sign)
    800004ec:	00088b63          	beqz	a7,80000502 <printint+0x60>
    buf[i++] = '-';
    800004f0:	fe040793          	addi	a5,s0,-32
    800004f4:	973e                	add	a4,a4,a5
    800004f6:	02d00793          	li	a5,45
    800004fa:	fef70823          	sb	a5,-16(a4)
    800004fe:	0028071b          	addiw	a4,a6,2

  while(--i >= 0)
    80000502:	02e05763          	blez	a4,80000530 <printint+0x8e>
    80000506:	fd040793          	addi	a5,s0,-48
    8000050a:	00e784b3          	add	s1,a5,a4
    8000050e:	fff78913          	addi	s2,a5,-1
    80000512:	993a                	add	s2,s2,a4
    80000514:	377d                	addiw	a4,a4,-1
    80000516:	1702                	slli	a4,a4,0x20
    80000518:	9301                	srli	a4,a4,0x20
    8000051a:	40e90933          	sub	s2,s2,a4
    consputc(buf[i]);
    8000051e:	fff4c503          	lbu	a0,-1(s1)
    80000522:	00000097          	auipc	ra,0x0
    80000526:	d60080e7          	jalr	-672(ra) # 80000282 <consputc>
  while(--i >= 0)
    8000052a:	14fd                	addi	s1,s1,-1
    8000052c:	ff2499e3          	bne	s1,s2,8000051e <printint+0x7c>
}
    80000530:	70a2                	ld	ra,40(sp)
    80000532:	7402                	ld	s0,32(sp)
    80000534:	64e2                	ld	s1,24(sp)
    80000536:	6942                	ld	s2,16(sp)
    80000538:	6145                	addi	sp,sp,48
    8000053a:	8082                	ret
    x = -xx;
    8000053c:	40a0053b          	negw	a0,a0
  if(sign && (sign = xx < 0))
    80000540:	4885                	li	a7,1
    x = -xx;
    80000542:	bf9d                	j	800004b8 <printint+0x16>

0000000080000544 <panic>:
    release(&pr.lock);
}

void
panic(char *s)
{
    80000544:	1101                	addi	sp,sp,-32
    80000546:	ec06                	sd	ra,24(sp)
    80000548:	e822                	sd	s0,16(sp)
    8000054a:	e426                	sd	s1,8(sp)
    8000054c:	1000                	addi	s0,sp,32
    8000054e:	84aa                	mv	s1,a0
  pr.locking = 0;
    80000550:	00011797          	auipc	a5,0x11
    80000554:	8207a023          	sw	zero,-2016(a5) # 80010d70 <pr+0x20>
  printf("panic: ");
    80000558:	00008517          	auipc	a0,0x8
    8000055c:	ac050513          	addi	a0,a0,-1344 # 80008018 <etext+0x18>
    80000560:	00000097          	auipc	ra,0x0
    80000564:	02e080e7          	jalr	46(ra) # 8000058e <printf>
  printf(s);
    80000568:	8526                	mv	a0,s1
    8000056a:	00000097          	auipc	ra,0x0
    8000056e:	024080e7          	jalr	36(ra) # 8000058e <printf>
  printf("\n");
    80000572:	00008517          	auipc	a0,0x8
    80000576:	b4e50513          	addi	a0,a0,-1202 # 800080c0 <digits+0x80>
    8000057a:	00000097          	auipc	ra,0x0
    8000057e:	014080e7          	jalr	20(ra) # 8000058e <printf>
  panicked = 1; // freeze uart output from other CPUs
    80000582:	4785                	li	a5,1
    80000584:	00008717          	auipc	a4,0x8
    80000588:	58f72e23          	sw	a5,1436(a4) # 80008b20 <panicked>
  for(;;)
    8000058c:	a001                	j	8000058c <panic+0x48>

000000008000058e <printf>:
{
    8000058e:	7131                	addi	sp,sp,-192
    80000590:	fc86                	sd	ra,120(sp)
    80000592:	f8a2                	sd	s0,112(sp)
    80000594:	f4a6                	sd	s1,104(sp)
    80000596:	f0ca                	sd	s2,96(sp)
    80000598:	ecce                	sd	s3,88(sp)
    8000059a:	e8d2                	sd	s4,80(sp)
    8000059c:	e4d6                	sd	s5,72(sp)
    8000059e:	e0da                	sd	s6,64(sp)
    800005a0:	fc5e                	sd	s7,56(sp)
    800005a2:	f862                	sd	s8,48(sp)
    800005a4:	f466                	sd	s9,40(sp)
    800005a6:	f06a                	sd	s10,32(sp)
    800005a8:	ec6e                	sd	s11,24(sp)
    800005aa:	0100                	addi	s0,sp,128
    800005ac:	8a2a                	mv	s4,a0
    800005ae:	e40c                	sd	a1,8(s0)
    800005b0:	e810                	sd	a2,16(s0)
    800005b2:	ec14                	sd	a3,24(s0)
    800005b4:	f018                	sd	a4,32(s0)
    800005b6:	f41c                	sd	a5,40(s0)
    800005b8:	03043823          	sd	a6,48(s0)
    800005bc:	03143c23          	sd	a7,56(s0)
  locking = pr.locking;
    800005c0:	00010d97          	auipc	s11,0x10
    800005c4:	7b0dad83          	lw	s11,1968(s11) # 80010d70 <pr+0x20>
  if(locking)
    800005c8:	020d9b63          	bnez	s11,800005fe <printf+0x70>
  if (fmt == 0)
    800005cc:	040a0263          	beqz	s4,80000610 <printf+0x82>
  va_start(ap, fmt);
    800005d0:	00840793          	addi	a5,s0,8
    800005d4:	f8f43423          	sd	a5,-120(s0)
  for(i = 0; (c = fmt[i] & 0xff) != 0; i++){
    800005d8:	000a4503          	lbu	a0,0(s4)
    800005dc:	16050263          	beqz	a0,80000740 <printf+0x1b2>
    800005e0:	4481                	li	s1,0
    if(c != '%'){
    800005e2:	02500a93          	li	s5,37
    switch(c){
    800005e6:	07000b13          	li	s6,112
  consputc('x');
    800005ea:	4d41                	li	s10,16
    consputc(digits[x >> (sizeof(uint64) * 8 - 4)]);
    800005ec:	00008b97          	auipc	s7,0x8
    800005f0:	a54b8b93          	addi	s7,s7,-1452 # 80008040 <digits>
    switch(c){
    800005f4:	07300c93          	li	s9,115
    800005f8:	06400c13          	li	s8,100
    800005fc:	a82d                	j	80000636 <printf+0xa8>
    acquire(&pr.lock);
    800005fe:	00010517          	auipc	a0,0x10
    80000602:	75250513          	addi	a0,a0,1874 # 80010d50 <pr>
    80000606:	00000097          	auipc	ra,0x0
    8000060a:	608080e7          	jalr	1544(ra) # 80000c0e <acquire>
    8000060e:	bf7d                	j	800005cc <printf+0x3e>
    panic("null fmt");
    80000610:	00008517          	auipc	a0,0x8
    80000614:	a1850513          	addi	a0,a0,-1512 # 80008028 <etext+0x28>
    80000618:	00000097          	auipc	ra,0x0
    8000061c:	f2c080e7          	jalr	-212(ra) # 80000544 <panic>
      consputc(c);
    80000620:	00000097          	auipc	ra,0x0
    80000624:	c62080e7          	jalr	-926(ra) # 80000282 <consputc>
  for(i = 0; (c = fmt[i] & 0xff) != 0; i++){
    80000628:	2485                	addiw	s1,s1,1
    8000062a:	009a07b3          	add	a5,s4,s1
    8000062e:	0007c503          	lbu	a0,0(a5)
    80000632:	10050763          	beqz	a0,80000740 <printf+0x1b2>
    if(c != '%'){
    80000636:	ff5515e3          	bne	a0,s5,80000620 <printf+0x92>
    c = fmt[++i] & 0xff;
    8000063a:	2485                	addiw	s1,s1,1
    8000063c:	009a07b3          	add	a5,s4,s1
    80000640:	0007c783          	lbu	a5,0(a5)
    80000644:	0007891b          	sext.w	s2,a5
    if(c == 0)
    80000648:	cfe5                	beqz	a5,80000740 <printf+0x1b2>
    switch(c){
    8000064a:	05678a63          	beq	a5,s6,8000069e <printf+0x110>
    8000064e:	02fb7663          	bgeu	s6,a5,8000067a <printf+0xec>
    80000652:	09978963          	beq	a5,s9,800006e4 <printf+0x156>
    80000656:	07800713          	li	a4,120
    8000065a:	0ce79863          	bne	a5,a4,8000072a <printf+0x19c>
      printint(va_arg(ap, int), 16, 1);
    8000065e:	f8843783          	ld	a5,-120(s0)
    80000662:	00878713          	addi	a4,a5,8
    80000666:	f8e43423          	sd	a4,-120(s0)
    8000066a:	4605                	li	a2,1
    8000066c:	85ea                	mv	a1,s10
    8000066e:	4388                	lw	a0,0(a5)
    80000670:	00000097          	auipc	ra,0x0
    80000674:	e32080e7          	jalr	-462(ra) # 800004a2 <printint>
      break;
    80000678:	bf45                	j	80000628 <printf+0x9a>
    switch(c){
    8000067a:	0b578263          	beq	a5,s5,8000071e <printf+0x190>
    8000067e:	0b879663          	bne	a5,s8,8000072a <printf+0x19c>
      printint(va_arg(ap, int), 10, 1);
    80000682:	f8843783          	ld	a5,-120(s0)
    80000686:	00878713          	addi	a4,a5,8
    8000068a:	f8e43423          	sd	a4,-120(s0)
    8000068e:	4605                	li	a2,1
    80000690:	45a9                	li	a1,10
    80000692:	4388                	lw	a0,0(a5)
    80000694:	00000097          	auipc	ra,0x0
    80000698:	e0e080e7          	jalr	-498(ra) # 800004a2 <printint>
      break;
    8000069c:	b771                	j	80000628 <printf+0x9a>
      printptr(va_arg(ap, uint64));
    8000069e:	f8843783          	ld	a5,-120(s0)
    800006a2:	00878713          	addi	a4,a5,8
    800006a6:	f8e43423          	sd	a4,-120(s0)
    800006aa:	0007b983          	ld	s3,0(a5)
  consputc('0');
    800006ae:	03000513          	li	a0,48
    800006b2:	00000097          	auipc	ra,0x0
    800006b6:	bd0080e7          	jalr	-1072(ra) # 80000282 <consputc>
  consputc('x');
    800006ba:	07800513          	li	a0,120
    800006be:	00000097          	auipc	ra,0x0
    800006c2:	bc4080e7          	jalr	-1084(ra) # 80000282 <consputc>
    800006c6:	896a                	mv	s2,s10
    consputc(digits[x >> (sizeof(uint64) * 8 - 4)]);
    800006c8:	03c9d793          	srli	a5,s3,0x3c
    800006cc:	97de                	add	a5,a5,s7
    800006ce:	0007c503          	lbu	a0,0(a5)
    800006d2:	00000097          	auipc	ra,0x0
    800006d6:	bb0080e7          	jalr	-1104(ra) # 80000282 <consputc>
  for (i = 0; i < (sizeof(uint64) * 2); i++, x <<= 4)
    800006da:	0992                	slli	s3,s3,0x4
    800006dc:	397d                	addiw	s2,s2,-1
    800006de:	fe0915e3          	bnez	s2,800006c8 <printf+0x13a>
    800006e2:	b799                	j	80000628 <printf+0x9a>
      if((s = va_arg(ap, char*)) == 0)
    800006e4:	f8843783          	ld	a5,-120(s0)
    800006e8:	00878713          	addi	a4,a5,8
    800006ec:	f8e43423          	sd	a4,-120(s0)
    800006f0:	0007b903          	ld	s2,0(a5)
    800006f4:	00090e63          	beqz	s2,80000710 <printf+0x182>
      for(; *s; s++)
    800006f8:	00094503          	lbu	a0,0(s2)
    800006fc:	d515                	beqz	a0,80000628 <printf+0x9a>
        consputc(*s);
    800006fe:	00000097          	auipc	ra,0x0
    80000702:	b84080e7          	jalr	-1148(ra) # 80000282 <consputc>
      for(; *s; s++)
    80000706:	0905                	addi	s2,s2,1
    80000708:	00094503          	lbu	a0,0(s2)
    8000070c:	f96d                	bnez	a0,800006fe <printf+0x170>
    8000070e:	bf29                	j	80000628 <printf+0x9a>
        s = "(null)";
    80000710:	00008917          	auipc	s2,0x8
    80000714:	91090913          	addi	s2,s2,-1776 # 80008020 <etext+0x20>
      for(; *s; s++)
    80000718:	02800513          	li	a0,40
    8000071c:	b7cd                	j	800006fe <printf+0x170>
      consputc('%');
    8000071e:	8556                	mv	a0,s5
    80000720:	00000097          	auipc	ra,0x0
    80000724:	b62080e7          	jalr	-1182(ra) # 80000282 <consputc>
      break;
    80000728:	b701                	j	80000628 <printf+0x9a>
      consputc('%');
    8000072a:	8556                	mv	a0,s5
    8000072c:	00000097          	auipc	ra,0x0
    80000730:	b56080e7          	jalr	-1194(ra) # 80000282 <consputc>
      consputc(c);
    80000734:	854a                	mv	a0,s2
    80000736:	00000097          	auipc	ra,0x0
    8000073a:	b4c080e7          	jalr	-1204(ra) # 80000282 <consputc>
      break;
    8000073e:	b5ed                	j	80000628 <printf+0x9a>
  if(locking)
    80000740:	020d9163          	bnez	s11,80000762 <printf+0x1d4>
}
    80000744:	70e6                	ld	ra,120(sp)
    80000746:	7446                	ld	s0,112(sp)
    80000748:	74a6                	ld	s1,104(sp)
    8000074a:	7906                	ld	s2,96(sp)
    8000074c:	69e6                	ld	s3,88(sp)
    8000074e:	6a46                	ld	s4,80(sp)
    80000750:	6aa6                	ld	s5,72(sp)
    80000752:	6b06                	ld	s6,64(sp)
    80000754:	7be2                	ld	s7,56(sp)
    80000756:	7c42                	ld	s8,48(sp)
    80000758:	7ca2                	ld	s9,40(sp)
    8000075a:	7d02                	ld	s10,32(sp)
    8000075c:	6de2                	ld	s11,24(sp)
    8000075e:	6129                	addi	sp,sp,192
    80000760:	8082                	ret
    release(&pr.lock);
    80000762:	00010517          	auipc	a0,0x10
    80000766:	5ee50513          	addi	a0,a0,1518 # 80010d50 <pr>
    8000076a:	00000097          	auipc	ra,0x0
    8000076e:	5fe080e7          	jalr	1534(ra) # 80000d68 <release>
}
    80000772:	bfc9                	j	80000744 <printf+0x1b6>

0000000080000774 <printfinit>:
    ;
}

void
printfinit(void)
{
    80000774:	1101                	addi	sp,sp,-32
    80000776:	ec06                	sd	ra,24(sp)
    80000778:	e822                	sd	s0,16(sp)
    8000077a:	e426                	sd	s1,8(sp)
    8000077c:	1000                	addi	s0,sp,32
  initlock(&pr.lock, "pr");
    8000077e:	00010497          	auipc	s1,0x10
    80000782:	5d248493          	addi	s1,s1,1490 # 80010d50 <pr>
    80000786:	00008597          	auipc	a1,0x8
    8000078a:	8b258593          	addi	a1,a1,-1870 # 80008038 <etext+0x38>
    8000078e:	8526                	mv	a0,s1
    80000790:	00000097          	auipc	ra,0x0
    80000794:	414080e7          	jalr	1044(ra) # 80000ba4 <initlock>
  pr.locking = 1;
    80000798:	4785                	li	a5,1
    8000079a:	d09c                	sw	a5,32(s1)
}
    8000079c:	60e2                	ld	ra,24(sp)
    8000079e:	6442                	ld	s0,16(sp)
    800007a0:	64a2                	ld	s1,8(sp)
    800007a2:	6105                	addi	sp,sp,32
    800007a4:	8082                	ret

00000000800007a6 <uartinit>:

void uartstart();

void
uartinit(void)
{
    800007a6:	1141                	addi	sp,sp,-16
    800007a8:	e406                	sd	ra,8(sp)
    800007aa:	e022                	sd	s0,0(sp)
    800007ac:	0800                	addi	s0,sp,16
  // disable interrupts.
  WriteReg(IER, 0x00);
    800007ae:	100007b7          	lui	a5,0x10000
    800007b2:	000780a3          	sb	zero,1(a5) # 10000001 <_entry-0x6fffffff>

  // special mode to set baud rate.
  WriteReg(LCR, LCR_BAUD_LATCH);
    800007b6:	f8000713          	li	a4,-128
    800007ba:	00e781a3          	sb	a4,3(a5)

  // LSB for baud rate of 38.4K.
  WriteReg(0, 0x03);
    800007be:	470d                	li	a4,3
    800007c0:	00e78023          	sb	a4,0(a5)

  // MSB for baud rate of 38.4K.
  WriteReg(1, 0x00);
    800007c4:	000780a3          	sb	zero,1(a5)

  // leave set-baud mode,
  // and set word length to 8 bits, no parity.
  WriteReg(LCR, LCR_EIGHT_BITS);
    800007c8:	00e781a3          	sb	a4,3(a5)

  // reset and enable FIFOs.
  WriteReg(FCR, FCR_FIFO_ENABLE | FCR_FIFO_CLEAR);
    800007cc:	469d                	li	a3,7
    800007ce:	00d78123          	sb	a3,2(a5)

  // enable transmit and receive interrupts.
  WriteReg(IER, IER_TX_ENABLE | IER_RX_ENABLE);
    800007d2:	00e780a3          	sb	a4,1(a5)

  initlock(&uart_tx_lock, "uart");
    800007d6:	00008597          	auipc	a1,0x8
    800007da:	88258593          	addi	a1,a1,-1918 # 80008058 <digits+0x18>
    800007de:	00010517          	auipc	a0,0x10
    800007e2:	59a50513          	addi	a0,a0,1434 # 80010d78 <uart_tx_lock>
    800007e6:	00000097          	auipc	ra,0x0
    800007ea:	3be080e7          	jalr	958(ra) # 80000ba4 <initlock>
}
    800007ee:	60a2                	ld	ra,8(sp)
    800007f0:	6402                	ld	s0,0(sp)
    800007f2:	0141                	addi	sp,sp,16
    800007f4:	8082                	ret

00000000800007f6 <uartputc_sync>:
// use interrupts, for use by kernel printf() and
// to echo characters. it spins waiting for the uart's
// output register to be empty.
void
uartputc_sync(int c)
{
    800007f6:	1101                	addi	sp,sp,-32
    800007f8:	ec06                	sd	ra,24(sp)
    800007fa:	e822                	sd	s0,16(sp)
    800007fc:	e426                	sd	s1,8(sp)
    800007fe:	1000                	addi	s0,sp,32
    80000800:	84aa                	mv	s1,a0
  push_off();
    80000802:	00000097          	auipc	ra,0x0
    80000806:	3c0080e7          	jalr	960(ra) # 80000bc2 <push_off>

  if(panicked){
    8000080a:	00008797          	auipc	a5,0x8
    8000080e:	3167a783          	lw	a5,790(a5) # 80008b20 <panicked>
    for(;;)
      ;
  }

  // wait for Transmit Holding Empty to be set in LSR.
  while((ReadReg(LSR) & LSR_TX_IDLE) == 0)
    80000812:	10000737          	lui	a4,0x10000
  if(panicked){
    80000816:	c391                	beqz	a5,8000081a <uartputc_sync+0x24>
    for(;;)
    80000818:	a001                	j	80000818 <uartputc_sync+0x22>
  while((ReadReg(LSR) & LSR_TX_IDLE) == 0)
    8000081a:	00574783          	lbu	a5,5(a4) # 10000005 <_entry-0x6ffffffb>
    8000081e:	0ff7f793          	andi	a5,a5,255
    80000822:	0207f793          	andi	a5,a5,32
    80000826:	dbf5                	beqz	a5,8000081a <uartputc_sync+0x24>
    ;
  WriteReg(THR, c);
    80000828:	0ff4f793          	andi	a5,s1,255
    8000082c:	10000737          	lui	a4,0x10000
    80000830:	00f70023          	sb	a5,0(a4) # 10000000 <_entry-0x70000000>

  pop_off();
    80000834:	00000097          	auipc	ra,0x0
    80000838:	490080e7          	jalr	1168(ra) # 80000cc4 <pop_off>
}
    8000083c:	60e2                	ld	ra,24(sp)
    8000083e:	6442                	ld	s0,16(sp)
    80000840:	64a2                	ld	s1,8(sp)
    80000842:	6105                	addi	sp,sp,32
    80000844:	8082                	ret

0000000080000846 <uartstart>:
// called from both the top- and bottom-half.
void
uartstart()
{
  while(1){
    if(uart_tx_w == uart_tx_r){
    80000846:	00008717          	auipc	a4,0x8
    8000084a:	2e273703          	ld	a4,738(a4) # 80008b28 <uart_tx_r>
    8000084e:	00008797          	auipc	a5,0x8
    80000852:	2e27b783          	ld	a5,738(a5) # 80008b30 <uart_tx_w>
    80000856:	06e78c63          	beq	a5,a4,800008ce <uartstart+0x88>
{
    8000085a:	7139                	addi	sp,sp,-64
    8000085c:	fc06                	sd	ra,56(sp)
    8000085e:	f822                	sd	s0,48(sp)
    80000860:	f426                	sd	s1,40(sp)
    80000862:	f04a                	sd	s2,32(sp)
    80000864:	ec4e                	sd	s3,24(sp)
    80000866:	e852                	sd	s4,16(sp)
    80000868:	e456                	sd	s5,8(sp)
    8000086a:	0080                	addi	s0,sp,64
      // transmit buffer is empty.
      return;
    }
    
    if((ReadReg(LSR) & LSR_TX_IDLE) == 0){
    8000086c:	10000937          	lui	s2,0x10000
      // so we cannot give it another byte.
      // it will interrupt when it's ready for a new byte.
      return;
    }
    
    int c = uart_tx_buf[uart_tx_r % UART_TX_BUF_SIZE];
    80000870:	00010a17          	auipc	s4,0x10
    80000874:	508a0a13          	addi	s4,s4,1288 # 80010d78 <uart_tx_lock>
    uart_tx_r += 1;
    80000878:	00008497          	auipc	s1,0x8
    8000087c:	2b048493          	addi	s1,s1,688 # 80008b28 <uart_tx_r>
    if(uart_tx_w == uart_tx_r){
    80000880:	00008997          	auipc	s3,0x8
    80000884:	2b098993          	addi	s3,s3,688 # 80008b30 <uart_tx_w>
    if((ReadReg(LSR) & LSR_TX_IDLE) == 0){
    80000888:	00594783          	lbu	a5,5(s2) # 10000005 <_entry-0x6ffffffb>
    8000088c:	0ff7f793          	andi	a5,a5,255
    80000890:	0207f793          	andi	a5,a5,32
    80000894:	c785                	beqz	a5,800008bc <uartstart+0x76>
    int c = uart_tx_buf[uart_tx_r % UART_TX_BUF_SIZE];
    80000896:	01f77793          	andi	a5,a4,31
    8000089a:	97d2                	add	a5,a5,s4
    8000089c:	0207ca83          	lbu	s5,32(a5)
    uart_tx_r += 1;
    800008a0:	0705                	addi	a4,a4,1
    800008a2:	e098                	sd	a4,0(s1)
    
    // maybe uartputc() is waiting for space in the buffer.
    wakeup(&uart_tx_r);
    800008a4:	8526                	mv	a0,s1
    800008a6:	00002097          	auipc	ra,0x2
    800008aa:	a3e080e7          	jalr	-1474(ra) # 800022e4 <wakeup>
    
    WriteReg(THR, c);
    800008ae:	01590023          	sb	s5,0(s2)
    if(uart_tx_w == uart_tx_r){
    800008b2:	6098                	ld	a4,0(s1)
    800008b4:	0009b783          	ld	a5,0(s3)
    800008b8:	fce798e3          	bne	a5,a4,80000888 <uartstart+0x42>
  }
}
    800008bc:	70e2                	ld	ra,56(sp)
    800008be:	7442                	ld	s0,48(sp)
    800008c0:	74a2                	ld	s1,40(sp)
    800008c2:	7902                	ld	s2,32(sp)
    800008c4:	69e2                	ld	s3,24(sp)
    800008c6:	6a42                	ld	s4,16(sp)
    800008c8:	6aa2                	ld	s5,8(sp)
    800008ca:	6121                	addi	sp,sp,64
    800008cc:	8082                	ret
    800008ce:	8082                	ret

00000000800008d0 <uartputc>:
{
    800008d0:	7179                	addi	sp,sp,-48
    800008d2:	f406                	sd	ra,40(sp)
    800008d4:	f022                	sd	s0,32(sp)
    800008d6:	ec26                	sd	s1,24(sp)
    800008d8:	e84a                	sd	s2,16(sp)
    800008da:	e44e                	sd	s3,8(sp)
    800008dc:	e052                	sd	s4,0(sp)
    800008de:	1800                	addi	s0,sp,48
    800008e0:	89aa                	mv	s3,a0
  acquire(&uart_tx_lock);
    800008e2:	00010517          	auipc	a0,0x10
    800008e6:	49650513          	addi	a0,a0,1174 # 80010d78 <uart_tx_lock>
    800008ea:	00000097          	auipc	ra,0x0
    800008ee:	324080e7          	jalr	804(ra) # 80000c0e <acquire>
  if(panicked){
    800008f2:	00008797          	auipc	a5,0x8
    800008f6:	22e7a783          	lw	a5,558(a5) # 80008b20 <panicked>
    800008fa:	e7c9                	bnez	a5,80000984 <uartputc+0xb4>
  while(uart_tx_w == uart_tx_r + UART_TX_BUF_SIZE){
    800008fc:	00008797          	auipc	a5,0x8
    80000900:	2347b783          	ld	a5,564(a5) # 80008b30 <uart_tx_w>
    80000904:	00008717          	auipc	a4,0x8
    80000908:	22473703          	ld	a4,548(a4) # 80008b28 <uart_tx_r>
    8000090c:	02070713          	addi	a4,a4,32
    sleep(&uart_tx_r, &uart_tx_lock);
    80000910:	00010a17          	auipc	s4,0x10
    80000914:	468a0a13          	addi	s4,s4,1128 # 80010d78 <uart_tx_lock>
    80000918:	00008497          	auipc	s1,0x8
    8000091c:	21048493          	addi	s1,s1,528 # 80008b28 <uart_tx_r>
  while(uart_tx_w == uart_tx_r + UART_TX_BUF_SIZE){
    80000920:	00008917          	auipc	s2,0x8
    80000924:	21090913          	addi	s2,s2,528 # 80008b30 <uart_tx_w>
    80000928:	00f71f63          	bne	a4,a5,80000946 <uartputc+0x76>
    sleep(&uart_tx_r, &uart_tx_lock);
    8000092c:	85d2                	mv	a1,s4
    8000092e:	8526                	mv	a0,s1
    80000930:	00002097          	auipc	ra,0x2
    80000934:	950080e7          	jalr	-1712(ra) # 80002280 <sleep>
  while(uart_tx_w == uart_tx_r + UART_TX_BUF_SIZE){
    80000938:	00093783          	ld	a5,0(s2)
    8000093c:	6098                	ld	a4,0(s1)
    8000093e:	02070713          	addi	a4,a4,32
    80000942:	fef705e3          	beq	a4,a5,8000092c <uartputc+0x5c>
  uart_tx_buf[uart_tx_w % UART_TX_BUF_SIZE] = c;
    80000946:	00010497          	auipc	s1,0x10
    8000094a:	43248493          	addi	s1,s1,1074 # 80010d78 <uart_tx_lock>
    8000094e:	01f7f713          	andi	a4,a5,31
    80000952:	9726                	add	a4,a4,s1
    80000954:	03370023          	sb	s3,32(a4)
  uart_tx_w += 1;
    80000958:	0785                	addi	a5,a5,1
    8000095a:	00008717          	auipc	a4,0x8
    8000095e:	1cf73b23          	sd	a5,470(a4) # 80008b30 <uart_tx_w>
  uartstart();
    80000962:	00000097          	auipc	ra,0x0
    80000966:	ee4080e7          	jalr	-284(ra) # 80000846 <uartstart>
  release(&uart_tx_lock);
    8000096a:	8526                	mv	a0,s1
    8000096c:	00000097          	auipc	ra,0x0
    80000970:	3fc080e7          	jalr	1020(ra) # 80000d68 <release>
}
    80000974:	70a2                	ld	ra,40(sp)
    80000976:	7402                	ld	s0,32(sp)
    80000978:	64e2                	ld	s1,24(sp)
    8000097a:	6942                	ld	s2,16(sp)
    8000097c:	69a2                	ld	s3,8(sp)
    8000097e:	6a02                	ld	s4,0(sp)
    80000980:	6145                	addi	sp,sp,48
    80000982:	8082                	ret
    for(;;)
    80000984:	a001                	j	80000984 <uartputc+0xb4>

0000000080000986 <uartgetc>:

// read one input character from the UART.
// return -1 if none is waiting.
int
uartgetc(void)
{
    80000986:	1141                	addi	sp,sp,-16
    80000988:	e422                	sd	s0,8(sp)
    8000098a:	0800                	addi	s0,sp,16
  if(ReadReg(LSR) & 0x01){
    8000098c:	100007b7          	lui	a5,0x10000
    80000990:	0057c783          	lbu	a5,5(a5) # 10000005 <_entry-0x6ffffffb>
    80000994:	8b85                	andi	a5,a5,1
    80000996:	cb91                	beqz	a5,800009aa <uartgetc+0x24>
    // input data is ready.
    return ReadReg(RHR);
    80000998:	100007b7          	lui	a5,0x10000
    8000099c:	0007c503          	lbu	a0,0(a5) # 10000000 <_entry-0x70000000>
    800009a0:	0ff57513          	andi	a0,a0,255
  } else {
    return -1;
  }
}
    800009a4:	6422                	ld	s0,8(sp)
    800009a6:	0141                	addi	sp,sp,16
    800009a8:	8082                	ret
    return -1;
    800009aa:	557d                	li	a0,-1
    800009ac:	bfe5                	j	800009a4 <uartgetc+0x1e>

00000000800009ae <uartintr>:
// handle a uart interrupt, raised because input has
// arrived, or the uart is ready for more output, or
// both. called from devintr().
void
uartintr(void)
{
    800009ae:	1101                	addi	sp,sp,-32
    800009b0:	ec06                	sd	ra,24(sp)
    800009b2:	e822                	sd	s0,16(sp)
    800009b4:	e426                	sd	s1,8(sp)
    800009b6:	1000                	addi	s0,sp,32
  // read and process incoming characters.
  while(1){
    int c = uartgetc();
    if(c == -1)
    800009b8:	54fd                	li	s1,-1
    int c = uartgetc();
    800009ba:	00000097          	auipc	ra,0x0
    800009be:	fcc080e7          	jalr	-52(ra) # 80000986 <uartgetc>
    if(c == -1)
    800009c2:	00950763          	beq	a0,s1,800009d0 <uartintr+0x22>
      break;
    consoleintr(c);
    800009c6:	00000097          	auipc	ra,0x0
    800009ca:	8fe080e7          	jalr	-1794(ra) # 800002c4 <consoleintr>
  while(1){
    800009ce:	b7f5                	j	800009ba <uartintr+0xc>
  }

  // send buffered characters.
  acquire(&uart_tx_lock);
    800009d0:	00010497          	auipc	s1,0x10
    800009d4:	3a848493          	addi	s1,s1,936 # 80010d78 <uart_tx_lock>
    800009d8:	8526                	mv	a0,s1
    800009da:	00000097          	auipc	ra,0x0
    800009de:	234080e7          	jalr	564(ra) # 80000c0e <acquire>
  uartstart();
    800009e2:	00000097          	auipc	ra,0x0
    800009e6:	e64080e7          	jalr	-412(ra) # 80000846 <uartstart>
  release(&uart_tx_lock);
    800009ea:	8526                	mv	a0,s1
    800009ec:	00000097          	auipc	ra,0x0
    800009f0:	37c080e7          	jalr	892(ra) # 80000d68 <release>
}
    800009f4:	60e2                	ld	ra,24(sp)
    800009f6:	6442                	ld	s0,16(sp)
    800009f8:	64a2                	ld	s1,8(sp)
    800009fa:	6105                	addi	sp,sp,32
    800009fc:	8082                	ret

00000000800009fe <kfree>:
// which normally should have been returned by a
// call to kalloc().  (The exception is when
// initializing the allocator; see kinit above.)
void
kfree(void *pa)
{
    800009fe:	1101                	addi	sp,sp,-32
    80000a00:	ec06                	sd	ra,24(sp)
    80000a02:	e822                	sd	s0,16(sp)
    80000a04:	e426                	sd	s1,8(sp)
    80000a06:	e04a                	sd	s2,0(sp)
    80000a08:	1000                	addi	s0,sp,32
  struct run *r;

  if(((uint64)pa % PGSIZE) != 0 || (char*)pa < end || (uint64)pa >= PHYSTOP)
    80000a0a:	03451793          	slli	a5,a0,0x34
    80000a0e:	ebb9                	bnez	a5,80000a64 <kfree+0x66>
    80000a10:	84aa                	mv	s1,a0
    80000a12:	00022797          	auipc	a5,0x22
    80000a16:	ea678793          	addi	a5,a5,-346 # 800228b8 <end>
    80000a1a:	04f56563          	bltu	a0,a5,80000a64 <kfree+0x66>
    80000a1e:	47c5                	li	a5,17
    80000a20:	07ee                	slli	a5,a5,0x1b
    80000a22:	04f57163          	bgeu	a0,a5,80000a64 <kfree+0x66>
    panic("kfree");

  // Fill with junk to catch dangling refs.
  memset(pa, 1, PGSIZE);
    80000a26:	6605                	lui	a2,0x1
    80000a28:	4585                	li	a1,1
    80000a2a:	00000097          	auipc	ra,0x0
    80000a2e:	38c080e7          	jalr	908(ra) # 80000db6 <memset>

  r = (struct run*)pa;

  acquire(&kmem.lock);
    80000a32:	00010917          	auipc	s2,0x10
    80000a36:	38690913          	addi	s2,s2,902 # 80010db8 <kmem>
    80000a3a:	854a                	mv	a0,s2
    80000a3c:	00000097          	auipc	ra,0x0
    80000a40:	1d2080e7          	jalr	466(ra) # 80000c0e <acquire>
  r->next = kmem.freelist;
    80000a44:	02093783          	ld	a5,32(s2)
    80000a48:	e09c                	sd	a5,0(s1)
  kmem.freelist = r;
    80000a4a:	02993023          	sd	s1,32(s2)
  release(&kmem.lock);
    80000a4e:	854a                	mv	a0,s2
    80000a50:	00000097          	auipc	ra,0x0
    80000a54:	318080e7          	jalr	792(ra) # 80000d68 <release>
}
    80000a58:	60e2                	ld	ra,24(sp)
    80000a5a:	6442                	ld	s0,16(sp)
    80000a5c:	64a2                	ld	s1,8(sp)
    80000a5e:	6902                	ld	s2,0(sp)
    80000a60:	6105                	addi	sp,sp,32
    80000a62:	8082                	ret
    panic("kfree");
    80000a64:	00007517          	auipc	a0,0x7
    80000a68:	5fc50513          	addi	a0,a0,1532 # 80008060 <digits+0x20>
    80000a6c:	00000097          	auipc	ra,0x0
    80000a70:	ad8080e7          	jalr	-1320(ra) # 80000544 <panic>

0000000080000a74 <freerange>:
{
    80000a74:	7179                	addi	sp,sp,-48
    80000a76:	f406                	sd	ra,40(sp)
    80000a78:	f022                	sd	s0,32(sp)
    80000a7a:	ec26                	sd	s1,24(sp)
    80000a7c:	e84a                	sd	s2,16(sp)
    80000a7e:	e44e                	sd	s3,8(sp)
    80000a80:	e052                	sd	s4,0(sp)
    80000a82:	1800                	addi	s0,sp,48
  p = (char*)PGROUNDUP((uint64)pa_start);
    80000a84:	6785                	lui	a5,0x1
    80000a86:	fff78493          	addi	s1,a5,-1 # fff <_entry-0x7ffff001>
    80000a8a:	94aa                	add	s1,s1,a0
    80000a8c:	757d                	lui	a0,0xfffff
    80000a8e:	8ce9                	and	s1,s1,a0
  for(; p + PGSIZE <= (char*)pa_end; p += PGSIZE)
    80000a90:	94be                	add	s1,s1,a5
    80000a92:	0095ee63          	bltu	a1,s1,80000aae <freerange+0x3a>
    80000a96:	892e                	mv	s2,a1
    kfree(p);
    80000a98:	7a7d                	lui	s4,0xfffff
  for(; p + PGSIZE <= (char*)pa_end; p += PGSIZE)
    80000a9a:	6985                	lui	s3,0x1
    kfree(p);
    80000a9c:	01448533          	add	a0,s1,s4
    80000aa0:	00000097          	auipc	ra,0x0
    80000aa4:	f5e080e7          	jalr	-162(ra) # 800009fe <kfree>
  for(; p + PGSIZE <= (char*)pa_end; p += PGSIZE)
    80000aa8:	94ce                	add	s1,s1,s3
    80000aaa:	fe9979e3          	bgeu	s2,s1,80000a9c <freerange+0x28>
}
    80000aae:	70a2                	ld	ra,40(sp)
    80000ab0:	7402                	ld	s0,32(sp)
    80000ab2:	64e2                	ld	s1,24(sp)
    80000ab4:	6942                	ld	s2,16(sp)
    80000ab6:	69a2                	ld	s3,8(sp)
    80000ab8:	6a02                	ld	s4,0(sp)
    80000aba:	6145                	addi	sp,sp,48
    80000abc:	8082                	ret

0000000080000abe <kinit>:
{
    80000abe:	1141                	addi	sp,sp,-16
    80000ac0:	e406                	sd	ra,8(sp)
    80000ac2:	e022                	sd	s0,0(sp)
    80000ac4:	0800                	addi	s0,sp,16
  initlock(&kmem.lock, "kmem");
    80000ac6:	00007597          	auipc	a1,0x7
    80000aca:	5a258593          	addi	a1,a1,1442 # 80008068 <digits+0x28>
    80000ace:	00010517          	auipc	a0,0x10
    80000ad2:	2ea50513          	addi	a0,a0,746 # 80010db8 <kmem>
    80000ad6:	00000097          	auipc	ra,0x0
    80000ada:	0ce080e7          	jalr	206(ra) # 80000ba4 <initlock>
  freerange(end, (void*)PHYSTOP);
    80000ade:	45c5                	li	a1,17
    80000ae0:	05ee                	slli	a1,a1,0x1b
    80000ae2:	00022517          	auipc	a0,0x22
    80000ae6:	dd650513          	addi	a0,a0,-554 # 800228b8 <end>
    80000aea:	00000097          	auipc	ra,0x0
    80000aee:	f8a080e7          	jalr	-118(ra) # 80000a74 <freerange>
}
    80000af2:	60a2                	ld	ra,8(sp)
    80000af4:	6402                	ld	s0,0(sp)
    80000af6:	0141                	addi	sp,sp,16
    80000af8:	8082                	ret

0000000080000afa <kalloc>:
// Allocate one 4096-byte page of physical memory.
// Returns a pointer that the kernel can use.
// Returns 0 if the memory cannot be allocated.
void *
kalloc(void)
{
    80000afa:	1101                	addi	sp,sp,-32
    80000afc:	ec06                	sd	ra,24(sp)
    80000afe:	e822                	sd	s0,16(sp)
    80000b00:	e426                	sd	s1,8(sp)
    80000b02:	1000                	addi	s0,sp,32
  struct run *r;

  acquire(&kmem.lock);
    80000b04:	00010497          	auipc	s1,0x10
    80000b08:	2b448493          	addi	s1,s1,692 # 80010db8 <kmem>
    80000b0c:	8526                	mv	a0,s1
    80000b0e:	00000097          	auipc	ra,0x0
    80000b12:	100080e7          	jalr	256(ra) # 80000c0e <acquire>
  r = kmem.freelist;
    80000b16:	7084                	ld	s1,32(s1)
  if(r)
    80000b18:	c885                	beqz	s1,80000b48 <kalloc+0x4e>
    kmem.freelist = r->next;
    80000b1a:	609c                	ld	a5,0(s1)
    80000b1c:	00010517          	auipc	a0,0x10
    80000b20:	29c50513          	addi	a0,a0,668 # 80010db8 <kmem>
    80000b24:	f11c                	sd	a5,32(a0)
  release(&kmem.lock);
    80000b26:	00000097          	auipc	ra,0x0
    80000b2a:	242080e7          	jalr	578(ra) # 80000d68 <release>

  if(r)
    memset((char*)r, 5, PGSIZE); // fill with junk
    80000b2e:	6605                	lui	a2,0x1
    80000b30:	4595                	li	a1,5
    80000b32:	8526                	mv	a0,s1
    80000b34:	00000097          	auipc	ra,0x0
    80000b38:	282080e7          	jalr	642(ra) # 80000db6 <memset>
  return (void*)r;
}
    80000b3c:	8526                	mv	a0,s1
    80000b3e:	60e2                	ld	ra,24(sp)
    80000b40:	6442                	ld	s0,16(sp)
    80000b42:	64a2                	ld	s1,8(sp)
    80000b44:	6105                	addi	sp,sp,32
    80000b46:	8082                	ret
  release(&kmem.lock);
    80000b48:	00010517          	auipc	a0,0x10
    80000b4c:	27050513          	addi	a0,a0,624 # 80010db8 <kmem>
    80000b50:	00000097          	auipc	ra,0x0
    80000b54:	218080e7          	jalr	536(ra) # 80000d68 <release>
  if(r)
    80000b58:	b7d5                	j	80000b3c <kalloc+0x42>

0000000080000b5a <freemem>:

// get free memory
uint64
freemem(void)
{
    80000b5a:	1101                	addi	sp,sp,-32
    80000b5c:	ec06                	sd	ra,24(sp)
    80000b5e:	e822                	sd	s0,16(sp)
    80000b60:	e426                	sd	s1,8(sp)
    80000b62:	1000                	addi	s0,sp,32
  uint64 counter = 0;
  struct run *r;
  acquire(&kmem.lock);  // 上锁
    80000b64:	00010497          	auipc	s1,0x10
    80000b68:	25448493          	addi	s1,s1,596 # 80010db8 <kmem>
    80000b6c:	8526                	mv	a0,s1
    80000b6e:	00000097          	auipc	ra,0x0
    80000b72:	0a0080e7          	jalr	160(ra) # 80000c0e <acquire>
  r = kmem.freelist;    // 空闲块链表
    80000b76:	709c                	ld	a5,32(s1)
  while(r){    // 遍历空闲块链表，统计空闲块块数
    80000b78:	c785                	beqz	a5,80000ba0 <freemem+0x46>
  uint64 counter = 0;
    80000b7a:	4481                	li	s1,0
    r = r->next;
    80000b7c:	639c                	ld	a5,0(a5)
    ++counter;
    80000b7e:	0485                	addi	s1,s1,1
  while(r){    // 遍历空闲块链表，统计空闲块块数
    80000b80:	fff5                	bnez	a5,80000b7c <freemem+0x22>
  }
  release(&kmem.lock); // 释放自旋锁
    80000b82:	00010517          	auipc	a0,0x10
    80000b86:	23650513          	addi	a0,a0,566 # 80010db8 <kmem>
    80000b8a:	00000097          	auipc	ra,0x0
    80000b8e:	1de080e7          	jalr	478(ra) # 80000d68 <release>
  return counter * PGSIZE; // 返回空闲存储空间大小，单位字节（B）
}
    80000b92:	00c49513          	slli	a0,s1,0xc
    80000b96:	60e2                	ld	ra,24(sp)
    80000b98:	6442                	ld	s0,16(sp)
    80000b9a:	64a2                	ld	s1,8(sp)
    80000b9c:	6105                	addi	sp,sp,32
    80000b9e:	8082                	ret
  uint64 counter = 0;
    80000ba0:	4481                	li	s1,0
    80000ba2:	b7c5                	j	80000b82 <freemem+0x28>

0000000080000ba4 <initlock>:
*/

// 初始化 next_ticket 和 current_ticket。
void
initlock(struct spinlock *lk, char *name)
{
    80000ba4:	1141                	addi	sp,sp,-16
    80000ba6:	e422                	sd	s0,8(sp)
    80000ba8:	0800                	addi	s0,sp,16
  lk->locked = 0;
    80000baa:	00052023          	sw	zero,0(a0)
  lk->name = name;
    80000bae:	e50c                	sd	a1,8(a0)
  lk->cpu = 0;
    80000bb0:	00053823          	sd	zero,16(a0)

  // Initialize ticket lock fields
  lk->next_ticket = 0;
    80000bb4:	00052c23          	sw	zero,24(a0)
  lk->current_ticket = 0;
    80000bb8:	00052e23          	sw	zero,28(a0)
}
    80000bbc:	6422                	ld	s0,8(sp)
    80000bbe:	0141                	addi	sp,sp,16
    80000bc0:	8082                	ret

0000000080000bc2 <push_off>:
// it takes two pop_off()s to undo two push_off()s.  Also, if interrupts
// are initially off, then push_off, pop_off leaves them off.

void
push_off(void)
{
    80000bc2:	1101                	addi	sp,sp,-32
    80000bc4:	ec06                	sd	ra,24(sp)
    80000bc6:	e822                	sd	s0,16(sp)
    80000bc8:	e426                	sd	s1,8(sp)
    80000bca:	1000                	addi	s0,sp,32
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80000bcc:	100024f3          	csrr	s1,sstatus
    80000bd0:	100027f3          	csrr	a5,sstatus
  w_sstatus(r_sstatus() & ~SSTATUS_SIE);
    80000bd4:	9bf5                	andi	a5,a5,-3
  asm volatile("csrw sstatus, %0" : : "r" (x));
    80000bd6:	10079073          	csrw	sstatus,a5
  int old = intr_get();

  intr_off();
  if(mycpu()->noff == 0)
    80000bda:	00001097          	auipc	ra,0x1
    80000bde:	ea0080e7          	jalr	-352(ra) # 80001a7a <mycpu>
    80000be2:	5d3c                	lw	a5,120(a0)
    80000be4:	cf89                	beqz	a5,80000bfe <push_off+0x3c>
    mycpu()->intena = old;
  mycpu()->noff += 1;
    80000be6:	00001097          	auipc	ra,0x1
    80000bea:	e94080e7          	jalr	-364(ra) # 80001a7a <mycpu>
    80000bee:	5d3c                	lw	a5,120(a0)
    80000bf0:	2785                	addiw	a5,a5,1
    80000bf2:	dd3c                	sw	a5,120(a0)
}
    80000bf4:	60e2                	ld	ra,24(sp)
    80000bf6:	6442                	ld	s0,16(sp)
    80000bf8:	64a2                	ld	s1,8(sp)
    80000bfa:	6105                	addi	sp,sp,32
    80000bfc:	8082                	ret
    mycpu()->intena = old;
    80000bfe:	00001097          	auipc	ra,0x1
    80000c02:	e7c080e7          	jalr	-388(ra) # 80001a7a <mycpu>
  return (x & SSTATUS_SIE) != 0;
    80000c06:	8085                	srli	s1,s1,0x1
    80000c08:	8885                	andi	s1,s1,1
    80000c0a:	dd64                	sw	s1,124(a0)
    80000c0c:	bfe9                	j	80000be6 <push_off+0x24>

0000000080000c0e <acquire>:
{
    80000c0e:	7179                	addi	sp,sp,-48
    80000c10:	f406                	sd	ra,40(sp)
    80000c12:	f022                	sd	s0,32(sp)
    80000c14:	ec26                	sd	s1,24(sp)
    80000c16:	1800                	addi	s0,sp,48
    80000c18:	84aa                	mv	s1,a0
  push_off(); // Disable interrupts to avoid deadlock.
    80000c1a:	00000097          	auipc	ra,0x0
    80000c1e:	fa8080e7          	jalr	-88(ra) # 80000bc2 <push_off>
  my_ticket = __sync_fetch_and_add(&lk->next_ticket, 1);
    80000c22:	4785                	li	a5,1
    80000c24:	01848713          	addi	a4,s1,24
    80000c28:	0f50000f          	fence	iorw,ow
    80000c2c:	04f7262f          	amoadd.w.aq	a2,a5,(a4)
    80000c30:	2601                	sext.w	a2,a2
    for (volatile int delay = 1; delay < 1024; delay *= 2) {
    80000c32:	4585                	li	a1,1
    80000c34:	3ff00693          	li	a3,1023
  while (__sync_val_compare_and_swap(&lk->current_ticket, my_ticket, my_ticket) != my_ticket) {
    80000c38:	01c48713          	addi	a4,s1,28
    80000c3c:	0f50000f          	fence	iorw,ow
    80000c40:	140727af          	lr.w.aq	a5,(a4)
    80000c44:	00c79563          	bne	a5,a2,80000c4e <acquire+0x40>
    80000c48:	1cc7252f          	sc.w.aq	a0,a2,(a4)
    80000c4c:	f975                	bnez	a0,80000c40 <acquire+0x32>
    80000c4e:	2781                	sext.w	a5,a5
    80000c50:	04c78e63          	beq	a5,a2,80000cac <acquire+0x9e>
    for (volatile int delay = 1; delay < 1024; delay *= 2) {
    80000c54:	fcb42c23          	sw	a1,-40(s0)
    80000c58:	fd842783          	lw	a5,-40(s0)
    80000c5c:	2781                	sext.w	a5,a5
    80000c5e:	00f6de63          	bge	a3,a5,80000c7a <acquire+0x6c>
    80000c62:	bfd9                	j	80000c38 <acquire+0x2a>
    80000c64:	fd842783          	lw	a5,-40(s0)
    80000c68:	0017979b          	slliw	a5,a5,0x1
    80000c6c:	fcf42c23          	sw	a5,-40(s0)
    80000c70:	fd842783          	lw	a5,-40(s0)
    80000c74:	2781                	sext.w	a5,a5
    80000c76:	fcf6c1e3          	blt	a3,a5,80000c38 <acquire+0x2a>
      for (volatile int i = 0; i < delay; i++) {
    80000c7a:	fc042e23          	sw	zero,-36(s0)
    80000c7e:	fdc42703          	lw	a4,-36(s0)
    80000c82:	2701                	sext.w	a4,a4
    80000c84:	fd842783          	lw	a5,-40(s0)
    80000c88:	2781                	sext.w	a5,a5
    80000c8a:	fcf75de3          	bge	a4,a5,80000c64 <acquire+0x56>
        __asm__ volatile("nop");
    80000c8e:	0001                	nop
      for (volatile int i = 0; i < delay; i++) {
    80000c90:	fdc42783          	lw	a5,-36(s0)
    80000c94:	2785                	addiw	a5,a5,1
    80000c96:	fcf42e23          	sw	a5,-36(s0)
    80000c9a:	fdc42703          	lw	a4,-36(s0)
    80000c9e:	2701                	sext.w	a4,a4
    80000ca0:	fd842783          	lw	a5,-40(s0)
    80000ca4:	2781                	sext.w	a5,a5
    80000ca6:	fef744e3          	blt	a4,a5,80000c8e <acquire+0x80>
    80000caa:	bf6d                	j	80000c64 <acquire+0x56>
  __sync_synchronize(); // Prevent memory reordering.
    80000cac:	0ff0000f          	fence
  lk->cpu = mycpu();
    80000cb0:	00001097          	auipc	ra,0x1
    80000cb4:	dca080e7          	jalr	-566(ra) # 80001a7a <mycpu>
    80000cb8:	e888                	sd	a0,16(s1)
}
    80000cba:	70a2                	ld	ra,40(sp)
    80000cbc:	7402                	ld	s0,32(sp)
    80000cbe:	64e2                	ld	s1,24(sp)
    80000cc0:	6145                	addi	sp,sp,48
    80000cc2:	8082                	ret

0000000080000cc4 <pop_off>:

void
pop_off(void)
{
    80000cc4:	1141                	addi	sp,sp,-16
    80000cc6:	e406                	sd	ra,8(sp)
    80000cc8:	e022                	sd	s0,0(sp)
    80000cca:	0800                	addi	s0,sp,16
  struct cpu *c = mycpu();
    80000ccc:	00001097          	auipc	ra,0x1
    80000cd0:	dae080e7          	jalr	-594(ra) # 80001a7a <mycpu>
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80000cd4:	100027f3          	csrr	a5,sstatus
  return (x & SSTATUS_SIE) != 0;
    80000cd8:	8b89                	andi	a5,a5,2
  if(intr_get())
    80000cda:	e78d                	bnez	a5,80000d04 <pop_off+0x40>
    panic("pop_off - interruptible");
  if(c->noff < 1)
    80000cdc:	5d3c                	lw	a5,120(a0)
    80000cde:	02f05b63          	blez	a5,80000d14 <pop_off+0x50>
    panic("pop_off");
  c->noff -= 1;
    80000ce2:	37fd                	addiw	a5,a5,-1
    80000ce4:	0007871b          	sext.w	a4,a5
    80000ce8:	dd3c                	sw	a5,120(a0)
  if(c->noff == 0 && c->intena)
    80000cea:	eb09                	bnez	a4,80000cfc <pop_off+0x38>
    80000cec:	5d7c                	lw	a5,124(a0)
    80000cee:	c799                	beqz	a5,80000cfc <pop_off+0x38>
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80000cf0:	100027f3          	csrr	a5,sstatus
  w_sstatus(r_sstatus() | SSTATUS_SIE);
    80000cf4:	0027e793          	ori	a5,a5,2
  asm volatile("csrw sstatus, %0" : : "r" (x));
    80000cf8:	10079073          	csrw	sstatus,a5
    intr_on();
}
    80000cfc:	60a2                	ld	ra,8(sp)
    80000cfe:	6402                	ld	s0,0(sp)
    80000d00:	0141                	addi	sp,sp,16
    80000d02:	8082                	ret
    panic("pop_off - interruptible");
    80000d04:	00007517          	auipc	a0,0x7
    80000d08:	36c50513          	addi	a0,a0,876 # 80008070 <digits+0x30>
    80000d0c:	00000097          	auipc	ra,0x0
    80000d10:	838080e7          	jalr	-1992(ra) # 80000544 <panic>
    panic("pop_off");
    80000d14:	00007517          	auipc	a0,0x7
    80000d18:	37450513          	addi	a0,a0,884 # 80008088 <digits+0x48>
    80000d1c:	00000097          	auipc	ra,0x0
    80000d20:	828080e7          	jalr	-2008(ra) # 80000544 <panic>

0000000080000d24 <holding>:
{
    80000d24:	1101                	addi	sp,sp,-32
    80000d26:	ec06                	sd	ra,24(sp)
    80000d28:	e822                	sd	s0,16(sp)
    80000d2a:	e426                	sd	s1,8(sp)
    80000d2c:	1000                	addi	s0,sp,32
    80000d2e:	84aa                	mv	s1,a0
  push_off();
    80000d30:	00000097          	auipc	ra,0x0
    80000d34:	e92080e7          	jalr	-366(ra) # 80000bc2 <push_off>
  r = (lk->current_ticket != lk->next_ticket) && (lk->cpu == mycpu());
    80000d38:	4cd8                	lw	a4,28(s1)
    80000d3a:	4c9c                	lw	a5,24(s1)
    80000d3c:	00f71d63          	bne	a4,a5,80000d56 <holding+0x32>
    80000d40:	4481                	li	s1,0
  pop_off();
    80000d42:	00000097          	auipc	ra,0x0
    80000d46:	f82080e7          	jalr	-126(ra) # 80000cc4 <pop_off>
}
    80000d4a:	8526                	mv	a0,s1
    80000d4c:	60e2                	ld	ra,24(sp)
    80000d4e:	6442                	ld	s0,16(sp)
    80000d50:	64a2                	ld	s1,8(sp)
    80000d52:	6105                	addi	sp,sp,32
    80000d54:	8082                	ret
  r = (lk->current_ticket != lk->next_ticket) && (lk->cpu == mycpu());
    80000d56:	6884                	ld	s1,16(s1)
    80000d58:	00001097          	auipc	ra,0x1
    80000d5c:	d22080e7          	jalr	-734(ra) # 80001a7a <mycpu>
    80000d60:	8c89                	sub	s1,s1,a0
    80000d62:	0014b493          	seqz	s1,s1
    80000d66:	bff1                	j	80000d42 <holding+0x1e>

0000000080000d68 <release>:
{
    80000d68:	1101                	addi	sp,sp,-32
    80000d6a:	ec06                	sd	ra,24(sp)
    80000d6c:	e822                	sd	s0,16(sp)
    80000d6e:	e426                	sd	s1,8(sp)
    80000d70:	1000                	addi	s0,sp,32
    80000d72:	84aa                	mv	s1,a0
  if (!holding(lk))
    80000d74:	00000097          	auipc	ra,0x0
    80000d78:	fb0080e7          	jalr	-80(ra) # 80000d24 <holding>
    80000d7c:	c50d                	beqz	a0,80000da6 <release+0x3e>
  __sync_fetch_and_add(&lk->current_ticket, 1);
    80000d7e:	4785                	li	a5,1
    80000d80:	01c48713          	addi	a4,s1,28
    80000d84:	0f50000f          	fence	iorw,ow
    80000d88:	04f7202f          	amoadd.w.aq	zero,a5,(a4)
  lk->cpu = 0;
    80000d8c:	0004b823          	sd	zero,16(s1)
  __sync_synchronize(); // Prevent memory reordering.
    80000d90:	0ff0000f          	fence
  pop_off(); // Re-enable interrupts.
    80000d94:	00000097          	auipc	ra,0x0
    80000d98:	f30080e7          	jalr	-208(ra) # 80000cc4 <pop_off>
}
    80000d9c:	60e2                	ld	ra,24(sp)
    80000d9e:	6442                	ld	s0,16(sp)
    80000da0:	64a2                	ld	s1,8(sp)
    80000da2:	6105                	addi	sp,sp,32
    80000da4:	8082                	ret
    panic("release");
    80000da6:	00007517          	auipc	a0,0x7
    80000daa:	2ea50513          	addi	a0,a0,746 # 80008090 <digits+0x50>
    80000dae:	fffff097          	auipc	ra,0xfffff
    80000db2:	796080e7          	jalr	1942(ra) # 80000544 <panic>

0000000080000db6 <memset>:
#include "types.h"

void*
memset(void *dst, int c, uint n)
{
    80000db6:	1141                	addi	sp,sp,-16
    80000db8:	e422                	sd	s0,8(sp)
    80000dba:	0800                	addi	s0,sp,16
  char *cdst = (char *) dst;
  int i;
  for(i = 0; i < n; i++){
    80000dbc:	ce09                	beqz	a2,80000dd6 <memset+0x20>
    80000dbe:	87aa                	mv	a5,a0
    80000dc0:	fff6071b          	addiw	a4,a2,-1
    80000dc4:	1702                	slli	a4,a4,0x20
    80000dc6:	9301                	srli	a4,a4,0x20
    80000dc8:	0705                	addi	a4,a4,1
    80000dca:	972a                	add	a4,a4,a0
    cdst[i] = c;
    80000dcc:	00b78023          	sb	a1,0(a5)
  for(i = 0; i < n; i++){
    80000dd0:	0785                	addi	a5,a5,1
    80000dd2:	fee79de3          	bne	a5,a4,80000dcc <memset+0x16>
  }
  return dst;
}
    80000dd6:	6422                	ld	s0,8(sp)
    80000dd8:	0141                	addi	sp,sp,16
    80000dda:	8082                	ret

0000000080000ddc <memcmp>:

int
memcmp(const void *v1, const void *v2, uint n)
{
    80000ddc:	1141                	addi	sp,sp,-16
    80000dde:	e422                	sd	s0,8(sp)
    80000de0:	0800                	addi	s0,sp,16
  const uchar *s1, *s2;

  s1 = v1;
  s2 = v2;
  while(n-- > 0){
    80000de2:	ca05                	beqz	a2,80000e12 <memcmp+0x36>
    80000de4:	fff6069b          	addiw	a3,a2,-1
    80000de8:	1682                	slli	a3,a3,0x20
    80000dea:	9281                	srli	a3,a3,0x20
    80000dec:	0685                	addi	a3,a3,1
    80000dee:	96aa                	add	a3,a3,a0
    if(*s1 != *s2)
    80000df0:	00054783          	lbu	a5,0(a0)
    80000df4:	0005c703          	lbu	a4,0(a1)
    80000df8:	00e79863          	bne	a5,a4,80000e08 <memcmp+0x2c>
      return *s1 - *s2;
    s1++, s2++;
    80000dfc:	0505                	addi	a0,a0,1
    80000dfe:	0585                	addi	a1,a1,1
  while(n-- > 0){
    80000e00:	fed518e3          	bne	a0,a3,80000df0 <memcmp+0x14>
  }

  return 0;
    80000e04:	4501                	li	a0,0
    80000e06:	a019                	j	80000e0c <memcmp+0x30>
      return *s1 - *s2;
    80000e08:	40e7853b          	subw	a0,a5,a4
}
    80000e0c:	6422                	ld	s0,8(sp)
    80000e0e:	0141                	addi	sp,sp,16
    80000e10:	8082                	ret
  return 0;
    80000e12:	4501                	li	a0,0
    80000e14:	bfe5                	j	80000e0c <memcmp+0x30>

0000000080000e16 <memmove>:

void*
memmove(void *dst, const void *src, uint n)
{
    80000e16:	1141                	addi	sp,sp,-16
    80000e18:	e422                	sd	s0,8(sp)
    80000e1a:	0800                	addi	s0,sp,16
  const char *s;
  char *d;

  if(n == 0)
    80000e1c:	ca0d                	beqz	a2,80000e4e <memmove+0x38>
    return dst;
  
  s = src;
  d = dst;
  if(s < d && s + n > d){
    80000e1e:	00a5f963          	bgeu	a1,a0,80000e30 <memmove+0x1a>
    80000e22:	02061693          	slli	a3,a2,0x20
    80000e26:	9281                	srli	a3,a3,0x20
    80000e28:	00d58733          	add	a4,a1,a3
    80000e2c:	02e56463          	bltu	a0,a4,80000e54 <memmove+0x3e>
    s += n;
    d += n;
    while(n-- > 0)
      *--d = *--s;
  } else
    while(n-- > 0)
    80000e30:	fff6079b          	addiw	a5,a2,-1
    80000e34:	1782                	slli	a5,a5,0x20
    80000e36:	9381                	srli	a5,a5,0x20
    80000e38:	0785                	addi	a5,a5,1
    80000e3a:	97ae                	add	a5,a5,a1
    80000e3c:	872a                	mv	a4,a0
      *d++ = *s++;
    80000e3e:	0585                	addi	a1,a1,1
    80000e40:	0705                	addi	a4,a4,1
    80000e42:	fff5c683          	lbu	a3,-1(a1)
    80000e46:	fed70fa3          	sb	a3,-1(a4)
    while(n-- > 0)
    80000e4a:	fef59ae3          	bne	a1,a5,80000e3e <memmove+0x28>

  return dst;
}
    80000e4e:	6422                	ld	s0,8(sp)
    80000e50:	0141                	addi	sp,sp,16
    80000e52:	8082                	ret
    d += n;
    80000e54:	96aa                	add	a3,a3,a0
    while(n-- > 0)
    80000e56:	fff6079b          	addiw	a5,a2,-1
    80000e5a:	1782                	slli	a5,a5,0x20
    80000e5c:	9381                	srli	a5,a5,0x20
    80000e5e:	fff7c793          	not	a5,a5
    80000e62:	97ba                	add	a5,a5,a4
      *--d = *--s;
    80000e64:	177d                	addi	a4,a4,-1
    80000e66:	16fd                	addi	a3,a3,-1
    80000e68:	00074603          	lbu	a2,0(a4)
    80000e6c:	00c68023          	sb	a2,0(a3)
    while(n-- > 0)
    80000e70:	fef71ae3          	bne	a4,a5,80000e64 <memmove+0x4e>
    80000e74:	bfe9                	j	80000e4e <memmove+0x38>

0000000080000e76 <memcpy>:

// memcpy exists to placate GCC.  Use memmove.
void*
memcpy(void *dst, const void *src, uint n)
{
    80000e76:	1141                	addi	sp,sp,-16
    80000e78:	e406                	sd	ra,8(sp)
    80000e7a:	e022                	sd	s0,0(sp)
    80000e7c:	0800                	addi	s0,sp,16
  return memmove(dst, src, n);
    80000e7e:	00000097          	auipc	ra,0x0
    80000e82:	f98080e7          	jalr	-104(ra) # 80000e16 <memmove>
}
    80000e86:	60a2                	ld	ra,8(sp)
    80000e88:	6402                	ld	s0,0(sp)
    80000e8a:	0141                	addi	sp,sp,16
    80000e8c:	8082                	ret

0000000080000e8e <strncmp>:

int
strncmp(const char *p, const char *q, uint n)
{
    80000e8e:	1141                	addi	sp,sp,-16
    80000e90:	e422                	sd	s0,8(sp)
    80000e92:	0800                	addi	s0,sp,16
  while(n > 0 && *p && *p == *q)
    80000e94:	ce11                	beqz	a2,80000eb0 <strncmp+0x22>
    80000e96:	00054783          	lbu	a5,0(a0)
    80000e9a:	cf89                	beqz	a5,80000eb4 <strncmp+0x26>
    80000e9c:	0005c703          	lbu	a4,0(a1)
    80000ea0:	00f71a63          	bne	a4,a5,80000eb4 <strncmp+0x26>
    n--, p++, q++;
    80000ea4:	367d                	addiw	a2,a2,-1
    80000ea6:	0505                	addi	a0,a0,1
    80000ea8:	0585                	addi	a1,a1,1
  while(n > 0 && *p && *p == *q)
    80000eaa:	f675                	bnez	a2,80000e96 <strncmp+0x8>
  if(n == 0)
    return 0;
    80000eac:	4501                	li	a0,0
    80000eae:	a809                	j	80000ec0 <strncmp+0x32>
    80000eb0:	4501                	li	a0,0
    80000eb2:	a039                	j	80000ec0 <strncmp+0x32>
  if(n == 0)
    80000eb4:	ca09                	beqz	a2,80000ec6 <strncmp+0x38>
  return (uchar)*p - (uchar)*q;
    80000eb6:	00054503          	lbu	a0,0(a0)
    80000eba:	0005c783          	lbu	a5,0(a1)
    80000ebe:	9d1d                	subw	a0,a0,a5
}
    80000ec0:	6422                	ld	s0,8(sp)
    80000ec2:	0141                	addi	sp,sp,16
    80000ec4:	8082                	ret
    return 0;
    80000ec6:	4501                	li	a0,0
    80000ec8:	bfe5                	j	80000ec0 <strncmp+0x32>

0000000080000eca <strncpy>:

char*
strncpy(char *s, const char *t, int n)
{
    80000eca:	1141                	addi	sp,sp,-16
    80000ecc:	e422                	sd	s0,8(sp)
    80000ece:	0800                	addi	s0,sp,16
  char *os;

  os = s;
  while(n-- > 0 && (*s++ = *t++) != 0)
    80000ed0:	872a                	mv	a4,a0
    80000ed2:	8832                	mv	a6,a2
    80000ed4:	367d                	addiw	a2,a2,-1
    80000ed6:	01005963          	blez	a6,80000ee8 <strncpy+0x1e>
    80000eda:	0705                	addi	a4,a4,1
    80000edc:	0005c783          	lbu	a5,0(a1)
    80000ee0:	fef70fa3          	sb	a5,-1(a4)
    80000ee4:	0585                	addi	a1,a1,1
    80000ee6:	f7f5                	bnez	a5,80000ed2 <strncpy+0x8>
    ;
  while(n-- > 0)
    80000ee8:	00c05d63          	blez	a2,80000f02 <strncpy+0x38>
    80000eec:	86ba                	mv	a3,a4
    *s++ = 0;
    80000eee:	0685                	addi	a3,a3,1
    80000ef0:	fe068fa3          	sb	zero,-1(a3)
  while(n-- > 0)
    80000ef4:	fff6c793          	not	a5,a3
    80000ef8:	9fb9                	addw	a5,a5,a4
    80000efa:	010787bb          	addw	a5,a5,a6
    80000efe:	fef048e3          	bgtz	a5,80000eee <strncpy+0x24>
  return os;
}
    80000f02:	6422                	ld	s0,8(sp)
    80000f04:	0141                	addi	sp,sp,16
    80000f06:	8082                	ret

0000000080000f08 <safestrcpy>:

// Like strncpy but guaranteed to NUL-terminate.
char*
safestrcpy(char *s, const char *t, int n)
{
    80000f08:	1141                	addi	sp,sp,-16
    80000f0a:	e422                	sd	s0,8(sp)
    80000f0c:	0800                	addi	s0,sp,16
  char *os;

  os = s;
  if(n <= 0)
    80000f0e:	02c05363          	blez	a2,80000f34 <safestrcpy+0x2c>
    80000f12:	fff6069b          	addiw	a3,a2,-1
    80000f16:	1682                	slli	a3,a3,0x20
    80000f18:	9281                	srli	a3,a3,0x20
    80000f1a:	96ae                	add	a3,a3,a1
    80000f1c:	87aa                	mv	a5,a0
    return os;
  while(--n > 0 && (*s++ = *t++) != 0)
    80000f1e:	00d58963          	beq	a1,a3,80000f30 <safestrcpy+0x28>
    80000f22:	0585                	addi	a1,a1,1
    80000f24:	0785                	addi	a5,a5,1
    80000f26:	fff5c703          	lbu	a4,-1(a1)
    80000f2a:	fee78fa3          	sb	a4,-1(a5)
    80000f2e:	fb65                	bnez	a4,80000f1e <safestrcpy+0x16>
    ;
  *s = 0;
    80000f30:	00078023          	sb	zero,0(a5)
  return os;
}
    80000f34:	6422                	ld	s0,8(sp)
    80000f36:	0141                	addi	sp,sp,16
    80000f38:	8082                	ret

0000000080000f3a <strlen>:

int
strlen(const char *s)
{
    80000f3a:	1141                	addi	sp,sp,-16
    80000f3c:	e422                	sd	s0,8(sp)
    80000f3e:	0800                	addi	s0,sp,16
  int n;

  for(n = 0; s[n]; n++)
    80000f40:	00054783          	lbu	a5,0(a0)
    80000f44:	cf91                	beqz	a5,80000f60 <strlen+0x26>
    80000f46:	0505                	addi	a0,a0,1
    80000f48:	87aa                	mv	a5,a0
    80000f4a:	4685                	li	a3,1
    80000f4c:	9e89                	subw	a3,a3,a0
    80000f4e:	00f6853b          	addw	a0,a3,a5
    80000f52:	0785                	addi	a5,a5,1
    80000f54:	fff7c703          	lbu	a4,-1(a5)
    80000f58:	fb7d                	bnez	a4,80000f4e <strlen+0x14>
    ;
  return n;
}
    80000f5a:	6422                	ld	s0,8(sp)
    80000f5c:	0141                	addi	sp,sp,16
    80000f5e:	8082                	ret
  for(n = 0; s[n]; n++)
    80000f60:	4501                	li	a0,0
    80000f62:	bfe5                	j	80000f5a <strlen+0x20>

0000000080000f64 <main>:
volatile static int started = 0;

// start() jumps here in supervisor mode on all CPUs.
void
main()
{
    80000f64:	1141                	addi	sp,sp,-16
    80000f66:	e406                	sd	ra,8(sp)
    80000f68:	e022                	sd	s0,0(sp)
    80000f6a:	0800                	addi	s0,sp,16
  if(cpuid() == 0){
    80000f6c:	00001097          	auipc	ra,0x1
    80000f70:	afe080e7          	jalr	-1282(ra) # 80001a6a <cpuid>
    virtio_disk_init(); // emulated hard disk
    userinit();      // first user process
    __sync_synchronize();
    started = 1;
  } else {
    while(started == 0)
    80000f74:	00008717          	auipc	a4,0x8
    80000f78:	bc470713          	addi	a4,a4,-1084 # 80008b38 <started>
  if(cpuid() == 0){
    80000f7c:	c139                	beqz	a0,80000fc2 <main+0x5e>
    while(started == 0)
    80000f7e:	431c                	lw	a5,0(a4)
    80000f80:	2781                	sext.w	a5,a5
    80000f82:	dff5                	beqz	a5,80000f7e <main+0x1a>
      ;
    __sync_synchronize();
    80000f84:	0ff0000f          	fence
    printf("hart %d starting\n", cpuid());
    80000f88:	00001097          	auipc	ra,0x1
    80000f8c:	ae2080e7          	jalr	-1310(ra) # 80001a6a <cpuid>
    80000f90:	85aa                	mv	a1,a0
    80000f92:	00007517          	auipc	a0,0x7
    80000f96:	11e50513          	addi	a0,a0,286 # 800080b0 <digits+0x70>
    80000f9a:	fffff097          	auipc	ra,0xfffff
    80000f9e:	5f4080e7          	jalr	1524(ra) # 8000058e <printf>
    kvminithart();    // turn on paging
    80000fa2:	00000097          	auipc	ra,0x0
    80000fa6:	0d8080e7          	jalr	216(ra) # 8000107a <kvminithart>
    trapinithart();   // install kernel trap vector
    80000faa:	00002097          	auipc	ra,0x2
    80000fae:	a52080e7          	jalr	-1454(ra) # 800029fc <trapinithart>
    plicinithart();   // ask PLIC for device interrupts
    80000fb2:	00005097          	auipc	ra,0x5
    80000fb6:	0be080e7          	jalr	190(ra) # 80006070 <plicinithart>
  }

  scheduler1();        
    80000fba:	00001097          	auipc	ra,0x1
    80000fbe:	096080e7          	jalr	150(ra) # 80002050 <scheduler1>
    consoleinit();
    80000fc2:	fffff097          	auipc	ra,0xfffff
    80000fc6:	494080e7          	jalr	1172(ra) # 80000456 <consoleinit>
    printfinit();
    80000fca:	fffff097          	auipc	ra,0xfffff
    80000fce:	7aa080e7          	jalr	1962(ra) # 80000774 <printfinit>
    printf("\n");
    80000fd2:	00007517          	auipc	a0,0x7
    80000fd6:	0ee50513          	addi	a0,a0,238 # 800080c0 <digits+0x80>
    80000fda:	fffff097          	auipc	ra,0xfffff
    80000fde:	5b4080e7          	jalr	1460(ra) # 8000058e <printf>
    printf("xv6 kernel is booting\n");
    80000fe2:	00007517          	auipc	a0,0x7
    80000fe6:	0b650513          	addi	a0,a0,182 # 80008098 <digits+0x58>
    80000fea:	fffff097          	auipc	ra,0xfffff
    80000fee:	5a4080e7          	jalr	1444(ra) # 8000058e <printf>
    printf("\n");
    80000ff2:	00007517          	auipc	a0,0x7
    80000ff6:	0ce50513          	addi	a0,a0,206 # 800080c0 <digits+0x80>
    80000ffa:	fffff097          	auipc	ra,0xfffff
    80000ffe:	594080e7          	jalr	1428(ra) # 8000058e <printf>
    kinit();         // physical page allocator
    80001002:	00000097          	auipc	ra,0x0
    80001006:	abc080e7          	jalr	-1348(ra) # 80000abe <kinit>
    kvminit();       // create kernel page table
    8000100a:	00000097          	auipc	ra,0x0
    8000100e:	326080e7          	jalr	806(ra) # 80001330 <kvminit>
    kvminithart();   // turn on paging
    80001012:	00000097          	auipc	ra,0x0
    80001016:	068080e7          	jalr	104(ra) # 8000107a <kvminithart>
    procinit();      // process table
    8000101a:	00001097          	auipc	ra,0x1
    8000101e:	99c080e7          	jalr	-1636(ra) # 800019b6 <procinit>
    trapinit();      // trap vectors
    80001022:	00002097          	auipc	ra,0x2
    80001026:	9b2080e7          	jalr	-1614(ra) # 800029d4 <trapinit>
    trapinithart();  // install kernel trap vector
    8000102a:	00002097          	auipc	ra,0x2
    8000102e:	9d2080e7          	jalr	-1582(ra) # 800029fc <trapinithart>
    plicinit();      // set up interrupt controller
    80001032:	00005097          	auipc	ra,0x5
    80001036:	028080e7          	jalr	40(ra) # 8000605a <plicinit>
    plicinithart();  // ask PLIC for device interrupts
    8000103a:	00005097          	auipc	ra,0x5
    8000103e:	036080e7          	jalr	54(ra) # 80006070 <plicinithart>
    binit();         // buffer cache
    80001042:	00002097          	auipc	ra,0x2
    80001046:	1e8080e7          	jalr	488(ra) # 8000322a <binit>
    iinit();         // inode table
    8000104a:	00003097          	auipc	ra,0x3
    8000104e:	88c080e7          	jalr	-1908(ra) # 800038d6 <iinit>
    fileinit();      // file table
    80001052:	00004097          	auipc	ra,0x4
    80001056:	82a080e7          	jalr	-2006(ra) # 8000487c <fileinit>
    virtio_disk_init(); // emulated hard disk
    8000105a:	00005097          	auipc	ra,0x5
    8000105e:	11e080e7          	jalr	286(ra) # 80006178 <virtio_disk_init>
    userinit();      // first user process
    80001062:	00001097          	auipc	ra,0x1
    80001066:	d1e080e7          	jalr	-738(ra) # 80001d80 <userinit>
    __sync_synchronize();
    8000106a:	0ff0000f          	fence
    started = 1;
    8000106e:	4785                	li	a5,1
    80001070:	00008717          	auipc	a4,0x8
    80001074:	acf72423          	sw	a5,-1336(a4) # 80008b38 <started>
    80001078:	b789                	j	80000fba <main+0x56>

000000008000107a <kvminithart>:

// Switch h/w page table register to the kernel's page table,
// and enable paging.
void
kvminithart()
{
    8000107a:	1141                	addi	sp,sp,-16
    8000107c:	e422                	sd	s0,8(sp)
    8000107e:	0800                	addi	s0,sp,16
// flush the TLB.
static inline void
sfence_vma()
{
  // the zero, zero means flush all TLB entries.
  asm volatile("sfence.vma zero, zero");
    80001080:	12000073          	sfence.vma
  // wait for any previous writes to the page table memory to finish.
  sfence_vma();

  w_satp(MAKE_SATP(kernel_pagetable));
    80001084:	00008797          	auipc	a5,0x8
    80001088:	abc7b783          	ld	a5,-1348(a5) # 80008b40 <kernel_pagetable>
    8000108c:	83b1                	srli	a5,a5,0xc
    8000108e:	577d                	li	a4,-1
    80001090:	177e                	slli	a4,a4,0x3f
    80001092:	8fd9                	or	a5,a5,a4
  asm volatile("csrw satp, %0" : : "r" (x));
    80001094:	18079073          	csrw	satp,a5
  asm volatile("sfence.vma zero, zero");
    80001098:	12000073          	sfence.vma

  // flush stale entries from the TLB.
  sfence_vma();
}
    8000109c:	6422                	ld	s0,8(sp)
    8000109e:	0141                	addi	sp,sp,16
    800010a0:	8082                	ret

00000000800010a2 <walk>:
//   21..29 -- 9 bits of level-1 index.
//   12..20 -- 9 bits of level-0 index.
//    0..11 -- 12 bits of byte offset within the page.
pte_t *
walk(pagetable_t pagetable, uint64 va, int alloc)
{
    800010a2:	7139                	addi	sp,sp,-64
    800010a4:	fc06                	sd	ra,56(sp)
    800010a6:	f822                	sd	s0,48(sp)
    800010a8:	f426                	sd	s1,40(sp)
    800010aa:	f04a                	sd	s2,32(sp)
    800010ac:	ec4e                	sd	s3,24(sp)
    800010ae:	e852                	sd	s4,16(sp)
    800010b0:	e456                	sd	s5,8(sp)
    800010b2:	e05a                	sd	s6,0(sp)
    800010b4:	0080                	addi	s0,sp,64
    800010b6:	84aa                	mv	s1,a0
    800010b8:	89ae                	mv	s3,a1
    800010ba:	8ab2                	mv	s5,a2
  if(va >= MAXVA)
    800010bc:	57fd                	li	a5,-1
    800010be:	83e9                	srli	a5,a5,0x1a
    800010c0:	4a79                	li	s4,30
    panic("walk");

  for(int level = 2; level > 0; level--) {
    800010c2:	4b31                	li	s6,12
  if(va >= MAXVA)
    800010c4:	04b7f263          	bgeu	a5,a1,80001108 <walk+0x66>
    panic("walk");
    800010c8:	00007517          	auipc	a0,0x7
    800010cc:	00050513          	mv	a0,a0
    800010d0:	fffff097          	auipc	ra,0xfffff
    800010d4:	474080e7          	jalr	1140(ra) # 80000544 <panic>
    pte_t *pte = &pagetable[PX(level, va)];
    if(*pte & PTE_V) {
      pagetable = (pagetable_t)PTE2PA(*pte);
    } else {
      if(!alloc || (pagetable = (pde_t*)kalloc()) == 0)
    800010d8:	060a8663          	beqz	s5,80001144 <walk+0xa2>
    800010dc:	00000097          	auipc	ra,0x0
    800010e0:	a1e080e7          	jalr	-1506(ra) # 80000afa <kalloc>
    800010e4:	84aa                	mv	s1,a0
    800010e6:	c529                	beqz	a0,80001130 <walk+0x8e>
        return 0;
      memset(pagetable, 0, PGSIZE);
    800010e8:	6605                	lui	a2,0x1
    800010ea:	4581                	li	a1,0
    800010ec:	00000097          	auipc	ra,0x0
    800010f0:	cca080e7          	jalr	-822(ra) # 80000db6 <memset>
      *pte = PA2PTE(pagetable) | PTE_V;
    800010f4:	00c4d793          	srli	a5,s1,0xc
    800010f8:	07aa                	slli	a5,a5,0xa
    800010fa:	0017e793          	ori	a5,a5,1
    800010fe:	00f93023          	sd	a5,0(s2)
  for(int level = 2; level > 0; level--) {
    80001102:	3a5d                	addiw	s4,s4,-9
    80001104:	036a0063          	beq	s4,s6,80001124 <walk+0x82>
    pte_t *pte = &pagetable[PX(level, va)];
    80001108:	0149d933          	srl	s2,s3,s4
    8000110c:	1ff97913          	andi	s2,s2,511
    80001110:	090e                	slli	s2,s2,0x3
    80001112:	9926                	add	s2,s2,s1
    if(*pte & PTE_V) {
    80001114:	00093483          	ld	s1,0(s2)
    80001118:	0014f793          	andi	a5,s1,1
    8000111c:	dfd5                	beqz	a5,800010d8 <walk+0x36>
      pagetable = (pagetable_t)PTE2PA(*pte);
    8000111e:	80a9                	srli	s1,s1,0xa
    80001120:	04b2                	slli	s1,s1,0xc
    80001122:	b7c5                	j	80001102 <walk+0x60>
    }
  }
  return &pagetable[PX(0, va)];
    80001124:	00c9d513          	srli	a0,s3,0xc
    80001128:	1ff57513          	andi	a0,a0,511
    8000112c:	050e                	slli	a0,a0,0x3
    8000112e:	9526                	add	a0,a0,s1
}
    80001130:	70e2                	ld	ra,56(sp)
    80001132:	7442                	ld	s0,48(sp)
    80001134:	74a2                	ld	s1,40(sp)
    80001136:	7902                	ld	s2,32(sp)
    80001138:	69e2                	ld	s3,24(sp)
    8000113a:	6a42                	ld	s4,16(sp)
    8000113c:	6aa2                	ld	s5,8(sp)
    8000113e:	6b02                	ld	s6,0(sp)
    80001140:	6121                	addi	sp,sp,64
    80001142:	8082                	ret
        return 0;
    80001144:	4501                	li	a0,0
    80001146:	b7ed                	j	80001130 <walk+0x8e>

0000000080001148 <walkaddr>:
walkaddr(pagetable_t pagetable, uint64 va)
{
  pte_t *pte;
  uint64 pa;

  if(va >= MAXVA)
    80001148:	57fd                	li	a5,-1
    8000114a:	83e9                	srli	a5,a5,0x1a
    8000114c:	00b7f463          	bgeu	a5,a1,80001154 <walkaddr+0xc>
    return 0;
    80001150:	4501                	li	a0,0
    return 0;
  if((*pte & PTE_U) == 0)
    return 0;
  pa = PTE2PA(*pte);
  return pa;
}
    80001152:	8082                	ret
{
    80001154:	1141                	addi	sp,sp,-16
    80001156:	e406                	sd	ra,8(sp)
    80001158:	e022                	sd	s0,0(sp)
    8000115a:	0800                	addi	s0,sp,16
  pte = walk(pagetable, va, 0);
    8000115c:	4601                	li	a2,0
    8000115e:	00000097          	auipc	ra,0x0
    80001162:	f44080e7          	jalr	-188(ra) # 800010a2 <walk>
  if(pte == 0)
    80001166:	c105                	beqz	a0,80001186 <walkaddr+0x3e>
  if((*pte & PTE_V) == 0)
    80001168:	611c                	ld	a5,0(a0)
  if((*pte & PTE_U) == 0)
    8000116a:	0117f693          	andi	a3,a5,17
    8000116e:	4745                	li	a4,17
    return 0;
    80001170:	4501                	li	a0,0
  if((*pte & PTE_U) == 0)
    80001172:	00e68663          	beq	a3,a4,8000117e <walkaddr+0x36>
}
    80001176:	60a2                	ld	ra,8(sp)
    80001178:	6402                	ld	s0,0(sp)
    8000117a:	0141                	addi	sp,sp,16
    8000117c:	8082                	ret
  pa = PTE2PA(*pte);
    8000117e:	00a7d513          	srli	a0,a5,0xa
    80001182:	0532                	slli	a0,a0,0xc
  return pa;
    80001184:	bfcd                	j	80001176 <walkaddr+0x2e>
    return 0;
    80001186:	4501                	li	a0,0
    80001188:	b7fd                	j	80001176 <walkaddr+0x2e>

000000008000118a <mappages>:
// physical addresses starting at pa. va and size might not
// be page-aligned. Returns 0 on success, -1 if walk() couldn't
// allocate a needed page-table page.
int
mappages(pagetable_t pagetable, uint64 va, uint64 size, uint64 pa, int perm)
{
    8000118a:	715d                	addi	sp,sp,-80
    8000118c:	e486                	sd	ra,72(sp)
    8000118e:	e0a2                	sd	s0,64(sp)
    80001190:	fc26                	sd	s1,56(sp)
    80001192:	f84a                	sd	s2,48(sp)
    80001194:	f44e                	sd	s3,40(sp)
    80001196:	f052                	sd	s4,32(sp)
    80001198:	ec56                	sd	s5,24(sp)
    8000119a:	e85a                	sd	s6,16(sp)
    8000119c:	e45e                	sd	s7,8(sp)
    8000119e:	0880                	addi	s0,sp,80
  uint64 a, last;
  pte_t *pte;

  if(size == 0)
    800011a0:	c205                	beqz	a2,800011c0 <mappages+0x36>
    800011a2:	8aaa                	mv	s5,a0
    800011a4:	8b3a                	mv	s6,a4
    panic("mappages: size");
  
  a = PGROUNDDOWN(va);
    800011a6:	77fd                	lui	a5,0xfffff
    800011a8:	00f5fa33          	and	s4,a1,a5
  last = PGROUNDDOWN(va + size - 1);
    800011ac:	15fd                	addi	a1,a1,-1
    800011ae:	00c589b3          	add	s3,a1,a2
    800011b2:	00f9f9b3          	and	s3,s3,a5
  a = PGROUNDDOWN(va);
    800011b6:	8952                	mv	s2,s4
    800011b8:	41468a33          	sub	s4,a3,s4
    if(*pte & PTE_V)
      panic("mappages: remap");
    *pte = PA2PTE(pa) | perm | PTE_V;
    if(a == last)
      break;
    a += PGSIZE;
    800011bc:	6b85                	lui	s7,0x1
    800011be:	a015                	j	800011e2 <mappages+0x58>
    panic("mappages: size");
    800011c0:	00007517          	auipc	a0,0x7
    800011c4:	f1050513          	addi	a0,a0,-240 # 800080d0 <digits+0x90>
    800011c8:	fffff097          	auipc	ra,0xfffff
    800011cc:	37c080e7          	jalr	892(ra) # 80000544 <panic>
      panic("mappages: remap");
    800011d0:	00007517          	auipc	a0,0x7
    800011d4:	f1050513          	addi	a0,a0,-240 # 800080e0 <digits+0xa0>
    800011d8:	fffff097          	auipc	ra,0xfffff
    800011dc:	36c080e7          	jalr	876(ra) # 80000544 <panic>
    a += PGSIZE;
    800011e0:	995e                	add	s2,s2,s7
  for(;;){
    800011e2:	012a04b3          	add	s1,s4,s2
    if((pte = walk(pagetable, a, 1)) == 0)
    800011e6:	4605                	li	a2,1
    800011e8:	85ca                	mv	a1,s2
    800011ea:	8556                	mv	a0,s5
    800011ec:	00000097          	auipc	ra,0x0
    800011f0:	eb6080e7          	jalr	-330(ra) # 800010a2 <walk>
    800011f4:	cd19                	beqz	a0,80001212 <mappages+0x88>
    if(*pte & PTE_V)
    800011f6:	611c                	ld	a5,0(a0)
    800011f8:	8b85                	andi	a5,a5,1
    800011fa:	fbf9                	bnez	a5,800011d0 <mappages+0x46>
    *pte = PA2PTE(pa) | perm | PTE_V;
    800011fc:	80b1                	srli	s1,s1,0xc
    800011fe:	04aa                	slli	s1,s1,0xa
    80001200:	0164e4b3          	or	s1,s1,s6
    80001204:	0014e493          	ori	s1,s1,1
    80001208:	e104                	sd	s1,0(a0)
    if(a == last)
    8000120a:	fd391be3          	bne	s2,s3,800011e0 <mappages+0x56>
    pa += PGSIZE;
  }
  return 0;
    8000120e:	4501                	li	a0,0
    80001210:	a011                	j	80001214 <mappages+0x8a>
      return -1;
    80001212:	557d                	li	a0,-1
}
    80001214:	60a6                	ld	ra,72(sp)
    80001216:	6406                	ld	s0,64(sp)
    80001218:	74e2                	ld	s1,56(sp)
    8000121a:	7942                	ld	s2,48(sp)
    8000121c:	79a2                	ld	s3,40(sp)
    8000121e:	7a02                	ld	s4,32(sp)
    80001220:	6ae2                	ld	s5,24(sp)
    80001222:	6b42                	ld	s6,16(sp)
    80001224:	6ba2                	ld	s7,8(sp)
    80001226:	6161                	addi	sp,sp,80
    80001228:	8082                	ret

000000008000122a <kvmmap>:
{
    8000122a:	1141                	addi	sp,sp,-16
    8000122c:	e406                	sd	ra,8(sp)
    8000122e:	e022                	sd	s0,0(sp)
    80001230:	0800                	addi	s0,sp,16
    80001232:	87b6                	mv	a5,a3
  if(mappages(kpgtbl, va, sz, pa, perm) != 0)
    80001234:	86b2                	mv	a3,a2
    80001236:	863e                	mv	a2,a5
    80001238:	00000097          	auipc	ra,0x0
    8000123c:	f52080e7          	jalr	-174(ra) # 8000118a <mappages>
    80001240:	e509                	bnez	a0,8000124a <kvmmap+0x20>
}
    80001242:	60a2                	ld	ra,8(sp)
    80001244:	6402                	ld	s0,0(sp)
    80001246:	0141                	addi	sp,sp,16
    80001248:	8082                	ret
    panic("kvmmap");
    8000124a:	00007517          	auipc	a0,0x7
    8000124e:	ea650513          	addi	a0,a0,-346 # 800080f0 <digits+0xb0>
    80001252:	fffff097          	auipc	ra,0xfffff
    80001256:	2f2080e7          	jalr	754(ra) # 80000544 <panic>

000000008000125a <kvmmake>:
{
    8000125a:	1101                	addi	sp,sp,-32
    8000125c:	ec06                	sd	ra,24(sp)
    8000125e:	e822                	sd	s0,16(sp)
    80001260:	e426                	sd	s1,8(sp)
    80001262:	e04a                	sd	s2,0(sp)
    80001264:	1000                	addi	s0,sp,32
  kpgtbl = (pagetable_t) kalloc();
    80001266:	00000097          	auipc	ra,0x0
    8000126a:	894080e7          	jalr	-1900(ra) # 80000afa <kalloc>
    8000126e:	84aa                	mv	s1,a0
  memset(kpgtbl, 0, PGSIZE);
    80001270:	6605                	lui	a2,0x1
    80001272:	4581                	li	a1,0
    80001274:	00000097          	auipc	ra,0x0
    80001278:	b42080e7          	jalr	-1214(ra) # 80000db6 <memset>
  kvmmap(kpgtbl, UART0, UART0, PGSIZE, PTE_R | PTE_W);
    8000127c:	4719                	li	a4,6
    8000127e:	6685                	lui	a3,0x1
    80001280:	10000637          	lui	a2,0x10000
    80001284:	100005b7          	lui	a1,0x10000
    80001288:	8526                	mv	a0,s1
    8000128a:	00000097          	auipc	ra,0x0
    8000128e:	fa0080e7          	jalr	-96(ra) # 8000122a <kvmmap>
  kvmmap(kpgtbl, VIRTIO0, VIRTIO0, PGSIZE, PTE_R | PTE_W);
    80001292:	4719                	li	a4,6
    80001294:	6685                	lui	a3,0x1
    80001296:	10001637          	lui	a2,0x10001
    8000129a:	100015b7          	lui	a1,0x10001
    8000129e:	8526                	mv	a0,s1
    800012a0:	00000097          	auipc	ra,0x0
    800012a4:	f8a080e7          	jalr	-118(ra) # 8000122a <kvmmap>
  kvmmap(kpgtbl, PLIC, PLIC, 0x400000, PTE_R | PTE_W);
    800012a8:	4719                	li	a4,6
    800012aa:	004006b7          	lui	a3,0x400
    800012ae:	0c000637          	lui	a2,0xc000
    800012b2:	0c0005b7          	lui	a1,0xc000
    800012b6:	8526                	mv	a0,s1
    800012b8:	00000097          	auipc	ra,0x0
    800012bc:	f72080e7          	jalr	-142(ra) # 8000122a <kvmmap>
  kvmmap(kpgtbl, KERNBASE, KERNBASE, (uint64)etext-KERNBASE, PTE_R | PTE_X);
    800012c0:	00007917          	auipc	s2,0x7
    800012c4:	d4090913          	addi	s2,s2,-704 # 80008000 <etext>
    800012c8:	4729                	li	a4,10
    800012ca:	80007697          	auipc	a3,0x80007
    800012ce:	d3668693          	addi	a3,a3,-714 # 8000 <_entry-0x7fff8000>
    800012d2:	4605                	li	a2,1
    800012d4:	067e                	slli	a2,a2,0x1f
    800012d6:	85b2                	mv	a1,a2
    800012d8:	8526                	mv	a0,s1
    800012da:	00000097          	auipc	ra,0x0
    800012de:	f50080e7          	jalr	-176(ra) # 8000122a <kvmmap>
  kvmmap(kpgtbl, (uint64)etext, (uint64)etext, PHYSTOP-(uint64)etext, PTE_R | PTE_W);
    800012e2:	4719                	li	a4,6
    800012e4:	46c5                	li	a3,17
    800012e6:	06ee                	slli	a3,a3,0x1b
    800012e8:	412686b3          	sub	a3,a3,s2
    800012ec:	864a                	mv	a2,s2
    800012ee:	85ca                	mv	a1,s2
    800012f0:	8526                	mv	a0,s1
    800012f2:	00000097          	auipc	ra,0x0
    800012f6:	f38080e7          	jalr	-200(ra) # 8000122a <kvmmap>
  kvmmap(kpgtbl, TRAMPOLINE, (uint64)trampoline, PGSIZE, PTE_R | PTE_X);
    800012fa:	4729                	li	a4,10
    800012fc:	6685                	lui	a3,0x1
    800012fe:	00006617          	auipc	a2,0x6
    80001302:	d0260613          	addi	a2,a2,-766 # 80007000 <_trampoline>
    80001306:	040005b7          	lui	a1,0x4000
    8000130a:	15fd                	addi	a1,a1,-1
    8000130c:	05b2                	slli	a1,a1,0xc
    8000130e:	8526                	mv	a0,s1
    80001310:	00000097          	auipc	ra,0x0
    80001314:	f1a080e7          	jalr	-230(ra) # 8000122a <kvmmap>
  proc_mapstacks(kpgtbl);
    80001318:	8526                	mv	a0,s1
    8000131a:	00000097          	auipc	ra,0x0
    8000131e:	606080e7          	jalr	1542(ra) # 80001920 <proc_mapstacks>
}
    80001322:	8526                	mv	a0,s1
    80001324:	60e2                	ld	ra,24(sp)
    80001326:	6442                	ld	s0,16(sp)
    80001328:	64a2                	ld	s1,8(sp)
    8000132a:	6902                	ld	s2,0(sp)
    8000132c:	6105                	addi	sp,sp,32
    8000132e:	8082                	ret

0000000080001330 <kvminit>:
{
    80001330:	1141                	addi	sp,sp,-16
    80001332:	e406                	sd	ra,8(sp)
    80001334:	e022                	sd	s0,0(sp)
    80001336:	0800                	addi	s0,sp,16
  kernel_pagetable = kvmmake();
    80001338:	00000097          	auipc	ra,0x0
    8000133c:	f22080e7          	jalr	-222(ra) # 8000125a <kvmmake>
    80001340:	00008797          	auipc	a5,0x8
    80001344:	80a7b023          	sd	a0,-2048(a5) # 80008b40 <kernel_pagetable>
}
    80001348:	60a2                	ld	ra,8(sp)
    8000134a:	6402                	ld	s0,0(sp)
    8000134c:	0141                	addi	sp,sp,16
    8000134e:	8082                	ret

0000000080001350 <uvmunmap>:
// Remove npages of mappings starting from va. va must be
// page-aligned. The mappings must exist.
// Optionally free the physical memory.
void
uvmunmap(pagetable_t pagetable, uint64 va, uint64 npages, int do_free)
{
    80001350:	715d                	addi	sp,sp,-80
    80001352:	e486                	sd	ra,72(sp)
    80001354:	e0a2                	sd	s0,64(sp)
    80001356:	fc26                	sd	s1,56(sp)
    80001358:	f84a                	sd	s2,48(sp)
    8000135a:	f44e                	sd	s3,40(sp)
    8000135c:	f052                	sd	s4,32(sp)
    8000135e:	ec56                	sd	s5,24(sp)
    80001360:	e85a                	sd	s6,16(sp)
    80001362:	e45e                	sd	s7,8(sp)
    80001364:	0880                	addi	s0,sp,80
  uint64 a;
  pte_t *pte;

  if((va % PGSIZE) != 0)
    80001366:	03459793          	slli	a5,a1,0x34
    8000136a:	e795                	bnez	a5,80001396 <uvmunmap+0x46>
    8000136c:	8a2a                	mv	s4,a0
    8000136e:	892e                	mv	s2,a1
    80001370:	8ab6                	mv	s5,a3
    panic("uvmunmap: not aligned");

  for(a = va; a < va + npages*PGSIZE; a += PGSIZE){
    80001372:	0632                	slli	a2,a2,0xc
    80001374:	00b609b3          	add	s3,a2,a1
    if((pte = walk(pagetable, a, 0)) == 0)
      panic("uvmunmap: walk");
    if((*pte & PTE_V) == 0)
      panic("uvmunmap: not mapped");
    if(PTE_FLAGS(*pte) == PTE_V)
    80001378:	4b85                	li	s7,1
  for(a = va; a < va + npages*PGSIZE; a += PGSIZE){
    8000137a:	6b05                	lui	s6,0x1
    8000137c:	0735e863          	bltu	a1,s3,800013ec <uvmunmap+0x9c>
      uint64 pa = PTE2PA(*pte);
      kfree((void*)pa);
    }
    *pte = 0;
  }
}
    80001380:	60a6                	ld	ra,72(sp)
    80001382:	6406                	ld	s0,64(sp)
    80001384:	74e2                	ld	s1,56(sp)
    80001386:	7942                	ld	s2,48(sp)
    80001388:	79a2                	ld	s3,40(sp)
    8000138a:	7a02                	ld	s4,32(sp)
    8000138c:	6ae2                	ld	s5,24(sp)
    8000138e:	6b42                	ld	s6,16(sp)
    80001390:	6ba2                	ld	s7,8(sp)
    80001392:	6161                	addi	sp,sp,80
    80001394:	8082                	ret
    panic("uvmunmap: not aligned");
    80001396:	00007517          	auipc	a0,0x7
    8000139a:	d6250513          	addi	a0,a0,-670 # 800080f8 <digits+0xb8>
    8000139e:	fffff097          	auipc	ra,0xfffff
    800013a2:	1a6080e7          	jalr	422(ra) # 80000544 <panic>
      panic("uvmunmap: walk");
    800013a6:	00007517          	auipc	a0,0x7
    800013aa:	d6a50513          	addi	a0,a0,-662 # 80008110 <digits+0xd0>
    800013ae:	fffff097          	auipc	ra,0xfffff
    800013b2:	196080e7          	jalr	406(ra) # 80000544 <panic>
      panic("uvmunmap: not mapped");
    800013b6:	00007517          	auipc	a0,0x7
    800013ba:	d6a50513          	addi	a0,a0,-662 # 80008120 <digits+0xe0>
    800013be:	fffff097          	auipc	ra,0xfffff
    800013c2:	186080e7          	jalr	390(ra) # 80000544 <panic>
      panic("uvmunmap: not a leaf");
    800013c6:	00007517          	auipc	a0,0x7
    800013ca:	d7250513          	addi	a0,a0,-654 # 80008138 <digits+0xf8>
    800013ce:	fffff097          	auipc	ra,0xfffff
    800013d2:	176080e7          	jalr	374(ra) # 80000544 <panic>
      uint64 pa = PTE2PA(*pte);
    800013d6:	8129                	srli	a0,a0,0xa
      kfree((void*)pa);
    800013d8:	0532                	slli	a0,a0,0xc
    800013da:	fffff097          	auipc	ra,0xfffff
    800013de:	624080e7          	jalr	1572(ra) # 800009fe <kfree>
    *pte = 0;
    800013e2:	0004b023          	sd	zero,0(s1)
  for(a = va; a < va + npages*PGSIZE; a += PGSIZE){
    800013e6:	995a                	add	s2,s2,s6
    800013e8:	f9397ce3          	bgeu	s2,s3,80001380 <uvmunmap+0x30>
    if((pte = walk(pagetable, a, 0)) == 0)
    800013ec:	4601                	li	a2,0
    800013ee:	85ca                	mv	a1,s2
    800013f0:	8552                	mv	a0,s4
    800013f2:	00000097          	auipc	ra,0x0
    800013f6:	cb0080e7          	jalr	-848(ra) # 800010a2 <walk>
    800013fa:	84aa                	mv	s1,a0
    800013fc:	d54d                	beqz	a0,800013a6 <uvmunmap+0x56>
    if((*pte & PTE_V) == 0)
    800013fe:	6108                	ld	a0,0(a0)
    80001400:	00157793          	andi	a5,a0,1
    80001404:	dbcd                	beqz	a5,800013b6 <uvmunmap+0x66>
    if(PTE_FLAGS(*pte) == PTE_V)
    80001406:	3ff57793          	andi	a5,a0,1023
    8000140a:	fb778ee3          	beq	a5,s7,800013c6 <uvmunmap+0x76>
    if(do_free){
    8000140e:	fc0a8ae3          	beqz	s5,800013e2 <uvmunmap+0x92>
    80001412:	b7d1                	j	800013d6 <uvmunmap+0x86>

0000000080001414 <uvmcreate>:

// create an empty user page table.
// returns 0 if out of memory.
pagetable_t
uvmcreate()
{
    80001414:	1101                	addi	sp,sp,-32
    80001416:	ec06                	sd	ra,24(sp)
    80001418:	e822                	sd	s0,16(sp)
    8000141a:	e426                	sd	s1,8(sp)
    8000141c:	1000                	addi	s0,sp,32
  pagetable_t pagetable;
  pagetable = (pagetable_t) kalloc();
    8000141e:	fffff097          	auipc	ra,0xfffff
    80001422:	6dc080e7          	jalr	1756(ra) # 80000afa <kalloc>
    80001426:	84aa                	mv	s1,a0
  if(pagetable == 0)
    80001428:	c519                	beqz	a0,80001436 <uvmcreate+0x22>
    return 0;
  memset(pagetable, 0, PGSIZE);
    8000142a:	6605                	lui	a2,0x1
    8000142c:	4581                	li	a1,0
    8000142e:	00000097          	auipc	ra,0x0
    80001432:	988080e7          	jalr	-1656(ra) # 80000db6 <memset>
  return pagetable;
}
    80001436:	8526                	mv	a0,s1
    80001438:	60e2                	ld	ra,24(sp)
    8000143a:	6442                	ld	s0,16(sp)
    8000143c:	64a2                	ld	s1,8(sp)
    8000143e:	6105                	addi	sp,sp,32
    80001440:	8082                	ret

0000000080001442 <uvmfirst>:
// Load the user initcode into address 0 of pagetable,
// for the very first process.
// sz must be less than a page.
void
uvmfirst(pagetable_t pagetable, uchar *src, uint sz)
{
    80001442:	7179                	addi	sp,sp,-48
    80001444:	f406                	sd	ra,40(sp)
    80001446:	f022                	sd	s0,32(sp)
    80001448:	ec26                	sd	s1,24(sp)
    8000144a:	e84a                	sd	s2,16(sp)
    8000144c:	e44e                	sd	s3,8(sp)
    8000144e:	e052                	sd	s4,0(sp)
    80001450:	1800                	addi	s0,sp,48
  char *mem;

  if(sz >= PGSIZE)
    80001452:	6785                	lui	a5,0x1
    80001454:	04f67863          	bgeu	a2,a5,800014a4 <uvmfirst+0x62>
    80001458:	8a2a                	mv	s4,a0
    8000145a:	89ae                	mv	s3,a1
    8000145c:	84b2                	mv	s1,a2
    panic("uvmfirst: more than a page");
  mem = kalloc();
    8000145e:	fffff097          	auipc	ra,0xfffff
    80001462:	69c080e7          	jalr	1692(ra) # 80000afa <kalloc>
    80001466:	892a                	mv	s2,a0
  memset(mem, 0, PGSIZE);
    80001468:	6605                	lui	a2,0x1
    8000146a:	4581                	li	a1,0
    8000146c:	00000097          	auipc	ra,0x0
    80001470:	94a080e7          	jalr	-1718(ra) # 80000db6 <memset>
  mappages(pagetable, 0, PGSIZE, (uint64)mem, PTE_W|PTE_R|PTE_X|PTE_U);
    80001474:	4779                	li	a4,30
    80001476:	86ca                	mv	a3,s2
    80001478:	6605                	lui	a2,0x1
    8000147a:	4581                	li	a1,0
    8000147c:	8552                	mv	a0,s4
    8000147e:	00000097          	auipc	ra,0x0
    80001482:	d0c080e7          	jalr	-756(ra) # 8000118a <mappages>
  memmove(mem, src, sz);
    80001486:	8626                	mv	a2,s1
    80001488:	85ce                	mv	a1,s3
    8000148a:	854a                	mv	a0,s2
    8000148c:	00000097          	auipc	ra,0x0
    80001490:	98a080e7          	jalr	-1654(ra) # 80000e16 <memmove>
}
    80001494:	70a2                	ld	ra,40(sp)
    80001496:	7402                	ld	s0,32(sp)
    80001498:	64e2                	ld	s1,24(sp)
    8000149a:	6942                	ld	s2,16(sp)
    8000149c:	69a2                	ld	s3,8(sp)
    8000149e:	6a02                	ld	s4,0(sp)
    800014a0:	6145                	addi	sp,sp,48
    800014a2:	8082                	ret
    panic("uvmfirst: more than a page");
    800014a4:	00007517          	auipc	a0,0x7
    800014a8:	cac50513          	addi	a0,a0,-852 # 80008150 <digits+0x110>
    800014ac:	fffff097          	auipc	ra,0xfffff
    800014b0:	098080e7          	jalr	152(ra) # 80000544 <panic>

00000000800014b4 <uvmdealloc>:
// newsz.  oldsz and newsz need not be page-aligned, nor does newsz
// need to be less than oldsz.  oldsz can be larger than the actual
// process size.  Returns the new process size.
uint64
uvmdealloc(pagetable_t pagetable, uint64 oldsz, uint64 newsz)
{
    800014b4:	1101                	addi	sp,sp,-32
    800014b6:	ec06                	sd	ra,24(sp)
    800014b8:	e822                	sd	s0,16(sp)
    800014ba:	e426                	sd	s1,8(sp)
    800014bc:	1000                	addi	s0,sp,32
  if(newsz >= oldsz)
    return oldsz;
    800014be:	84ae                	mv	s1,a1
  if(newsz >= oldsz)
    800014c0:	00b67d63          	bgeu	a2,a1,800014da <uvmdealloc+0x26>
    800014c4:	84b2                	mv	s1,a2

  if(PGROUNDUP(newsz) < PGROUNDUP(oldsz)){
    800014c6:	6785                	lui	a5,0x1
    800014c8:	17fd                	addi	a5,a5,-1
    800014ca:	00f60733          	add	a4,a2,a5
    800014ce:	767d                	lui	a2,0xfffff
    800014d0:	8f71                	and	a4,a4,a2
    800014d2:	97ae                	add	a5,a5,a1
    800014d4:	8ff1                	and	a5,a5,a2
    800014d6:	00f76863          	bltu	a4,a5,800014e6 <uvmdealloc+0x32>
    int npages = (PGROUNDUP(oldsz) - PGROUNDUP(newsz)) / PGSIZE;
    uvmunmap(pagetable, PGROUNDUP(newsz), npages, 1);
  }

  return newsz;
}
    800014da:	8526                	mv	a0,s1
    800014dc:	60e2                	ld	ra,24(sp)
    800014de:	6442                	ld	s0,16(sp)
    800014e0:	64a2                	ld	s1,8(sp)
    800014e2:	6105                	addi	sp,sp,32
    800014e4:	8082                	ret
    int npages = (PGROUNDUP(oldsz) - PGROUNDUP(newsz)) / PGSIZE;
    800014e6:	8f99                	sub	a5,a5,a4
    800014e8:	83b1                	srli	a5,a5,0xc
    uvmunmap(pagetable, PGROUNDUP(newsz), npages, 1);
    800014ea:	4685                	li	a3,1
    800014ec:	0007861b          	sext.w	a2,a5
    800014f0:	85ba                	mv	a1,a4
    800014f2:	00000097          	auipc	ra,0x0
    800014f6:	e5e080e7          	jalr	-418(ra) # 80001350 <uvmunmap>
    800014fa:	b7c5                	j	800014da <uvmdealloc+0x26>

00000000800014fc <uvmalloc>:
  if(newsz < oldsz)
    800014fc:	0ab66563          	bltu	a2,a1,800015a6 <uvmalloc+0xaa>
{
    80001500:	7139                	addi	sp,sp,-64
    80001502:	fc06                	sd	ra,56(sp)
    80001504:	f822                	sd	s0,48(sp)
    80001506:	f426                	sd	s1,40(sp)
    80001508:	f04a                	sd	s2,32(sp)
    8000150a:	ec4e                	sd	s3,24(sp)
    8000150c:	e852                	sd	s4,16(sp)
    8000150e:	e456                	sd	s5,8(sp)
    80001510:	e05a                	sd	s6,0(sp)
    80001512:	0080                	addi	s0,sp,64
    80001514:	8aaa                	mv	s5,a0
    80001516:	8a32                	mv	s4,a2
  oldsz = PGROUNDUP(oldsz);
    80001518:	6985                	lui	s3,0x1
    8000151a:	19fd                	addi	s3,s3,-1
    8000151c:	95ce                	add	a1,a1,s3
    8000151e:	79fd                	lui	s3,0xfffff
    80001520:	0135f9b3          	and	s3,a1,s3
  for(a = oldsz; a < newsz; a += PGSIZE){
    80001524:	08c9f363          	bgeu	s3,a2,800015aa <uvmalloc+0xae>
    80001528:	894e                	mv	s2,s3
    if(mappages(pagetable, a, PGSIZE, (uint64)mem, PTE_R|PTE_U|xperm) != 0){
    8000152a:	0126eb13          	ori	s6,a3,18
    mem = kalloc();
    8000152e:	fffff097          	auipc	ra,0xfffff
    80001532:	5cc080e7          	jalr	1484(ra) # 80000afa <kalloc>
    80001536:	84aa                	mv	s1,a0
    if(mem == 0){
    80001538:	c51d                	beqz	a0,80001566 <uvmalloc+0x6a>
    memset(mem, 0, PGSIZE);
    8000153a:	6605                	lui	a2,0x1
    8000153c:	4581                	li	a1,0
    8000153e:	00000097          	auipc	ra,0x0
    80001542:	878080e7          	jalr	-1928(ra) # 80000db6 <memset>
    if(mappages(pagetable, a, PGSIZE, (uint64)mem, PTE_R|PTE_U|xperm) != 0){
    80001546:	875a                	mv	a4,s6
    80001548:	86a6                	mv	a3,s1
    8000154a:	6605                	lui	a2,0x1
    8000154c:	85ca                	mv	a1,s2
    8000154e:	8556                	mv	a0,s5
    80001550:	00000097          	auipc	ra,0x0
    80001554:	c3a080e7          	jalr	-966(ra) # 8000118a <mappages>
    80001558:	e90d                	bnez	a0,8000158a <uvmalloc+0x8e>
  for(a = oldsz; a < newsz; a += PGSIZE){
    8000155a:	6785                	lui	a5,0x1
    8000155c:	993e                	add	s2,s2,a5
    8000155e:	fd4968e3          	bltu	s2,s4,8000152e <uvmalloc+0x32>
  return newsz;
    80001562:	8552                	mv	a0,s4
    80001564:	a809                	j	80001576 <uvmalloc+0x7a>
      uvmdealloc(pagetable, a, oldsz);
    80001566:	864e                	mv	a2,s3
    80001568:	85ca                	mv	a1,s2
    8000156a:	8556                	mv	a0,s5
    8000156c:	00000097          	auipc	ra,0x0
    80001570:	f48080e7          	jalr	-184(ra) # 800014b4 <uvmdealloc>
      return 0;
    80001574:	4501                	li	a0,0
}
    80001576:	70e2                	ld	ra,56(sp)
    80001578:	7442                	ld	s0,48(sp)
    8000157a:	74a2                	ld	s1,40(sp)
    8000157c:	7902                	ld	s2,32(sp)
    8000157e:	69e2                	ld	s3,24(sp)
    80001580:	6a42                	ld	s4,16(sp)
    80001582:	6aa2                	ld	s5,8(sp)
    80001584:	6b02                	ld	s6,0(sp)
    80001586:	6121                	addi	sp,sp,64
    80001588:	8082                	ret
      kfree(mem);
    8000158a:	8526                	mv	a0,s1
    8000158c:	fffff097          	auipc	ra,0xfffff
    80001590:	472080e7          	jalr	1138(ra) # 800009fe <kfree>
      uvmdealloc(pagetable, a, oldsz);
    80001594:	864e                	mv	a2,s3
    80001596:	85ca                	mv	a1,s2
    80001598:	8556                	mv	a0,s5
    8000159a:	00000097          	auipc	ra,0x0
    8000159e:	f1a080e7          	jalr	-230(ra) # 800014b4 <uvmdealloc>
      return 0;
    800015a2:	4501                	li	a0,0
    800015a4:	bfc9                	j	80001576 <uvmalloc+0x7a>
    return oldsz;
    800015a6:	852e                	mv	a0,a1
}
    800015a8:	8082                	ret
  return newsz;
    800015aa:	8532                	mv	a0,a2
    800015ac:	b7e9                	j	80001576 <uvmalloc+0x7a>

00000000800015ae <freewalk>:

// Recursively free page-table pages.
// All leaf mappings must already have been removed.
void
freewalk(pagetable_t pagetable)
{
    800015ae:	7179                	addi	sp,sp,-48
    800015b0:	f406                	sd	ra,40(sp)
    800015b2:	f022                	sd	s0,32(sp)
    800015b4:	ec26                	sd	s1,24(sp)
    800015b6:	e84a                	sd	s2,16(sp)
    800015b8:	e44e                	sd	s3,8(sp)
    800015ba:	e052                	sd	s4,0(sp)
    800015bc:	1800                	addi	s0,sp,48
    800015be:	8a2a                	mv	s4,a0
  // there are 2^9 = 512 PTEs in a page table.
  for(int i = 0; i < 512; i++){
    800015c0:	84aa                	mv	s1,a0
    800015c2:	6905                	lui	s2,0x1
    800015c4:	992a                	add	s2,s2,a0
    pte_t pte = pagetable[i];
    if((pte & PTE_V) && (pte & (PTE_R|PTE_W|PTE_X)) == 0){
    800015c6:	4985                	li	s3,1
    800015c8:	a821                	j	800015e0 <freewalk+0x32>
      // this PTE points to a lower-level page table.
      uint64 child = PTE2PA(pte);
    800015ca:	8129                	srli	a0,a0,0xa
      freewalk((pagetable_t)child);
    800015cc:	0532                	slli	a0,a0,0xc
    800015ce:	00000097          	auipc	ra,0x0
    800015d2:	fe0080e7          	jalr	-32(ra) # 800015ae <freewalk>
      pagetable[i] = 0;
    800015d6:	0004b023          	sd	zero,0(s1)
  for(int i = 0; i < 512; i++){
    800015da:	04a1                	addi	s1,s1,8
    800015dc:	03248163          	beq	s1,s2,800015fe <freewalk+0x50>
    pte_t pte = pagetable[i];
    800015e0:	6088                	ld	a0,0(s1)
    if((pte & PTE_V) && (pte & (PTE_R|PTE_W|PTE_X)) == 0){
    800015e2:	00f57793          	andi	a5,a0,15
    800015e6:	ff3782e3          	beq	a5,s3,800015ca <freewalk+0x1c>
    } else if(pte & PTE_V){
    800015ea:	8905                	andi	a0,a0,1
    800015ec:	d57d                	beqz	a0,800015da <freewalk+0x2c>
      panic("freewalk: leaf");
    800015ee:	00007517          	auipc	a0,0x7
    800015f2:	b8250513          	addi	a0,a0,-1150 # 80008170 <digits+0x130>
    800015f6:	fffff097          	auipc	ra,0xfffff
    800015fa:	f4e080e7          	jalr	-178(ra) # 80000544 <panic>
    }
  }
  kfree((void*)pagetable);
    800015fe:	8552                	mv	a0,s4
    80001600:	fffff097          	auipc	ra,0xfffff
    80001604:	3fe080e7          	jalr	1022(ra) # 800009fe <kfree>
}
    80001608:	70a2                	ld	ra,40(sp)
    8000160a:	7402                	ld	s0,32(sp)
    8000160c:	64e2                	ld	s1,24(sp)
    8000160e:	6942                	ld	s2,16(sp)
    80001610:	69a2                	ld	s3,8(sp)
    80001612:	6a02                	ld	s4,0(sp)
    80001614:	6145                	addi	sp,sp,48
    80001616:	8082                	ret

0000000080001618 <uvmfree>:

// Free user memory pages,
// then free page-table pages.
void
uvmfree(pagetable_t pagetable, uint64 sz)
{
    80001618:	1101                	addi	sp,sp,-32
    8000161a:	ec06                	sd	ra,24(sp)
    8000161c:	e822                	sd	s0,16(sp)
    8000161e:	e426                	sd	s1,8(sp)
    80001620:	1000                	addi	s0,sp,32
    80001622:	84aa                	mv	s1,a0
  if(sz > 0)
    80001624:	e999                	bnez	a1,8000163a <uvmfree+0x22>
    uvmunmap(pagetable, 0, PGROUNDUP(sz)/PGSIZE, 1);
  freewalk(pagetable);
    80001626:	8526                	mv	a0,s1
    80001628:	00000097          	auipc	ra,0x0
    8000162c:	f86080e7          	jalr	-122(ra) # 800015ae <freewalk>
}
    80001630:	60e2                	ld	ra,24(sp)
    80001632:	6442                	ld	s0,16(sp)
    80001634:	64a2                	ld	s1,8(sp)
    80001636:	6105                	addi	sp,sp,32
    80001638:	8082                	ret
    uvmunmap(pagetable, 0, PGROUNDUP(sz)/PGSIZE, 1);
    8000163a:	6605                	lui	a2,0x1
    8000163c:	167d                	addi	a2,a2,-1
    8000163e:	962e                	add	a2,a2,a1
    80001640:	4685                	li	a3,1
    80001642:	8231                	srli	a2,a2,0xc
    80001644:	4581                	li	a1,0
    80001646:	00000097          	auipc	ra,0x0
    8000164a:	d0a080e7          	jalr	-758(ra) # 80001350 <uvmunmap>
    8000164e:	bfe1                	j	80001626 <uvmfree+0xe>

0000000080001650 <uvmcopy>:
  pte_t *pte;
  uint64 pa, i;
  uint flags;
  char *mem;

  for(i = 0; i < sz; i += PGSIZE){
    80001650:	c679                	beqz	a2,8000171e <uvmcopy+0xce>
{
    80001652:	715d                	addi	sp,sp,-80
    80001654:	e486                	sd	ra,72(sp)
    80001656:	e0a2                	sd	s0,64(sp)
    80001658:	fc26                	sd	s1,56(sp)
    8000165a:	f84a                	sd	s2,48(sp)
    8000165c:	f44e                	sd	s3,40(sp)
    8000165e:	f052                	sd	s4,32(sp)
    80001660:	ec56                	sd	s5,24(sp)
    80001662:	e85a                	sd	s6,16(sp)
    80001664:	e45e                	sd	s7,8(sp)
    80001666:	0880                	addi	s0,sp,80
    80001668:	8b2a                	mv	s6,a0
    8000166a:	8aae                	mv	s5,a1
    8000166c:	8a32                	mv	s4,a2
  for(i = 0; i < sz; i += PGSIZE){
    8000166e:	4981                	li	s3,0
    if((pte = walk(old, i, 0)) == 0)
    80001670:	4601                	li	a2,0
    80001672:	85ce                	mv	a1,s3
    80001674:	855a                	mv	a0,s6
    80001676:	00000097          	auipc	ra,0x0
    8000167a:	a2c080e7          	jalr	-1492(ra) # 800010a2 <walk>
    8000167e:	c531                	beqz	a0,800016ca <uvmcopy+0x7a>
      panic("uvmcopy: pte should exist");
    if((*pte & PTE_V) == 0)
    80001680:	6118                	ld	a4,0(a0)
    80001682:	00177793          	andi	a5,a4,1
    80001686:	cbb1                	beqz	a5,800016da <uvmcopy+0x8a>
      panic("uvmcopy: page not present");
    pa = PTE2PA(*pte);
    80001688:	00a75593          	srli	a1,a4,0xa
    8000168c:	00c59b93          	slli	s7,a1,0xc
    flags = PTE_FLAGS(*pte);
    80001690:	3ff77493          	andi	s1,a4,1023
    if((mem = kalloc()) == 0)
    80001694:	fffff097          	auipc	ra,0xfffff
    80001698:	466080e7          	jalr	1126(ra) # 80000afa <kalloc>
    8000169c:	892a                	mv	s2,a0
    8000169e:	c939                	beqz	a0,800016f4 <uvmcopy+0xa4>
      goto err;
    memmove(mem, (char*)pa, PGSIZE);
    800016a0:	6605                	lui	a2,0x1
    800016a2:	85de                	mv	a1,s7
    800016a4:	fffff097          	auipc	ra,0xfffff
    800016a8:	772080e7          	jalr	1906(ra) # 80000e16 <memmove>
    if(mappages(new, i, PGSIZE, (uint64)mem, flags) != 0){
    800016ac:	8726                	mv	a4,s1
    800016ae:	86ca                	mv	a3,s2
    800016b0:	6605                	lui	a2,0x1
    800016b2:	85ce                	mv	a1,s3
    800016b4:	8556                	mv	a0,s5
    800016b6:	00000097          	auipc	ra,0x0
    800016ba:	ad4080e7          	jalr	-1324(ra) # 8000118a <mappages>
    800016be:	e515                	bnez	a0,800016ea <uvmcopy+0x9a>
  for(i = 0; i < sz; i += PGSIZE){
    800016c0:	6785                	lui	a5,0x1
    800016c2:	99be                	add	s3,s3,a5
    800016c4:	fb49e6e3          	bltu	s3,s4,80001670 <uvmcopy+0x20>
    800016c8:	a081                	j	80001708 <uvmcopy+0xb8>
      panic("uvmcopy: pte should exist");
    800016ca:	00007517          	auipc	a0,0x7
    800016ce:	ab650513          	addi	a0,a0,-1354 # 80008180 <digits+0x140>
    800016d2:	fffff097          	auipc	ra,0xfffff
    800016d6:	e72080e7          	jalr	-398(ra) # 80000544 <panic>
      panic("uvmcopy: page not present");
    800016da:	00007517          	auipc	a0,0x7
    800016de:	ac650513          	addi	a0,a0,-1338 # 800081a0 <digits+0x160>
    800016e2:	fffff097          	auipc	ra,0xfffff
    800016e6:	e62080e7          	jalr	-414(ra) # 80000544 <panic>
      kfree(mem);
    800016ea:	854a                	mv	a0,s2
    800016ec:	fffff097          	auipc	ra,0xfffff
    800016f0:	312080e7          	jalr	786(ra) # 800009fe <kfree>
    }
  }
  return 0;

 err:
  uvmunmap(new, 0, i / PGSIZE, 1);
    800016f4:	4685                	li	a3,1
    800016f6:	00c9d613          	srli	a2,s3,0xc
    800016fa:	4581                	li	a1,0
    800016fc:	8556                	mv	a0,s5
    800016fe:	00000097          	auipc	ra,0x0
    80001702:	c52080e7          	jalr	-942(ra) # 80001350 <uvmunmap>
  return -1;
    80001706:	557d                	li	a0,-1
}
    80001708:	60a6                	ld	ra,72(sp)
    8000170a:	6406                	ld	s0,64(sp)
    8000170c:	74e2                	ld	s1,56(sp)
    8000170e:	7942                	ld	s2,48(sp)
    80001710:	79a2                	ld	s3,40(sp)
    80001712:	7a02                	ld	s4,32(sp)
    80001714:	6ae2                	ld	s5,24(sp)
    80001716:	6b42                	ld	s6,16(sp)
    80001718:	6ba2                	ld	s7,8(sp)
    8000171a:	6161                	addi	sp,sp,80
    8000171c:	8082                	ret
  return 0;
    8000171e:	4501                	li	a0,0
}
    80001720:	8082                	ret

0000000080001722 <uvmclear>:

// mark a PTE invalid for user access.
// used by exec for the user stack guard page.
void
uvmclear(pagetable_t pagetable, uint64 va)
{
    80001722:	1141                	addi	sp,sp,-16
    80001724:	e406                	sd	ra,8(sp)
    80001726:	e022                	sd	s0,0(sp)
    80001728:	0800                	addi	s0,sp,16
  pte_t *pte;
  
  pte = walk(pagetable, va, 0);
    8000172a:	4601                	li	a2,0
    8000172c:	00000097          	auipc	ra,0x0
    80001730:	976080e7          	jalr	-1674(ra) # 800010a2 <walk>
  if(pte == 0)
    80001734:	c901                	beqz	a0,80001744 <uvmclear+0x22>
    panic("uvmclear");
  *pte &= ~PTE_U;
    80001736:	611c                	ld	a5,0(a0)
    80001738:	9bbd                	andi	a5,a5,-17
    8000173a:	e11c                	sd	a5,0(a0)
}
    8000173c:	60a2                	ld	ra,8(sp)
    8000173e:	6402                	ld	s0,0(sp)
    80001740:	0141                	addi	sp,sp,16
    80001742:	8082                	ret
    panic("uvmclear");
    80001744:	00007517          	auipc	a0,0x7
    80001748:	a7c50513          	addi	a0,a0,-1412 # 800081c0 <digits+0x180>
    8000174c:	fffff097          	auipc	ra,0xfffff
    80001750:	df8080e7          	jalr	-520(ra) # 80000544 <panic>

0000000080001754 <copyout>:
int
copyout(pagetable_t pagetable, uint64 dstva, char *src, uint64 len)
{
  uint64 n, va0, pa0;

  while(len > 0){
    80001754:	c6bd                	beqz	a3,800017c2 <copyout+0x6e>
{
    80001756:	715d                	addi	sp,sp,-80
    80001758:	e486                	sd	ra,72(sp)
    8000175a:	e0a2                	sd	s0,64(sp)
    8000175c:	fc26                	sd	s1,56(sp)
    8000175e:	f84a                	sd	s2,48(sp)
    80001760:	f44e                	sd	s3,40(sp)
    80001762:	f052                	sd	s4,32(sp)
    80001764:	ec56                	sd	s5,24(sp)
    80001766:	e85a                	sd	s6,16(sp)
    80001768:	e45e                	sd	s7,8(sp)
    8000176a:	e062                	sd	s8,0(sp)
    8000176c:	0880                	addi	s0,sp,80
    8000176e:	8b2a                	mv	s6,a0
    80001770:	8c2e                	mv	s8,a1
    80001772:	8a32                	mv	s4,a2
    80001774:	89b6                	mv	s3,a3
    va0 = PGROUNDDOWN(dstva);
    80001776:	7bfd                	lui	s7,0xfffff
    pa0 = walkaddr(pagetable, va0);
    if(pa0 == 0)
      return -1;
    n = PGSIZE - (dstva - va0);
    80001778:	6a85                	lui	s5,0x1
    8000177a:	a015                	j	8000179e <copyout+0x4a>
    if(n > len)
      n = len;
    memmove((void *)(pa0 + (dstva - va0)), src, n);
    8000177c:	9562                	add	a0,a0,s8
    8000177e:	0004861b          	sext.w	a2,s1
    80001782:	85d2                	mv	a1,s4
    80001784:	41250533          	sub	a0,a0,s2
    80001788:	fffff097          	auipc	ra,0xfffff
    8000178c:	68e080e7          	jalr	1678(ra) # 80000e16 <memmove>

    len -= n;
    80001790:	409989b3          	sub	s3,s3,s1
    src += n;
    80001794:	9a26                	add	s4,s4,s1
    dstva = va0 + PGSIZE;
    80001796:	01590c33          	add	s8,s2,s5
  while(len > 0){
    8000179a:	02098263          	beqz	s3,800017be <copyout+0x6a>
    va0 = PGROUNDDOWN(dstva);
    8000179e:	017c7933          	and	s2,s8,s7
    pa0 = walkaddr(pagetable, va0);
    800017a2:	85ca                	mv	a1,s2
    800017a4:	855a                	mv	a0,s6
    800017a6:	00000097          	auipc	ra,0x0
    800017aa:	9a2080e7          	jalr	-1630(ra) # 80001148 <walkaddr>
    if(pa0 == 0)
    800017ae:	cd01                	beqz	a0,800017c6 <copyout+0x72>
    n = PGSIZE - (dstva - va0);
    800017b0:	418904b3          	sub	s1,s2,s8
    800017b4:	94d6                	add	s1,s1,s5
    if(n > len)
    800017b6:	fc99f3e3          	bgeu	s3,s1,8000177c <copyout+0x28>
    800017ba:	84ce                	mv	s1,s3
    800017bc:	b7c1                	j	8000177c <copyout+0x28>
  }
  return 0;
    800017be:	4501                	li	a0,0
    800017c0:	a021                	j	800017c8 <copyout+0x74>
    800017c2:	4501                	li	a0,0
}
    800017c4:	8082                	ret
      return -1;
    800017c6:	557d                	li	a0,-1
}
    800017c8:	60a6                	ld	ra,72(sp)
    800017ca:	6406                	ld	s0,64(sp)
    800017cc:	74e2                	ld	s1,56(sp)
    800017ce:	7942                	ld	s2,48(sp)
    800017d0:	79a2                	ld	s3,40(sp)
    800017d2:	7a02                	ld	s4,32(sp)
    800017d4:	6ae2                	ld	s5,24(sp)
    800017d6:	6b42                	ld	s6,16(sp)
    800017d8:	6ba2                	ld	s7,8(sp)
    800017da:	6c02                	ld	s8,0(sp)
    800017dc:	6161                	addi	sp,sp,80
    800017de:	8082                	ret

00000000800017e0 <copyin>:
int
copyin(pagetable_t pagetable, char *dst, uint64 srcva, uint64 len)
{
  uint64 n, va0, pa0;

  while(len > 0){
    800017e0:	c6bd                	beqz	a3,8000184e <copyin+0x6e>
{
    800017e2:	715d                	addi	sp,sp,-80
    800017e4:	e486                	sd	ra,72(sp)
    800017e6:	e0a2                	sd	s0,64(sp)
    800017e8:	fc26                	sd	s1,56(sp)
    800017ea:	f84a                	sd	s2,48(sp)
    800017ec:	f44e                	sd	s3,40(sp)
    800017ee:	f052                	sd	s4,32(sp)
    800017f0:	ec56                	sd	s5,24(sp)
    800017f2:	e85a                	sd	s6,16(sp)
    800017f4:	e45e                	sd	s7,8(sp)
    800017f6:	e062                	sd	s8,0(sp)
    800017f8:	0880                	addi	s0,sp,80
    800017fa:	8b2a                	mv	s6,a0
    800017fc:	8a2e                	mv	s4,a1
    800017fe:	8c32                	mv	s8,a2
    80001800:	89b6                	mv	s3,a3
    va0 = PGROUNDDOWN(srcva);
    80001802:	7bfd                	lui	s7,0xfffff
    pa0 = walkaddr(pagetable, va0);
    if(pa0 == 0)
      return -1;
    n = PGSIZE - (srcva - va0);
    80001804:	6a85                	lui	s5,0x1
    80001806:	a015                	j	8000182a <copyin+0x4a>
    if(n > len)
      n = len;
    memmove(dst, (void *)(pa0 + (srcva - va0)), n);
    80001808:	9562                	add	a0,a0,s8
    8000180a:	0004861b          	sext.w	a2,s1
    8000180e:	412505b3          	sub	a1,a0,s2
    80001812:	8552                	mv	a0,s4
    80001814:	fffff097          	auipc	ra,0xfffff
    80001818:	602080e7          	jalr	1538(ra) # 80000e16 <memmove>

    len -= n;
    8000181c:	409989b3          	sub	s3,s3,s1
    dst += n;
    80001820:	9a26                	add	s4,s4,s1
    srcva = va0 + PGSIZE;
    80001822:	01590c33          	add	s8,s2,s5
  while(len > 0){
    80001826:	02098263          	beqz	s3,8000184a <copyin+0x6a>
    va0 = PGROUNDDOWN(srcva);
    8000182a:	017c7933          	and	s2,s8,s7
    pa0 = walkaddr(pagetable, va0);
    8000182e:	85ca                	mv	a1,s2
    80001830:	855a                	mv	a0,s6
    80001832:	00000097          	auipc	ra,0x0
    80001836:	916080e7          	jalr	-1770(ra) # 80001148 <walkaddr>
    if(pa0 == 0)
    8000183a:	cd01                	beqz	a0,80001852 <copyin+0x72>
    n = PGSIZE - (srcva - va0);
    8000183c:	418904b3          	sub	s1,s2,s8
    80001840:	94d6                	add	s1,s1,s5
    if(n > len)
    80001842:	fc99f3e3          	bgeu	s3,s1,80001808 <copyin+0x28>
    80001846:	84ce                	mv	s1,s3
    80001848:	b7c1                	j	80001808 <copyin+0x28>
  }
  return 0;
    8000184a:	4501                	li	a0,0
    8000184c:	a021                	j	80001854 <copyin+0x74>
    8000184e:	4501                	li	a0,0
}
    80001850:	8082                	ret
      return -1;
    80001852:	557d                	li	a0,-1
}
    80001854:	60a6                	ld	ra,72(sp)
    80001856:	6406                	ld	s0,64(sp)
    80001858:	74e2                	ld	s1,56(sp)
    8000185a:	7942                	ld	s2,48(sp)
    8000185c:	79a2                	ld	s3,40(sp)
    8000185e:	7a02                	ld	s4,32(sp)
    80001860:	6ae2                	ld	s5,24(sp)
    80001862:	6b42                	ld	s6,16(sp)
    80001864:	6ba2                	ld	s7,8(sp)
    80001866:	6c02                	ld	s8,0(sp)
    80001868:	6161                	addi	sp,sp,80
    8000186a:	8082                	ret

000000008000186c <copyinstr>:
copyinstr(pagetable_t pagetable, char *dst, uint64 srcva, uint64 max)
{
  uint64 n, va0, pa0;
  int got_null = 0;

  while(got_null == 0 && max > 0){
    8000186c:	c6c5                	beqz	a3,80001914 <copyinstr+0xa8>
{
    8000186e:	715d                	addi	sp,sp,-80
    80001870:	e486                	sd	ra,72(sp)
    80001872:	e0a2                	sd	s0,64(sp)
    80001874:	fc26                	sd	s1,56(sp)
    80001876:	f84a                	sd	s2,48(sp)
    80001878:	f44e                	sd	s3,40(sp)
    8000187a:	f052                	sd	s4,32(sp)
    8000187c:	ec56                	sd	s5,24(sp)
    8000187e:	e85a                	sd	s6,16(sp)
    80001880:	e45e                	sd	s7,8(sp)
    80001882:	0880                	addi	s0,sp,80
    80001884:	8a2a                	mv	s4,a0
    80001886:	8b2e                	mv	s6,a1
    80001888:	8bb2                	mv	s7,a2
    8000188a:	84b6                	mv	s1,a3
    va0 = PGROUNDDOWN(srcva);
    8000188c:	7afd                	lui	s5,0xfffff
    pa0 = walkaddr(pagetable, va0);
    if(pa0 == 0)
      return -1;
    n = PGSIZE - (srcva - va0);
    8000188e:	6985                	lui	s3,0x1
    80001890:	a035                	j	800018bc <copyinstr+0x50>
      n = max;

    char *p = (char *) (pa0 + (srcva - va0));
    while(n > 0){
      if(*p == '\0'){
        *dst = '\0';
    80001892:	00078023          	sb	zero,0(a5) # 1000 <_entry-0x7ffff000>
    80001896:	4785                	li	a5,1
      dst++;
    }

    srcva = va0 + PGSIZE;
  }
  if(got_null){
    80001898:	0017b793          	seqz	a5,a5
    8000189c:	40f00533          	neg	a0,a5
    return 0;
  } else {
    return -1;
  }
}
    800018a0:	60a6                	ld	ra,72(sp)
    800018a2:	6406                	ld	s0,64(sp)
    800018a4:	74e2                	ld	s1,56(sp)
    800018a6:	7942                	ld	s2,48(sp)
    800018a8:	79a2                	ld	s3,40(sp)
    800018aa:	7a02                	ld	s4,32(sp)
    800018ac:	6ae2                	ld	s5,24(sp)
    800018ae:	6b42                	ld	s6,16(sp)
    800018b0:	6ba2                	ld	s7,8(sp)
    800018b2:	6161                	addi	sp,sp,80
    800018b4:	8082                	ret
    srcva = va0 + PGSIZE;
    800018b6:	01390bb3          	add	s7,s2,s3
  while(got_null == 0 && max > 0){
    800018ba:	c8a9                	beqz	s1,8000190c <copyinstr+0xa0>
    va0 = PGROUNDDOWN(srcva);
    800018bc:	015bf933          	and	s2,s7,s5
    pa0 = walkaddr(pagetable, va0);
    800018c0:	85ca                	mv	a1,s2
    800018c2:	8552                	mv	a0,s4
    800018c4:	00000097          	auipc	ra,0x0
    800018c8:	884080e7          	jalr	-1916(ra) # 80001148 <walkaddr>
    if(pa0 == 0)
    800018cc:	c131                	beqz	a0,80001910 <copyinstr+0xa4>
    n = PGSIZE - (srcva - va0);
    800018ce:	41790833          	sub	a6,s2,s7
    800018d2:	984e                	add	a6,a6,s3
    if(n > max)
    800018d4:	0104f363          	bgeu	s1,a6,800018da <copyinstr+0x6e>
    800018d8:	8826                	mv	a6,s1
    char *p = (char *) (pa0 + (srcva - va0));
    800018da:	955e                	add	a0,a0,s7
    800018dc:	41250533          	sub	a0,a0,s2
    while(n > 0){
    800018e0:	fc080be3          	beqz	a6,800018b6 <copyinstr+0x4a>
    800018e4:	985a                	add	a6,a6,s6
    800018e6:	87da                	mv	a5,s6
      if(*p == '\0'){
    800018e8:	41650633          	sub	a2,a0,s6
    800018ec:	14fd                	addi	s1,s1,-1
    800018ee:	9b26                	add	s6,s6,s1
    800018f0:	00f60733          	add	a4,a2,a5
    800018f4:	00074703          	lbu	a4,0(a4)
    800018f8:	df49                	beqz	a4,80001892 <copyinstr+0x26>
        *dst = *p;
    800018fa:	00e78023          	sb	a4,0(a5)
      --max;
    800018fe:	40fb04b3          	sub	s1,s6,a5
      dst++;
    80001902:	0785                	addi	a5,a5,1
    while(n > 0){
    80001904:	ff0796e3          	bne	a5,a6,800018f0 <copyinstr+0x84>
      dst++;
    80001908:	8b42                	mv	s6,a6
    8000190a:	b775                	j	800018b6 <copyinstr+0x4a>
    8000190c:	4781                	li	a5,0
    8000190e:	b769                	j	80001898 <copyinstr+0x2c>
      return -1;
    80001910:	557d                	li	a0,-1
    80001912:	b779                	j	800018a0 <copyinstr+0x34>
  int got_null = 0;
    80001914:	4781                	li	a5,0
  if(got_null){
    80001916:	0017b793          	seqz	a5,a5
    8000191a:	40f00533          	neg	a0,a5
}
    8000191e:	8082                	ret

0000000080001920 <proc_mapstacks>:
// Allocate a page for each process's kernel stack.
// Map it high in memory, followed by an invalid
// guard page.
void
proc_mapstacks(pagetable_t kpgtbl)
{
    80001920:	7139                	addi	sp,sp,-64
    80001922:	fc06                	sd	ra,56(sp)
    80001924:	f822                	sd	s0,48(sp)
    80001926:	f426                	sd	s1,40(sp)
    80001928:	f04a                	sd	s2,32(sp)
    8000192a:	ec4e                	sd	s3,24(sp)
    8000192c:	e852                	sd	s4,16(sp)
    8000192e:	e456                	sd	s5,8(sp)
    80001930:	e05a                	sd	s6,0(sp)
    80001932:	0080                	addi	s0,sp,64
    80001934:	89aa                	mv	s3,a0
  struct proc *p;
  
  for(p = proc; p < &proc[NPROC]; p++) {
    80001936:	00010497          	auipc	s1,0x10
    8000193a:	8ea48493          	addi	s1,s1,-1814 # 80011220 <proc>
    char *pa = kalloc();
    if(pa == 0)
      panic("kalloc");
    uint64 va = KSTACK((int) (p - proc));
    8000193e:	8b26                	mv	s6,s1
    80001940:	00006a97          	auipc	s5,0x6
    80001944:	6c0a8a93          	addi	s5,s5,1728 # 80008000 <etext>
    80001948:	04000937          	lui	s2,0x4000
    8000194c:	197d                	addi	s2,s2,-1
    8000194e:	0932                	slli	s2,s2,0xc
  for(p = proc; p < &proc[NPROC]; p++) {
    80001950:	00016a17          	auipc	s4,0x16
    80001954:	8d0a0a13          	addi	s4,s4,-1840 # 80017220 <tickslock>
    char *pa = kalloc();
    80001958:	fffff097          	auipc	ra,0xfffff
    8000195c:	1a2080e7          	jalr	418(ra) # 80000afa <kalloc>
    80001960:	862a                	mv	a2,a0
    if(pa == 0)
    80001962:	c131                	beqz	a0,800019a6 <proc_mapstacks+0x86>
    uint64 va = KSTACK((int) (p - proc));
    80001964:	416485b3          	sub	a1,s1,s6
    80001968:	859d                	srai	a1,a1,0x7
    8000196a:	000ab783          	ld	a5,0(s5)
    8000196e:	02f585b3          	mul	a1,a1,a5
    80001972:	2585                	addiw	a1,a1,1
    80001974:	00d5959b          	slliw	a1,a1,0xd
    kvmmap(kpgtbl, va, (uint64)pa, PGSIZE, PTE_R | PTE_W);
    80001978:	4719                	li	a4,6
    8000197a:	6685                	lui	a3,0x1
    8000197c:	40b905b3          	sub	a1,s2,a1
    80001980:	854e                	mv	a0,s3
    80001982:	00000097          	auipc	ra,0x0
    80001986:	8a8080e7          	jalr	-1880(ra) # 8000122a <kvmmap>
  for(p = proc; p < &proc[NPROC]; p++) {
    8000198a:	18048493          	addi	s1,s1,384
    8000198e:	fd4495e3          	bne	s1,s4,80001958 <proc_mapstacks+0x38>
  }
}
    80001992:	70e2                	ld	ra,56(sp)
    80001994:	7442                	ld	s0,48(sp)
    80001996:	74a2                	ld	s1,40(sp)
    80001998:	7902                	ld	s2,32(sp)
    8000199a:	69e2                	ld	s3,24(sp)
    8000199c:	6a42                	ld	s4,16(sp)
    8000199e:	6aa2                	ld	s5,8(sp)
    800019a0:	6b02                	ld	s6,0(sp)
    800019a2:	6121                	addi	sp,sp,64
    800019a4:	8082                	ret
      panic("kalloc");
    800019a6:	00007517          	auipc	a0,0x7
    800019aa:	82a50513          	addi	a0,a0,-2006 # 800081d0 <digits+0x190>
    800019ae:	fffff097          	auipc	ra,0xfffff
    800019b2:	b96080e7          	jalr	-1130(ra) # 80000544 <panic>

00000000800019b6 <procinit>:

// initialize the proc table.
void
procinit(void)
{
    800019b6:	7139                	addi	sp,sp,-64
    800019b8:	fc06                	sd	ra,56(sp)
    800019ba:	f822                	sd	s0,48(sp)
    800019bc:	f426                	sd	s1,40(sp)
    800019be:	f04a                	sd	s2,32(sp)
    800019c0:	ec4e                	sd	s3,24(sp)
    800019c2:	e852                	sd	s4,16(sp)
    800019c4:	e456                	sd	s5,8(sp)
    800019c6:	e05a                	sd	s6,0(sp)
    800019c8:	0080                	addi	s0,sp,64
  struct proc *p;
  
  initlock(&pid_lock, "nextpid");
    800019ca:	00007597          	auipc	a1,0x7
    800019ce:	80e58593          	addi	a1,a1,-2034 # 800081d8 <digits+0x198>
    800019d2:	0000f517          	auipc	a0,0xf
    800019d6:	40e50513          	addi	a0,a0,1038 # 80010de0 <pid_lock>
    800019da:	fffff097          	auipc	ra,0xfffff
    800019de:	1ca080e7          	jalr	458(ra) # 80000ba4 <initlock>
  initlock(&wait_lock, "wait_lock");
    800019e2:	00006597          	auipc	a1,0x6
    800019e6:	7fe58593          	addi	a1,a1,2046 # 800081e0 <digits+0x1a0>
    800019ea:	0000f517          	auipc	a0,0xf
    800019ee:	41650513          	addi	a0,a0,1046 # 80010e00 <wait_lock>
    800019f2:	fffff097          	auipc	ra,0xfffff
    800019f6:	1b2080e7          	jalr	434(ra) # 80000ba4 <initlock>
  for(p = proc; p < &proc[NPROC]; p++) {
    800019fa:	00010497          	auipc	s1,0x10
    800019fe:	82648493          	addi	s1,s1,-2010 # 80011220 <proc>
      initlock(&p->lock, "proc");
    80001a02:	00006b17          	auipc	s6,0x6
    80001a06:	7eeb0b13          	addi	s6,s6,2030 # 800081f0 <digits+0x1b0>
      p->state = UNUSED;
      p->kstack = KSTACK((int) (p - proc));
    80001a0a:	8aa6                	mv	s5,s1
    80001a0c:	00006a17          	auipc	s4,0x6
    80001a10:	5f4a0a13          	addi	s4,s4,1524 # 80008000 <etext>
    80001a14:	04000937          	lui	s2,0x4000
    80001a18:	197d                	addi	s2,s2,-1
    80001a1a:	0932                	slli	s2,s2,0xc
  for(p = proc; p < &proc[NPROC]; p++) {
    80001a1c:	00016997          	auipc	s3,0x16
    80001a20:	80498993          	addi	s3,s3,-2044 # 80017220 <tickslock>
      initlock(&p->lock, "proc");
    80001a24:	85da                	mv	a1,s6
    80001a26:	8526                	mv	a0,s1
    80001a28:	fffff097          	auipc	ra,0xfffff
    80001a2c:	17c080e7          	jalr	380(ra) # 80000ba4 <initlock>
      p->state = UNUSED;
    80001a30:	0204a023          	sw	zero,32(s1)
      p->kstack = KSTACK((int) (p - proc));
    80001a34:	415487b3          	sub	a5,s1,s5
    80001a38:	879d                	srai	a5,a5,0x7
    80001a3a:	000a3703          	ld	a4,0(s4)
    80001a3e:	02e787b3          	mul	a5,a5,a4
    80001a42:	2785                	addiw	a5,a5,1
    80001a44:	00d7979b          	slliw	a5,a5,0xd
    80001a48:	40f907b3          	sub	a5,s2,a5
    80001a4c:	e8bc                	sd	a5,80(s1)
  for(p = proc; p < &proc[NPROC]; p++) {
    80001a4e:	18048493          	addi	s1,s1,384
    80001a52:	fd3499e3          	bne	s1,s3,80001a24 <procinit+0x6e>
  }
}
    80001a56:	70e2                	ld	ra,56(sp)
    80001a58:	7442                	ld	s0,48(sp)
    80001a5a:	74a2                	ld	s1,40(sp)
    80001a5c:	7902                	ld	s2,32(sp)
    80001a5e:	69e2                	ld	s3,24(sp)
    80001a60:	6a42                	ld	s4,16(sp)
    80001a62:	6aa2                	ld	s5,8(sp)
    80001a64:	6b02                	ld	s6,0(sp)
    80001a66:	6121                	addi	sp,sp,64
    80001a68:	8082                	ret

0000000080001a6a <cpuid>:
// Must be called with interrupts disabled,
// to prevent race with process being moved
// to a different CPU.
int
cpuid()
{
    80001a6a:	1141                	addi	sp,sp,-16
    80001a6c:	e422                	sd	s0,8(sp)
    80001a6e:	0800                	addi	s0,sp,16
  asm volatile("mv %0, tp" : "=r" (x) );
    80001a70:	8512                	mv	a0,tp
  int id = r_tp();
  return id;
}
    80001a72:	2501                	sext.w	a0,a0
    80001a74:	6422                	ld	s0,8(sp)
    80001a76:	0141                	addi	sp,sp,16
    80001a78:	8082                	ret

0000000080001a7a <mycpu>:

// Return this CPU's cpu struct.
// Interrupts must be disabled.
struct cpu*
mycpu(void)
{
    80001a7a:	1141                	addi	sp,sp,-16
    80001a7c:	e422                	sd	s0,8(sp)
    80001a7e:	0800                	addi	s0,sp,16
    80001a80:	8792                	mv	a5,tp
  int id = cpuid();
  struct cpu *c = &cpus[id];
    80001a82:	2781                	sext.w	a5,a5
    80001a84:	079e                	slli	a5,a5,0x7
  return c;
}
    80001a86:	0000f517          	auipc	a0,0xf
    80001a8a:	39a50513          	addi	a0,a0,922 # 80010e20 <cpus>
    80001a8e:	953e                	add	a0,a0,a5
    80001a90:	6422                	ld	s0,8(sp)
    80001a92:	0141                	addi	sp,sp,16
    80001a94:	8082                	ret

0000000080001a96 <myproc>:

// Return the current struct proc *, or zero if none.
struct proc*
myproc(void)
{
    80001a96:	1101                	addi	sp,sp,-32
    80001a98:	ec06                	sd	ra,24(sp)
    80001a9a:	e822                	sd	s0,16(sp)
    80001a9c:	e426                	sd	s1,8(sp)
    80001a9e:	1000                	addi	s0,sp,32
  push_off();
    80001aa0:	fffff097          	auipc	ra,0xfffff
    80001aa4:	122080e7          	jalr	290(ra) # 80000bc2 <push_off>
    80001aa8:	8792                	mv	a5,tp
  struct cpu *c = mycpu();
  struct proc *p = c->proc;
    80001aaa:	2781                	sext.w	a5,a5
    80001aac:	079e                	slli	a5,a5,0x7
    80001aae:	0000f717          	auipc	a4,0xf
    80001ab2:	33270713          	addi	a4,a4,818 # 80010de0 <pid_lock>
    80001ab6:	97ba                	add	a5,a5,a4
    80001ab8:	63a4                	ld	s1,64(a5)
  pop_off();
    80001aba:	fffff097          	auipc	ra,0xfffff
    80001abe:	20a080e7          	jalr	522(ra) # 80000cc4 <pop_off>
  return p;
}
    80001ac2:	8526                	mv	a0,s1
    80001ac4:	60e2                	ld	ra,24(sp)
    80001ac6:	6442                	ld	s0,16(sp)
    80001ac8:	64a2                	ld	s1,8(sp)
    80001aca:	6105                	addi	sp,sp,32
    80001acc:	8082                	ret

0000000080001ace <forkret>:

// A fork child's very first scheduling by scheduler()
// will swtch to forkret.
void
forkret(void)
{
    80001ace:	1141                	addi	sp,sp,-16
    80001ad0:	e406                	sd	ra,8(sp)
    80001ad2:	e022                	sd	s0,0(sp)
    80001ad4:	0800                	addi	s0,sp,16
  static int first = 1;

  // Still holding p->lock from scheduler.
  release(&myproc()->lock);
    80001ad6:	00000097          	auipc	ra,0x0
    80001ada:	fc0080e7          	jalr	-64(ra) # 80001a96 <myproc>
    80001ade:	fffff097          	auipc	ra,0xfffff
    80001ae2:	28a080e7          	jalr	650(ra) # 80000d68 <release>

  if (first) {
    80001ae6:	00007797          	auipc	a5,0x7
    80001aea:	fca7a783          	lw	a5,-54(a5) # 80008ab0 <first.1703>
    80001aee:	eb89                	bnez	a5,80001b00 <forkret+0x32>
    // be run from main().
    first = 0;
    fsinit(ROOTDEV);
  }

  usertrapret();
    80001af0:	00001097          	auipc	ra,0x1
    80001af4:	f24080e7          	jalr	-220(ra) # 80002a14 <usertrapret>
}
    80001af8:	60a2                	ld	ra,8(sp)
    80001afa:	6402                	ld	s0,0(sp)
    80001afc:	0141                	addi	sp,sp,16
    80001afe:	8082                	ret
    first = 0;
    80001b00:	00007797          	auipc	a5,0x7
    80001b04:	fa07a823          	sw	zero,-80(a5) # 80008ab0 <first.1703>
    fsinit(ROOTDEV);
    80001b08:	4505                	li	a0,1
    80001b0a:	00002097          	auipc	ra,0x2
    80001b0e:	d4c080e7          	jalr	-692(ra) # 80003856 <fsinit>
    80001b12:	bff9                	j	80001af0 <forkret+0x22>

0000000080001b14 <allocpid>:
{
    80001b14:	1101                	addi	sp,sp,-32
    80001b16:	ec06                	sd	ra,24(sp)
    80001b18:	e822                	sd	s0,16(sp)
    80001b1a:	e426                	sd	s1,8(sp)
    80001b1c:	e04a                	sd	s2,0(sp)
    80001b1e:	1000                	addi	s0,sp,32
  acquire(&pid_lock);
    80001b20:	0000f917          	auipc	s2,0xf
    80001b24:	2c090913          	addi	s2,s2,704 # 80010de0 <pid_lock>
    80001b28:	854a                	mv	a0,s2
    80001b2a:	fffff097          	auipc	ra,0xfffff
    80001b2e:	0e4080e7          	jalr	228(ra) # 80000c0e <acquire>
  pid = nextpid;
    80001b32:	00007797          	auipc	a5,0x7
    80001b36:	f8278793          	addi	a5,a5,-126 # 80008ab4 <nextpid>
    80001b3a:	4384                	lw	s1,0(a5)
  nextpid = nextpid + 1;
    80001b3c:	0014871b          	addiw	a4,s1,1
    80001b40:	c398                	sw	a4,0(a5)
  release(&pid_lock);
    80001b42:	854a                	mv	a0,s2
    80001b44:	fffff097          	auipc	ra,0xfffff
    80001b48:	224080e7          	jalr	548(ra) # 80000d68 <release>
}
    80001b4c:	8526                	mv	a0,s1
    80001b4e:	60e2                	ld	ra,24(sp)
    80001b50:	6442                	ld	s0,16(sp)
    80001b52:	64a2                	ld	s1,8(sp)
    80001b54:	6902                	ld	s2,0(sp)
    80001b56:	6105                	addi	sp,sp,32
    80001b58:	8082                	ret

0000000080001b5a <proc_pagetable>:
{
    80001b5a:	1101                	addi	sp,sp,-32
    80001b5c:	ec06                	sd	ra,24(sp)
    80001b5e:	e822                	sd	s0,16(sp)
    80001b60:	e426                	sd	s1,8(sp)
    80001b62:	e04a                	sd	s2,0(sp)
    80001b64:	1000                	addi	s0,sp,32
    80001b66:	892a                	mv	s2,a0
  pagetable = uvmcreate();
    80001b68:	00000097          	auipc	ra,0x0
    80001b6c:	8ac080e7          	jalr	-1876(ra) # 80001414 <uvmcreate>
    80001b70:	84aa                	mv	s1,a0
  if(pagetable == 0)
    80001b72:	c121                	beqz	a0,80001bb2 <proc_pagetable+0x58>
  if(mappages(pagetable, TRAMPOLINE, PGSIZE,
    80001b74:	4729                	li	a4,10
    80001b76:	00005697          	auipc	a3,0x5
    80001b7a:	48a68693          	addi	a3,a3,1162 # 80007000 <_trampoline>
    80001b7e:	6605                	lui	a2,0x1
    80001b80:	040005b7          	lui	a1,0x4000
    80001b84:	15fd                	addi	a1,a1,-1
    80001b86:	05b2                	slli	a1,a1,0xc
    80001b88:	fffff097          	auipc	ra,0xfffff
    80001b8c:	602080e7          	jalr	1538(ra) # 8000118a <mappages>
    80001b90:	02054863          	bltz	a0,80001bc0 <proc_pagetable+0x66>
  if(mappages(pagetable, TRAPFRAME, PGSIZE,
    80001b94:	4719                	li	a4,6
    80001b96:	06893683          	ld	a3,104(s2)
    80001b9a:	6605                	lui	a2,0x1
    80001b9c:	020005b7          	lui	a1,0x2000
    80001ba0:	15fd                	addi	a1,a1,-1
    80001ba2:	05b6                	slli	a1,a1,0xd
    80001ba4:	8526                	mv	a0,s1
    80001ba6:	fffff097          	auipc	ra,0xfffff
    80001baa:	5e4080e7          	jalr	1508(ra) # 8000118a <mappages>
    80001bae:	02054163          	bltz	a0,80001bd0 <proc_pagetable+0x76>
}
    80001bb2:	8526                	mv	a0,s1
    80001bb4:	60e2                	ld	ra,24(sp)
    80001bb6:	6442                	ld	s0,16(sp)
    80001bb8:	64a2                	ld	s1,8(sp)
    80001bba:	6902                	ld	s2,0(sp)
    80001bbc:	6105                	addi	sp,sp,32
    80001bbe:	8082                	ret
    uvmfree(pagetable, 0);
    80001bc0:	4581                	li	a1,0
    80001bc2:	8526                	mv	a0,s1
    80001bc4:	00000097          	auipc	ra,0x0
    80001bc8:	a54080e7          	jalr	-1452(ra) # 80001618 <uvmfree>
    return 0;
    80001bcc:	4481                	li	s1,0
    80001bce:	b7d5                	j	80001bb2 <proc_pagetable+0x58>
    uvmunmap(pagetable, TRAMPOLINE, 1, 0);
    80001bd0:	4681                	li	a3,0
    80001bd2:	4605                	li	a2,1
    80001bd4:	040005b7          	lui	a1,0x4000
    80001bd8:	15fd                	addi	a1,a1,-1
    80001bda:	05b2                	slli	a1,a1,0xc
    80001bdc:	8526                	mv	a0,s1
    80001bde:	fffff097          	auipc	ra,0xfffff
    80001be2:	772080e7          	jalr	1906(ra) # 80001350 <uvmunmap>
    uvmfree(pagetable, 0);
    80001be6:	4581                	li	a1,0
    80001be8:	8526                	mv	a0,s1
    80001bea:	00000097          	auipc	ra,0x0
    80001bee:	a2e080e7          	jalr	-1490(ra) # 80001618 <uvmfree>
    return 0;
    80001bf2:	4481                	li	s1,0
    80001bf4:	bf7d                	j	80001bb2 <proc_pagetable+0x58>

0000000080001bf6 <proc_freepagetable>:
{
    80001bf6:	1101                	addi	sp,sp,-32
    80001bf8:	ec06                	sd	ra,24(sp)
    80001bfa:	e822                	sd	s0,16(sp)
    80001bfc:	e426                	sd	s1,8(sp)
    80001bfe:	e04a                	sd	s2,0(sp)
    80001c00:	1000                	addi	s0,sp,32
    80001c02:	84aa                	mv	s1,a0
    80001c04:	892e                	mv	s2,a1
  uvmunmap(pagetable, TRAMPOLINE, 1, 0);
    80001c06:	4681                	li	a3,0
    80001c08:	4605                	li	a2,1
    80001c0a:	040005b7          	lui	a1,0x4000
    80001c0e:	15fd                	addi	a1,a1,-1
    80001c10:	05b2                	slli	a1,a1,0xc
    80001c12:	fffff097          	auipc	ra,0xfffff
    80001c16:	73e080e7          	jalr	1854(ra) # 80001350 <uvmunmap>
  uvmunmap(pagetable, TRAPFRAME, 1, 0);
    80001c1a:	4681                	li	a3,0
    80001c1c:	4605                	li	a2,1
    80001c1e:	020005b7          	lui	a1,0x2000
    80001c22:	15fd                	addi	a1,a1,-1
    80001c24:	05b6                	slli	a1,a1,0xd
    80001c26:	8526                	mv	a0,s1
    80001c28:	fffff097          	auipc	ra,0xfffff
    80001c2c:	728080e7          	jalr	1832(ra) # 80001350 <uvmunmap>
  uvmfree(pagetable, sz);
    80001c30:	85ca                	mv	a1,s2
    80001c32:	8526                	mv	a0,s1
    80001c34:	00000097          	auipc	ra,0x0
    80001c38:	9e4080e7          	jalr	-1564(ra) # 80001618 <uvmfree>
}
    80001c3c:	60e2                	ld	ra,24(sp)
    80001c3e:	6442                	ld	s0,16(sp)
    80001c40:	64a2                	ld	s1,8(sp)
    80001c42:	6902                	ld	s2,0(sp)
    80001c44:	6105                	addi	sp,sp,32
    80001c46:	8082                	ret

0000000080001c48 <freeproc>:
{
    80001c48:	1101                	addi	sp,sp,-32
    80001c4a:	ec06                	sd	ra,24(sp)
    80001c4c:	e822                	sd	s0,16(sp)
    80001c4e:	e426                	sd	s1,8(sp)
    80001c50:	1000                	addi	s0,sp,32
    80001c52:	84aa                	mv	s1,a0
  if(p->trapframe)
    80001c54:	7528                	ld	a0,104(a0)
    80001c56:	c509                	beqz	a0,80001c60 <freeproc+0x18>
    kfree((void*)p->trapframe);
    80001c58:	fffff097          	auipc	ra,0xfffff
    80001c5c:	da6080e7          	jalr	-602(ra) # 800009fe <kfree>
  p->trapframe = 0;
    80001c60:	0604b423          	sd	zero,104(s1)
  if(p->pagetable)
    80001c64:	70a8                	ld	a0,96(s1)
    80001c66:	c511                	beqz	a0,80001c72 <freeproc+0x2a>
    proc_freepagetable(p->pagetable, p->sz);
    80001c68:	6cac                	ld	a1,88(s1)
    80001c6a:	00000097          	auipc	ra,0x0
    80001c6e:	f8c080e7          	jalr	-116(ra) # 80001bf6 <proc_freepagetable>
  p->pagetable = 0;
    80001c72:	0604b023          	sd	zero,96(s1)
  p->sz = 0;
    80001c76:	0404bc23          	sd	zero,88(s1)
  p->pid = 0;
    80001c7a:	0204ac23          	sw	zero,56(s1)
  p->parent = 0;
    80001c7e:	0404b423          	sd	zero,72(s1)
  p->name[0] = 0;
    80001c82:	16048423          	sb	zero,360(s1)
  p->chan = 0;
    80001c86:	0204b423          	sd	zero,40(s1)
  p->killed = 0;
    80001c8a:	0204a823          	sw	zero,48(s1)
  p->xstate = 0;
    80001c8e:	0204aa23          	sw	zero,52(s1)
  p->state = UNUSED;
    80001c92:	0204a023          	sw	zero,32(s1)
  p->priority =0;
    80001c96:	0204ae23          	sw	zero,60(s1)
  p->runtime=0;
    80001c9a:	0404b023          	sd	zero,64(s1)
}
    80001c9e:	60e2                	ld	ra,24(sp)
    80001ca0:	6442                	ld	s0,16(sp)
    80001ca2:	64a2                	ld	s1,8(sp)
    80001ca4:	6105                	addi	sp,sp,32
    80001ca6:	8082                	ret

0000000080001ca8 <allocproc>:
{
    80001ca8:	1101                	addi	sp,sp,-32
    80001caa:	ec06                	sd	ra,24(sp)
    80001cac:	e822                	sd	s0,16(sp)
    80001cae:	e426                	sd	s1,8(sp)
    80001cb0:	e04a                	sd	s2,0(sp)
    80001cb2:	1000                	addi	s0,sp,32
  for(p = proc; p < &proc[NPROC]; p++) {
    80001cb4:	0000f497          	auipc	s1,0xf
    80001cb8:	56c48493          	addi	s1,s1,1388 # 80011220 <proc>
    80001cbc:	00015917          	auipc	s2,0x15
    80001cc0:	56490913          	addi	s2,s2,1380 # 80017220 <tickslock>
    acquire(&p->lock);
    80001cc4:	8526                	mv	a0,s1
    80001cc6:	fffff097          	auipc	ra,0xfffff
    80001cca:	f48080e7          	jalr	-184(ra) # 80000c0e <acquire>
    if(p->state == UNUSED) {
    80001cce:	509c                	lw	a5,32(s1)
    80001cd0:	cf81                	beqz	a5,80001ce8 <allocproc+0x40>
      release(&p->lock);
    80001cd2:	8526                	mv	a0,s1
    80001cd4:	fffff097          	auipc	ra,0xfffff
    80001cd8:	094080e7          	jalr	148(ra) # 80000d68 <release>
  for(p = proc; p < &proc[NPROC]; p++) {
    80001cdc:	18048493          	addi	s1,s1,384
    80001ce0:	ff2492e3          	bne	s1,s2,80001cc4 <allocproc+0x1c>
  return 0;
    80001ce4:	4481                	li	s1,0
    80001ce6:	a8b1                	j	80001d42 <allocproc+0x9a>
  p->pid = allocpid();
    80001ce8:	00000097          	auipc	ra,0x0
    80001cec:	e2c080e7          	jalr	-468(ra) # 80001b14 <allocpid>
    80001cf0:	dc88                	sw	a0,56(s1)
  p->state = USED;
    80001cf2:	4785                	li	a5,1
    80001cf4:	d09c                	sw	a5,32(s1)
  p->priority=50;//***new
    80001cf6:	03200793          	li	a5,50
    80001cfa:	dcdc                	sw	a5,60(s1)
  p->runtime=0;
    80001cfc:	0404b023          	sd	zero,64(s1)
  if((p->trapframe = (struct trapframe *)kalloc()) == 0){
    80001d00:	fffff097          	auipc	ra,0xfffff
    80001d04:	dfa080e7          	jalr	-518(ra) # 80000afa <kalloc>
    80001d08:	892a                	mv	s2,a0
    80001d0a:	f4a8                	sd	a0,104(s1)
    80001d0c:	c131                	beqz	a0,80001d50 <allocproc+0xa8>
  p->pagetable = proc_pagetable(p);
    80001d0e:	8526                	mv	a0,s1
    80001d10:	00000097          	auipc	ra,0x0
    80001d14:	e4a080e7          	jalr	-438(ra) # 80001b5a <proc_pagetable>
    80001d18:	892a                	mv	s2,a0
    80001d1a:	f0a8                	sd	a0,96(s1)
  if(p->pagetable == 0){
    80001d1c:	c531                	beqz	a0,80001d68 <allocproc+0xc0>
  memset(&p->context, 0, sizeof(p->context));
    80001d1e:	07000613          	li	a2,112
    80001d22:	4581                	li	a1,0
    80001d24:	07048513          	addi	a0,s1,112
    80001d28:	fffff097          	auipc	ra,0xfffff
    80001d2c:	08e080e7          	jalr	142(ra) # 80000db6 <memset>
  p->context.ra = (uint64)forkret;
    80001d30:	00000797          	auipc	a5,0x0
    80001d34:	d9e78793          	addi	a5,a5,-610 # 80001ace <forkret>
    80001d38:	f8bc                	sd	a5,112(s1)
  p->context.sp = p->kstack + PGSIZE;
    80001d3a:	68bc                	ld	a5,80(s1)
    80001d3c:	6705                	lui	a4,0x1
    80001d3e:	97ba                	add	a5,a5,a4
    80001d40:	fcbc                	sd	a5,120(s1)
}
    80001d42:	8526                	mv	a0,s1
    80001d44:	60e2                	ld	ra,24(sp)
    80001d46:	6442                	ld	s0,16(sp)
    80001d48:	64a2                	ld	s1,8(sp)
    80001d4a:	6902                	ld	s2,0(sp)
    80001d4c:	6105                	addi	sp,sp,32
    80001d4e:	8082                	ret
    freeproc(p);
    80001d50:	8526                	mv	a0,s1
    80001d52:	00000097          	auipc	ra,0x0
    80001d56:	ef6080e7          	jalr	-266(ra) # 80001c48 <freeproc>
    release(&p->lock);
    80001d5a:	8526                	mv	a0,s1
    80001d5c:	fffff097          	auipc	ra,0xfffff
    80001d60:	00c080e7          	jalr	12(ra) # 80000d68 <release>
    return 0;
    80001d64:	84ca                	mv	s1,s2
    80001d66:	bff1                	j	80001d42 <allocproc+0x9a>
    freeproc(p);
    80001d68:	8526                	mv	a0,s1
    80001d6a:	00000097          	auipc	ra,0x0
    80001d6e:	ede080e7          	jalr	-290(ra) # 80001c48 <freeproc>
    release(&p->lock);
    80001d72:	8526                	mv	a0,s1
    80001d74:	fffff097          	auipc	ra,0xfffff
    80001d78:	ff4080e7          	jalr	-12(ra) # 80000d68 <release>
    return 0;
    80001d7c:	84ca                	mv	s1,s2
    80001d7e:	b7d1                	j	80001d42 <allocproc+0x9a>

0000000080001d80 <userinit>:
{
    80001d80:	1101                	addi	sp,sp,-32
    80001d82:	ec06                	sd	ra,24(sp)
    80001d84:	e822                	sd	s0,16(sp)
    80001d86:	e426                	sd	s1,8(sp)
    80001d88:	1000                	addi	s0,sp,32
  p = allocproc();
    80001d8a:	00000097          	auipc	ra,0x0
    80001d8e:	f1e080e7          	jalr	-226(ra) # 80001ca8 <allocproc>
    80001d92:	84aa                	mv	s1,a0
  initproc = p;
    80001d94:	00007797          	auipc	a5,0x7
    80001d98:	daa7ba23          	sd	a0,-588(a5) # 80008b48 <initproc>
  uvmfirst(p->pagetable, initcode, sizeof(initcode));
    80001d9c:	03400613          	li	a2,52
    80001da0:	00007597          	auipc	a1,0x7
    80001da4:	d2058593          	addi	a1,a1,-736 # 80008ac0 <initcode>
    80001da8:	7128                	ld	a0,96(a0)
    80001daa:	fffff097          	auipc	ra,0xfffff
    80001dae:	698080e7          	jalr	1688(ra) # 80001442 <uvmfirst>
  p->sz = PGSIZE;
    80001db2:	6785                	lui	a5,0x1
    80001db4:	ecbc                	sd	a5,88(s1)
  p->trapframe->epc = 0;      // user program counter
    80001db6:	74b8                	ld	a4,104(s1)
    80001db8:	00073c23          	sd	zero,24(a4) # 1018 <_entry-0x7fffefe8>
  p->trapframe->sp = PGSIZE;  // user stack pointer
    80001dbc:	74b8                	ld	a4,104(s1)
    80001dbe:	fb1c                	sd	a5,48(a4)
  safestrcpy(p->name, "initcode", sizeof(p->name));
    80001dc0:	4641                	li	a2,16
    80001dc2:	00006597          	auipc	a1,0x6
    80001dc6:	43658593          	addi	a1,a1,1078 # 800081f8 <digits+0x1b8>
    80001dca:	16848513          	addi	a0,s1,360
    80001dce:	fffff097          	auipc	ra,0xfffff
    80001dd2:	13a080e7          	jalr	314(ra) # 80000f08 <safestrcpy>
  p->cwd = namei("/");
    80001dd6:	00006517          	auipc	a0,0x6
    80001dda:	43250513          	addi	a0,a0,1074 # 80008208 <digits+0x1c8>
    80001dde:	00002097          	auipc	ra,0x2
    80001de2:	49a080e7          	jalr	1178(ra) # 80004278 <namei>
    80001de6:	16a4b023          	sd	a0,352(s1)
  p->state = RUNNABLE;
    80001dea:	478d                	li	a5,3
    80001dec:	d09c                	sw	a5,32(s1)
  release(&p->lock);
    80001dee:	8526                	mv	a0,s1
    80001df0:	fffff097          	auipc	ra,0xfffff
    80001df4:	f78080e7          	jalr	-136(ra) # 80000d68 <release>
}
    80001df8:	60e2                	ld	ra,24(sp)
    80001dfa:	6442                	ld	s0,16(sp)
    80001dfc:	64a2                	ld	s1,8(sp)
    80001dfe:	6105                	addi	sp,sp,32
    80001e00:	8082                	ret

0000000080001e02 <growproc>:
{
    80001e02:	1101                	addi	sp,sp,-32
    80001e04:	ec06                	sd	ra,24(sp)
    80001e06:	e822                	sd	s0,16(sp)
    80001e08:	e426                	sd	s1,8(sp)
    80001e0a:	e04a                	sd	s2,0(sp)
    80001e0c:	1000                	addi	s0,sp,32
    80001e0e:	892a                	mv	s2,a0
  struct proc *p = myproc();
    80001e10:	00000097          	auipc	ra,0x0
    80001e14:	c86080e7          	jalr	-890(ra) # 80001a96 <myproc>
    80001e18:	84aa                	mv	s1,a0
  sz = p->sz;
    80001e1a:	6d2c                	ld	a1,88(a0)
  if(n > 0){
    80001e1c:	01204c63          	bgtz	s2,80001e34 <growproc+0x32>
  } else if(n < 0){
    80001e20:	02094663          	bltz	s2,80001e4c <growproc+0x4a>
  p->sz = sz;
    80001e24:	ecac                	sd	a1,88(s1)
  return 0;
    80001e26:	4501                	li	a0,0
}
    80001e28:	60e2                	ld	ra,24(sp)
    80001e2a:	6442                	ld	s0,16(sp)
    80001e2c:	64a2                	ld	s1,8(sp)
    80001e2e:	6902                	ld	s2,0(sp)
    80001e30:	6105                	addi	sp,sp,32
    80001e32:	8082                	ret
    if((sz = uvmalloc(p->pagetable, sz, sz + n, PTE_W)) == 0) {
    80001e34:	4691                	li	a3,4
    80001e36:	00b90633          	add	a2,s2,a1
    80001e3a:	7128                	ld	a0,96(a0)
    80001e3c:	fffff097          	auipc	ra,0xfffff
    80001e40:	6c0080e7          	jalr	1728(ra) # 800014fc <uvmalloc>
    80001e44:	85aa                	mv	a1,a0
    80001e46:	fd79                	bnez	a0,80001e24 <growproc+0x22>
      return -1;
    80001e48:	557d                	li	a0,-1
    80001e4a:	bff9                	j	80001e28 <growproc+0x26>
    sz = uvmdealloc(p->pagetable, sz, sz + n);
    80001e4c:	00b90633          	add	a2,s2,a1
    80001e50:	7128                	ld	a0,96(a0)
    80001e52:	fffff097          	auipc	ra,0xfffff
    80001e56:	662080e7          	jalr	1634(ra) # 800014b4 <uvmdealloc>
    80001e5a:	85aa                	mv	a1,a0
    80001e5c:	b7e1                	j	80001e24 <growproc+0x22>

0000000080001e5e <fork>:
{
    80001e5e:	7179                	addi	sp,sp,-48
    80001e60:	f406                	sd	ra,40(sp)
    80001e62:	f022                	sd	s0,32(sp)
    80001e64:	ec26                	sd	s1,24(sp)
    80001e66:	e84a                	sd	s2,16(sp)
    80001e68:	e44e                	sd	s3,8(sp)
    80001e6a:	e052                	sd	s4,0(sp)
    80001e6c:	1800                	addi	s0,sp,48
  struct proc *p = myproc();
    80001e6e:	00000097          	auipc	ra,0x0
    80001e72:	c28080e7          	jalr	-984(ra) # 80001a96 <myproc>
    80001e76:	89aa                	mv	s3,a0
  if((np = allocproc()) == 0){
    80001e78:	00000097          	auipc	ra,0x0
    80001e7c:	e30080e7          	jalr	-464(ra) # 80001ca8 <allocproc>
    80001e80:	12050663          	beqz	a0,80001fac <fork+0x14e>
    80001e84:	892a                	mv	s2,a0
  if(uvmcopy(p->pagetable, np->pagetable, p->sz) < 0){
    80001e86:	0589b603          	ld	a2,88(s3)
    80001e8a:	712c                	ld	a1,96(a0)
    80001e8c:	0609b503          	ld	a0,96(s3)
    80001e90:	fffff097          	auipc	ra,0xfffff
    80001e94:	7c0080e7          	jalr	1984(ra) # 80001650 <uvmcopy>
    80001e98:	04054c63          	bltz	a0,80001ef0 <fork+0x92>
  np->sz = p->sz;
    80001e9c:	0589b783          	ld	a5,88(s3)
    80001ea0:	04f93c23          	sd	a5,88(s2)
  np->parent =p ;
    80001ea4:	05393423          	sd	s3,72(s2)
  np->trace_mask=p->trace_mask;
    80001ea8:	1789a783          	lw	a5,376(s3)
    80001eac:	16f92c23          	sw	a5,376(s2)
  *(np->trapframe) = *(p->trapframe);
    80001eb0:	0689b683          	ld	a3,104(s3)
    80001eb4:	87b6                	mv	a5,a3
    80001eb6:	06893703          	ld	a4,104(s2)
    80001eba:	12068693          	addi	a3,a3,288
    80001ebe:	0007b803          	ld	a6,0(a5) # 1000 <_entry-0x7ffff000>
    80001ec2:	6788                	ld	a0,8(a5)
    80001ec4:	6b8c                	ld	a1,16(a5)
    80001ec6:	6f90                	ld	a2,24(a5)
    80001ec8:	01073023          	sd	a6,0(a4)
    80001ecc:	e708                	sd	a0,8(a4)
    80001ece:	eb0c                	sd	a1,16(a4)
    80001ed0:	ef10                	sd	a2,24(a4)
    80001ed2:	02078793          	addi	a5,a5,32
    80001ed6:	02070713          	addi	a4,a4,32
    80001eda:	fed792e3          	bne	a5,a3,80001ebe <fork+0x60>
  np->trapframe->a0 = 0;
    80001ede:	06893783          	ld	a5,104(s2)
    80001ee2:	0607b823          	sd	zero,112(a5)
    80001ee6:	0e000493          	li	s1,224
  for(i = 0; i < NOFILE; i++)
    80001eea:	16000a13          	li	s4,352
    80001eee:	a03d                	j	80001f1c <fork+0xbe>
    freeproc(np);
    80001ef0:	854a                	mv	a0,s2
    80001ef2:	00000097          	auipc	ra,0x0
    80001ef6:	d56080e7          	jalr	-682(ra) # 80001c48 <freeproc>
    release(&np->lock);
    80001efa:	854a                	mv	a0,s2
    80001efc:	fffff097          	auipc	ra,0xfffff
    80001f00:	e6c080e7          	jalr	-404(ra) # 80000d68 <release>
    return -1;
    80001f04:	5a7d                	li	s4,-1
    80001f06:	a851                	j	80001f9a <fork+0x13c>
      np->ofile[i] = filedup(p->ofile[i]);
    80001f08:	00003097          	auipc	ra,0x3
    80001f0c:	a06080e7          	jalr	-1530(ra) # 8000490e <filedup>
    80001f10:	009907b3          	add	a5,s2,s1
    80001f14:	e388                	sd	a0,0(a5)
  for(i = 0; i < NOFILE; i++)
    80001f16:	04a1                	addi	s1,s1,8
    80001f18:	01448763          	beq	s1,s4,80001f26 <fork+0xc8>
    if(p->ofile[i])
    80001f1c:	009987b3          	add	a5,s3,s1
    80001f20:	6388                	ld	a0,0(a5)
    80001f22:	f17d                	bnez	a0,80001f08 <fork+0xaa>
    80001f24:	bfcd                	j	80001f16 <fork+0xb8>
  np->cwd = idup(p->cwd);
    80001f26:	1609b503          	ld	a0,352(s3)
    80001f2a:	00002097          	auipc	ra,0x2
    80001f2e:	b6a080e7          	jalr	-1174(ra) # 80003a94 <idup>
    80001f32:	16a93023          	sd	a0,352(s2)
  safestrcpy(np->name, p->name, sizeof(p->name));
    80001f36:	4641                	li	a2,16
    80001f38:	16898593          	addi	a1,s3,360
    80001f3c:	16890513          	addi	a0,s2,360
    80001f40:	fffff097          	auipc	ra,0xfffff
    80001f44:	fc8080e7          	jalr	-56(ra) # 80000f08 <safestrcpy>
  pid = np->pid;
    80001f48:	03892a03          	lw	s4,56(s2)
  release(&np->lock);
    80001f4c:	854a                	mv	a0,s2
    80001f4e:	fffff097          	auipc	ra,0xfffff
    80001f52:	e1a080e7          	jalr	-486(ra) # 80000d68 <release>
  acquire(&wait_lock);
    80001f56:	0000f497          	auipc	s1,0xf
    80001f5a:	eaa48493          	addi	s1,s1,-342 # 80010e00 <wait_lock>
    80001f5e:	8526                	mv	a0,s1
    80001f60:	fffff097          	auipc	ra,0xfffff
    80001f64:	cae080e7          	jalr	-850(ra) # 80000c0e <acquire>
  np->parent = p;
    80001f68:	05393423          	sd	s3,72(s2)
  release(&wait_lock);
    80001f6c:	8526                	mv	a0,s1
    80001f6e:	fffff097          	auipc	ra,0xfffff
    80001f72:	dfa080e7          	jalr	-518(ra) # 80000d68 <release>
  acquire(&np->lock);
    80001f76:	854a                	mv	a0,s2
    80001f78:	fffff097          	auipc	ra,0xfffff
    80001f7c:	c96080e7          	jalr	-874(ra) # 80000c0e <acquire>
  np->state = RUNNABLE;
    80001f80:	478d                	li	a5,3
    80001f82:	02f92023          	sw	a5,32(s2)
  np->priority=25;
    80001f86:	47e5                	li	a5,25
    80001f88:	02f92e23          	sw	a5,60(s2)
  np->runtime=0;
    80001f8c:	04093023          	sd	zero,64(s2)
  release(&np->lock);
    80001f90:	854a                	mv	a0,s2
    80001f92:	fffff097          	auipc	ra,0xfffff
    80001f96:	dd6080e7          	jalr	-554(ra) # 80000d68 <release>
}
    80001f9a:	8552                	mv	a0,s4
    80001f9c:	70a2                	ld	ra,40(sp)
    80001f9e:	7402                	ld	s0,32(sp)
    80001fa0:	64e2                	ld	s1,24(sp)
    80001fa2:	6942                	ld	s2,16(sp)
    80001fa4:	69a2                	ld	s3,8(sp)
    80001fa6:	6a02                	ld	s4,0(sp)
    80001fa8:	6145                	addi	sp,sp,48
    80001faa:	8082                	ret
    return -1;
    80001fac:	5a7d                	li	s4,-1
    80001fae:	b7f5                	j	80001f9a <fork+0x13c>

0000000080001fb0 <scheduler>:
{
    80001fb0:	7139                	addi	sp,sp,-64
    80001fb2:	fc06                	sd	ra,56(sp)
    80001fb4:	f822                	sd	s0,48(sp)
    80001fb6:	f426                	sd	s1,40(sp)
    80001fb8:	f04a                	sd	s2,32(sp)
    80001fba:	ec4e                	sd	s3,24(sp)
    80001fbc:	e852                	sd	s4,16(sp)
    80001fbe:	e456                	sd	s5,8(sp)
    80001fc0:	e05a                	sd	s6,0(sp)
    80001fc2:	0080                	addi	s0,sp,64
    80001fc4:	8792                	mv	a5,tp
  int id = r_tp();
    80001fc6:	2781                	sext.w	a5,a5
  c->proc = 0;
    80001fc8:	00779a93          	slli	s5,a5,0x7
    80001fcc:	0000f717          	auipc	a4,0xf
    80001fd0:	e1470713          	addi	a4,a4,-492 # 80010de0 <pid_lock>
    80001fd4:	9756                	add	a4,a4,s5
    80001fd6:	04073023          	sd	zero,64(a4)
        swtch(&c->context, &p->context);
    80001fda:	0000f717          	auipc	a4,0xf
    80001fde:	e4e70713          	addi	a4,a4,-434 # 80010e28 <cpus+0x8>
    80001fe2:	9aba                	add	s5,s5,a4
      if(p->state == RUNNABLE) {
    80001fe4:	498d                	li	s3,3
        p->state = RUNNING;
    80001fe6:	4b11                	li	s6,4
        c->proc = p;
    80001fe8:	079e                	slli	a5,a5,0x7
    80001fea:	0000fa17          	auipc	s4,0xf
    80001fee:	df6a0a13          	addi	s4,s4,-522 # 80010de0 <pid_lock>
    80001ff2:	9a3e                	add	s4,s4,a5
    for(p = proc; p < &proc[NPROC]; p++) {
    80001ff4:	00015917          	auipc	s2,0x15
    80001ff8:	22c90913          	addi	s2,s2,556 # 80017220 <tickslock>
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80001ffc:	100027f3          	csrr	a5,sstatus
  w_sstatus(r_sstatus() | SSTATUS_SIE);
    80002000:	0027e793          	ori	a5,a5,2
  asm volatile("csrw sstatus, %0" : : "r" (x));
    80002004:	10079073          	csrw	sstatus,a5
    80002008:	0000f497          	auipc	s1,0xf
    8000200c:	21848493          	addi	s1,s1,536 # 80011220 <proc>
    80002010:	a03d                	j	8000203e <scheduler+0x8e>
        p->state = RUNNING;
    80002012:	0364a023          	sw	s6,32(s1)
        c->proc = p;
    80002016:	049a3023          	sd	s1,64(s4)
        swtch(&c->context, &p->context);
    8000201a:	07048593          	addi	a1,s1,112
    8000201e:	8556                	mv	a0,s5
    80002020:	00001097          	auipc	ra,0x1
    80002024:	94a080e7          	jalr	-1718(ra) # 8000296a <swtch>
        c->proc = 0;
    80002028:	040a3023          	sd	zero,64(s4)
      release(&p->lock);
    8000202c:	8526                	mv	a0,s1
    8000202e:	fffff097          	auipc	ra,0xfffff
    80002032:	d3a080e7          	jalr	-710(ra) # 80000d68 <release>
    for(p = proc; p < &proc[NPROC]; p++) {
    80002036:	18048493          	addi	s1,s1,384
    8000203a:	fd2481e3          	beq	s1,s2,80001ffc <scheduler+0x4c>
      acquire(&p->lock);
    8000203e:	8526                	mv	a0,s1
    80002040:	fffff097          	auipc	ra,0xfffff
    80002044:	bce080e7          	jalr	-1074(ra) # 80000c0e <acquire>
      if(p->state == RUNNABLE) {
    80002048:	509c                	lw	a5,32(s1)
    8000204a:	ff3791e3          	bne	a5,s3,8000202c <scheduler+0x7c>
    8000204e:	b7d1                	j	80002012 <scheduler+0x62>

0000000080002050 <scheduler1>:
void scheduler1(void) {
    80002050:	715d                	addi	sp,sp,-80
    80002052:	e486                	sd	ra,72(sp)
    80002054:	e0a2                	sd	s0,64(sp)
    80002056:	fc26                	sd	s1,56(sp)
    80002058:	f84a                	sd	s2,48(sp)
    8000205a:	f44e                	sd	s3,40(sp)
    8000205c:	f052                	sd	s4,32(sp)
    8000205e:	ec56                	sd	s5,24(sp)
    80002060:	e85a                	sd	s6,16(sp)
    80002062:	e45e                	sd	s7,8(sp)
    80002064:	e062                	sd	s8,0(sp)
    80002066:	0880                	addi	s0,sp,80
  asm volatile("mv %0, tp" : "=r" (x) );
    80002068:	8492                	mv	s1,tp
  int id = r_tp();
    8000206a:	2481                	sext.w	s1,s1
  c->proc = 0;
    8000206c:	00749b93          	slli	s7,s1,0x7
    80002070:	0000f797          	auipc	a5,0xf
    80002074:	d7078793          	addi	a5,a5,-656 # 80010de0 <pid_lock>
    80002078:	97de                	add	a5,a5,s7
    8000207a:	0407b023          	sd	zero,64(a5)
  printf("Using Priority Scheduling Algorithm\n");
    8000207e:	00006517          	auipc	a0,0x6
    80002082:	19250513          	addi	a0,a0,402 # 80008210 <digits+0x1d0>
    80002086:	ffffe097          	auipc	ra,0xffffe
    8000208a:	508080e7          	jalr	1288(ra) # 8000058e <printf>
        swtch(&c->context, &high_proc->context);  // 切换到该进程
    8000208e:	0000f797          	auipc	a5,0xf
    80002092:	d9a78793          	addi	a5,a5,-614 # 80010e28 <cpus+0x8>
    80002096:	9bbe                	add	s7,s7,a5
    struct proc *high_proc = 0;
    80002098:	4a81                	li	s5,0
      if (p->state == RUNNABLE) {
    8000209a:	490d                	li	s2,3
    for (p = proc; p < &proc[NPROC]; p++) {
    8000209c:	00015997          	auipc	s3,0x15
    800020a0:	18498993          	addi	s3,s3,388 # 80017220 <tickslock>
        high_proc->state = RUNNING;       // 标记为正在运行
    800020a4:	4c11                	li	s8,4
        c->proc = high_proc;
    800020a6:	049e                	slli	s1,s1,0x7
    800020a8:	0000fb17          	auipc	s6,0xf
    800020ac:	d38b0b13          	addi	s6,s6,-712 # 80010de0 <pid_lock>
    800020b0:	9b26                	add	s6,s6,s1
    800020b2:	a0b5                	j	8000211e <scheduler1+0xce>
    800020b4:	8a26                	mv	s4,s1
    800020b6:	a011                	j	800020ba <scheduler1+0x6a>
    800020b8:	8a26                	mv	s4,s1
      release(&p->lock);
    800020ba:	8526                	mv	a0,s1
    800020bc:	fffff097          	auipc	ra,0xfffff
    800020c0:	cac080e7          	jalr	-852(ra) # 80000d68 <release>
    for (p = proc; p < &proc[NPROC]; p++) {
    800020c4:	18048493          	addi	s1,s1,384
    800020c8:	03348a63          	beq	s1,s3,800020fc <scheduler1+0xac>
      acquire(&p->lock);
    800020cc:	8526                	mv	a0,s1
    800020ce:	fffff097          	auipc	ra,0xfffff
    800020d2:	b40080e7          	jalr	-1216(ra) # 80000c0e <acquire>
      if (p->state == RUNNABLE) {
    800020d6:	509c                	lw	a5,32(s1)
    800020d8:	ff2791e3          	bne	a5,s2,800020ba <scheduler1+0x6a>
        if (high_proc == 0 || 
    800020dc:	fc0a0ce3          	beqz	s4,800020b4 <scheduler1+0x64>
            p->priority > high_proc->priority || 
    800020e0:	5cd8                	lw	a4,60(s1)
    800020e2:	03ca2783          	lw	a5,60(s4)
        if (high_proc == 0 || 
    800020e6:	fce7c9e3          	blt	a5,a4,800020b8 <scheduler1+0x68>
            p->priority > high_proc->priority || 
    800020ea:	fcf718e3          	bne	a4,a5,800020ba <scheduler1+0x6a>
            (p->priority == high_proc->priority && p->runtime < high_proc->runtime)) {
    800020ee:	60b8                	ld	a4,64(s1)
    800020f0:	040a3783          	ld	a5,64(s4)
    800020f4:	fcf773e3          	bgeu	a4,a5,800020ba <scheduler1+0x6a>
    800020f8:	8a26                	mv	s4,s1
    800020fa:	b7c1                	j	800020ba <scheduler1+0x6a>
    if (high_proc) {
    800020fc:	060a0063          	beqz	s4,8000215c <scheduler1+0x10c>
      acquire(&high_proc->lock);
    80002100:	84d2                	mv	s1,s4
    80002102:	8552                	mv	a0,s4
    80002104:	fffff097          	auipc	ra,0xfffff
    80002108:	b0a080e7          	jalr	-1270(ra) # 80000c0e <acquire>
      if (high_proc->state == RUNNABLE) {  // 再次检查状态
    8000210c:	020a2783          	lw	a5,32(s4)
    80002110:	03278363          	beq	a5,s2,80002136 <scheduler1+0xe6>
      release(&high_proc->lock);
    80002114:	8526                	mv	a0,s1
    80002116:	fffff097          	auipc	ra,0xfffff
    8000211a:	c52080e7          	jalr	-942(ra) # 80000d68 <release>
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    8000211e:	100027f3          	csrr	a5,sstatus
  w_sstatus(r_sstatus() | SSTATUS_SIE);
    80002122:	0027e793          	ori	a5,a5,2
  asm volatile("csrw sstatus, %0" : : "r" (x));
    80002126:	10079073          	csrw	sstatus,a5
    struct proc *high_proc = 0;
    8000212a:	8a56                	mv	s4,s5
    for (p = proc; p < &proc[NPROC]; p++) {
    8000212c:	0000f497          	auipc	s1,0xf
    80002130:	0f448493          	addi	s1,s1,244 # 80011220 <proc>
    80002134:	bf61                	j	800020cc <scheduler1+0x7c>
        high_proc->runtime++;             // 更新运行时间
    80002136:	040a3783          	ld	a5,64(s4)
    8000213a:	0785                	addi	a5,a5,1
    8000213c:	04fa3023          	sd	a5,64(s4)
        high_proc->state = RUNNING;       // 标记为正在运行
    80002140:	038a2023          	sw	s8,32(s4)
        c->proc = high_proc;
    80002144:	054b3023          	sd	s4,64(s6)
        swtch(&c->context, &high_proc->context);  // 切换到该进程
    80002148:	070a0593          	addi	a1,s4,112
    8000214c:	855e                	mv	a0,s7
    8000214e:	00001097          	auipc	ra,0x1
    80002152:	81c080e7          	jalr	-2020(ra) # 8000296a <swtch>
        c->proc = 0;                     // 运行结束后清空当前 CPU 的进程
    80002156:	040b3023          	sd	zero,64(s6)
    8000215a:	bf6d                	j	80002114 <scheduler1+0xc4>
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    8000215c:	100027f3          	csrr	a5,sstatus
  w_sstatus(r_sstatus() | SSTATUS_SIE);
    80002160:	0027e793          	ori	a5,a5,2
  asm volatile("csrw sstatus, %0" : : "r" (x));
    80002164:	10079073          	csrw	sstatus,a5
      asm volatile("wfi");
    80002168:	10500073          	wfi
    8000216c:	bf4d                	j	8000211e <scheduler1+0xce>

000000008000216e <sched>:
{
    8000216e:	7179                	addi	sp,sp,-48
    80002170:	f406                	sd	ra,40(sp)
    80002172:	f022                	sd	s0,32(sp)
    80002174:	ec26                	sd	s1,24(sp)
    80002176:	e84a                	sd	s2,16(sp)
    80002178:	e44e                	sd	s3,8(sp)
    8000217a:	1800                	addi	s0,sp,48
  struct proc *p = myproc();
    8000217c:	00000097          	auipc	ra,0x0
    80002180:	91a080e7          	jalr	-1766(ra) # 80001a96 <myproc>
    80002184:	84aa                	mv	s1,a0
  if(!holding(&p->lock))
    80002186:	fffff097          	auipc	ra,0xfffff
    8000218a:	b9e080e7          	jalr	-1122(ra) # 80000d24 <holding>
    8000218e:	c93d                	beqz	a0,80002204 <sched+0x96>
  asm volatile("mv %0, tp" : "=r" (x) );
    80002190:	8792                	mv	a5,tp
  if(mycpu()->noff != 1)
    80002192:	2781                	sext.w	a5,a5
    80002194:	079e                	slli	a5,a5,0x7
    80002196:	0000f717          	auipc	a4,0xf
    8000219a:	c4a70713          	addi	a4,a4,-950 # 80010de0 <pid_lock>
    8000219e:	97ba                	add	a5,a5,a4
    800021a0:	0b87a703          	lw	a4,184(a5)
    800021a4:	4785                	li	a5,1
    800021a6:	06f71763          	bne	a4,a5,80002214 <sched+0xa6>
  if(p->state == RUNNING)
    800021aa:	5098                	lw	a4,32(s1)
    800021ac:	4791                	li	a5,4
    800021ae:	06f70b63          	beq	a4,a5,80002224 <sched+0xb6>
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    800021b2:	100027f3          	csrr	a5,sstatus
  return (x & SSTATUS_SIE) != 0;
    800021b6:	8b89                	andi	a5,a5,2
  if(intr_get())
    800021b8:	efb5                	bnez	a5,80002234 <sched+0xc6>
  asm volatile("mv %0, tp" : "=r" (x) );
    800021ba:	8792                	mv	a5,tp
  intena = mycpu()->intena;
    800021bc:	0000f917          	auipc	s2,0xf
    800021c0:	c2490913          	addi	s2,s2,-988 # 80010de0 <pid_lock>
    800021c4:	2781                	sext.w	a5,a5
    800021c6:	079e                	slli	a5,a5,0x7
    800021c8:	97ca                	add	a5,a5,s2
    800021ca:	0bc7a983          	lw	s3,188(a5)
    800021ce:	8792                	mv	a5,tp
  swtch(&p->context, &mycpu()->context);
    800021d0:	2781                	sext.w	a5,a5
    800021d2:	079e                	slli	a5,a5,0x7
    800021d4:	0000f597          	auipc	a1,0xf
    800021d8:	c5458593          	addi	a1,a1,-940 # 80010e28 <cpus+0x8>
    800021dc:	95be                	add	a1,a1,a5
    800021de:	07048513          	addi	a0,s1,112
    800021e2:	00000097          	auipc	ra,0x0
    800021e6:	788080e7          	jalr	1928(ra) # 8000296a <swtch>
    800021ea:	8792                	mv	a5,tp
  mycpu()->intena = intena;
    800021ec:	2781                	sext.w	a5,a5
    800021ee:	079e                	slli	a5,a5,0x7
    800021f0:	97ca                	add	a5,a5,s2
    800021f2:	0b37ae23          	sw	s3,188(a5)
}
    800021f6:	70a2                	ld	ra,40(sp)
    800021f8:	7402                	ld	s0,32(sp)
    800021fa:	64e2                	ld	s1,24(sp)
    800021fc:	6942                	ld	s2,16(sp)
    800021fe:	69a2                	ld	s3,8(sp)
    80002200:	6145                	addi	sp,sp,48
    80002202:	8082                	ret
    panic("sched p->lock");
    80002204:	00006517          	auipc	a0,0x6
    80002208:	03450513          	addi	a0,a0,52 # 80008238 <digits+0x1f8>
    8000220c:	ffffe097          	auipc	ra,0xffffe
    80002210:	338080e7          	jalr	824(ra) # 80000544 <panic>
    panic("sched locks");
    80002214:	00006517          	auipc	a0,0x6
    80002218:	03450513          	addi	a0,a0,52 # 80008248 <digits+0x208>
    8000221c:	ffffe097          	auipc	ra,0xffffe
    80002220:	328080e7          	jalr	808(ra) # 80000544 <panic>
    panic("sched running");
    80002224:	00006517          	auipc	a0,0x6
    80002228:	03450513          	addi	a0,a0,52 # 80008258 <digits+0x218>
    8000222c:	ffffe097          	auipc	ra,0xffffe
    80002230:	318080e7          	jalr	792(ra) # 80000544 <panic>
    panic("sched interruptible");
    80002234:	00006517          	auipc	a0,0x6
    80002238:	03450513          	addi	a0,a0,52 # 80008268 <digits+0x228>
    8000223c:	ffffe097          	auipc	ra,0xffffe
    80002240:	308080e7          	jalr	776(ra) # 80000544 <panic>

0000000080002244 <yield>:
{
    80002244:	1101                	addi	sp,sp,-32
    80002246:	ec06                	sd	ra,24(sp)
    80002248:	e822                	sd	s0,16(sp)
    8000224a:	e426                	sd	s1,8(sp)
    8000224c:	1000                	addi	s0,sp,32
  struct proc *p = myproc();
    8000224e:	00000097          	auipc	ra,0x0
    80002252:	848080e7          	jalr	-1976(ra) # 80001a96 <myproc>
    80002256:	84aa                	mv	s1,a0
  acquire(&p->lock);
    80002258:	fffff097          	auipc	ra,0xfffff
    8000225c:	9b6080e7          	jalr	-1610(ra) # 80000c0e <acquire>
  p->state = RUNNABLE;
    80002260:	478d                	li	a5,3
    80002262:	d09c                	sw	a5,32(s1)
  sched();
    80002264:	00000097          	auipc	ra,0x0
    80002268:	f0a080e7          	jalr	-246(ra) # 8000216e <sched>
  release(&p->lock);
    8000226c:	8526                	mv	a0,s1
    8000226e:	fffff097          	auipc	ra,0xfffff
    80002272:	afa080e7          	jalr	-1286(ra) # 80000d68 <release>
}
    80002276:	60e2                	ld	ra,24(sp)
    80002278:	6442                	ld	s0,16(sp)
    8000227a:	64a2                	ld	s1,8(sp)
    8000227c:	6105                	addi	sp,sp,32
    8000227e:	8082                	ret

0000000080002280 <sleep>:

// Atomically release lock and sleep on chan.
// Reacquires lock when awakened.
void
sleep(void *chan, struct spinlock *lk)
{
    80002280:	7179                	addi	sp,sp,-48
    80002282:	f406                	sd	ra,40(sp)
    80002284:	f022                	sd	s0,32(sp)
    80002286:	ec26                	sd	s1,24(sp)
    80002288:	e84a                	sd	s2,16(sp)
    8000228a:	e44e                	sd	s3,8(sp)
    8000228c:	1800                	addi	s0,sp,48
    8000228e:	89aa                	mv	s3,a0
    80002290:	892e                	mv	s2,a1
  struct proc *p = myproc();
    80002292:	00000097          	auipc	ra,0x0
    80002296:	804080e7          	jalr	-2044(ra) # 80001a96 <myproc>
    8000229a:	84aa                	mv	s1,a0
  // Once we hold p->lock, we can be
  // guaranteed that we won't miss any wakeup
  // (wakeup locks p->lock),
  // so it's okay to release lk.

  acquire(&p->lock);  //DOC: sleeplock1 // 获取进程锁
    8000229c:	fffff097          	auipc	ra,0xfffff
    800022a0:	972080e7          	jalr	-1678(ra) # 80000c0e <acquire>
  release(lk);        // 释放当前锁
    800022a4:	854a                	mv	a0,s2
    800022a6:	fffff097          	auipc	ra,0xfffff
    800022aa:	ac2080e7          	jalr	-1342(ra) # 80000d68 <release>

  // Go to sleep.
  p->chan = chan;
    800022ae:	0334b423          	sd	s3,40(s1)
  p->state = SLEEPING;
    800022b2:	4789                	li	a5,2
    800022b4:	d09c                	sw	a5,32(s1)

  sched();            // 调度其他进程
    800022b6:	00000097          	auipc	ra,0x0
    800022ba:	eb8080e7          	jalr	-328(ra) # 8000216e <sched>

  // Tidy up.
  p->chan = 0;
    800022be:	0204b423          	sd	zero,40(s1)

  // Reacquire original lock.
  release(&p->lock);  // 释放进程锁
    800022c2:	8526                	mv	a0,s1
    800022c4:	fffff097          	auipc	ra,0xfffff
    800022c8:	aa4080e7          	jalr	-1372(ra) # 80000d68 <release>
  acquire(lk);         // 重新获取原锁
    800022cc:	854a                	mv	a0,s2
    800022ce:	fffff097          	auipc	ra,0xfffff
    800022d2:	940080e7          	jalr	-1728(ra) # 80000c0e <acquire>
}
    800022d6:	70a2                	ld	ra,40(sp)
    800022d8:	7402                	ld	s0,32(sp)
    800022da:	64e2                	ld	s1,24(sp)
    800022dc:	6942                	ld	s2,16(sp)
    800022de:	69a2                	ld	s3,8(sp)
    800022e0:	6145                	addi	sp,sp,48
    800022e2:	8082                	ret

00000000800022e4 <wakeup>:

// Wake up all processes sleeping on chan.
// Must be called without any p->lock.
void
wakeup(void *chan)
{
    800022e4:	7139                	addi	sp,sp,-64
    800022e6:	fc06                	sd	ra,56(sp)
    800022e8:	f822                	sd	s0,48(sp)
    800022ea:	f426                	sd	s1,40(sp)
    800022ec:	f04a                	sd	s2,32(sp)
    800022ee:	ec4e                	sd	s3,24(sp)
    800022f0:	e852                	sd	s4,16(sp)
    800022f2:	e456                	sd	s5,8(sp)
    800022f4:	0080                	addi	s0,sp,64
    800022f6:	8a2a                	mv	s4,a0
  struct proc *p;

  for(p = proc; p < &proc[NPROC]; p++) {
    800022f8:	0000f497          	auipc	s1,0xf
    800022fc:	f2848493          	addi	s1,s1,-216 # 80011220 <proc>
    if(p != myproc()){
      acquire(&p->lock);
      if(p->state == SLEEPING && p->chan == chan) {
    80002300:	4989                	li	s3,2
        p->state = RUNNABLE;
    80002302:	4a8d                	li	s5,3
  for(p = proc; p < &proc[NPROC]; p++) {
    80002304:	00015917          	auipc	s2,0x15
    80002308:	f1c90913          	addi	s2,s2,-228 # 80017220 <tickslock>
    8000230c:	a821                	j	80002324 <wakeup+0x40>
        p->state = RUNNABLE;
    8000230e:	0354a023          	sw	s5,32(s1)
      }
      release(&p->lock);
    80002312:	8526                	mv	a0,s1
    80002314:	fffff097          	auipc	ra,0xfffff
    80002318:	a54080e7          	jalr	-1452(ra) # 80000d68 <release>
  for(p = proc; p < &proc[NPROC]; p++) {
    8000231c:	18048493          	addi	s1,s1,384
    80002320:	03248463          	beq	s1,s2,80002348 <wakeup+0x64>
    if(p != myproc()){
    80002324:	fffff097          	auipc	ra,0xfffff
    80002328:	772080e7          	jalr	1906(ra) # 80001a96 <myproc>
    8000232c:	fea488e3          	beq	s1,a0,8000231c <wakeup+0x38>
      acquire(&p->lock);
    80002330:	8526                	mv	a0,s1
    80002332:	fffff097          	auipc	ra,0xfffff
    80002336:	8dc080e7          	jalr	-1828(ra) # 80000c0e <acquire>
      if(p->state == SLEEPING && p->chan == chan) {
    8000233a:	509c                	lw	a5,32(s1)
    8000233c:	fd379be3          	bne	a5,s3,80002312 <wakeup+0x2e>
    80002340:	749c                	ld	a5,40(s1)
    80002342:	fd4798e3          	bne	a5,s4,80002312 <wakeup+0x2e>
    80002346:	b7e1                	j	8000230e <wakeup+0x2a>
    }
  }
}
    80002348:	70e2                	ld	ra,56(sp)
    8000234a:	7442                	ld	s0,48(sp)
    8000234c:	74a2                	ld	s1,40(sp)
    8000234e:	7902                	ld	s2,32(sp)
    80002350:	69e2                	ld	s3,24(sp)
    80002352:	6a42                	ld	s4,16(sp)
    80002354:	6aa2                	ld	s5,8(sp)
    80002356:	6121                	addi	sp,sp,64
    80002358:	8082                	ret

000000008000235a <reparent>:
{
    8000235a:	7179                	addi	sp,sp,-48
    8000235c:	f406                	sd	ra,40(sp)
    8000235e:	f022                	sd	s0,32(sp)
    80002360:	ec26                	sd	s1,24(sp)
    80002362:	e84a                	sd	s2,16(sp)
    80002364:	e44e                	sd	s3,8(sp)
    80002366:	e052                	sd	s4,0(sp)
    80002368:	1800                	addi	s0,sp,48
    8000236a:	892a                	mv	s2,a0
  for(pp = proc; pp < &proc[NPROC]; pp++){
    8000236c:	0000f497          	auipc	s1,0xf
    80002370:	eb448493          	addi	s1,s1,-332 # 80011220 <proc>
      pp->parent = initproc;
    80002374:	00006a17          	auipc	s4,0x6
    80002378:	7d4a0a13          	addi	s4,s4,2004 # 80008b48 <initproc>
  for(pp = proc; pp < &proc[NPROC]; pp++){
    8000237c:	00015997          	auipc	s3,0x15
    80002380:	ea498993          	addi	s3,s3,-348 # 80017220 <tickslock>
    80002384:	a029                	j	8000238e <reparent+0x34>
    80002386:	18048493          	addi	s1,s1,384
    8000238a:	01348d63          	beq	s1,s3,800023a4 <reparent+0x4a>
    if(pp->parent == p){
    8000238e:	64bc                	ld	a5,72(s1)
    80002390:	ff279be3          	bne	a5,s2,80002386 <reparent+0x2c>
      pp->parent = initproc;
    80002394:	000a3503          	ld	a0,0(s4)
    80002398:	e4a8                	sd	a0,72(s1)
      wakeup(initproc);
    8000239a:	00000097          	auipc	ra,0x0
    8000239e:	f4a080e7          	jalr	-182(ra) # 800022e4 <wakeup>
    800023a2:	b7d5                	j	80002386 <reparent+0x2c>
}
    800023a4:	70a2                	ld	ra,40(sp)
    800023a6:	7402                	ld	s0,32(sp)
    800023a8:	64e2                	ld	s1,24(sp)
    800023aa:	6942                	ld	s2,16(sp)
    800023ac:	69a2                	ld	s3,8(sp)
    800023ae:	6a02                	ld	s4,0(sp)
    800023b0:	6145                	addi	sp,sp,48
    800023b2:	8082                	ret

00000000800023b4 <exit>:
{
    800023b4:	7179                	addi	sp,sp,-48
    800023b6:	f406                	sd	ra,40(sp)
    800023b8:	f022                	sd	s0,32(sp)
    800023ba:	ec26                	sd	s1,24(sp)
    800023bc:	e84a                	sd	s2,16(sp)
    800023be:	e44e                	sd	s3,8(sp)
    800023c0:	e052                	sd	s4,0(sp)
    800023c2:	1800                	addi	s0,sp,48
    800023c4:	8a2a                	mv	s4,a0
  struct proc *p = myproc();
    800023c6:	fffff097          	auipc	ra,0xfffff
    800023ca:	6d0080e7          	jalr	1744(ra) # 80001a96 <myproc>
    800023ce:	89aa                	mv	s3,a0
  if(p == initproc)
    800023d0:	00006797          	auipc	a5,0x6
    800023d4:	7787b783          	ld	a5,1912(a5) # 80008b48 <initproc>
    800023d8:	0e050493          	addi	s1,a0,224
    800023dc:	16050913          	addi	s2,a0,352
    800023e0:	02a79363          	bne	a5,a0,80002406 <exit+0x52>
    panic("init exiting");
    800023e4:	00006517          	auipc	a0,0x6
    800023e8:	e9c50513          	addi	a0,a0,-356 # 80008280 <digits+0x240>
    800023ec:	ffffe097          	auipc	ra,0xffffe
    800023f0:	158080e7          	jalr	344(ra) # 80000544 <panic>
      fileclose(f);
    800023f4:	00002097          	auipc	ra,0x2
    800023f8:	56c080e7          	jalr	1388(ra) # 80004960 <fileclose>
      p->ofile[fd] = 0;
    800023fc:	0004b023          	sd	zero,0(s1)
  for(int fd = 0; fd < NOFILE; fd++){
    80002400:	04a1                	addi	s1,s1,8
    80002402:	01248563          	beq	s1,s2,8000240c <exit+0x58>
    if(p->ofile[fd]){
    80002406:	6088                	ld	a0,0(s1)
    80002408:	f575                	bnez	a0,800023f4 <exit+0x40>
    8000240a:	bfdd                	j	80002400 <exit+0x4c>
  begin_op();
    8000240c:	00002097          	auipc	ra,0x2
    80002410:	088080e7          	jalr	136(ra) # 80004494 <begin_op>
  iput(p->cwd);
    80002414:	1609b503          	ld	a0,352(s3)
    80002418:	00002097          	auipc	ra,0x2
    8000241c:	874080e7          	jalr	-1932(ra) # 80003c8c <iput>
  end_op();
    80002420:	00002097          	auipc	ra,0x2
    80002424:	0f4080e7          	jalr	244(ra) # 80004514 <end_op>
  p->cwd = 0;
    80002428:	1609b023          	sd	zero,352(s3)
  acquire(&wait_lock);
    8000242c:	0000f497          	auipc	s1,0xf
    80002430:	9d448493          	addi	s1,s1,-1580 # 80010e00 <wait_lock>
    80002434:	8526                	mv	a0,s1
    80002436:	ffffe097          	auipc	ra,0xffffe
    8000243a:	7d8080e7          	jalr	2008(ra) # 80000c0e <acquire>
  reparent(p);
    8000243e:	854e                	mv	a0,s3
    80002440:	00000097          	auipc	ra,0x0
    80002444:	f1a080e7          	jalr	-230(ra) # 8000235a <reparent>
  wakeup(p->parent);
    80002448:	0489b503          	ld	a0,72(s3)
    8000244c:	00000097          	auipc	ra,0x0
    80002450:	e98080e7          	jalr	-360(ra) # 800022e4 <wakeup>
  acquire(&p->lock);
    80002454:	854e                	mv	a0,s3
    80002456:	ffffe097          	auipc	ra,0xffffe
    8000245a:	7b8080e7          	jalr	1976(ra) # 80000c0e <acquire>
  p->xstate = status;
    8000245e:	0349aa23          	sw	s4,52(s3)
  p->state = ZOMBIE;
    80002462:	4795                	li	a5,5
    80002464:	02f9a023          	sw	a5,32(s3)
  release(&wait_lock);
    80002468:	8526                	mv	a0,s1
    8000246a:	fffff097          	auipc	ra,0xfffff
    8000246e:	8fe080e7          	jalr	-1794(ra) # 80000d68 <release>
  sched();
    80002472:	00000097          	auipc	ra,0x0
    80002476:	cfc080e7          	jalr	-772(ra) # 8000216e <sched>
  panic("zombie exit");
    8000247a:	00006517          	auipc	a0,0x6
    8000247e:	e1650513          	addi	a0,a0,-490 # 80008290 <digits+0x250>
    80002482:	ffffe097          	auipc	ra,0xffffe
    80002486:	0c2080e7          	jalr	194(ra) # 80000544 <panic>

000000008000248a <kill>:
// Kill the process with the given pid.
// The victim won't exit until it tries to return
// to user space (see usertrap() in trap.c).
int
kill(int pid)
{
    8000248a:	7179                	addi	sp,sp,-48
    8000248c:	f406                	sd	ra,40(sp)
    8000248e:	f022                	sd	s0,32(sp)
    80002490:	ec26                	sd	s1,24(sp)
    80002492:	e84a                	sd	s2,16(sp)
    80002494:	e44e                	sd	s3,8(sp)
    80002496:	1800                	addi	s0,sp,48
    80002498:	892a                	mv	s2,a0
  struct proc *p;

  for(p = proc; p < &proc[NPROC]; p++){
    8000249a:	0000f497          	auipc	s1,0xf
    8000249e:	d8648493          	addi	s1,s1,-634 # 80011220 <proc>
    800024a2:	00015997          	auipc	s3,0x15
    800024a6:	d7e98993          	addi	s3,s3,-642 # 80017220 <tickslock>
    acquire(&p->lock);
    800024aa:	8526                	mv	a0,s1
    800024ac:	ffffe097          	auipc	ra,0xffffe
    800024b0:	762080e7          	jalr	1890(ra) # 80000c0e <acquire>
    if(p->pid == pid){
    800024b4:	5c9c                	lw	a5,56(s1)
    800024b6:	01278d63          	beq	a5,s2,800024d0 <kill+0x46>
        p->state = RUNNABLE;
      }
      release(&p->lock);
      return 0;
    }
    release(&p->lock);
    800024ba:	8526                	mv	a0,s1
    800024bc:	fffff097          	auipc	ra,0xfffff
    800024c0:	8ac080e7          	jalr	-1876(ra) # 80000d68 <release>
  for(p = proc; p < &proc[NPROC]; p++){
    800024c4:	18048493          	addi	s1,s1,384
    800024c8:	ff3491e3          	bne	s1,s3,800024aa <kill+0x20>
  }
  return -1;
    800024cc:	557d                	li	a0,-1
    800024ce:	a829                	j	800024e8 <kill+0x5e>
      p->killed = 1;
    800024d0:	4785                	li	a5,1
    800024d2:	d89c                	sw	a5,48(s1)
      if(p->state == SLEEPING){
    800024d4:	5098                	lw	a4,32(s1)
    800024d6:	4789                	li	a5,2
    800024d8:	00f70f63          	beq	a4,a5,800024f6 <kill+0x6c>
      release(&p->lock);
    800024dc:	8526                	mv	a0,s1
    800024de:	fffff097          	auipc	ra,0xfffff
    800024e2:	88a080e7          	jalr	-1910(ra) # 80000d68 <release>
      return 0;
    800024e6:	4501                	li	a0,0
}
    800024e8:	70a2                	ld	ra,40(sp)
    800024ea:	7402                	ld	s0,32(sp)
    800024ec:	64e2                	ld	s1,24(sp)
    800024ee:	6942                	ld	s2,16(sp)
    800024f0:	69a2                	ld	s3,8(sp)
    800024f2:	6145                	addi	sp,sp,48
    800024f4:	8082                	ret
        p->state = RUNNABLE;
    800024f6:	478d                	li	a5,3
    800024f8:	d09c                	sw	a5,32(s1)
    800024fa:	b7cd                	j	800024dc <kill+0x52>

00000000800024fc <setkilled>:

void
setkilled(struct proc *p)
{
    800024fc:	1101                	addi	sp,sp,-32
    800024fe:	ec06                	sd	ra,24(sp)
    80002500:	e822                	sd	s0,16(sp)
    80002502:	e426                	sd	s1,8(sp)
    80002504:	1000                	addi	s0,sp,32
    80002506:	84aa                	mv	s1,a0
  acquire(&p->lock);
    80002508:	ffffe097          	auipc	ra,0xffffe
    8000250c:	706080e7          	jalr	1798(ra) # 80000c0e <acquire>
  p->killed = 1;
    80002510:	4785                	li	a5,1
    80002512:	d89c                	sw	a5,48(s1)
  release(&p->lock);
    80002514:	8526                	mv	a0,s1
    80002516:	fffff097          	auipc	ra,0xfffff
    8000251a:	852080e7          	jalr	-1966(ra) # 80000d68 <release>
}
    8000251e:	60e2                	ld	ra,24(sp)
    80002520:	6442                	ld	s0,16(sp)
    80002522:	64a2                	ld	s1,8(sp)
    80002524:	6105                	addi	sp,sp,32
    80002526:	8082                	ret

0000000080002528 <killed>:

int
killed(struct proc *p)
{
    80002528:	1101                	addi	sp,sp,-32
    8000252a:	ec06                	sd	ra,24(sp)
    8000252c:	e822                	sd	s0,16(sp)
    8000252e:	e426                	sd	s1,8(sp)
    80002530:	e04a                	sd	s2,0(sp)
    80002532:	1000                	addi	s0,sp,32
    80002534:	84aa                	mv	s1,a0
  int k;
  
  acquire(&p->lock);
    80002536:	ffffe097          	auipc	ra,0xffffe
    8000253a:	6d8080e7          	jalr	1752(ra) # 80000c0e <acquire>
  k = p->killed;
    8000253e:	0304a903          	lw	s2,48(s1)
  release(&p->lock);
    80002542:	8526                	mv	a0,s1
    80002544:	fffff097          	auipc	ra,0xfffff
    80002548:	824080e7          	jalr	-2012(ra) # 80000d68 <release>
  return k;
}
    8000254c:	854a                	mv	a0,s2
    8000254e:	60e2                	ld	ra,24(sp)
    80002550:	6442                	ld	s0,16(sp)
    80002552:	64a2                	ld	s1,8(sp)
    80002554:	6902                	ld	s2,0(sp)
    80002556:	6105                	addi	sp,sp,32
    80002558:	8082                	ret

000000008000255a <wait>:
{
    8000255a:	715d                	addi	sp,sp,-80
    8000255c:	e486                	sd	ra,72(sp)
    8000255e:	e0a2                	sd	s0,64(sp)
    80002560:	fc26                	sd	s1,56(sp)
    80002562:	f84a                	sd	s2,48(sp)
    80002564:	f44e                	sd	s3,40(sp)
    80002566:	f052                	sd	s4,32(sp)
    80002568:	ec56                	sd	s5,24(sp)
    8000256a:	e85a                	sd	s6,16(sp)
    8000256c:	e45e                	sd	s7,8(sp)
    8000256e:	e062                	sd	s8,0(sp)
    80002570:	0880                	addi	s0,sp,80
    80002572:	8b2a                	mv	s6,a0
  struct proc *p = myproc();
    80002574:	fffff097          	auipc	ra,0xfffff
    80002578:	522080e7          	jalr	1314(ra) # 80001a96 <myproc>
    8000257c:	892a                	mv	s2,a0
  acquire(&wait_lock);
    8000257e:	0000f517          	auipc	a0,0xf
    80002582:	88250513          	addi	a0,a0,-1918 # 80010e00 <wait_lock>
    80002586:	ffffe097          	auipc	ra,0xffffe
    8000258a:	688080e7          	jalr	1672(ra) # 80000c0e <acquire>
    havekids = 0;
    8000258e:	4b81                	li	s7,0
        if(pp->state == ZOMBIE){
    80002590:	4a15                	li	s4,5
    for(pp = proc; pp < &proc[NPROC]; pp++){
    80002592:	00015997          	auipc	s3,0x15
    80002596:	c8e98993          	addi	s3,s3,-882 # 80017220 <tickslock>
        havekids = 1;
    8000259a:	4a85                	li	s5,1
    sleep(p, &wait_lock);  //DOC: wait-sleep
    8000259c:	0000fc17          	auipc	s8,0xf
    800025a0:	864c0c13          	addi	s8,s8,-1948 # 80010e00 <wait_lock>
    havekids = 0;
    800025a4:	875e                	mv	a4,s7
    for(pp = proc; pp < &proc[NPROC]; pp++){
    800025a6:	0000f497          	auipc	s1,0xf
    800025aa:	c7a48493          	addi	s1,s1,-902 # 80011220 <proc>
    800025ae:	a0bd                	j	8000261c <wait+0xc2>
          pid = pp->pid;
    800025b0:	0384a983          	lw	s3,56(s1)
          if(addr != 0 && copyout(p->pagetable, addr, (char *)&pp->xstate,
    800025b4:	000b0e63          	beqz	s6,800025d0 <wait+0x76>
    800025b8:	4691                	li	a3,4
    800025ba:	03448613          	addi	a2,s1,52
    800025be:	85da                	mv	a1,s6
    800025c0:	06093503          	ld	a0,96(s2)
    800025c4:	fffff097          	auipc	ra,0xfffff
    800025c8:	190080e7          	jalr	400(ra) # 80001754 <copyout>
    800025cc:	02054563          	bltz	a0,800025f6 <wait+0x9c>
          freeproc(pp);
    800025d0:	8526                	mv	a0,s1
    800025d2:	fffff097          	auipc	ra,0xfffff
    800025d6:	676080e7          	jalr	1654(ra) # 80001c48 <freeproc>
          release(&pp->lock);
    800025da:	8526                	mv	a0,s1
    800025dc:	ffffe097          	auipc	ra,0xffffe
    800025e0:	78c080e7          	jalr	1932(ra) # 80000d68 <release>
          release(&wait_lock);
    800025e4:	0000f517          	auipc	a0,0xf
    800025e8:	81c50513          	addi	a0,a0,-2020 # 80010e00 <wait_lock>
    800025ec:	ffffe097          	auipc	ra,0xffffe
    800025f0:	77c080e7          	jalr	1916(ra) # 80000d68 <release>
          return pid;
    800025f4:	a0b5                	j	80002660 <wait+0x106>
            release(&pp->lock);
    800025f6:	8526                	mv	a0,s1
    800025f8:	ffffe097          	auipc	ra,0xffffe
    800025fc:	770080e7          	jalr	1904(ra) # 80000d68 <release>
            release(&wait_lock);
    80002600:	0000f517          	auipc	a0,0xf
    80002604:	80050513          	addi	a0,a0,-2048 # 80010e00 <wait_lock>
    80002608:	ffffe097          	auipc	ra,0xffffe
    8000260c:	760080e7          	jalr	1888(ra) # 80000d68 <release>
            return -1;
    80002610:	59fd                	li	s3,-1
    80002612:	a0b9                	j	80002660 <wait+0x106>
    for(pp = proc; pp < &proc[NPROC]; pp++){
    80002614:	18048493          	addi	s1,s1,384
    80002618:	03348463          	beq	s1,s3,80002640 <wait+0xe6>
      if(pp->parent == p){
    8000261c:	64bc                	ld	a5,72(s1)
    8000261e:	ff279be3          	bne	a5,s2,80002614 <wait+0xba>
        acquire(&pp->lock);
    80002622:	8526                	mv	a0,s1
    80002624:	ffffe097          	auipc	ra,0xffffe
    80002628:	5ea080e7          	jalr	1514(ra) # 80000c0e <acquire>
        if(pp->state == ZOMBIE){
    8000262c:	509c                	lw	a5,32(s1)
    8000262e:	f94781e3          	beq	a5,s4,800025b0 <wait+0x56>
        release(&pp->lock);
    80002632:	8526                	mv	a0,s1
    80002634:	ffffe097          	auipc	ra,0xffffe
    80002638:	734080e7          	jalr	1844(ra) # 80000d68 <release>
        havekids = 1;
    8000263c:	8756                	mv	a4,s5
    8000263e:	bfd9                	j	80002614 <wait+0xba>
    if(!havekids || killed(p)){
    80002640:	c719                	beqz	a4,8000264e <wait+0xf4>
    80002642:	854a                	mv	a0,s2
    80002644:	00000097          	auipc	ra,0x0
    80002648:	ee4080e7          	jalr	-284(ra) # 80002528 <killed>
    8000264c:	c51d                	beqz	a0,8000267a <wait+0x120>
      release(&wait_lock);
    8000264e:	0000e517          	auipc	a0,0xe
    80002652:	7b250513          	addi	a0,a0,1970 # 80010e00 <wait_lock>
    80002656:	ffffe097          	auipc	ra,0xffffe
    8000265a:	712080e7          	jalr	1810(ra) # 80000d68 <release>
      return -1;
    8000265e:	59fd                	li	s3,-1
}
    80002660:	854e                	mv	a0,s3
    80002662:	60a6                	ld	ra,72(sp)
    80002664:	6406                	ld	s0,64(sp)
    80002666:	74e2                	ld	s1,56(sp)
    80002668:	7942                	ld	s2,48(sp)
    8000266a:	79a2                	ld	s3,40(sp)
    8000266c:	7a02                	ld	s4,32(sp)
    8000266e:	6ae2                	ld	s5,24(sp)
    80002670:	6b42                	ld	s6,16(sp)
    80002672:	6ba2                	ld	s7,8(sp)
    80002674:	6c02                	ld	s8,0(sp)
    80002676:	6161                	addi	sp,sp,80
    80002678:	8082                	ret
    sleep(p, &wait_lock);  //DOC: wait-sleep
    8000267a:	85e2                	mv	a1,s8
    8000267c:	854a                	mv	a0,s2
    8000267e:	00000097          	auipc	ra,0x0
    80002682:	c02080e7          	jalr	-1022(ra) # 80002280 <sleep>
    havekids = 0;
    80002686:	bf39                	j	800025a4 <wait+0x4a>

0000000080002688 <either_copyout>:
// Copy to either a user address, or kernel address,
// depending on usr_dst.
// Returns 0 on success, -1 on error.
int
either_copyout(int user_dst, uint64 dst, void *src, uint64 len)
{
    80002688:	7179                	addi	sp,sp,-48
    8000268a:	f406                	sd	ra,40(sp)
    8000268c:	f022                	sd	s0,32(sp)
    8000268e:	ec26                	sd	s1,24(sp)
    80002690:	e84a                	sd	s2,16(sp)
    80002692:	e44e                	sd	s3,8(sp)
    80002694:	e052                	sd	s4,0(sp)
    80002696:	1800                	addi	s0,sp,48
    80002698:	84aa                	mv	s1,a0
    8000269a:	892e                	mv	s2,a1
    8000269c:	89b2                	mv	s3,a2
    8000269e:	8a36                	mv	s4,a3
  struct proc *p = myproc();
    800026a0:	fffff097          	auipc	ra,0xfffff
    800026a4:	3f6080e7          	jalr	1014(ra) # 80001a96 <myproc>
  if(user_dst){
    800026a8:	c08d                	beqz	s1,800026ca <either_copyout+0x42>
    return copyout(p->pagetable, dst, src, len);
    800026aa:	86d2                	mv	a3,s4
    800026ac:	864e                	mv	a2,s3
    800026ae:	85ca                	mv	a1,s2
    800026b0:	7128                	ld	a0,96(a0)
    800026b2:	fffff097          	auipc	ra,0xfffff
    800026b6:	0a2080e7          	jalr	162(ra) # 80001754 <copyout>
  } else {
    memmove((char *)dst, src, len);
    return 0;
  }
}
    800026ba:	70a2                	ld	ra,40(sp)
    800026bc:	7402                	ld	s0,32(sp)
    800026be:	64e2                	ld	s1,24(sp)
    800026c0:	6942                	ld	s2,16(sp)
    800026c2:	69a2                	ld	s3,8(sp)
    800026c4:	6a02                	ld	s4,0(sp)
    800026c6:	6145                	addi	sp,sp,48
    800026c8:	8082                	ret
    memmove((char *)dst, src, len);
    800026ca:	000a061b          	sext.w	a2,s4
    800026ce:	85ce                	mv	a1,s3
    800026d0:	854a                	mv	a0,s2
    800026d2:	ffffe097          	auipc	ra,0xffffe
    800026d6:	744080e7          	jalr	1860(ra) # 80000e16 <memmove>
    return 0;
    800026da:	8526                	mv	a0,s1
    800026dc:	bff9                	j	800026ba <either_copyout+0x32>

00000000800026de <either_copyin>:
// Copy from either a user address, or kernel address,
// depending on usr_src.
// Returns 0 on success, -1 on error.
int
either_copyin(void *dst, int user_src, uint64 src, uint64 len)
{
    800026de:	7179                	addi	sp,sp,-48
    800026e0:	f406                	sd	ra,40(sp)
    800026e2:	f022                	sd	s0,32(sp)
    800026e4:	ec26                	sd	s1,24(sp)
    800026e6:	e84a                	sd	s2,16(sp)
    800026e8:	e44e                	sd	s3,8(sp)
    800026ea:	e052                	sd	s4,0(sp)
    800026ec:	1800                	addi	s0,sp,48
    800026ee:	892a                	mv	s2,a0
    800026f0:	84ae                	mv	s1,a1
    800026f2:	89b2                	mv	s3,a2
    800026f4:	8a36                	mv	s4,a3
  struct proc *p = myproc();
    800026f6:	fffff097          	auipc	ra,0xfffff
    800026fa:	3a0080e7          	jalr	928(ra) # 80001a96 <myproc>
  if(user_src){
    800026fe:	c08d                	beqz	s1,80002720 <either_copyin+0x42>
    return copyin(p->pagetable, dst, src, len);
    80002700:	86d2                	mv	a3,s4
    80002702:	864e                	mv	a2,s3
    80002704:	85ca                	mv	a1,s2
    80002706:	7128                	ld	a0,96(a0)
    80002708:	fffff097          	auipc	ra,0xfffff
    8000270c:	0d8080e7          	jalr	216(ra) # 800017e0 <copyin>
  } else {
    memmove(dst, (char*)src, len);
    return 0;
  }
}
    80002710:	70a2                	ld	ra,40(sp)
    80002712:	7402                	ld	s0,32(sp)
    80002714:	64e2                	ld	s1,24(sp)
    80002716:	6942                	ld	s2,16(sp)
    80002718:	69a2                	ld	s3,8(sp)
    8000271a:	6a02                	ld	s4,0(sp)
    8000271c:	6145                	addi	sp,sp,48
    8000271e:	8082                	ret
    memmove(dst, (char*)src, len);
    80002720:	000a061b          	sext.w	a2,s4
    80002724:	85ce                	mv	a1,s3
    80002726:	854a                	mv	a0,s2
    80002728:	ffffe097          	auipc	ra,0xffffe
    8000272c:	6ee080e7          	jalr	1774(ra) # 80000e16 <memmove>
    return 0;
    80002730:	8526                	mv	a0,s1
    80002732:	bff9                	j	80002710 <either_copyin+0x32>

0000000080002734 <procdump>:
// Print a process listing to console.  For debugging.
// Runs when user types ^P on console.
// No lock to avoid wedging a stuck machine further.
void
procdump(void)
{
    80002734:	715d                	addi	sp,sp,-80
    80002736:	e486                	sd	ra,72(sp)
    80002738:	e0a2                	sd	s0,64(sp)
    8000273a:	fc26                	sd	s1,56(sp)
    8000273c:	f84a                	sd	s2,48(sp)
    8000273e:	f44e                	sd	s3,40(sp)
    80002740:	f052                	sd	s4,32(sp)
    80002742:	ec56                	sd	s5,24(sp)
    80002744:	e85a                	sd	s6,16(sp)
    80002746:	e45e                	sd	s7,8(sp)
    80002748:	0880                	addi	s0,sp,80
  [ZOMBIE]    "zombie"
  };
  struct proc *p;
  char *state;

  printf("\n");
    8000274a:	00006517          	auipc	a0,0x6
    8000274e:	97650513          	addi	a0,a0,-1674 # 800080c0 <digits+0x80>
    80002752:	ffffe097          	auipc	ra,0xffffe
    80002756:	e3c080e7          	jalr	-452(ra) # 8000058e <printf>
  for(p = proc; p < &proc[NPROC]; p++){
    8000275a:	0000f497          	auipc	s1,0xf
    8000275e:	c2e48493          	addi	s1,s1,-978 # 80011388 <proc+0x168>
    80002762:	00015917          	auipc	s2,0x15
    80002766:	c2690913          	addi	s2,s2,-986 # 80017388 <bcache+0x148>
    if(p->state == UNUSED)
      continue;
    if(p->state >= 0 && p->state < NELEM(states) && states[p->state])
    8000276a:	4b15                	li	s6,5
      state = states[p->state];
    else
      state = "???";
    8000276c:	00006997          	auipc	s3,0x6
    80002770:	b3498993          	addi	s3,s3,-1228 # 800082a0 <digits+0x260>
    printf("%d %s %s", p->pid, state, p->name);
    80002774:	00006a97          	auipc	s5,0x6
    80002778:	b34a8a93          	addi	s5,s5,-1228 # 800082a8 <digits+0x268>
    printf("\n");
    8000277c:	00006a17          	auipc	s4,0x6
    80002780:	944a0a13          	addi	s4,s4,-1724 # 800080c0 <digits+0x80>
    if(p->state >= 0 && p->state < NELEM(states) && states[p->state])
    80002784:	00006b97          	auipc	s7,0x6
    80002788:	be4b8b93          	addi	s7,s7,-1052 # 80008368 <states.1747>
    8000278c:	a00d                	j	800027ae <procdump+0x7a>
    printf("%d %s %s", p->pid, state, p->name);
    8000278e:	ed06a583          	lw	a1,-304(a3)
    80002792:	8556                	mv	a0,s5
    80002794:	ffffe097          	auipc	ra,0xffffe
    80002798:	dfa080e7          	jalr	-518(ra) # 8000058e <printf>
    printf("\n");
    8000279c:	8552                	mv	a0,s4
    8000279e:	ffffe097          	auipc	ra,0xffffe
    800027a2:	df0080e7          	jalr	-528(ra) # 8000058e <printf>
  for(p = proc; p < &proc[NPROC]; p++){
    800027a6:	18048493          	addi	s1,s1,384
    800027aa:	03248163          	beq	s1,s2,800027cc <procdump+0x98>
    if(p->state == UNUSED)
    800027ae:	86a6                	mv	a3,s1
    800027b0:	eb84a783          	lw	a5,-328(s1)
    800027b4:	dbed                	beqz	a5,800027a6 <procdump+0x72>
      state = "???";
    800027b6:	864e                	mv	a2,s3
    if(p->state >= 0 && p->state < NELEM(states) && states[p->state])
    800027b8:	fcfb6be3          	bltu	s6,a5,8000278e <procdump+0x5a>
    800027bc:	1782                	slli	a5,a5,0x20
    800027be:	9381                	srli	a5,a5,0x20
    800027c0:	078e                	slli	a5,a5,0x3
    800027c2:	97de                	add	a5,a5,s7
    800027c4:	6390                	ld	a2,0(a5)
    800027c6:	f661                	bnez	a2,8000278e <procdump+0x5a>
      state = "???";
    800027c8:	864e                	mv	a2,s3
    800027ca:	b7d1                	j	8000278e <procdump+0x5a>
  }
}
    800027cc:	60a6                	ld	ra,72(sp)
    800027ce:	6406                	ld	s0,64(sp)
    800027d0:	74e2                	ld	s1,56(sp)
    800027d2:	7942                	ld	s2,48(sp)
    800027d4:	79a2                	ld	s3,40(sp)
    800027d6:	7a02                	ld	s4,32(sp)
    800027d8:	6ae2                	ld	s5,24(sp)
    800027da:	6b42                	ld	s6,16(sp)
    800027dc:	6ba2                	ld	s7,8(sp)
    800027de:	6161                	addi	sp,sp,80
    800027e0:	8082                	ret

00000000800027e2 <cps>:
int cps(void) {
    800027e2:	711d                	addi	sp,sp,-96
    800027e4:	ec86                	sd	ra,88(sp)
    800027e6:	e8a2                	sd	s0,80(sp)
    800027e8:	e4a6                	sd	s1,72(sp)
    800027ea:	e0ca                	sd	s2,64(sp)
    800027ec:	fc4e                	sd	s3,56(sp)
    800027ee:	f852                	sd	s4,48(sp)
    800027f0:	f456                	sd	s5,40(sp)
    800027f2:	f05a                	sd	s6,32(sp)
    800027f4:	ec5e                	sd	s7,24(sp)
    800027f6:	e862                	sd	s8,16(sp)
    800027f8:	e466                	sd	s9,8(sp)
    800027fa:	e06a                	sd	s10,0(sp)
    800027fc:	1080                	addi	s0,sp,96
  struct proc *p; // 用于遍历进程表的指针

  // 打印标题行，显示进程信息表头
  printf("name       \t pid  \t state       \t priority \n");
    800027fe:	00006517          	auipc	a0,0x6
    80002802:	af250513          	addi	a0,a0,-1294 # 800082f0 <digits+0x2b0>
    80002806:	ffffe097          	auipc	ra,0xffffe
    8000280a:	d88080e7          	jalr	-632(ra) # 8000058e <printf>

  // 遍历进程表，逐一加锁每个条目
  for (p = proc; p < &proc[NPROC]; p++) {
    8000280e:	0000f497          	auipc	s1,0xf
    80002812:	a1248493          	addi	s1,s1,-1518 # 80011220 <proc>
    acquire(&p->lock); // 加锁当前进程条目
    if (p->state != UNUSED) { // 跳过未使用的进程条目

      // 确定进程状态的字符串表示
      const char *state = "UNKNOWN";
      if (p->state == SLEEPING)
    80002816:	4b09                	li	s6,2
        state = "SLEEPING";
    80002818:	00006a97          	auipc	s5,0x6
    8000281c:	ab8a8a93          	addi	s5,s5,-1352 # 800082d0 <digits+0x290>
        state = "RUNNABLE";
      else if (p->state == ZOMBIE)
        state = "ZOMBIE";

      // 打印当前进程的信息
      printf("%s  \t %d   \t %s \t %d\n", p->name, p->pid, state, p->priority);
    80002820:	00006a17          	auipc	s4,0x6
    80002824:	b00a0a13          	addi	s4,s4,-1280 # 80008320 <digits+0x2e0>
        state = "RUNNING";
    80002828:	00006b97          	auipc	s7,0x6
    8000282c:	ab8b8b93          	addi	s7,s7,-1352 # 800082e0 <digits+0x2a0>
        state = "RUNNABLE";
    80002830:	00006c17          	auipc	s8,0x6
    80002834:	a88c0c13          	addi	s8,s8,-1400 # 800082b8 <digits+0x278>
      const char *state = "UNKNOWN";
    80002838:	00006c97          	auipc	s9,0x6
    8000283c:	a90c8c93          	addi	s9,s9,-1392 # 800082c8 <digits+0x288>
        state = "ZOMBIE";
    80002840:	00006d17          	auipc	s10,0x6
    80002844:	aa8d0d13          	addi	s10,s10,-1368 # 800082e8 <digits+0x2a8>
  for (p = proc; p < &proc[NPROC]; p++) {
    80002848:	00015997          	auipc	s3,0x15
    8000284c:	9d898993          	addi	s3,s3,-1576 # 80017220 <tickslock>
    80002850:	a01d                	j	80002876 <cps+0x94>
      printf("%s  \t %d   \t %s \t %d\n", p->name, p->pid, state, p->priority);
    80002852:	5cd8                	lw	a4,60(s1)
    80002854:	5c90                	lw	a2,56(s1)
    80002856:	16890593          	addi	a1,s2,360
    8000285a:	8552                	mv	a0,s4
    8000285c:	ffffe097          	auipc	ra,0xffffe
    80002860:	d32080e7          	jalr	-718(ra) # 8000058e <printf>
    }
    release(&p->lock); // 释放锁
    80002864:	8526                	mv	a0,s1
    80002866:	ffffe097          	auipc	ra,0xffffe
    8000286a:	502080e7          	jalr	1282(ra) # 80000d68 <release>
  for (p = proc; p < &proc[NPROC]; p++) {
    8000286e:	18048493          	addi	s1,s1,384
    80002872:	03348b63          	beq	s1,s3,800028a8 <cps+0xc6>
    acquire(&p->lock); // 加锁当前进程条目
    80002876:	8926                	mv	s2,s1
    80002878:	8526                	mv	a0,s1
    8000287a:	ffffe097          	auipc	ra,0xffffe
    8000287e:	394080e7          	jalr	916(ra) # 80000c0e <acquire>
    if (p->state != UNUSED) { // 跳过未使用的进程条目
    80002882:	509c                	lw	a5,32(s1)
    80002884:	d3e5                	beqz	a5,80002864 <cps+0x82>
        state = "SLEEPING";
    80002886:	86d6                	mv	a3,s5
      if (p->state == SLEEPING)
    80002888:	fd6785e3          	beq	a5,s6,80002852 <cps+0x70>
      else if (p->state == RUNNING)
    8000288c:	4711                	li	a4,4
        state = "RUNNING";
    8000288e:	86de                	mv	a3,s7
      else if (p->state == RUNNING)
    80002890:	fce781e3          	beq	a5,a4,80002852 <cps+0x70>
      else if (p->state == RUNNABLE)
    80002894:	470d                	li	a4,3
        state = "RUNNABLE";
    80002896:	86e2                	mv	a3,s8
      else if (p->state == RUNNABLE)
    80002898:	fae78de3          	beq	a5,a4,80002852 <cps+0x70>
      else if (p->state == ZOMBIE)
    8000289c:	4715                	li	a4,5
      const char *state = "UNKNOWN";
    8000289e:	86e6                	mv	a3,s9
      else if (p->state == ZOMBIE)
    800028a0:	fae799e3          	bne	a5,a4,80002852 <cps+0x70>
        state = "ZOMBIE";
    800028a4:	86ea                	mv	a3,s10
    800028a6:	b775                	j	80002852 <cps+0x70>
  }

  return 0; // 返回值，表示成功执行
}
    800028a8:	4501                	li	a0,0
    800028aa:	60e6                	ld	ra,88(sp)
    800028ac:	6446                	ld	s0,80(sp)
    800028ae:	64a6                	ld	s1,72(sp)
    800028b0:	6906                	ld	s2,64(sp)
    800028b2:	79e2                	ld	s3,56(sp)
    800028b4:	7a42                	ld	s4,48(sp)
    800028b6:	7aa2                	ld	s5,40(sp)
    800028b8:	7b02                	ld	s6,32(sp)
    800028ba:	6be2                	ld	s7,24(sp)
    800028bc:	6c42                	ld	s8,16(sp)
    800028be:	6ca2                	ld	s9,8(sp)
    800028c0:	6d02                	ld	s10,0(sp)
    800028c2:	6125                	addi	sp,sp,96
    800028c4:	8082                	ret

00000000800028c6 <nproc>:

 
// get number of proc
uint64
nproc(void)
{
    800028c6:	7179                	addi	sp,sp,-48
    800028c8:	f406                	sd	ra,40(sp)
    800028ca:	f022                	sd	s0,32(sp)
    800028cc:	ec26                	sd	s1,24(sp)
    800028ce:	e84a                	sd	s2,16(sp)
    800028d0:	e44e                	sd	s3,8(sp)
    800028d2:	1800                	addi	s0,sp,48
  uint64 counter = 0;
  struct proc *p;
  // 遍历进程控制块，即OS课程中的PCB
  for(p = proc; p < &proc[NPROC]; p++) { 
    800028d4:	0000f497          	auipc	s1,0xf
    800028d8:	94c48493          	addi	s1,s1,-1716 # 80011220 <proc>
  uint64 counter = 0;
    800028dc:	4901                	li	s2,0
  for(p = proc; p < &proc[NPROC]; p++) { 
    800028de:	00015997          	auipc	s3,0x15
    800028e2:	94298993          	addi	s3,s3,-1726 # 80017220 <tickslock>
    acquire(&p->lock);
    800028e6:	8526                	mv	a0,s1
    800028e8:	ffffe097          	auipc	ra,0xffffe
    800028ec:	326080e7          	jalr	806(ra) # 80000c0e <acquire>
    if(p->state != UNUSED) {
    800028f0:	509c                	lw	a5,32(s1)
      ++counter;
    800028f2:	00f037b3          	snez	a5,a5
    800028f6:	993e                	add	s2,s2,a5
    }
    release(&p->lock);
    800028f8:	8526                	mv	a0,s1
    800028fa:	ffffe097          	auipc	ra,0xffffe
    800028fe:	46e080e7          	jalr	1134(ra) # 80000d68 <release>
  for(p = proc; p < &proc[NPROC]; p++) { 
    80002902:	18048493          	addi	s1,s1,384
    80002906:	ff3490e3          	bne	s1,s3,800028e6 <nproc+0x20>
  }
  return counter;
}
    8000290a:	854a                	mv	a0,s2
    8000290c:	70a2                	ld	ra,40(sp)
    8000290e:	7402                	ld	s0,32(sp)
    80002910:	64e2                	ld	s1,24(sp)
    80002912:	6942                	ld	s2,16(sp)
    80002914:	69a2                	ld	s3,8(sp)
    80002916:	6145                	addi	sp,sp,48
    80002918:	8082                	ret

000000008000291a <sys_setpriority>:

uint64
sys_setpriority(void) {
    8000291a:	7179                	addi	sp,sp,-48
    8000291c:	f406                	sd	ra,40(sp)
    8000291e:	f022                	sd	s0,32(sp)
    80002920:	ec26                	sd	s1,24(sp)
    80002922:	1800                	addi	s0,sp,48
  int priority;  // 用于存储用户传递的优先级值

  // 从系统调用参数中获取优先级值
  argint(0, &priority);
    80002924:	fdc40593          	addi	a1,s0,-36
    80002928:	4501                	li	a0,0
    8000292a:	00000097          	auipc	ra,0x0
    8000292e:	54a080e7          	jalr	1354(ra) # 80002e74 <argint>
  if (priority < 0)
    80002932:	fdc42783          	lw	a5,-36(s0)
    return -1; // 获取失败，返回错误
    80002936:	557d                	li	a0,-1
  if (priority < 0)
    80002938:	0207c463          	bltz	a5,80002960 <sys_setpriority+0x46>

  // 获取当前进程
  struct proc *p = myproc();
    8000293c:	fffff097          	auipc	ra,0xfffff
    80002940:	15a080e7          	jalr	346(ra) # 80001a96 <myproc>
    80002944:	84aa                	mv	s1,a0

  // 更新进程的优先级
  acquire(&p->lock);     // 加锁保护当前进程
    80002946:	ffffe097          	auipc	ra,0xffffe
    8000294a:	2c8080e7          	jalr	712(ra) # 80000c0e <acquire>
  p->priority = priority; // 设置优先级
    8000294e:	fdc42783          	lw	a5,-36(s0)
    80002952:	dcdc                	sw	a5,60(s1)
  release(&p->lock);     // 解锁
    80002954:	8526                	mv	a0,s1
    80002956:	ffffe097          	auipc	ra,0xffffe
    8000295a:	412080e7          	jalr	1042(ra) # 80000d68 <release>

  return 0;  // 成功返回 0
    8000295e:	4501                	li	a0,0
}
    80002960:	70a2                	ld	ra,40(sp)
    80002962:	7402                	ld	s0,32(sp)
    80002964:	64e2                	ld	s1,24(sp)
    80002966:	6145                	addi	sp,sp,48
    80002968:	8082                	ret

000000008000296a <swtch>:
    8000296a:	00153023          	sd	ra,0(a0)
    8000296e:	00253423          	sd	sp,8(a0)
    80002972:	e900                	sd	s0,16(a0)
    80002974:	ed04                	sd	s1,24(a0)
    80002976:	03253023          	sd	s2,32(a0)
    8000297a:	03353423          	sd	s3,40(a0)
    8000297e:	03453823          	sd	s4,48(a0)
    80002982:	03553c23          	sd	s5,56(a0)
    80002986:	05653023          	sd	s6,64(a0)
    8000298a:	05753423          	sd	s7,72(a0)
    8000298e:	05853823          	sd	s8,80(a0)
    80002992:	05953c23          	sd	s9,88(a0)
    80002996:	07a53023          	sd	s10,96(a0)
    8000299a:	07b53423          	sd	s11,104(a0)
    8000299e:	0005b083          	ld	ra,0(a1)
    800029a2:	0085b103          	ld	sp,8(a1)
    800029a6:	6980                	ld	s0,16(a1)
    800029a8:	6d84                	ld	s1,24(a1)
    800029aa:	0205b903          	ld	s2,32(a1)
    800029ae:	0285b983          	ld	s3,40(a1)
    800029b2:	0305ba03          	ld	s4,48(a1)
    800029b6:	0385ba83          	ld	s5,56(a1)
    800029ba:	0405bb03          	ld	s6,64(a1)
    800029be:	0485bb83          	ld	s7,72(a1)
    800029c2:	0505bc03          	ld	s8,80(a1)
    800029c6:	0585bc83          	ld	s9,88(a1)
    800029ca:	0605bd03          	ld	s10,96(a1)
    800029ce:	0685bd83          	ld	s11,104(a1)
    800029d2:	8082                	ret

00000000800029d4 <trapinit>:

extern int devintr();

void
trapinit(void)
{
    800029d4:	1141                	addi	sp,sp,-16
    800029d6:	e406                	sd	ra,8(sp)
    800029d8:	e022                	sd	s0,0(sp)
    800029da:	0800                	addi	s0,sp,16
  initlock(&tickslock, "time");
    800029dc:	00006597          	auipc	a1,0x6
    800029e0:	9bc58593          	addi	a1,a1,-1604 # 80008398 <states.1747+0x30>
    800029e4:	00015517          	auipc	a0,0x15
    800029e8:	83c50513          	addi	a0,a0,-1988 # 80017220 <tickslock>
    800029ec:	ffffe097          	auipc	ra,0xffffe
    800029f0:	1b8080e7          	jalr	440(ra) # 80000ba4 <initlock>
}
    800029f4:	60a2                	ld	ra,8(sp)
    800029f6:	6402                	ld	s0,0(sp)
    800029f8:	0141                	addi	sp,sp,16
    800029fa:	8082                	ret

00000000800029fc <trapinithart>:

// set up to take exceptions and traps while in the kernel.
void
trapinithart(void)
{
    800029fc:	1141                	addi	sp,sp,-16
    800029fe:	e422                	sd	s0,8(sp)
    80002a00:	0800                	addi	s0,sp,16
  asm volatile("csrw stvec, %0" : : "r" (x));
    80002a02:	00003797          	auipc	a5,0x3
    80002a06:	59e78793          	addi	a5,a5,1438 # 80005fa0 <kernelvec>
    80002a0a:	10579073          	csrw	stvec,a5
  w_stvec((uint64)kernelvec);
}
    80002a0e:	6422                	ld	s0,8(sp)
    80002a10:	0141                	addi	sp,sp,16
    80002a12:	8082                	ret

0000000080002a14 <usertrapret>:
//
// return to user space
//
void
usertrapret(void)
{
    80002a14:	1141                	addi	sp,sp,-16
    80002a16:	e406                	sd	ra,8(sp)
    80002a18:	e022                	sd	s0,0(sp)
    80002a1a:	0800                	addi	s0,sp,16
  struct proc *p = myproc();
    80002a1c:	fffff097          	auipc	ra,0xfffff
    80002a20:	07a080e7          	jalr	122(ra) # 80001a96 <myproc>
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80002a24:	100027f3          	csrr	a5,sstatus
  w_sstatus(r_sstatus() & ~SSTATUS_SIE);
    80002a28:	9bf5                	andi	a5,a5,-3
  asm volatile("csrw sstatus, %0" : : "r" (x));
    80002a2a:	10079073          	csrw	sstatus,a5
  // kerneltrap() to usertrap(), so turn off interrupts until
  // we're back in user space, where usertrap() is correct.
  intr_off();

  // send syscalls, interrupts, and exceptions to uservec in trampoline.S
  uint64 trampoline_uservec = TRAMPOLINE + (uservec - trampoline);
    80002a2e:	00004617          	auipc	a2,0x4
    80002a32:	5d260613          	addi	a2,a2,1490 # 80007000 <_trampoline>
    80002a36:	00004697          	auipc	a3,0x4
    80002a3a:	5ca68693          	addi	a3,a3,1482 # 80007000 <_trampoline>
    80002a3e:	8e91                	sub	a3,a3,a2
    80002a40:	040007b7          	lui	a5,0x4000
    80002a44:	17fd                	addi	a5,a5,-1
    80002a46:	07b2                	slli	a5,a5,0xc
    80002a48:	96be                	add	a3,a3,a5
  asm volatile("csrw stvec, %0" : : "r" (x));
    80002a4a:	10569073          	csrw	stvec,a3
  w_stvec(trampoline_uservec);

  // set up trapframe values that uservec will need when
  // the process next traps into the kernel.
  p->trapframe->kernel_satp = r_satp();         // kernel page table
    80002a4e:	7538                	ld	a4,104(a0)
  asm volatile("csrr %0, satp" : "=r" (x) );
    80002a50:	180026f3          	csrr	a3,satp
    80002a54:	e314                	sd	a3,0(a4)
  p->trapframe->kernel_sp = p->kstack + PGSIZE; // process's kernel stack
    80002a56:	7538                	ld	a4,104(a0)
    80002a58:	6934                	ld	a3,80(a0)
    80002a5a:	6585                	lui	a1,0x1
    80002a5c:	96ae                	add	a3,a3,a1
    80002a5e:	e714                	sd	a3,8(a4)
  p->trapframe->kernel_trap = (uint64)usertrap;
    80002a60:	7538                	ld	a4,104(a0)
    80002a62:	00000697          	auipc	a3,0x0
    80002a66:	13068693          	addi	a3,a3,304 # 80002b92 <usertrap>
    80002a6a:	eb14                	sd	a3,16(a4)
  p->trapframe->kernel_hartid = r_tp();         // hartid for cpuid()
    80002a6c:	7538                	ld	a4,104(a0)
  asm volatile("mv %0, tp" : "=r" (x) );
    80002a6e:	8692                	mv	a3,tp
    80002a70:	f314                	sd	a3,32(a4)
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80002a72:	100026f3          	csrr	a3,sstatus
  // set up the registers that trampoline.S's sret will use
  // to get to user space.
  
  // set S Previous Privilege mode to User.
  unsigned long x = r_sstatus();
  x &= ~SSTATUS_SPP; // clear SPP to 0 for user mode
    80002a76:	eff6f693          	andi	a3,a3,-257
  x |= SSTATUS_SPIE; // enable interrupts in user mode
    80002a7a:	0206e693          	ori	a3,a3,32
  asm volatile("csrw sstatus, %0" : : "r" (x));
    80002a7e:	10069073          	csrw	sstatus,a3
  w_sstatus(x);

  // set S Exception Program Counter to the saved user pc.
  w_sepc(p->trapframe->epc);
    80002a82:	7538                	ld	a4,104(a0)
  asm volatile("csrw sepc, %0" : : "r" (x));
    80002a84:	6f18                	ld	a4,24(a4)
    80002a86:	14171073          	csrw	sepc,a4

  // tell trampoline.S the user page table to switch to.
  uint64 satp = MAKE_SATP(p->pagetable);
    80002a8a:	7128                	ld	a0,96(a0)
    80002a8c:	8131                	srli	a0,a0,0xc

  // jump to userret in trampoline.S at the top of memory, which 
  // switches to the user page table, restores user registers,
  // and switches to user mode with sret.
  uint64 trampoline_userret = TRAMPOLINE + (userret - trampoline);
    80002a8e:	00004717          	auipc	a4,0x4
    80002a92:	60e70713          	addi	a4,a4,1550 # 8000709c <userret>
    80002a96:	8f11                	sub	a4,a4,a2
    80002a98:	97ba                	add	a5,a5,a4
  ((void (*)(uint64))trampoline_userret)(satp);
    80002a9a:	577d                	li	a4,-1
    80002a9c:	177e                	slli	a4,a4,0x3f
    80002a9e:	8d59                	or	a0,a0,a4
    80002aa0:	9782                	jalr	a5
}
    80002aa2:	60a2                	ld	ra,8(sp)
    80002aa4:	6402                	ld	s0,0(sp)
    80002aa6:	0141                	addi	sp,sp,16
    80002aa8:	8082                	ret

0000000080002aaa <clockintr>:
  w_sstatus(sstatus);
}

void
clockintr()
{
    80002aaa:	1101                	addi	sp,sp,-32
    80002aac:	ec06                	sd	ra,24(sp)
    80002aae:	e822                	sd	s0,16(sp)
    80002ab0:	e426                	sd	s1,8(sp)
    80002ab2:	1000                	addi	s0,sp,32
  acquire(&tickslock);
    80002ab4:	00014497          	auipc	s1,0x14
    80002ab8:	76c48493          	addi	s1,s1,1900 # 80017220 <tickslock>
    80002abc:	8526                	mv	a0,s1
    80002abe:	ffffe097          	auipc	ra,0xffffe
    80002ac2:	150080e7          	jalr	336(ra) # 80000c0e <acquire>
  ticks++;
    80002ac6:	00006517          	auipc	a0,0x6
    80002aca:	08a50513          	addi	a0,a0,138 # 80008b50 <ticks>
    80002ace:	411c                	lw	a5,0(a0)
    80002ad0:	2785                	addiw	a5,a5,1
    80002ad2:	c11c                	sw	a5,0(a0)
  wakeup(&ticks);
    80002ad4:	00000097          	auipc	ra,0x0
    80002ad8:	810080e7          	jalr	-2032(ra) # 800022e4 <wakeup>
  release(&tickslock);
    80002adc:	8526                	mv	a0,s1
    80002ade:	ffffe097          	auipc	ra,0xffffe
    80002ae2:	28a080e7          	jalr	650(ra) # 80000d68 <release>
}
    80002ae6:	60e2                	ld	ra,24(sp)
    80002ae8:	6442                	ld	s0,16(sp)
    80002aea:	64a2                	ld	s1,8(sp)
    80002aec:	6105                	addi	sp,sp,32
    80002aee:	8082                	ret

0000000080002af0 <devintr>:
// returns 2 if timer interrupt,
// 1 if other device,
// 0 if not recognized.
int
devintr()
{
    80002af0:	1101                	addi	sp,sp,-32
    80002af2:	ec06                	sd	ra,24(sp)
    80002af4:	e822                	sd	s0,16(sp)
    80002af6:	e426                	sd	s1,8(sp)
    80002af8:	1000                	addi	s0,sp,32
  asm volatile("csrr %0, scause" : "=r" (x) );
    80002afa:	14202773          	csrr	a4,scause
  uint64 scause = r_scause();

  if((scause & 0x8000000000000000L) &&
    80002afe:	00074d63          	bltz	a4,80002b18 <devintr+0x28>
    // now allowed to interrupt again.
    if(irq)
      plic_complete(irq);

    return 1;
  } else if(scause == 0x8000000000000001L){
    80002b02:	57fd                	li	a5,-1
    80002b04:	17fe                	slli	a5,a5,0x3f
    80002b06:	0785                	addi	a5,a5,1
    // the SSIP bit in sip.
    w_sip(r_sip() & ~2);

    return 2;
  } else {
    return 0;
    80002b08:	4501                	li	a0,0
  } else if(scause == 0x8000000000000001L){
    80002b0a:	06f70363          	beq	a4,a5,80002b70 <devintr+0x80>
  }
}
    80002b0e:	60e2                	ld	ra,24(sp)
    80002b10:	6442                	ld	s0,16(sp)
    80002b12:	64a2                	ld	s1,8(sp)
    80002b14:	6105                	addi	sp,sp,32
    80002b16:	8082                	ret
     (scause & 0xff) == 9){
    80002b18:	0ff77793          	andi	a5,a4,255
  if((scause & 0x8000000000000000L) &&
    80002b1c:	46a5                	li	a3,9
    80002b1e:	fed792e3          	bne	a5,a3,80002b02 <devintr+0x12>
    int irq = plic_claim();
    80002b22:	00003097          	auipc	ra,0x3
    80002b26:	586080e7          	jalr	1414(ra) # 800060a8 <plic_claim>
    80002b2a:	84aa                	mv	s1,a0
    if(irq == UART0_IRQ){
    80002b2c:	47a9                	li	a5,10
    80002b2e:	02f50763          	beq	a0,a5,80002b5c <devintr+0x6c>
    } else if(irq == VIRTIO0_IRQ){
    80002b32:	4785                	li	a5,1
    80002b34:	02f50963          	beq	a0,a5,80002b66 <devintr+0x76>
    return 1;
    80002b38:	4505                	li	a0,1
    } else if(irq){
    80002b3a:	d8f1                	beqz	s1,80002b0e <devintr+0x1e>
      printf("unexpected interrupt irq=%d\n", irq);
    80002b3c:	85a6                	mv	a1,s1
    80002b3e:	00006517          	auipc	a0,0x6
    80002b42:	86250513          	addi	a0,a0,-1950 # 800083a0 <states.1747+0x38>
    80002b46:	ffffe097          	auipc	ra,0xffffe
    80002b4a:	a48080e7          	jalr	-1464(ra) # 8000058e <printf>
      plic_complete(irq);
    80002b4e:	8526                	mv	a0,s1
    80002b50:	00003097          	auipc	ra,0x3
    80002b54:	57c080e7          	jalr	1404(ra) # 800060cc <plic_complete>
    return 1;
    80002b58:	4505                	li	a0,1
    80002b5a:	bf55                	j	80002b0e <devintr+0x1e>
      uartintr();
    80002b5c:	ffffe097          	auipc	ra,0xffffe
    80002b60:	e52080e7          	jalr	-430(ra) # 800009ae <uartintr>
    80002b64:	b7ed                	j	80002b4e <devintr+0x5e>
      virtio_disk_intr();
    80002b66:	00004097          	auipc	ra,0x4
    80002b6a:	a90080e7          	jalr	-1392(ra) # 800065f6 <virtio_disk_intr>
    80002b6e:	b7c5                	j	80002b4e <devintr+0x5e>
    if(cpuid() == 0){
    80002b70:	fffff097          	auipc	ra,0xfffff
    80002b74:	efa080e7          	jalr	-262(ra) # 80001a6a <cpuid>
    80002b78:	c901                	beqz	a0,80002b88 <devintr+0x98>
  asm volatile("csrr %0, sip" : "=r" (x) );
    80002b7a:	144027f3          	csrr	a5,sip
    w_sip(r_sip() & ~2);
    80002b7e:	9bf5                	andi	a5,a5,-3
  asm volatile("csrw sip, %0" : : "r" (x));
    80002b80:	14479073          	csrw	sip,a5
    return 2;
    80002b84:	4509                	li	a0,2
    80002b86:	b761                	j	80002b0e <devintr+0x1e>
      clockintr();
    80002b88:	00000097          	auipc	ra,0x0
    80002b8c:	f22080e7          	jalr	-222(ra) # 80002aaa <clockintr>
    80002b90:	b7ed                	j	80002b7a <devintr+0x8a>

0000000080002b92 <usertrap>:
{
    80002b92:	1101                	addi	sp,sp,-32
    80002b94:	ec06                	sd	ra,24(sp)
    80002b96:	e822                	sd	s0,16(sp)
    80002b98:	e426                	sd	s1,8(sp)
    80002b9a:	e04a                	sd	s2,0(sp)
    80002b9c:	1000                	addi	s0,sp,32
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80002b9e:	100027f3          	csrr	a5,sstatus
  if((r_sstatus() & SSTATUS_SPP) != 0)
    80002ba2:	1007f793          	andi	a5,a5,256
    80002ba6:	e3b1                	bnez	a5,80002bea <usertrap+0x58>
  asm volatile("csrw stvec, %0" : : "r" (x));
    80002ba8:	00003797          	auipc	a5,0x3
    80002bac:	3f878793          	addi	a5,a5,1016 # 80005fa0 <kernelvec>
    80002bb0:	10579073          	csrw	stvec,a5
  struct proc *p = myproc();
    80002bb4:	fffff097          	auipc	ra,0xfffff
    80002bb8:	ee2080e7          	jalr	-286(ra) # 80001a96 <myproc>
    80002bbc:	84aa                	mv	s1,a0
  p->trapframe->epc = r_sepc();
    80002bbe:	753c                	ld	a5,104(a0)
  asm volatile("csrr %0, sepc" : "=r" (x) );
    80002bc0:	14102773          	csrr	a4,sepc
    80002bc4:	ef98                	sd	a4,24(a5)
  asm volatile("csrr %0, scause" : "=r" (x) );
    80002bc6:	14202773          	csrr	a4,scause
  if(r_scause() == 8){
    80002bca:	47a1                	li	a5,8
    80002bcc:	02f70763          	beq	a4,a5,80002bfa <usertrap+0x68>
  } else if((which_dev = devintr()) != 0){
    80002bd0:	00000097          	auipc	ra,0x0
    80002bd4:	f20080e7          	jalr	-224(ra) # 80002af0 <devintr>
    80002bd8:	892a                	mv	s2,a0
    80002bda:	c151                	beqz	a0,80002c5e <usertrap+0xcc>
  if(killed(p))
    80002bdc:	8526                	mv	a0,s1
    80002bde:	00000097          	auipc	ra,0x0
    80002be2:	94a080e7          	jalr	-1718(ra) # 80002528 <killed>
    80002be6:	c929                	beqz	a0,80002c38 <usertrap+0xa6>
    80002be8:	a099                	j	80002c2e <usertrap+0x9c>
    panic("usertrap: not from user mode");
    80002bea:	00005517          	auipc	a0,0x5
    80002bee:	7d650513          	addi	a0,a0,2006 # 800083c0 <states.1747+0x58>
    80002bf2:	ffffe097          	auipc	ra,0xffffe
    80002bf6:	952080e7          	jalr	-1710(ra) # 80000544 <panic>
    if(killed(p))
    80002bfa:	00000097          	auipc	ra,0x0
    80002bfe:	92e080e7          	jalr	-1746(ra) # 80002528 <killed>
    80002c02:	e921                	bnez	a0,80002c52 <usertrap+0xc0>
    p->trapframe->epc += 4;
    80002c04:	74b8                	ld	a4,104(s1)
    80002c06:	6f1c                	ld	a5,24(a4)
    80002c08:	0791                	addi	a5,a5,4
    80002c0a:	ef1c                	sd	a5,24(a4)
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80002c0c:	100027f3          	csrr	a5,sstatus
  w_sstatus(r_sstatus() | SSTATUS_SIE);
    80002c10:	0027e793          	ori	a5,a5,2
  asm volatile("csrw sstatus, %0" : : "r" (x));
    80002c14:	10079073          	csrw	sstatus,a5
    syscall();
    80002c18:	00000097          	auipc	ra,0x0
    80002c1c:	2d4080e7          	jalr	724(ra) # 80002eec <syscall>
  if(killed(p))
    80002c20:	8526                	mv	a0,s1
    80002c22:	00000097          	auipc	ra,0x0
    80002c26:	906080e7          	jalr	-1786(ra) # 80002528 <killed>
    80002c2a:	c911                	beqz	a0,80002c3e <usertrap+0xac>
    80002c2c:	4901                	li	s2,0
    exit(-1);
    80002c2e:	557d                	li	a0,-1
    80002c30:	fffff097          	auipc	ra,0xfffff
    80002c34:	784080e7          	jalr	1924(ra) # 800023b4 <exit>
  if(which_dev == 2)
    80002c38:	4789                	li	a5,2
    80002c3a:	04f90f63          	beq	s2,a5,80002c98 <usertrap+0x106>
  usertrapret();
    80002c3e:	00000097          	auipc	ra,0x0
    80002c42:	dd6080e7          	jalr	-554(ra) # 80002a14 <usertrapret>
}
    80002c46:	60e2                	ld	ra,24(sp)
    80002c48:	6442                	ld	s0,16(sp)
    80002c4a:	64a2                	ld	s1,8(sp)
    80002c4c:	6902                	ld	s2,0(sp)
    80002c4e:	6105                	addi	sp,sp,32
    80002c50:	8082                	ret
      exit(-1);
    80002c52:	557d                	li	a0,-1
    80002c54:	fffff097          	auipc	ra,0xfffff
    80002c58:	760080e7          	jalr	1888(ra) # 800023b4 <exit>
    80002c5c:	b765                	j	80002c04 <usertrap+0x72>
  asm volatile("csrr %0, scause" : "=r" (x) );
    80002c5e:	142025f3          	csrr	a1,scause
    printf("usertrap(): unexpected scause %p pid=%d\n", r_scause(), p->pid);
    80002c62:	5c90                	lw	a2,56(s1)
    80002c64:	00005517          	auipc	a0,0x5
    80002c68:	77c50513          	addi	a0,a0,1916 # 800083e0 <states.1747+0x78>
    80002c6c:	ffffe097          	auipc	ra,0xffffe
    80002c70:	922080e7          	jalr	-1758(ra) # 8000058e <printf>
  asm volatile("csrr %0, sepc" : "=r" (x) );
    80002c74:	141025f3          	csrr	a1,sepc
  asm volatile("csrr %0, stval" : "=r" (x) );
    80002c78:	14302673          	csrr	a2,stval
    printf("            sepc=%p stval=%p\n", r_sepc(), r_stval());
    80002c7c:	00005517          	auipc	a0,0x5
    80002c80:	79450513          	addi	a0,a0,1940 # 80008410 <states.1747+0xa8>
    80002c84:	ffffe097          	auipc	ra,0xffffe
    80002c88:	90a080e7          	jalr	-1782(ra) # 8000058e <printf>
    setkilled(p);
    80002c8c:	8526                	mv	a0,s1
    80002c8e:	00000097          	auipc	ra,0x0
    80002c92:	86e080e7          	jalr	-1938(ra) # 800024fc <setkilled>
    80002c96:	b769                	j	80002c20 <usertrap+0x8e>
    yield();
    80002c98:	fffff097          	auipc	ra,0xfffff
    80002c9c:	5ac080e7          	jalr	1452(ra) # 80002244 <yield>
    80002ca0:	bf79                	j	80002c3e <usertrap+0xac>

0000000080002ca2 <kerneltrap>:
{
    80002ca2:	7179                	addi	sp,sp,-48
    80002ca4:	f406                	sd	ra,40(sp)
    80002ca6:	f022                	sd	s0,32(sp)
    80002ca8:	ec26                	sd	s1,24(sp)
    80002caa:	e84a                	sd	s2,16(sp)
    80002cac:	e44e                	sd	s3,8(sp)
    80002cae:	1800                	addi	s0,sp,48
  asm volatile("csrr %0, sepc" : "=r" (x) );
    80002cb0:	14102973          	csrr	s2,sepc
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80002cb4:	100024f3          	csrr	s1,sstatus
  asm volatile("csrr %0, scause" : "=r" (x) );
    80002cb8:	142029f3          	csrr	s3,scause
  if((sstatus & SSTATUS_SPP) == 0)
    80002cbc:	1004f793          	andi	a5,s1,256
    80002cc0:	cb85                	beqz	a5,80002cf0 <kerneltrap+0x4e>
  asm volatile("csrr %0, sstatus" : "=r" (x) );
    80002cc2:	100027f3          	csrr	a5,sstatus
  return (x & SSTATUS_SIE) != 0;
    80002cc6:	8b89                	andi	a5,a5,2
  if(intr_get() != 0)
    80002cc8:	ef85                	bnez	a5,80002d00 <kerneltrap+0x5e>
  if((which_dev = devintr()) == 0){
    80002cca:	00000097          	auipc	ra,0x0
    80002cce:	e26080e7          	jalr	-474(ra) # 80002af0 <devintr>
    80002cd2:	cd1d                	beqz	a0,80002d10 <kerneltrap+0x6e>
  if(which_dev == 2 && myproc() != 0 && myproc()->state == RUNNING)
    80002cd4:	4789                	li	a5,2
    80002cd6:	06f50a63          	beq	a0,a5,80002d4a <kerneltrap+0xa8>
  asm volatile("csrw sepc, %0" : : "r" (x));
    80002cda:	14191073          	csrw	sepc,s2
  asm volatile("csrw sstatus, %0" : : "r" (x));
    80002cde:	10049073          	csrw	sstatus,s1
}
    80002ce2:	70a2                	ld	ra,40(sp)
    80002ce4:	7402                	ld	s0,32(sp)
    80002ce6:	64e2                	ld	s1,24(sp)
    80002ce8:	6942                	ld	s2,16(sp)
    80002cea:	69a2                	ld	s3,8(sp)
    80002cec:	6145                	addi	sp,sp,48
    80002cee:	8082                	ret
    panic("kerneltrap: not from supervisor mode");
    80002cf0:	00005517          	auipc	a0,0x5
    80002cf4:	74050513          	addi	a0,a0,1856 # 80008430 <states.1747+0xc8>
    80002cf8:	ffffe097          	auipc	ra,0xffffe
    80002cfc:	84c080e7          	jalr	-1972(ra) # 80000544 <panic>
    panic("kerneltrap: interrupts enabled");
    80002d00:	00005517          	auipc	a0,0x5
    80002d04:	75850513          	addi	a0,a0,1880 # 80008458 <states.1747+0xf0>
    80002d08:	ffffe097          	auipc	ra,0xffffe
    80002d0c:	83c080e7          	jalr	-1988(ra) # 80000544 <panic>
    printf("scause %p\n", scause);
    80002d10:	85ce                	mv	a1,s3
    80002d12:	00005517          	auipc	a0,0x5
    80002d16:	76650513          	addi	a0,a0,1894 # 80008478 <states.1747+0x110>
    80002d1a:	ffffe097          	auipc	ra,0xffffe
    80002d1e:	874080e7          	jalr	-1932(ra) # 8000058e <printf>
  asm volatile("csrr %0, sepc" : "=r" (x) );
    80002d22:	141025f3          	csrr	a1,sepc
  asm volatile("csrr %0, stval" : "=r" (x) );
    80002d26:	14302673          	csrr	a2,stval
    printf("sepc=%p stval=%p\n", r_sepc(), r_stval());
    80002d2a:	00005517          	auipc	a0,0x5
    80002d2e:	75e50513          	addi	a0,a0,1886 # 80008488 <states.1747+0x120>
    80002d32:	ffffe097          	auipc	ra,0xffffe
    80002d36:	85c080e7          	jalr	-1956(ra) # 8000058e <printf>
    panic("kerneltrap");
    80002d3a:	00005517          	auipc	a0,0x5
    80002d3e:	76650513          	addi	a0,a0,1894 # 800084a0 <states.1747+0x138>
    80002d42:	ffffe097          	auipc	ra,0xffffe
    80002d46:	802080e7          	jalr	-2046(ra) # 80000544 <panic>
  if(which_dev == 2 && myproc() != 0 && myproc()->state == RUNNING)
    80002d4a:	fffff097          	auipc	ra,0xfffff
    80002d4e:	d4c080e7          	jalr	-692(ra) # 80001a96 <myproc>
    80002d52:	d541                	beqz	a0,80002cda <kerneltrap+0x38>
    80002d54:	fffff097          	auipc	ra,0xfffff
    80002d58:	d42080e7          	jalr	-702(ra) # 80001a96 <myproc>
    80002d5c:	5118                	lw	a4,32(a0)
    80002d5e:	4791                	li	a5,4
    80002d60:	f6f71de3          	bne	a4,a5,80002cda <kerneltrap+0x38>
    yield();
    80002d64:	fffff097          	auipc	ra,0xfffff
    80002d68:	4e0080e7          	jalr	1248(ra) # 80002244 <yield>
    80002d6c:	b7bd                	j	80002cda <kerneltrap+0x38>

0000000080002d6e <argraw>:
  return strlen(buf);
}

static uint64
argraw(int n)
{
    80002d6e:	1101                	addi	sp,sp,-32
    80002d70:	ec06                	sd	ra,24(sp)
    80002d72:	e822                	sd	s0,16(sp)
    80002d74:	e426                	sd	s1,8(sp)
    80002d76:	1000                	addi	s0,sp,32
    80002d78:	84aa                	mv	s1,a0
  struct proc *p = myproc();
    80002d7a:	fffff097          	auipc	ra,0xfffff
    80002d7e:	d1c080e7          	jalr	-740(ra) # 80001a96 <myproc>
  switch (n) {
    80002d82:	4795                	li	a5,5
    80002d84:	0497e163          	bltu	a5,s1,80002dc6 <argraw+0x58>
    80002d88:	048a                	slli	s1,s1,0x2
    80002d8a:	00006717          	auipc	a4,0x6
    80002d8e:	82e70713          	addi	a4,a4,-2002 # 800085b8 <states.1747+0x250>
    80002d92:	94ba                	add	s1,s1,a4
    80002d94:	409c                	lw	a5,0(s1)
    80002d96:	97ba                	add	a5,a5,a4
    80002d98:	8782                	jr	a5
  case 0:
    return p->trapframe->a0;
    80002d9a:	753c                	ld	a5,104(a0)
    80002d9c:	7ba8                	ld	a0,112(a5)
  case 5:
    return p->trapframe->a5;
  }
  panic("argraw");
  return -1;
}
    80002d9e:	60e2                	ld	ra,24(sp)
    80002da0:	6442                	ld	s0,16(sp)
    80002da2:	64a2                	ld	s1,8(sp)
    80002da4:	6105                	addi	sp,sp,32
    80002da6:	8082                	ret
    return p->trapframe->a1;
    80002da8:	753c                	ld	a5,104(a0)
    80002daa:	7fa8                	ld	a0,120(a5)
    80002dac:	bfcd                	j	80002d9e <argraw+0x30>
    return p->trapframe->a2;
    80002dae:	753c                	ld	a5,104(a0)
    80002db0:	63c8                	ld	a0,128(a5)
    80002db2:	b7f5                	j	80002d9e <argraw+0x30>
    return p->trapframe->a3;
    80002db4:	753c                	ld	a5,104(a0)
    80002db6:	67c8                	ld	a0,136(a5)
    80002db8:	b7dd                	j	80002d9e <argraw+0x30>
    return p->trapframe->a4;
    80002dba:	753c                	ld	a5,104(a0)
    80002dbc:	6bc8                	ld	a0,144(a5)
    80002dbe:	b7c5                	j	80002d9e <argraw+0x30>
    return p->trapframe->a5;
    80002dc0:	753c                	ld	a5,104(a0)
    80002dc2:	6fc8                	ld	a0,152(a5)
    80002dc4:	bfe9                	j	80002d9e <argraw+0x30>
  panic("argraw");
    80002dc6:	00005517          	auipc	a0,0x5
    80002dca:	6ea50513          	addi	a0,a0,1770 # 800084b0 <states.1747+0x148>
    80002dce:	ffffd097          	auipc	ra,0xffffd
    80002dd2:	776080e7          	jalr	1910(ra) # 80000544 <panic>

0000000080002dd6 <fetchaddr>:
{
    80002dd6:	1101                	addi	sp,sp,-32
    80002dd8:	ec06                	sd	ra,24(sp)
    80002dda:	e822                	sd	s0,16(sp)
    80002ddc:	e426                	sd	s1,8(sp)
    80002dde:	e04a                	sd	s2,0(sp)
    80002de0:	1000                	addi	s0,sp,32
    80002de2:	84aa                	mv	s1,a0
    80002de4:	892e                	mv	s2,a1
  struct proc *p = myproc();
    80002de6:	fffff097          	auipc	ra,0xfffff
    80002dea:	cb0080e7          	jalr	-848(ra) # 80001a96 <myproc>
  if(addr >= p->sz || addr+sizeof(uint64) > p->sz) // both tests needed, in case of overflow
    80002dee:	6d3c                	ld	a5,88(a0)
    80002df0:	02f4f863          	bgeu	s1,a5,80002e20 <fetchaddr+0x4a>
    80002df4:	00848713          	addi	a4,s1,8
    80002df8:	02e7e663          	bltu	a5,a4,80002e24 <fetchaddr+0x4e>
  if(copyin(p->pagetable, (char *)ip, addr, sizeof(*ip)) != 0)
    80002dfc:	46a1                	li	a3,8
    80002dfe:	8626                	mv	a2,s1
    80002e00:	85ca                	mv	a1,s2
    80002e02:	7128                	ld	a0,96(a0)
    80002e04:	fffff097          	auipc	ra,0xfffff
    80002e08:	9dc080e7          	jalr	-1572(ra) # 800017e0 <copyin>
    80002e0c:	00a03533          	snez	a0,a0
    80002e10:	40a00533          	neg	a0,a0
}
    80002e14:	60e2                	ld	ra,24(sp)
    80002e16:	6442                	ld	s0,16(sp)
    80002e18:	64a2                	ld	s1,8(sp)
    80002e1a:	6902                	ld	s2,0(sp)
    80002e1c:	6105                	addi	sp,sp,32
    80002e1e:	8082                	ret
    return -1;
    80002e20:	557d                	li	a0,-1
    80002e22:	bfcd                	j	80002e14 <fetchaddr+0x3e>
    80002e24:	557d                	li	a0,-1
    80002e26:	b7fd                	j	80002e14 <fetchaddr+0x3e>

0000000080002e28 <fetchstr>:
{
    80002e28:	7179                	addi	sp,sp,-48
    80002e2a:	f406                	sd	ra,40(sp)
    80002e2c:	f022                	sd	s0,32(sp)
    80002e2e:	ec26                	sd	s1,24(sp)
    80002e30:	e84a                	sd	s2,16(sp)
    80002e32:	e44e                	sd	s3,8(sp)
    80002e34:	1800                	addi	s0,sp,48
    80002e36:	892a                	mv	s2,a0
    80002e38:	84ae                	mv	s1,a1
    80002e3a:	89b2                	mv	s3,a2
  struct proc *p = myproc();
    80002e3c:	fffff097          	auipc	ra,0xfffff
    80002e40:	c5a080e7          	jalr	-934(ra) # 80001a96 <myproc>
  if(copyinstr(p->pagetable, buf, addr, max) < 0)
    80002e44:	86ce                	mv	a3,s3
    80002e46:	864a                	mv	a2,s2
    80002e48:	85a6                	mv	a1,s1
    80002e4a:	7128                	ld	a0,96(a0)
    80002e4c:	fffff097          	auipc	ra,0xfffff
    80002e50:	a20080e7          	jalr	-1504(ra) # 8000186c <copyinstr>
    80002e54:	00054e63          	bltz	a0,80002e70 <fetchstr+0x48>
  return strlen(buf);
    80002e58:	8526                	mv	a0,s1
    80002e5a:	ffffe097          	auipc	ra,0xffffe
    80002e5e:	0e0080e7          	jalr	224(ra) # 80000f3a <strlen>
}
    80002e62:	70a2                	ld	ra,40(sp)
    80002e64:	7402                	ld	s0,32(sp)
    80002e66:	64e2                	ld	s1,24(sp)
    80002e68:	6942                	ld	s2,16(sp)
    80002e6a:	69a2                	ld	s3,8(sp)
    80002e6c:	6145                	addi	sp,sp,48
    80002e6e:	8082                	ret
    return -1;
    80002e70:	557d                	li	a0,-1
    80002e72:	bfc5                	j	80002e62 <fetchstr+0x3a>

0000000080002e74 <argint>:

// Fetch the nth 32-bit system call argument.
void
argint(int n, int *ip)
{
    80002e74:	1101                	addi	sp,sp,-32
    80002e76:	ec06                	sd	ra,24(sp)
    80002e78:	e822                	sd	s0,16(sp)
    80002e7a:	e426                	sd	s1,8(sp)
    80002e7c:	1000                	addi	s0,sp,32
    80002e7e:	84ae                	mv	s1,a1
  *ip = argraw(n);
    80002e80:	00000097          	auipc	ra,0x0
    80002e84:	eee080e7          	jalr	-274(ra) # 80002d6e <argraw>
    80002e88:	c088                	sw	a0,0(s1)
}
    80002e8a:	60e2                	ld	ra,24(sp)
    80002e8c:	6442                	ld	s0,16(sp)
    80002e8e:	64a2                	ld	s1,8(sp)
    80002e90:	6105                	addi	sp,sp,32
    80002e92:	8082                	ret

0000000080002e94 <argaddr>:
// Retrieve an argument as a pointer.
// Doesn't check for legality, since
// copyin/copyout will do that.
void
argaddr(int n, uint64 *ip)
{
    80002e94:	1101                	addi	sp,sp,-32
    80002e96:	ec06                	sd	ra,24(sp)
    80002e98:	e822                	sd	s0,16(sp)
    80002e9a:	e426                	sd	s1,8(sp)
    80002e9c:	1000                	addi	s0,sp,32
    80002e9e:	84ae                	mv	s1,a1
  *ip = argraw(n);
    80002ea0:	00000097          	auipc	ra,0x0
    80002ea4:	ece080e7          	jalr	-306(ra) # 80002d6e <argraw>
    80002ea8:	e088                	sd	a0,0(s1)
}
    80002eaa:	60e2                	ld	ra,24(sp)
    80002eac:	6442                	ld	s0,16(sp)
    80002eae:	64a2                	ld	s1,8(sp)
    80002eb0:	6105                	addi	sp,sp,32
    80002eb2:	8082                	ret

0000000080002eb4 <argstr>:
// Fetch the nth word-sized system call argument as a null-terminated string.
// Copies into buf, at most max.
// Returns string length if OK (including nul), -1 if error.
int
argstr(int n, char *buf, int max)
{
    80002eb4:	7179                	addi	sp,sp,-48
    80002eb6:	f406                	sd	ra,40(sp)
    80002eb8:	f022                	sd	s0,32(sp)
    80002eba:	ec26                	sd	s1,24(sp)
    80002ebc:	e84a                	sd	s2,16(sp)
    80002ebe:	1800                	addi	s0,sp,48
    80002ec0:	84ae                	mv	s1,a1
    80002ec2:	8932                	mv	s2,a2
  uint64 addr;
  argaddr(n, &addr);
    80002ec4:	fd840593          	addi	a1,s0,-40
    80002ec8:	00000097          	auipc	ra,0x0
    80002ecc:	fcc080e7          	jalr	-52(ra) # 80002e94 <argaddr>
  return fetchstr(addr, buf, max);
    80002ed0:	864a                	mv	a2,s2
    80002ed2:	85a6                	mv	a1,s1
    80002ed4:	fd843503          	ld	a0,-40(s0)
    80002ed8:	00000097          	auipc	ra,0x0
    80002edc:	f50080e7          	jalr	-176(ra) # 80002e28 <fetchstr>
}
    80002ee0:	70a2                	ld	ra,40(sp)
    80002ee2:	7402                	ld	s0,32(sp)
    80002ee4:	64e2                	ld	s1,24(sp)
    80002ee6:	6942                	ld	s2,16(sp)
    80002ee8:	6145                	addi	sp,sp,48
    80002eea:	8082                	ret

0000000080002eec <syscall>:
[SYS_setpriority] "setpriority",
};

void
syscall(void)
{
    80002eec:	1101                	addi	sp,sp,-32
    80002eee:	ec06                	sd	ra,24(sp)
    80002ef0:	e822                	sd	s0,16(sp)
    80002ef2:	e426                	sd	s1,8(sp)
    80002ef4:	e04a                	sd	s2,0(sp)
    80002ef6:	1000                	addi	s0,sp,32
  int num;
  struct proc *p = myproc();
    80002ef8:	fffff097          	auipc	ra,0xfffff
    80002efc:	b9e080e7          	jalr	-1122(ra) # 80001a96 <myproc>
    80002f00:	84aa                	mv	s1,a0

  num = p->trapframe->a7;
    80002f02:	753c                	ld	a5,104(a0)
    80002f04:	77dc                	ld	a5,168(a5)
    80002f06:	0007891b          	sext.w	s2,a5
  if(num > 0 && num < NELEM(syscalls) && syscalls[num]) {
    80002f0a:	37fd                	addiw	a5,a5,-1
    80002f0c:	4761                	li	a4,24
    80002f0e:	04f76963          	bltu	a4,a5,80002f60 <syscall+0x74>
    80002f12:	00391713          	slli	a4,s2,0x3
    80002f16:	00005797          	auipc	a5,0x5
    80002f1a:	6ba78793          	addi	a5,a5,1722 # 800085d0 <syscalls>
    80002f1e:	97ba                	add	a5,a5,a4
    80002f20:	639c                	ld	a5,0(a5)
    80002f22:	cf9d                	beqz	a5,80002f60 <syscall+0x74>
    // Use num to lookup the system call function for num, call it,
    // and store its return value in p->trapframe->a0
    uint64 ret = syscalls[num]();
    80002f24:	9782                	jalr	a5
    p->trapframe->a0 = ret;
    80002f26:	74bc                	ld	a5,104(s1)
    80002f28:	fba8                	sd	a0,112(a5)
    if((1<<num) & p->trace_mask){
    80002f2a:	4785                	li	a5,1
    80002f2c:	012797bb          	sllw	a5,a5,s2
    80002f30:	1784a703          	lw	a4,376(s1)
    80002f34:	8ff9                	and	a5,a5,a4
    80002f36:	2781                	sext.w	a5,a5
    80002f38:	c3b9                	beqz	a5,80002f7e <syscall+0x92>
      printf("%d: syscall %s -> %d\n",p->pid,syscall_name[num],ret);
    80002f3a:	090e                	slli	s2,s2,0x3
    80002f3c:	00005797          	auipc	a5,0x5
    80002f40:	69478793          	addi	a5,a5,1684 # 800085d0 <syscalls>
    80002f44:	993e                	add	s2,s2,a5
    80002f46:	86aa                	mv	a3,a0
    80002f48:	0d093603          	ld	a2,208(s2)
    80002f4c:	5c8c                	lw	a1,56(s1)
    80002f4e:	00005517          	auipc	a0,0x5
    80002f52:	56a50513          	addi	a0,a0,1386 # 800084b8 <states.1747+0x150>
    80002f56:	ffffd097          	auipc	ra,0xffffd
    80002f5a:	638080e7          	jalr	1592(ra) # 8000058e <printf>
    80002f5e:	a005                	j	80002f7e <syscall+0x92>
    }
  } else {
    printf("%d %s: unknown sys call %d\n",
    80002f60:	86ca                	mv	a3,s2
    80002f62:	16848613          	addi	a2,s1,360
    80002f66:	5c8c                	lw	a1,56(s1)
    80002f68:	00005517          	auipc	a0,0x5
    80002f6c:	56850513          	addi	a0,a0,1384 # 800084d0 <states.1747+0x168>
    80002f70:	ffffd097          	auipc	ra,0xffffd
    80002f74:	61e080e7          	jalr	1566(ra) # 8000058e <printf>
            p->pid, p->name, num);
    p->trapframe->a0 = -1;
    80002f78:	74bc                	ld	a5,104(s1)
    80002f7a:	577d                	li	a4,-1
    80002f7c:	fbb8                	sd	a4,112(a5)
  }
}
    80002f7e:	60e2                	ld	ra,24(sp)
    80002f80:	6442                	ld	s0,16(sp)
    80002f82:	64a2                	ld	s1,8(sp)
    80002f84:	6902                	ld	s2,0(sp)
    80002f86:	6105                	addi	sp,sp,32
    80002f88:	8082                	ret

0000000080002f8a <sys_exit>:
#include "proc.h"
#include "sysinfo.h"

uint64
sys_exit(void)
{
    80002f8a:	1101                	addi	sp,sp,-32
    80002f8c:	ec06                	sd	ra,24(sp)
    80002f8e:	e822                	sd	s0,16(sp)
    80002f90:	1000                	addi	s0,sp,32
  int n;
  argint(0, &n);
    80002f92:	fec40593          	addi	a1,s0,-20
    80002f96:	4501                	li	a0,0
    80002f98:	00000097          	auipc	ra,0x0
    80002f9c:	edc080e7          	jalr	-292(ra) # 80002e74 <argint>
  exit(n);
    80002fa0:	fec42503          	lw	a0,-20(s0)
    80002fa4:	fffff097          	auipc	ra,0xfffff
    80002fa8:	410080e7          	jalr	1040(ra) # 800023b4 <exit>
  return 0;  // not reached
}
    80002fac:	4501                	li	a0,0
    80002fae:	60e2                	ld	ra,24(sp)
    80002fb0:	6442                	ld	s0,16(sp)
    80002fb2:	6105                	addi	sp,sp,32
    80002fb4:	8082                	ret

0000000080002fb6 <sys_getpid>:

uint64
sys_getpid(void)
{
    80002fb6:	1141                	addi	sp,sp,-16
    80002fb8:	e406                	sd	ra,8(sp)
    80002fba:	e022                	sd	s0,0(sp)
    80002fbc:	0800                	addi	s0,sp,16
  return myproc()->pid;
    80002fbe:	fffff097          	auipc	ra,0xfffff
    80002fc2:	ad8080e7          	jalr	-1320(ra) # 80001a96 <myproc>
}
    80002fc6:	5d08                	lw	a0,56(a0)
    80002fc8:	60a2                	ld	ra,8(sp)
    80002fca:	6402                	ld	s0,0(sp)
    80002fcc:	0141                	addi	sp,sp,16
    80002fce:	8082                	ret

0000000080002fd0 <sys_fork>:

uint64
sys_fork(void)
{
    80002fd0:	1141                	addi	sp,sp,-16
    80002fd2:	e406                	sd	ra,8(sp)
    80002fd4:	e022                	sd	s0,0(sp)
    80002fd6:	0800                	addi	s0,sp,16
  return fork();
    80002fd8:	fffff097          	auipc	ra,0xfffff
    80002fdc:	e86080e7          	jalr	-378(ra) # 80001e5e <fork>
}
    80002fe0:	60a2                	ld	ra,8(sp)
    80002fe2:	6402                	ld	s0,0(sp)
    80002fe4:	0141                	addi	sp,sp,16
    80002fe6:	8082                	ret

0000000080002fe8 <sys_wait>:

uint64
sys_wait(void)
{
    80002fe8:	1101                	addi	sp,sp,-32
    80002fea:	ec06                	sd	ra,24(sp)
    80002fec:	e822                	sd	s0,16(sp)
    80002fee:	1000                	addi	s0,sp,32
  uint64 p;
  argaddr(0, &p);
    80002ff0:	fe840593          	addi	a1,s0,-24
    80002ff4:	4501                	li	a0,0
    80002ff6:	00000097          	auipc	ra,0x0
    80002ffa:	e9e080e7          	jalr	-354(ra) # 80002e94 <argaddr>
  return wait(p);
    80002ffe:	fe843503          	ld	a0,-24(s0)
    80003002:	fffff097          	auipc	ra,0xfffff
    80003006:	558080e7          	jalr	1368(ra) # 8000255a <wait>
}
    8000300a:	60e2                	ld	ra,24(sp)
    8000300c:	6442                	ld	s0,16(sp)
    8000300e:	6105                	addi	sp,sp,32
    80003010:	8082                	ret

0000000080003012 <sys_sbrk>:

uint64
sys_sbrk(void)
{
    80003012:	7179                	addi	sp,sp,-48
    80003014:	f406                	sd	ra,40(sp)
    80003016:	f022                	sd	s0,32(sp)
    80003018:	ec26                	sd	s1,24(sp)
    8000301a:	1800                	addi	s0,sp,48
  uint64 addr;
  int n;

  argint(0, &n);
    8000301c:	fdc40593          	addi	a1,s0,-36
    80003020:	4501                	li	a0,0
    80003022:	00000097          	auipc	ra,0x0
    80003026:	e52080e7          	jalr	-430(ra) # 80002e74 <argint>
  addr = myproc()->sz;
    8000302a:	fffff097          	auipc	ra,0xfffff
    8000302e:	a6c080e7          	jalr	-1428(ra) # 80001a96 <myproc>
    80003032:	6d24                	ld	s1,88(a0)
  if(growproc(n) < 0)
    80003034:	fdc42503          	lw	a0,-36(s0)
    80003038:	fffff097          	auipc	ra,0xfffff
    8000303c:	dca080e7          	jalr	-566(ra) # 80001e02 <growproc>
    80003040:	00054863          	bltz	a0,80003050 <sys_sbrk+0x3e>
    return -1;
  return addr;
}
    80003044:	8526                	mv	a0,s1
    80003046:	70a2                	ld	ra,40(sp)
    80003048:	7402                	ld	s0,32(sp)
    8000304a:	64e2                	ld	s1,24(sp)
    8000304c:	6145                	addi	sp,sp,48
    8000304e:	8082                	ret
    return -1;
    80003050:	54fd                	li	s1,-1
    80003052:	bfcd                	j	80003044 <sys_sbrk+0x32>

0000000080003054 <sys_sleep>:

uint64
sys_sleep(void)
{
    80003054:	7139                	addi	sp,sp,-64
    80003056:	fc06                	sd	ra,56(sp)
    80003058:	f822                	sd	s0,48(sp)
    8000305a:	f426                	sd	s1,40(sp)
    8000305c:	f04a                	sd	s2,32(sp)
    8000305e:	ec4e                	sd	s3,24(sp)
    80003060:	0080                	addi	s0,sp,64
  int n;
  uint ticks0;

  argint(0, &n);
    80003062:	fcc40593          	addi	a1,s0,-52
    80003066:	4501                	li	a0,0
    80003068:	00000097          	auipc	ra,0x0
    8000306c:	e0c080e7          	jalr	-500(ra) # 80002e74 <argint>
  acquire(&tickslock);
    80003070:	00014517          	auipc	a0,0x14
    80003074:	1b050513          	addi	a0,a0,432 # 80017220 <tickslock>
    80003078:	ffffe097          	auipc	ra,0xffffe
    8000307c:	b96080e7          	jalr	-1130(ra) # 80000c0e <acquire>
  ticks0 = ticks;
    80003080:	00006917          	auipc	s2,0x6
    80003084:	ad092903          	lw	s2,-1328(s2) # 80008b50 <ticks>
  while(ticks - ticks0 < n){
    80003088:	fcc42783          	lw	a5,-52(s0)
    8000308c:	cf9d                	beqz	a5,800030ca <sys_sleep+0x76>
    if(killed(myproc())){
      release(&tickslock);
      return -1;
    }
    sleep(&ticks, &tickslock);
    8000308e:	00014997          	auipc	s3,0x14
    80003092:	19298993          	addi	s3,s3,402 # 80017220 <tickslock>
    80003096:	00006497          	auipc	s1,0x6
    8000309a:	aba48493          	addi	s1,s1,-1350 # 80008b50 <ticks>
    if(killed(myproc())){
    8000309e:	fffff097          	auipc	ra,0xfffff
    800030a2:	9f8080e7          	jalr	-1544(ra) # 80001a96 <myproc>
    800030a6:	fffff097          	auipc	ra,0xfffff
    800030aa:	482080e7          	jalr	1154(ra) # 80002528 <killed>
    800030ae:	ed15                	bnez	a0,800030ea <sys_sleep+0x96>
    sleep(&ticks, &tickslock);
    800030b0:	85ce                	mv	a1,s3
    800030b2:	8526                	mv	a0,s1
    800030b4:	fffff097          	auipc	ra,0xfffff
    800030b8:	1cc080e7          	jalr	460(ra) # 80002280 <sleep>
  while(ticks - ticks0 < n){
    800030bc:	409c                	lw	a5,0(s1)
    800030be:	412787bb          	subw	a5,a5,s2
    800030c2:	fcc42703          	lw	a4,-52(s0)
    800030c6:	fce7ece3          	bltu	a5,a4,8000309e <sys_sleep+0x4a>
  }
  release(&tickslock);
    800030ca:	00014517          	auipc	a0,0x14
    800030ce:	15650513          	addi	a0,a0,342 # 80017220 <tickslock>
    800030d2:	ffffe097          	auipc	ra,0xffffe
    800030d6:	c96080e7          	jalr	-874(ra) # 80000d68 <release>
  return 0;
    800030da:	4501                	li	a0,0
}
    800030dc:	70e2                	ld	ra,56(sp)
    800030de:	7442                	ld	s0,48(sp)
    800030e0:	74a2                	ld	s1,40(sp)
    800030e2:	7902                	ld	s2,32(sp)
    800030e4:	69e2                	ld	s3,24(sp)
    800030e6:	6121                	addi	sp,sp,64
    800030e8:	8082                	ret
      release(&tickslock);
    800030ea:	00014517          	auipc	a0,0x14
    800030ee:	13650513          	addi	a0,a0,310 # 80017220 <tickslock>
    800030f2:	ffffe097          	auipc	ra,0xffffe
    800030f6:	c76080e7          	jalr	-906(ra) # 80000d68 <release>
      return -1;
    800030fa:	557d                	li	a0,-1
    800030fc:	b7c5                	j	800030dc <sys_sleep+0x88>

00000000800030fe <sys_kill>:

uint64
sys_kill(void)
{
    800030fe:	1101                	addi	sp,sp,-32
    80003100:	ec06                	sd	ra,24(sp)
    80003102:	e822                	sd	s0,16(sp)
    80003104:	1000                	addi	s0,sp,32
  int pid;

  argint(0, &pid);
    80003106:	fec40593          	addi	a1,s0,-20
    8000310a:	4501                	li	a0,0
    8000310c:	00000097          	auipc	ra,0x0
    80003110:	d68080e7          	jalr	-664(ra) # 80002e74 <argint>
  return kill(pid);
    80003114:	fec42503          	lw	a0,-20(s0)
    80003118:	fffff097          	auipc	ra,0xfffff
    8000311c:	372080e7          	jalr	882(ra) # 8000248a <kill>
}
    80003120:	60e2                	ld	ra,24(sp)
    80003122:	6442                	ld	s0,16(sp)
    80003124:	6105                	addi	sp,sp,32
    80003126:	8082                	ret

0000000080003128 <sys_uptime>:

// return how many clock tick interrupts have occurred
// since start.
uint64
sys_uptime(void)
{
    80003128:	1101                	addi	sp,sp,-32
    8000312a:	ec06                	sd	ra,24(sp)
    8000312c:	e822                	sd	s0,16(sp)
    8000312e:	e426                	sd	s1,8(sp)
    80003130:	1000                	addi	s0,sp,32
  uint xticks;

  acquire(&tickslock);
    80003132:	00014517          	auipc	a0,0x14
    80003136:	0ee50513          	addi	a0,a0,238 # 80017220 <tickslock>
    8000313a:	ffffe097          	auipc	ra,0xffffe
    8000313e:	ad4080e7          	jalr	-1324(ra) # 80000c0e <acquire>
  xticks = ticks;
    80003142:	00006497          	auipc	s1,0x6
    80003146:	a0e4a483          	lw	s1,-1522(s1) # 80008b50 <ticks>
  release(&tickslock);
    8000314a:	00014517          	auipc	a0,0x14
    8000314e:	0d650513          	addi	a0,a0,214 # 80017220 <tickslock>
    80003152:	ffffe097          	auipc	ra,0xffffe
    80003156:	c16080e7          	jalr	-1002(ra) # 80000d68 <release>
  return xticks;
}
    8000315a:	02049513          	slli	a0,s1,0x20
    8000315e:	9101                	srli	a0,a0,0x20
    80003160:	60e2                	ld	ra,24(sp)
    80003162:	6442                	ld	s0,16(sp)
    80003164:	64a2                	ld	s1,8(sp)
    80003166:	6105                	addi	sp,sp,32
    80003168:	8082                	ret

000000008000316a <sys_cps>:
//***new
uint64
sys_cps(void) 
{
    8000316a:	1141                	addi	sp,sp,-16
    8000316c:	e406                	sd	ra,8(sp)
    8000316e:	e022                	sd	s0,0(sp)
    80003170:	0800                	addi	s0,sp,16
  return cps();
    80003172:	fffff097          	auipc	ra,0xfffff
    80003176:	670080e7          	jalr	1648(ra) # 800027e2 <cps>
}
    8000317a:	60a2                	ld	ra,8(sp)
    8000317c:	6402                	ld	s0,0(sp)
    8000317e:	0141                	addi	sp,sp,16
    80003180:	8082                	ret

0000000080003182 <sys_trace>:

uint64
sys_trace(void)
{
    80003182:	1101                	addi	sp,sp,-32
    80003184:	ec06                	sd	ra,24(sp)
    80003186:	e822                	sd	s0,16(sp)
    80003188:	1000                	addi	s0,sp,32
 uint mask;
 argint(0,(int*)&mask);
    8000318a:	fec40593          	addi	a1,s0,-20
    8000318e:	4501                	li	a0,0
    80003190:	00000097          	auipc	ra,0x0
    80003194:	ce4080e7          	jalr	-796(ra) # 80002e74 <argint>
 if(mask<0)
   return -1;
 struct proc *p = myproc();
    80003198:	fffff097          	auipc	ra,0xfffff
    8000319c:	8fe080e7          	jalr	-1794(ra) # 80001a96 <myproc>
 p->trace_mask |= mask;
    800031a0:	17852783          	lw	a5,376(a0)
    800031a4:	fec42703          	lw	a4,-20(s0)
    800031a8:	8fd9                	or	a5,a5,a4
    800031aa:	16f52c23          	sw	a5,376(a0)
 return 0;
 } 
    800031ae:	4501                	li	a0,0
    800031b0:	60e2                	ld	ra,24(sp)
    800031b2:	6442                	ld	s0,16(sp)
    800031b4:	6105                	addi	sp,sp,32
    800031b6:	8082                	ret

00000000800031b8 <sys_sysinfo>:
 
  
// get sysinfo
uint64
sys_sysinfo(void)
{
    800031b8:	7139                	addi	sp,sp,-64
    800031ba:	fc06                	sd	ra,56(sp)
    800031bc:	f822                	sd	s0,48(sp)
    800031be:	f426                	sd	s1,40(sp)
    800031c0:	0080                	addi	s0,sp,64
  uint64 info; // user pointer
  struct sysinfo kinfo;
  struct proc *p = myproc();
    800031c2:	fffff097          	auipc	ra,0xfffff
    800031c6:	8d4080e7          	jalr	-1836(ra) # 80001a96 <myproc>
    800031ca:	84aa                	mv	s1,a0
  argaddr(0, &info);
    800031cc:	fd840593          	addi	a1,s0,-40
    800031d0:	4501                	li	a0,0
    800031d2:	00000097          	auipc	ra,0x0
    800031d6:	cc2080e7          	jalr	-830(ra) # 80002e94 <argaddr>
  if(info < 0){
    return -1;
  }
  kinfo.freemem = freemem();
    800031da:	ffffe097          	auipc	ra,0xffffe
    800031de:	980080e7          	jalr	-1664(ra) # 80000b5a <freemem>
    800031e2:	fca43423          	sd	a0,-56(s0)
  kinfo.nproc = nproc();
    800031e6:	fffff097          	auipc	ra,0xfffff
    800031ea:	6e0080e7          	jalr	1760(ra) # 800028c6 <nproc>
    800031ee:	fca43823          	sd	a0,-48(s0)
  if(copyout(p->pagetable, info, (char*)&kinfo, sizeof(kinfo)) < 0){
    800031f2:	46c1                	li	a3,16
    800031f4:	fc840613          	addi	a2,s0,-56
    800031f8:	fd843583          	ld	a1,-40(s0)
    800031fc:	70a8                	ld	a0,96(s1)
    800031fe:	ffffe097          	auipc	ra,0xffffe
    80003202:	556080e7          	jalr	1366(ra) # 80001754 <copyout>
    return -1;
  }
  return 0;
}
    80003206:	957d                	srai	a0,a0,0x3f
    80003208:	70e2                	ld	ra,56(sp)
    8000320a:	7442                	ld	s0,48(sp)
    8000320c:	74a2                	ld	s1,40(sp)
    8000320e:	6121                	addi	sp,sp,64
    80003210:	8082                	ret

0000000080003212 <setpriority>:

int setpriority(int priority) {
    80003212:	1141                	addi	sp,sp,-16
    80003214:	e406                	sd	ra,8(sp)
    80003216:	e022                	sd	s0,0(sp)
    80003218:	0800                	addi	s0,sp,16
  return setpriority( priority);
    8000321a:	00000097          	auipc	ra,0x0
    8000321e:	ff8080e7          	jalr	-8(ra) # 80003212 <setpriority>
}
    80003222:	60a2                	ld	ra,8(sp)
    80003224:	6402                	ld	s0,0(sp)
    80003226:	0141                	addi	sp,sp,16
    80003228:	8082                	ret

000000008000322a <binit>:
  struct buf head;
} bcache;

void
binit(void)
{
    8000322a:	7179                	addi	sp,sp,-48
    8000322c:	f406                	sd	ra,40(sp)
    8000322e:	f022                	sd	s0,32(sp)
    80003230:	ec26                	sd	s1,24(sp)
    80003232:	e84a                	sd	s2,16(sp)
    80003234:	e44e                	sd	s3,8(sp)
    80003236:	e052                	sd	s4,0(sp)
    80003238:	1800                	addi	s0,sp,48
  struct buf *b;

  initlock(&bcache.lock, "bcache");
    8000323a:	00005597          	auipc	a1,0x5
    8000323e:	53658593          	addi	a1,a1,1334 # 80008770 <syscall_name+0xd0>
    80003242:	00014517          	auipc	a0,0x14
    80003246:	ffe50513          	addi	a0,a0,-2 # 80017240 <bcache>
    8000324a:	ffffe097          	auipc	ra,0xffffe
    8000324e:	95a080e7          	jalr	-1702(ra) # 80000ba4 <initlock>

  // Create linked list of buffers
  bcache.head.prev = &bcache.head;
    80003252:	0001c797          	auipc	a5,0x1c
    80003256:	fee78793          	addi	a5,a5,-18 # 8001f240 <bcache+0x8000>
    8000325a:	0001c717          	auipc	a4,0x1c
    8000325e:	34670713          	addi	a4,a4,838 # 8001f5a0 <bcache+0x8360>
    80003262:	3ae7b823          	sd	a4,944(a5)
  bcache.head.next = &bcache.head;
    80003266:	3ae7bc23          	sd	a4,952(a5)
  for(b = bcache.buf; b < bcache.buf+NBUF; b++){
    8000326a:	00014497          	auipc	s1,0x14
    8000326e:	ff648493          	addi	s1,s1,-10 # 80017260 <bcache+0x20>
    b->next = bcache.head.next;
    80003272:	893e                	mv	s2,a5
    b->prev = &bcache.head;
    80003274:	89ba                	mv	s3,a4
    initsleeplock(&b->lock, "buffer");
    80003276:	00005a17          	auipc	s4,0x5
    8000327a:	502a0a13          	addi	s4,s4,1282 # 80008778 <syscall_name+0xd8>
    b->next = bcache.head.next;
    8000327e:	3b893783          	ld	a5,952(s2)
    80003282:	ecbc                	sd	a5,88(s1)
    b->prev = &bcache.head;
    80003284:	0534b823          	sd	s3,80(s1)
    initsleeplock(&b->lock, "buffer");
    80003288:	85d2                	mv	a1,s4
    8000328a:	01048513          	addi	a0,s1,16
    8000328e:	00001097          	auipc	ra,0x1
    80003292:	4c4080e7          	jalr	1220(ra) # 80004752 <initsleeplock>
    bcache.head.next->prev = b;
    80003296:	3b893783          	ld	a5,952(s2)
    8000329a:	eba4                	sd	s1,80(a5)
    bcache.head.next = b;
    8000329c:	3a993c23          	sd	s1,952(s2)
  for(b = bcache.buf; b < bcache.buf+NBUF; b++){
    800032a0:	46048493          	addi	s1,s1,1120
    800032a4:	fd349de3          	bne	s1,s3,8000327e <binit+0x54>
  }
}
    800032a8:	70a2                	ld	ra,40(sp)
    800032aa:	7402                	ld	s0,32(sp)
    800032ac:	64e2                	ld	s1,24(sp)
    800032ae:	6942                	ld	s2,16(sp)
    800032b0:	69a2                	ld	s3,8(sp)
    800032b2:	6a02                	ld	s4,0(sp)
    800032b4:	6145                	addi	sp,sp,48
    800032b6:	8082                	ret

00000000800032b8 <bread>:
}

// Return a locked buf with the contents of the indicated block.
struct buf*
bread(uint dev, uint blockno)
{
    800032b8:	7179                	addi	sp,sp,-48
    800032ba:	f406                	sd	ra,40(sp)
    800032bc:	f022                	sd	s0,32(sp)
    800032be:	ec26                	sd	s1,24(sp)
    800032c0:	e84a                	sd	s2,16(sp)
    800032c2:	e44e                	sd	s3,8(sp)
    800032c4:	1800                	addi	s0,sp,48
    800032c6:	89aa                	mv	s3,a0
    800032c8:	892e                	mv	s2,a1
  acquire(&bcache.lock);
    800032ca:	00014517          	auipc	a0,0x14
    800032ce:	f7650513          	addi	a0,a0,-138 # 80017240 <bcache>
    800032d2:	ffffe097          	auipc	ra,0xffffe
    800032d6:	93c080e7          	jalr	-1732(ra) # 80000c0e <acquire>
  for(b = bcache.head.next; b != &bcache.head; b = b->next){
    800032da:	0001c497          	auipc	s1,0x1c
    800032de:	31e4b483          	ld	s1,798(s1) # 8001f5f8 <bcache+0x83b8>
    800032e2:	0001c797          	auipc	a5,0x1c
    800032e6:	2be78793          	addi	a5,a5,702 # 8001f5a0 <bcache+0x8360>
    800032ea:	02f48f63          	beq	s1,a5,80003328 <bread+0x70>
    800032ee:	873e                	mv	a4,a5
    800032f0:	a021                	j	800032f8 <bread+0x40>
    800032f2:	6ca4                	ld	s1,88(s1)
    800032f4:	02e48a63          	beq	s1,a4,80003328 <bread+0x70>
    if(b->dev == dev && b->blockno == blockno){
    800032f8:	449c                	lw	a5,8(s1)
    800032fa:	ff379ce3          	bne	a5,s3,800032f2 <bread+0x3a>
    800032fe:	44dc                	lw	a5,12(s1)
    80003300:	ff2799e3          	bne	a5,s2,800032f2 <bread+0x3a>
      b->refcnt++;
    80003304:	44bc                	lw	a5,72(s1)
    80003306:	2785                	addiw	a5,a5,1
    80003308:	c4bc                	sw	a5,72(s1)
      release(&bcache.lock);
    8000330a:	00014517          	auipc	a0,0x14
    8000330e:	f3650513          	addi	a0,a0,-202 # 80017240 <bcache>
    80003312:	ffffe097          	auipc	ra,0xffffe
    80003316:	a56080e7          	jalr	-1450(ra) # 80000d68 <release>
      acquiresleep(&b->lock);
    8000331a:	01048513          	addi	a0,s1,16
    8000331e:	00001097          	auipc	ra,0x1
    80003322:	46e080e7          	jalr	1134(ra) # 8000478c <acquiresleep>
      return b;
    80003326:	a8b9                	j	80003384 <bread+0xcc>
  for(b = bcache.head.prev; b != &bcache.head; b = b->prev){
    80003328:	0001c497          	auipc	s1,0x1c
    8000332c:	2c84b483          	ld	s1,712(s1) # 8001f5f0 <bcache+0x83b0>
    80003330:	0001c797          	auipc	a5,0x1c
    80003334:	27078793          	addi	a5,a5,624 # 8001f5a0 <bcache+0x8360>
    80003338:	00f48863          	beq	s1,a5,80003348 <bread+0x90>
    8000333c:	873e                	mv	a4,a5
    if(b->refcnt == 0) {
    8000333e:	44bc                	lw	a5,72(s1)
    80003340:	cf81                	beqz	a5,80003358 <bread+0xa0>
  for(b = bcache.head.prev; b != &bcache.head; b = b->prev){
    80003342:	68a4                	ld	s1,80(s1)
    80003344:	fee49de3          	bne	s1,a4,8000333e <bread+0x86>
  panic("bget: no buffers");
    80003348:	00005517          	auipc	a0,0x5
    8000334c:	43850513          	addi	a0,a0,1080 # 80008780 <syscall_name+0xe0>
    80003350:	ffffd097          	auipc	ra,0xffffd
    80003354:	1f4080e7          	jalr	500(ra) # 80000544 <panic>
      b->dev = dev;
    80003358:	0134a423          	sw	s3,8(s1)
      b->blockno = blockno;
    8000335c:	0124a623          	sw	s2,12(s1)
      b->valid = 0;
    80003360:	0004a023          	sw	zero,0(s1)
      b->refcnt = 1;
    80003364:	4785                	li	a5,1
    80003366:	c4bc                	sw	a5,72(s1)
      release(&bcache.lock);
    80003368:	00014517          	auipc	a0,0x14
    8000336c:	ed850513          	addi	a0,a0,-296 # 80017240 <bcache>
    80003370:	ffffe097          	auipc	ra,0xffffe
    80003374:	9f8080e7          	jalr	-1544(ra) # 80000d68 <release>
      acquiresleep(&b->lock);
    80003378:	01048513          	addi	a0,s1,16
    8000337c:	00001097          	auipc	ra,0x1
    80003380:	410080e7          	jalr	1040(ra) # 8000478c <acquiresleep>
  struct buf *b;

  b = bget(dev, blockno);
  if(!b->valid) {
    80003384:	409c                	lw	a5,0(s1)
    80003386:	cb89                	beqz	a5,80003398 <bread+0xe0>
    virtio_disk_rw(b, 0);
    b->valid = 1;
  }
  return b;
}
    80003388:	8526                	mv	a0,s1
    8000338a:	70a2                	ld	ra,40(sp)
    8000338c:	7402                	ld	s0,32(sp)
    8000338e:	64e2                	ld	s1,24(sp)
    80003390:	6942                	ld	s2,16(sp)
    80003392:	69a2                	ld	s3,8(sp)
    80003394:	6145                	addi	sp,sp,48
    80003396:	8082                	ret
    virtio_disk_rw(b, 0);
    80003398:	4581                	li	a1,0
    8000339a:	8526                	mv	a0,s1
    8000339c:	00003097          	auipc	ra,0x3
    800033a0:	fcc080e7          	jalr	-52(ra) # 80006368 <virtio_disk_rw>
    b->valid = 1;
    800033a4:	4785                	li	a5,1
    800033a6:	c09c                	sw	a5,0(s1)
  return b;
    800033a8:	b7c5                	j	80003388 <bread+0xd0>

00000000800033aa <bwrite>:

// Write b's contents to disk.  Must be locked.
void
bwrite(struct buf *b)
{
    800033aa:	1101                	addi	sp,sp,-32
    800033ac:	ec06                	sd	ra,24(sp)
    800033ae:	e822                	sd	s0,16(sp)
    800033b0:	e426                	sd	s1,8(sp)
    800033b2:	1000                	addi	s0,sp,32
    800033b4:	84aa                	mv	s1,a0
  if(!holdingsleep(&b->lock))
    800033b6:	0541                	addi	a0,a0,16
    800033b8:	00001097          	auipc	ra,0x1
    800033bc:	46e080e7          	jalr	1134(ra) # 80004826 <holdingsleep>
    800033c0:	cd01                	beqz	a0,800033d8 <bwrite+0x2e>
    panic("bwrite");
  virtio_disk_rw(b, 1);
    800033c2:	4585                	li	a1,1
    800033c4:	8526                	mv	a0,s1
    800033c6:	00003097          	auipc	ra,0x3
    800033ca:	fa2080e7          	jalr	-94(ra) # 80006368 <virtio_disk_rw>
}
    800033ce:	60e2                	ld	ra,24(sp)
    800033d0:	6442                	ld	s0,16(sp)
    800033d2:	64a2                	ld	s1,8(sp)
    800033d4:	6105                	addi	sp,sp,32
    800033d6:	8082                	ret
    panic("bwrite");
    800033d8:	00005517          	auipc	a0,0x5
    800033dc:	3c050513          	addi	a0,a0,960 # 80008798 <syscall_name+0xf8>
    800033e0:	ffffd097          	auipc	ra,0xffffd
    800033e4:	164080e7          	jalr	356(ra) # 80000544 <panic>

00000000800033e8 <brelse>:

// Release a locked buffer.
// Move to the head of the most-recently-used list.
void
brelse(struct buf *b)
{
    800033e8:	1101                	addi	sp,sp,-32
    800033ea:	ec06                	sd	ra,24(sp)
    800033ec:	e822                	sd	s0,16(sp)
    800033ee:	e426                	sd	s1,8(sp)
    800033f0:	e04a                	sd	s2,0(sp)
    800033f2:	1000                	addi	s0,sp,32
    800033f4:	84aa                	mv	s1,a0
  if(!holdingsleep(&b->lock))
    800033f6:	01050913          	addi	s2,a0,16
    800033fa:	854a                	mv	a0,s2
    800033fc:	00001097          	auipc	ra,0x1
    80003400:	42a080e7          	jalr	1066(ra) # 80004826 <holdingsleep>
    80003404:	c92d                	beqz	a0,80003476 <brelse+0x8e>
    panic("brelse");

  releasesleep(&b->lock);
    80003406:	854a                	mv	a0,s2
    80003408:	00001097          	auipc	ra,0x1
    8000340c:	3da080e7          	jalr	986(ra) # 800047e2 <releasesleep>

  acquire(&bcache.lock);
    80003410:	00014517          	auipc	a0,0x14
    80003414:	e3050513          	addi	a0,a0,-464 # 80017240 <bcache>
    80003418:	ffffd097          	auipc	ra,0xffffd
    8000341c:	7f6080e7          	jalr	2038(ra) # 80000c0e <acquire>
  b->refcnt--;
    80003420:	44bc                	lw	a5,72(s1)
    80003422:	37fd                	addiw	a5,a5,-1
    80003424:	0007871b          	sext.w	a4,a5
    80003428:	c4bc                	sw	a5,72(s1)
  if (b->refcnt == 0) {
    8000342a:	eb05                	bnez	a4,8000345a <brelse+0x72>
    // no one is waiting for it.
    b->next->prev = b->prev;
    8000342c:	6cbc                	ld	a5,88(s1)
    8000342e:	68b8                	ld	a4,80(s1)
    80003430:	ebb8                	sd	a4,80(a5)
    b->prev->next = b->next;
    80003432:	68bc                	ld	a5,80(s1)
    80003434:	6cb8                	ld	a4,88(s1)
    80003436:	efb8                	sd	a4,88(a5)
    b->next = bcache.head.next;
    80003438:	0001c797          	auipc	a5,0x1c
    8000343c:	e0878793          	addi	a5,a5,-504 # 8001f240 <bcache+0x8000>
    80003440:	3b87b703          	ld	a4,952(a5)
    80003444:	ecb8                	sd	a4,88(s1)
    b->prev = &bcache.head;
    80003446:	0001c717          	auipc	a4,0x1c
    8000344a:	15a70713          	addi	a4,a4,346 # 8001f5a0 <bcache+0x8360>
    8000344e:	e8b8                	sd	a4,80(s1)
    bcache.head.next->prev = b;
    80003450:	3b87b703          	ld	a4,952(a5)
    80003454:	eb24                	sd	s1,80(a4)
    bcache.head.next = b;
    80003456:	3a97bc23          	sd	s1,952(a5)
  }
  
  release(&bcache.lock);
    8000345a:	00014517          	auipc	a0,0x14
    8000345e:	de650513          	addi	a0,a0,-538 # 80017240 <bcache>
    80003462:	ffffe097          	auipc	ra,0xffffe
    80003466:	906080e7          	jalr	-1786(ra) # 80000d68 <release>
}
    8000346a:	60e2                	ld	ra,24(sp)
    8000346c:	6442                	ld	s0,16(sp)
    8000346e:	64a2                	ld	s1,8(sp)
    80003470:	6902                	ld	s2,0(sp)
    80003472:	6105                	addi	sp,sp,32
    80003474:	8082                	ret
    panic("brelse");
    80003476:	00005517          	auipc	a0,0x5
    8000347a:	32a50513          	addi	a0,a0,810 # 800087a0 <syscall_name+0x100>
    8000347e:	ffffd097          	auipc	ra,0xffffd
    80003482:	0c6080e7          	jalr	198(ra) # 80000544 <panic>

0000000080003486 <bpin>:

void
bpin(struct buf *b) {
    80003486:	1101                	addi	sp,sp,-32
    80003488:	ec06                	sd	ra,24(sp)
    8000348a:	e822                	sd	s0,16(sp)
    8000348c:	e426                	sd	s1,8(sp)
    8000348e:	1000                	addi	s0,sp,32
    80003490:	84aa                	mv	s1,a0
  acquire(&bcache.lock);
    80003492:	00014517          	auipc	a0,0x14
    80003496:	dae50513          	addi	a0,a0,-594 # 80017240 <bcache>
    8000349a:	ffffd097          	auipc	ra,0xffffd
    8000349e:	774080e7          	jalr	1908(ra) # 80000c0e <acquire>
  b->refcnt++;
    800034a2:	44bc                	lw	a5,72(s1)
    800034a4:	2785                	addiw	a5,a5,1
    800034a6:	c4bc                	sw	a5,72(s1)
  release(&bcache.lock);
    800034a8:	00014517          	auipc	a0,0x14
    800034ac:	d9850513          	addi	a0,a0,-616 # 80017240 <bcache>
    800034b0:	ffffe097          	auipc	ra,0xffffe
    800034b4:	8b8080e7          	jalr	-1864(ra) # 80000d68 <release>
}
    800034b8:	60e2                	ld	ra,24(sp)
    800034ba:	6442                	ld	s0,16(sp)
    800034bc:	64a2                	ld	s1,8(sp)
    800034be:	6105                	addi	sp,sp,32
    800034c0:	8082                	ret

00000000800034c2 <bunpin>:

void
bunpin(struct buf *b) {
    800034c2:	1101                	addi	sp,sp,-32
    800034c4:	ec06                	sd	ra,24(sp)
    800034c6:	e822                	sd	s0,16(sp)
    800034c8:	e426                	sd	s1,8(sp)
    800034ca:	1000                	addi	s0,sp,32
    800034cc:	84aa                	mv	s1,a0
  acquire(&bcache.lock);
    800034ce:	00014517          	auipc	a0,0x14
    800034d2:	d7250513          	addi	a0,a0,-654 # 80017240 <bcache>
    800034d6:	ffffd097          	auipc	ra,0xffffd
    800034da:	738080e7          	jalr	1848(ra) # 80000c0e <acquire>
  b->refcnt--;
    800034de:	44bc                	lw	a5,72(s1)
    800034e0:	37fd                	addiw	a5,a5,-1
    800034e2:	c4bc                	sw	a5,72(s1)
  release(&bcache.lock);
    800034e4:	00014517          	auipc	a0,0x14
    800034e8:	d5c50513          	addi	a0,a0,-676 # 80017240 <bcache>
    800034ec:	ffffe097          	auipc	ra,0xffffe
    800034f0:	87c080e7          	jalr	-1924(ra) # 80000d68 <release>
}
    800034f4:	60e2                	ld	ra,24(sp)
    800034f6:	6442                	ld	s0,16(sp)
    800034f8:	64a2                	ld	s1,8(sp)
    800034fa:	6105                	addi	sp,sp,32
    800034fc:	8082                	ret

00000000800034fe <bfree>:
}

// Free a disk block.
static void
bfree(int dev, uint b)
{
    800034fe:	1101                	addi	sp,sp,-32
    80003500:	ec06                	sd	ra,24(sp)
    80003502:	e822                	sd	s0,16(sp)
    80003504:	e426                	sd	s1,8(sp)
    80003506:	e04a                	sd	s2,0(sp)
    80003508:	1000                	addi	s0,sp,32
    8000350a:	84ae                	mv	s1,a1
  struct buf *bp;
  int bi, m;

  bp = bread(dev, BBLOCK(b, sb));
    8000350c:	00d5d59b          	srliw	a1,a1,0xd
    80003510:	0001c797          	auipc	a5,0x1c
    80003514:	50c7a783          	lw	a5,1292(a5) # 8001fa1c <sb+0x1c>
    80003518:	9dbd                	addw	a1,a1,a5
    8000351a:	00000097          	auipc	ra,0x0
    8000351e:	d9e080e7          	jalr	-610(ra) # 800032b8 <bread>
  bi = b % BPB;
  m = 1 << (bi % 8);
    80003522:	0074f713          	andi	a4,s1,7
    80003526:	4785                	li	a5,1
    80003528:	00e797bb          	sllw	a5,a5,a4
  if((bp->data[bi/8] & m) == 0)
    8000352c:	14ce                	slli	s1,s1,0x33
    8000352e:	90d9                	srli	s1,s1,0x36
    80003530:	00950733          	add	a4,a0,s1
    80003534:	06074703          	lbu	a4,96(a4)
    80003538:	00e7f6b3          	and	a3,a5,a4
    8000353c:	c69d                	beqz	a3,8000356a <bfree+0x6c>
    8000353e:	892a                	mv	s2,a0
    panic("freeing free block");
  bp->data[bi/8] &= ~m;
    80003540:	94aa                	add	s1,s1,a0
    80003542:	fff7c793          	not	a5,a5
    80003546:	8ff9                	and	a5,a5,a4
    80003548:	06f48023          	sb	a5,96(s1)
  log_write(bp);
    8000354c:	00001097          	auipc	ra,0x1
    80003550:	120080e7          	jalr	288(ra) # 8000466c <log_write>
  brelse(bp);
    80003554:	854a                	mv	a0,s2
    80003556:	00000097          	auipc	ra,0x0
    8000355a:	e92080e7          	jalr	-366(ra) # 800033e8 <brelse>
}
    8000355e:	60e2                	ld	ra,24(sp)
    80003560:	6442                	ld	s0,16(sp)
    80003562:	64a2                	ld	s1,8(sp)
    80003564:	6902                	ld	s2,0(sp)
    80003566:	6105                	addi	sp,sp,32
    80003568:	8082                	ret
    panic("freeing free block");
    8000356a:	00005517          	auipc	a0,0x5
    8000356e:	23e50513          	addi	a0,a0,574 # 800087a8 <syscall_name+0x108>
    80003572:	ffffd097          	auipc	ra,0xffffd
    80003576:	fd2080e7          	jalr	-46(ra) # 80000544 <panic>

000000008000357a <balloc>:
{
    8000357a:	711d                	addi	sp,sp,-96
    8000357c:	ec86                	sd	ra,88(sp)
    8000357e:	e8a2                	sd	s0,80(sp)
    80003580:	e4a6                	sd	s1,72(sp)
    80003582:	e0ca                	sd	s2,64(sp)
    80003584:	fc4e                	sd	s3,56(sp)
    80003586:	f852                	sd	s4,48(sp)
    80003588:	f456                	sd	s5,40(sp)
    8000358a:	f05a                	sd	s6,32(sp)
    8000358c:	ec5e                	sd	s7,24(sp)
    8000358e:	e862                	sd	s8,16(sp)
    80003590:	e466                	sd	s9,8(sp)
    80003592:	1080                	addi	s0,sp,96
  for(b = 0; b < sb.size; b += BPB){
    80003594:	0001c797          	auipc	a5,0x1c
    80003598:	4707a783          	lw	a5,1136(a5) # 8001fa04 <sb+0x4>
    8000359c:	10078163          	beqz	a5,8000369e <balloc+0x124>
    800035a0:	8baa                	mv	s7,a0
    800035a2:	4a81                	li	s5,0
    bp = bread(dev, BBLOCK(b, sb));
    800035a4:	0001cb17          	auipc	s6,0x1c
    800035a8:	45cb0b13          	addi	s6,s6,1116 # 8001fa00 <sb>
    for(bi = 0; bi < BPB && b + bi < sb.size; bi++){
    800035ac:	4c01                	li	s8,0
      m = 1 << (bi % 8);
    800035ae:	4985                	li	s3,1
    for(bi = 0; bi < BPB && b + bi < sb.size; bi++){
    800035b0:	6a09                	lui	s4,0x2
  for(b = 0; b < sb.size; b += BPB){
    800035b2:	6c89                	lui	s9,0x2
    800035b4:	a061                	j	8000363c <balloc+0xc2>
        bp->data[bi/8] |= m;  // Mark block in use.
    800035b6:	974a                	add	a4,a4,s2
    800035b8:	8fd5                	or	a5,a5,a3
    800035ba:	06f70023          	sb	a5,96(a4)
        log_write(bp);
    800035be:	854a                	mv	a0,s2
    800035c0:	00001097          	auipc	ra,0x1
    800035c4:	0ac080e7          	jalr	172(ra) # 8000466c <log_write>
        brelse(bp);
    800035c8:	854a                	mv	a0,s2
    800035ca:	00000097          	auipc	ra,0x0
    800035ce:	e1e080e7          	jalr	-482(ra) # 800033e8 <brelse>
  bp = bread(dev, bno);
    800035d2:	85a6                	mv	a1,s1
    800035d4:	855e                	mv	a0,s7
    800035d6:	00000097          	auipc	ra,0x0
    800035da:	ce2080e7          	jalr	-798(ra) # 800032b8 <bread>
    800035de:	892a                	mv	s2,a0
  memset(bp->data, 0, BSIZE);
    800035e0:	40000613          	li	a2,1024
    800035e4:	4581                	li	a1,0
    800035e6:	06050513          	addi	a0,a0,96
    800035ea:	ffffd097          	auipc	ra,0xffffd
    800035ee:	7cc080e7          	jalr	1996(ra) # 80000db6 <memset>
  log_write(bp);
    800035f2:	854a                	mv	a0,s2
    800035f4:	00001097          	auipc	ra,0x1
    800035f8:	078080e7          	jalr	120(ra) # 8000466c <log_write>
  brelse(bp);
    800035fc:	854a                	mv	a0,s2
    800035fe:	00000097          	auipc	ra,0x0
    80003602:	dea080e7          	jalr	-534(ra) # 800033e8 <brelse>
}
    80003606:	8526                	mv	a0,s1
    80003608:	60e6                	ld	ra,88(sp)
    8000360a:	6446                	ld	s0,80(sp)
    8000360c:	64a6                	ld	s1,72(sp)
    8000360e:	6906                	ld	s2,64(sp)
    80003610:	79e2                	ld	s3,56(sp)
    80003612:	7a42                	ld	s4,48(sp)
    80003614:	7aa2                	ld	s5,40(sp)
    80003616:	7b02                	ld	s6,32(sp)
    80003618:	6be2                	ld	s7,24(sp)
    8000361a:	6c42                	ld	s8,16(sp)
    8000361c:	6ca2                	ld	s9,8(sp)
    8000361e:	6125                	addi	sp,sp,96
    80003620:	8082                	ret
    brelse(bp);
    80003622:	854a                	mv	a0,s2
    80003624:	00000097          	auipc	ra,0x0
    80003628:	dc4080e7          	jalr	-572(ra) # 800033e8 <brelse>
  for(b = 0; b < sb.size; b += BPB){
    8000362c:	015c87bb          	addw	a5,s9,s5
    80003630:	00078a9b          	sext.w	s5,a5
    80003634:	004b2703          	lw	a4,4(s6)
    80003638:	06eaf363          	bgeu	s5,a4,8000369e <balloc+0x124>
    bp = bread(dev, BBLOCK(b, sb));
    8000363c:	41fad79b          	sraiw	a5,s5,0x1f
    80003640:	0137d79b          	srliw	a5,a5,0x13
    80003644:	015787bb          	addw	a5,a5,s5
    80003648:	40d7d79b          	sraiw	a5,a5,0xd
    8000364c:	01cb2583          	lw	a1,28(s6)
    80003650:	9dbd                	addw	a1,a1,a5
    80003652:	855e                	mv	a0,s7
    80003654:	00000097          	auipc	ra,0x0
    80003658:	c64080e7          	jalr	-924(ra) # 800032b8 <bread>
    8000365c:	892a                	mv	s2,a0
    for(bi = 0; bi < BPB && b + bi < sb.size; bi++){
    8000365e:	004b2503          	lw	a0,4(s6)
    80003662:	000a849b          	sext.w	s1,s5
    80003666:	8662                	mv	a2,s8
    80003668:	faa4fde3          	bgeu	s1,a0,80003622 <balloc+0xa8>
      m = 1 << (bi % 8);
    8000366c:	41f6579b          	sraiw	a5,a2,0x1f
    80003670:	01d7d69b          	srliw	a3,a5,0x1d
    80003674:	00c6873b          	addw	a4,a3,a2
    80003678:	00777793          	andi	a5,a4,7
    8000367c:	9f95                	subw	a5,a5,a3
    8000367e:	00f997bb          	sllw	a5,s3,a5
      if((bp->data[bi/8] & m) == 0){  // Is block free?
    80003682:	4037571b          	sraiw	a4,a4,0x3
    80003686:	00e906b3          	add	a3,s2,a4
    8000368a:	0606c683          	lbu	a3,96(a3)
    8000368e:	00d7f5b3          	and	a1,a5,a3
    80003692:	d195                	beqz	a1,800035b6 <balloc+0x3c>
    for(bi = 0; bi < BPB && b + bi < sb.size; bi++){
    80003694:	2605                	addiw	a2,a2,1
    80003696:	2485                	addiw	s1,s1,1
    80003698:	fd4618e3          	bne	a2,s4,80003668 <balloc+0xee>
    8000369c:	b759                	j	80003622 <balloc+0xa8>
  printf("balloc: out of blocks\n");
    8000369e:	00005517          	auipc	a0,0x5
    800036a2:	12250513          	addi	a0,a0,290 # 800087c0 <syscall_name+0x120>
    800036a6:	ffffd097          	auipc	ra,0xffffd
    800036aa:	ee8080e7          	jalr	-280(ra) # 8000058e <printf>
  return 0;
    800036ae:	4481                	li	s1,0
    800036b0:	bf99                	j	80003606 <balloc+0x8c>

00000000800036b2 <bmap>:
// Return the disk block address of the nth block in inode ip.
// If there is no such block, bmap allocates one.
// returns 0 if out of disk space.
static uint
bmap(struct inode *ip, uint bn)
{
    800036b2:	7179                	addi	sp,sp,-48
    800036b4:	f406                	sd	ra,40(sp)
    800036b6:	f022                	sd	s0,32(sp)
    800036b8:	ec26                	sd	s1,24(sp)
    800036ba:	e84a                	sd	s2,16(sp)
    800036bc:	e44e                	sd	s3,8(sp)
    800036be:	e052                	sd	s4,0(sp)
    800036c0:	1800                	addi	s0,sp,48
    800036c2:	89aa                	mv	s3,a0
  uint addr, *a;
  struct buf *bp;

  if(bn < NDIRECT){
    800036c4:	47ad                	li	a5,11
    800036c6:	02b7e763          	bltu	a5,a1,800036f4 <bmap+0x42>
    if((addr = ip->addrs[bn]) == 0){
    800036ca:	02059493          	slli	s1,a1,0x20
    800036ce:	9081                	srli	s1,s1,0x20
    800036d0:	048a                	slli	s1,s1,0x2
    800036d2:	94aa                	add	s1,s1,a0
    800036d4:	0584a903          	lw	s2,88(s1)
    800036d8:	06091e63          	bnez	s2,80003754 <bmap+0xa2>
      addr = balloc(ip->dev);
    800036dc:	4108                	lw	a0,0(a0)
    800036de:	00000097          	auipc	ra,0x0
    800036e2:	e9c080e7          	jalr	-356(ra) # 8000357a <balloc>
    800036e6:	0005091b          	sext.w	s2,a0
      if(addr == 0)
    800036ea:	06090563          	beqz	s2,80003754 <bmap+0xa2>
        return 0;
      ip->addrs[bn] = addr;
    800036ee:	0524ac23          	sw	s2,88(s1)
    800036f2:	a08d                	j	80003754 <bmap+0xa2>
    }
    return addr;
  }
  bn -= NDIRECT;
    800036f4:	ff45849b          	addiw	s1,a1,-12
    800036f8:	0004871b          	sext.w	a4,s1

  if(bn < NINDIRECT){
    800036fc:	0ff00793          	li	a5,255
    80003700:	08e7e563          	bltu	a5,a4,8000378a <bmap+0xd8>
    // Load indirect block, allocating if necessary.
    if((addr = ip->addrs[NDIRECT]) == 0){
    80003704:	08852903          	lw	s2,136(a0)
    80003708:	00091d63          	bnez	s2,80003722 <bmap+0x70>
      addr = balloc(ip->dev);
    8000370c:	4108                	lw	a0,0(a0)
    8000370e:	00000097          	auipc	ra,0x0
    80003712:	e6c080e7          	jalr	-404(ra) # 8000357a <balloc>
    80003716:	0005091b          	sext.w	s2,a0
      if(addr == 0)
    8000371a:	02090d63          	beqz	s2,80003754 <bmap+0xa2>
        return 0;
      ip->addrs[NDIRECT] = addr;
    8000371e:	0929a423          	sw	s2,136(s3)
    }
    bp = bread(ip->dev, addr);
    80003722:	85ca                	mv	a1,s2
    80003724:	0009a503          	lw	a0,0(s3)
    80003728:	00000097          	auipc	ra,0x0
    8000372c:	b90080e7          	jalr	-1136(ra) # 800032b8 <bread>
    80003730:	8a2a                	mv	s4,a0
    a = (uint*)bp->data;
    80003732:	06050793          	addi	a5,a0,96
    if((addr = a[bn]) == 0){
    80003736:	02049593          	slli	a1,s1,0x20
    8000373a:	9181                	srli	a1,a1,0x20
    8000373c:	058a                	slli	a1,a1,0x2
    8000373e:	00b784b3          	add	s1,a5,a1
    80003742:	0004a903          	lw	s2,0(s1)
    80003746:	02090063          	beqz	s2,80003766 <bmap+0xb4>
      if(addr){
        a[bn] = addr;
        log_write(bp);
      }
    }
    brelse(bp);
    8000374a:	8552                	mv	a0,s4
    8000374c:	00000097          	auipc	ra,0x0
    80003750:	c9c080e7          	jalr	-868(ra) # 800033e8 <brelse>
    return addr;
  }

  panic("bmap: out of range");
}
    80003754:	854a                	mv	a0,s2
    80003756:	70a2                	ld	ra,40(sp)
    80003758:	7402                	ld	s0,32(sp)
    8000375a:	64e2                	ld	s1,24(sp)
    8000375c:	6942                	ld	s2,16(sp)
    8000375e:	69a2                	ld	s3,8(sp)
    80003760:	6a02                	ld	s4,0(sp)
    80003762:	6145                	addi	sp,sp,48
    80003764:	8082                	ret
      addr = balloc(ip->dev);
    80003766:	0009a503          	lw	a0,0(s3)
    8000376a:	00000097          	auipc	ra,0x0
    8000376e:	e10080e7          	jalr	-496(ra) # 8000357a <balloc>
    80003772:	0005091b          	sext.w	s2,a0
      if(addr){
    80003776:	fc090ae3          	beqz	s2,8000374a <bmap+0x98>
        a[bn] = addr;
    8000377a:	0124a023          	sw	s2,0(s1)
        log_write(bp);
    8000377e:	8552                	mv	a0,s4
    80003780:	00001097          	auipc	ra,0x1
    80003784:	eec080e7          	jalr	-276(ra) # 8000466c <log_write>
    80003788:	b7c9                	j	8000374a <bmap+0x98>
  panic("bmap: out of range");
    8000378a:	00005517          	auipc	a0,0x5
    8000378e:	04e50513          	addi	a0,a0,78 # 800087d8 <syscall_name+0x138>
    80003792:	ffffd097          	auipc	ra,0xffffd
    80003796:	db2080e7          	jalr	-590(ra) # 80000544 <panic>

000000008000379a <iget>:
{
    8000379a:	7179                	addi	sp,sp,-48
    8000379c:	f406                	sd	ra,40(sp)
    8000379e:	f022                	sd	s0,32(sp)
    800037a0:	ec26                	sd	s1,24(sp)
    800037a2:	e84a                	sd	s2,16(sp)
    800037a4:	e44e                	sd	s3,8(sp)
    800037a6:	e052                	sd	s4,0(sp)
    800037a8:	1800                	addi	s0,sp,48
    800037aa:	89aa                	mv	s3,a0
    800037ac:	8a2e                	mv	s4,a1
  acquire(&itable.lock);
    800037ae:	0001c517          	auipc	a0,0x1c
    800037b2:	27250513          	addi	a0,a0,626 # 8001fa20 <itable>
    800037b6:	ffffd097          	auipc	ra,0xffffd
    800037ba:	458080e7          	jalr	1112(ra) # 80000c0e <acquire>
  empty = 0;
    800037be:	4901                	li	s2,0
  for(ip = &itable.inode[0]; ip < &itable.inode[NINODE]; ip++){
    800037c0:	0001c497          	auipc	s1,0x1c
    800037c4:	28048493          	addi	s1,s1,640 # 8001fa40 <itable+0x20>
    800037c8:	0001e697          	auipc	a3,0x1e
    800037cc:	e9868693          	addi	a3,a3,-360 # 80021660 <log>
    800037d0:	a039                	j	800037de <iget+0x44>
    if(empty == 0 && ip->ref == 0)    // Remember empty slot.
    800037d2:	02090b63          	beqz	s2,80003808 <iget+0x6e>
  for(ip = &itable.inode[0]; ip < &itable.inode[NINODE]; ip++){
    800037d6:	09048493          	addi	s1,s1,144
    800037da:	02d48a63          	beq	s1,a3,8000380e <iget+0x74>
    if(ip->ref > 0 && ip->dev == dev && ip->inum == inum){
    800037de:	449c                	lw	a5,8(s1)
    800037e0:	fef059e3          	blez	a5,800037d2 <iget+0x38>
    800037e4:	4098                	lw	a4,0(s1)
    800037e6:	ff3716e3          	bne	a4,s3,800037d2 <iget+0x38>
    800037ea:	40d8                	lw	a4,4(s1)
    800037ec:	ff4713e3          	bne	a4,s4,800037d2 <iget+0x38>
      ip->ref++;
    800037f0:	2785                	addiw	a5,a5,1
    800037f2:	c49c                	sw	a5,8(s1)
      release(&itable.lock);
    800037f4:	0001c517          	auipc	a0,0x1c
    800037f8:	22c50513          	addi	a0,a0,556 # 8001fa20 <itable>
    800037fc:	ffffd097          	auipc	ra,0xffffd
    80003800:	56c080e7          	jalr	1388(ra) # 80000d68 <release>
      return ip;
    80003804:	8926                	mv	s2,s1
    80003806:	a03d                	j	80003834 <iget+0x9a>
    if(empty == 0 && ip->ref == 0)    // Remember empty slot.
    80003808:	f7f9                	bnez	a5,800037d6 <iget+0x3c>
    8000380a:	8926                	mv	s2,s1
    8000380c:	b7e9                	j	800037d6 <iget+0x3c>
  if(empty == 0)
    8000380e:	02090c63          	beqz	s2,80003846 <iget+0xac>
  ip->dev = dev;
    80003812:	01392023          	sw	s3,0(s2)
  ip->inum = inum;
    80003816:	01492223          	sw	s4,4(s2)
  ip->ref = 1;
    8000381a:	4785                	li	a5,1
    8000381c:	00f92423          	sw	a5,8(s2)
  ip->valid = 0;
    80003820:	04092423          	sw	zero,72(s2)
  release(&itable.lock);
    80003824:	0001c517          	auipc	a0,0x1c
    80003828:	1fc50513          	addi	a0,a0,508 # 8001fa20 <itable>
    8000382c:	ffffd097          	auipc	ra,0xffffd
    80003830:	53c080e7          	jalr	1340(ra) # 80000d68 <release>
}
    80003834:	854a                	mv	a0,s2
    80003836:	70a2                	ld	ra,40(sp)
    80003838:	7402                	ld	s0,32(sp)
    8000383a:	64e2                	ld	s1,24(sp)
    8000383c:	6942                	ld	s2,16(sp)
    8000383e:	69a2                	ld	s3,8(sp)
    80003840:	6a02                	ld	s4,0(sp)
    80003842:	6145                	addi	sp,sp,48
    80003844:	8082                	ret
    panic("iget: no inodes");
    80003846:	00005517          	auipc	a0,0x5
    8000384a:	faa50513          	addi	a0,a0,-86 # 800087f0 <syscall_name+0x150>
    8000384e:	ffffd097          	auipc	ra,0xffffd
    80003852:	cf6080e7          	jalr	-778(ra) # 80000544 <panic>

0000000080003856 <fsinit>:
fsinit(int dev) {
    80003856:	7179                	addi	sp,sp,-48
    80003858:	f406                	sd	ra,40(sp)
    8000385a:	f022                	sd	s0,32(sp)
    8000385c:	ec26                	sd	s1,24(sp)
    8000385e:	e84a                	sd	s2,16(sp)
    80003860:	e44e                	sd	s3,8(sp)
    80003862:	1800                	addi	s0,sp,48
    80003864:	892a                	mv	s2,a0
  bp = bread(dev, 1);
    80003866:	4585                	li	a1,1
    80003868:	00000097          	auipc	ra,0x0
    8000386c:	a50080e7          	jalr	-1456(ra) # 800032b8 <bread>
    80003870:	84aa                	mv	s1,a0
  memmove(sb, bp->data, sizeof(*sb));
    80003872:	0001c997          	auipc	s3,0x1c
    80003876:	18e98993          	addi	s3,s3,398 # 8001fa00 <sb>
    8000387a:	02000613          	li	a2,32
    8000387e:	06050593          	addi	a1,a0,96
    80003882:	854e                	mv	a0,s3
    80003884:	ffffd097          	auipc	ra,0xffffd
    80003888:	592080e7          	jalr	1426(ra) # 80000e16 <memmove>
  brelse(bp);
    8000388c:	8526                	mv	a0,s1
    8000388e:	00000097          	auipc	ra,0x0
    80003892:	b5a080e7          	jalr	-1190(ra) # 800033e8 <brelse>
  if(sb.magic != FSMAGIC)
    80003896:	0009a703          	lw	a4,0(s3)
    8000389a:	102037b7          	lui	a5,0x10203
    8000389e:	04078793          	addi	a5,a5,64 # 10203040 <_entry-0x6fdfcfc0>
    800038a2:	02f71263          	bne	a4,a5,800038c6 <fsinit+0x70>
  initlog(dev, &sb);
    800038a6:	0001c597          	auipc	a1,0x1c
    800038aa:	15a58593          	addi	a1,a1,346 # 8001fa00 <sb>
    800038ae:	854a                	mv	a0,s2
    800038b0:	00001097          	auipc	ra,0x1
    800038b4:	b40080e7          	jalr	-1216(ra) # 800043f0 <initlog>
}
    800038b8:	70a2                	ld	ra,40(sp)
    800038ba:	7402                	ld	s0,32(sp)
    800038bc:	64e2                	ld	s1,24(sp)
    800038be:	6942                	ld	s2,16(sp)
    800038c0:	69a2                	ld	s3,8(sp)
    800038c2:	6145                	addi	sp,sp,48
    800038c4:	8082                	ret
    panic("invalid file system");
    800038c6:	00005517          	auipc	a0,0x5
    800038ca:	f3a50513          	addi	a0,a0,-198 # 80008800 <syscall_name+0x160>
    800038ce:	ffffd097          	auipc	ra,0xffffd
    800038d2:	c76080e7          	jalr	-906(ra) # 80000544 <panic>

00000000800038d6 <iinit>:
{
    800038d6:	7179                	addi	sp,sp,-48
    800038d8:	f406                	sd	ra,40(sp)
    800038da:	f022                	sd	s0,32(sp)
    800038dc:	ec26                	sd	s1,24(sp)
    800038de:	e84a                	sd	s2,16(sp)
    800038e0:	e44e                	sd	s3,8(sp)
    800038e2:	1800                	addi	s0,sp,48
  initlock(&itable.lock, "itable");
    800038e4:	00005597          	auipc	a1,0x5
    800038e8:	f3458593          	addi	a1,a1,-204 # 80008818 <syscall_name+0x178>
    800038ec:	0001c517          	auipc	a0,0x1c
    800038f0:	13450513          	addi	a0,a0,308 # 8001fa20 <itable>
    800038f4:	ffffd097          	auipc	ra,0xffffd
    800038f8:	2b0080e7          	jalr	688(ra) # 80000ba4 <initlock>
  for(i = 0; i < NINODE; i++) {
    800038fc:	0001c497          	auipc	s1,0x1c
    80003900:	15448493          	addi	s1,s1,340 # 8001fa50 <itable+0x30>
    80003904:	0001e997          	auipc	s3,0x1e
    80003908:	d6c98993          	addi	s3,s3,-660 # 80021670 <log+0x10>
    initsleeplock(&itable.inode[i].lock, "inode");
    8000390c:	00005917          	auipc	s2,0x5
    80003910:	f1490913          	addi	s2,s2,-236 # 80008820 <syscall_name+0x180>
    80003914:	85ca                	mv	a1,s2
    80003916:	8526                	mv	a0,s1
    80003918:	00001097          	auipc	ra,0x1
    8000391c:	e3a080e7          	jalr	-454(ra) # 80004752 <initsleeplock>
  for(i = 0; i < NINODE; i++) {
    80003920:	09048493          	addi	s1,s1,144
    80003924:	ff3498e3          	bne	s1,s3,80003914 <iinit+0x3e>
}
    80003928:	70a2                	ld	ra,40(sp)
    8000392a:	7402                	ld	s0,32(sp)
    8000392c:	64e2                	ld	s1,24(sp)
    8000392e:	6942                	ld	s2,16(sp)
    80003930:	69a2                	ld	s3,8(sp)
    80003932:	6145                	addi	sp,sp,48
    80003934:	8082                	ret

0000000080003936 <ialloc>:
{
    80003936:	715d                	addi	sp,sp,-80
    80003938:	e486                	sd	ra,72(sp)
    8000393a:	e0a2                	sd	s0,64(sp)
    8000393c:	fc26                	sd	s1,56(sp)
    8000393e:	f84a                	sd	s2,48(sp)
    80003940:	f44e                	sd	s3,40(sp)
    80003942:	f052                	sd	s4,32(sp)
    80003944:	ec56                	sd	s5,24(sp)
    80003946:	e85a                	sd	s6,16(sp)
    80003948:	e45e                	sd	s7,8(sp)
    8000394a:	0880                	addi	s0,sp,80
  for(inum = 1; inum < sb.ninodes; inum++){
    8000394c:	0001c717          	auipc	a4,0x1c
    80003950:	0c072703          	lw	a4,192(a4) # 8001fa0c <sb+0xc>
    80003954:	4785                	li	a5,1
    80003956:	04e7fa63          	bgeu	a5,a4,800039aa <ialloc+0x74>
    8000395a:	8aaa                	mv	s5,a0
    8000395c:	8bae                	mv	s7,a1
    8000395e:	4485                	li	s1,1
    bp = bread(dev, IBLOCK(inum, sb));
    80003960:	0001ca17          	auipc	s4,0x1c
    80003964:	0a0a0a13          	addi	s4,s4,160 # 8001fa00 <sb>
    80003968:	00048b1b          	sext.w	s6,s1
    8000396c:	0044d593          	srli	a1,s1,0x4
    80003970:	018a2783          	lw	a5,24(s4)
    80003974:	9dbd                	addw	a1,a1,a5
    80003976:	8556                	mv	a0,s5
    80003978:	00000097          	auipc	ra,0x0
    8000397c:	940080e7          	jalr	-1728(ra) # 800032b8 <bread>
    80003980:	892a                	mv	s2,a0
    dip = (struct dinode*)bp->data + inum%IPB;
    80003982:	06050993          	addi	s3,a0,96
    80003986:	00f4f793          	andi	a5,s1,15
    8000398a:	079a                	slli	a5,a5,0x6
    8000398c:	99be                	add	s3,s3,a5
    if(dip->type == 0){  // a free inode
    8000398e:	00099783          	lh	a5,0(s3)
    80003992:	c3a1                	beqz	a5,800039d2 <ialloc+0x9c>
    brelse(bp);
    80003994:	00000097          	auipc	ra,0x0
    80003998:	a54080e7          	jalr	-1452(ra) # 800033e8 <brelse>
  for(inum = 1; inum < sb.ninodes; inum++){
    8000399c:	0485                	addi	s1,s1,1
    8000399e:	00ca2703          	lw	a4,12(s4)
    800039a2:	0004879b          	sext.w	a5,s1
    800039a6:	fce7e1e3          	bltu	a5,a4,80003968 <ialloc+0x32>
  printf("ialloc: no inodes\n");
    800039aa:	00005517          	auipc	a0,0x5
    800039ae:	e7e50513          	addi	a0,a0,-386 # 80008828 <syscall_name+0x188>
    800039b2:	ffffd097          	auipc	ra,0xffffd
    800039b6:	bdc080e7          	jalr	-1060(ra) # 8000058e <printf>
  return 0;
    800039ba:	4501                	li	a0,0
}
    800039bc:	60a6                	ld	ra,72(sp)
    800039be:	6406                	ld	s0,64(sp)
    800039c0:	74e2                	ld	s1,56(sp)
    800039c2:	7942                	ld	s2,48(sp)
    800039c4:	79a2                	ld	s3,40(sp)
    800039c6:	7a02                	ld	s4,32(sp)
    800039c8:	6ae2                	ld	s5,24(sp)
    800039ca:	6b42                	ld	s6,16(sp)
    800039cc:	6ba2                	ld	s7,8(sp)
    800039ce:	6161                	addi	sp,sp,80
    800039d0:	8082                	ret
      memset(dip, 0, sizeof(*dip));
    800039d2:	04000613          	li	a2,64
    800039d6:	4581                	li	a1,0
    800039d8:	854e                	mv	a0,s3
    800039da:	ffffd097          	auipc	ra,0xffffd
    800039de:	3dc080e7          	jalr	988(ra) # 80000db6 <memset>
      dip->type = type;
    800039e2:	01799023          	sh	s7,0(s3)
      log_write(bp);   // mark it allocated on the disk
    800039e6:	854a                	mv	a0,s2
    800039e8:	00001097          	auipc	ra,0x1
    800039ec:	c84080e7          	jalr	-892(ra) # 8000466c <log_write>
      brelse(bp);
    800039f0:	854a                	mv	a0,s2
    800039f2:	00000097          	auipc	ra,0x0
    800039f6:	9f6080e7          	jalr	-1546(ra) # 800033e8 <brelse>
      return iget(dev, inum);
    800039fa:	85da                	mv	a1,s6
    800039fc:	8556                	mv	a0,s5
    800039fe:	00000097          	auipc	ra,0x0
    80003a02:	d9c080e7          	jalr	-612(ra) # 8000379a <iget>
    80003a06:	bf5d                	j	800039bc <ialloc+0x86>

0000000080003a08 <iupdate>:
{
    80003a08:	1101                	addi	sp,sp,-32
    80003a0a:	ec06                	sd	ra,24(sp)
    80003a0c:	e822                	sd	s0,16(sp)
    80003a0e:	e426                	sd	s1,8(sp)
    80003a10:	e04a                	sd	s2,0(sp)
    80003a12:	1000                	addi	s0,sp,32
    80003a14:	84aa                	mv	s1,a0
  bp = bread(ip->dev, IBLOCK(ip->inum, sb));
    80003a16:	415c                	lw	a5,4(a0)
    80003a18:	0047d79b          	srliw	a5,a5,0x4
    80003a1c:	0001c597          	auipc	a1,0x1c
    80003a20:	ffc5a583          	lw	a1,-4(a1) # 8001fa18 <sb+0x18>
    80003a24:	9dbd                	addw	a1,a1,a5
    80003a26:	4108                	lw	a0,0(a0)
    80003a28:	00000097          	auipc	ra,0x0
    80003a2c:	890080e7          	jalr	-1904(ra) # 800032b8 <bread>
    80003a30:	892a                	mv	s2,a0
  dip = (struct dinode*)bp->data + ip->inum%IPB;
    80003a32:	06050793          	addi	a5,a0,96
    80003a36:	40c8                	lw	a0,4(s1)
    80003a38:	893d                	andi	a0,a0,15
    80003a3a:	051a                	slli	a0,a0,0x6
    80003a3c:	953e                	add	a0,a0,a5
  dip->type = ip->type;
    80003a3e:	04c49703          	lh	a4,76(s1)
    80003a42:	00e51023          	sh	a4,0(a0)
  dip->major = ip->major;
    80003a46:	04e49703          	lh	a4,78(s1)
    80003a4a:	00e51123          	sh	a4,2(a0)
  dip->minor = ip->minor;
    80003a4e:	05049703          	lh	a4,80(s1)
    80003a52:	00e51223          	sh	a4,4(a0)
  dip->nlink = ip->nlink;
    80003a56:	05249703          	lh	a4,82(s1)
    80003a5a:	00e51323          	sh	a4,6(a0)
  dip->size = ip->size;
    80003a5e:	48f8                	lw	a4,84(s1)
    80003a60:	c518                	sw	a4,8(a0)
  memmove(dip->addrs, ip->addrs, sizeof(ip->addrs));
    80003a62:	03400613          	li	a2,52
    80003a66:	05848593          	addi	a1,s1,88
    80003a6a:	0531                	addi	a0,a0,12
    80003a6c:	ffffd097          	auipc	ra,0xffffd
    80003a70:	3aa080e7          	jalr	938(ra) # 80000e16 <memmove>
  log_write(bp);
    80003a74:	854a                	mv	a0,s2
    80003a76:	00001097          	auipc	ra,0x1
    80003a7a:	bf6080e7          	jalr	-1034(ra) # 8000466c <log_write>
  brelse(bp);
    80003a7e:	854a                	mv	a0,s2
    80003a80:	00000097          	auipc	ra,0x0
    80003a84:	968080e7          	jalr	-1688(ra) # 800033e8 <brelse>
}
    80003a88:	60e2                	ld	ra,24(sp)
    80003a8a:	6442                	ld	s0,16(sp)
    80003a8c:	64a2                	ld	s1,8(sp)
    80003a8e:	6902                	ld	s2,0(sp)
    80003a90:	6105                	addi	sp,sp,32
    80003a92:	8082                	ret

0000000080003a94 <idup>:
{
    80003a94:	1101                	addi	sp,sp,-32
    80003a96:	ec06                	sd	ra,24(sp)
    80003a98:	e822                	sd	s0,16(sp)
    80003a9a:	e426                	sd	s1,8(sp)
    80003a9c:	1000                	addi	s0,sp,32
    80003a9e:	84aa                	mv	s1,a0
  acquire(&itable.lock);
    80003aa0:	0001c517          	auipc	a0,0x1c
    80003aa4:	f8050513          	addi	a0,a0,-128 # 8001fa20 <itable>
    80003aa8:	ffffd097          	auipc	ra,0xffffd
    80003aac:	166080e7          	jalr	358(ra) # 80000c0e <acquire>
  ip->ref++;
    80003ab0:	449c                	lw	a5,8(s1)
    80003ab2:	2785                	addiw	a5,a5,1
    80003ab4:	c49c                	sw	a5,8(s1)
  release(&itable.lock);
    80003ab6:	0001c517          	auipc	a0,0x1c
    80003aba:	f6a50513          	addi	a0,a0,-150 # 8001fa20 <itable>
    80003abe:	ffffd097          	auipc	ra,0xffffd
    80003ac2:	2aa080e7          	jalr	682(ra) # 80000d68 <release>
}
    80003ac6:	8526                	mv	a0,s1
    80003ac8:	60e2                	ld	ra,24(sp)
    80003aca:	6442                	ld	s0,16(sp)
    80003acc:	64a2                	ld	s1,8(sp)
    80003ace:	6105                	addi	sp,sp,32
    80003ad0:	8082                	ret

0000000080003ad2 <ilock>:
{
    80003ad2:	1101                	addi	sp,sp,-32
    80003ad4:	ec06                	sd	ra,24(sp)
    80003ad6:	e822                	sd	s0,16(sp)
    80003ad8:	e426                	sd	s1,8(sp)
    80003ada:	e04a                	sd	s2,0(sp)
    80003adc:	1000                	addi	s0,sp,32
  if(ip == 0 || ip->ref < 1)
    80003ade:	c115                	beqz	a0,80003b02 <ilock+0x30>
    80003ae0:	84aa                	mv	s1,a0
    80003ae2:	451c                	lw	a5,8(a0)
    80003ae4:	00f05f63          	blez	a5,80003b02 <ilock+0x30>
  acquiresleep(&ip->lock);
    80003ae8:	0541                	addi	a0,a0,16
    80003aea:	00001097          	auipc	ra,0x1
    80003aee:	ca2080e7          	jalr	-862(ra) # 8000478c <acquiresleep>
  if(ip->valid == 0){
    80003af2:	44bc                	lw	a5,72(s1)
    80003af4:	cf99                	beqz	a5,80003b12 <ilock+0x40>
}
    80003af6:	60e2                	ld	ra,24(sp)
    80003af8:	6442                	ld	s0,16(sp)
    80003afa:	64a2                	ld	s1,8(sp)
    80003afc:	6902                	ld	s2,0(sp)
    80003afe:	6105                	addi	sp,sp,32
    80003b00:	8082                	ret
    panic("ilock");
    80003b02:	00005517          	auipc	a0,0x5
    80003b06:	d3e50513          	addi	a0,a0,-706 # 80008840 <syscall_name+0x1a0>
    80003b0a:	ffffd097          	auipc	ra,0xffffd
    80003b0e:	a3a080e7          	jalr	-1478(ra) # 80000544 <panic>
    bp = bread(ip->dev, IBLOCK(ip->inum, sb));
    80003b12:	40dc                	lw	a5,4(s1)
    80003b14:	0047d79b          	srliw	a5,a5,0x4
    80003b18:	0001c597          	auipc	a1,0x1c
    80003b1c:	f005a583          	lw	a1,-256(a1) # 8001fa18 <sb+0x18>
    80003b20:	9dbd                	addw	a1,a1,a5
    80003b22:	4088                	lw	a0,0(s1)
    80003b24:	fffff097          	auipc	ra,0xfffff
    80003b28:	794080e7          	jalr	1940(ra) # 800032b8 <bread>
    80003b2c:	892a                	mv	s2,a0
    dip = (struct dinode*)bp->data + ip->inum%IPB;
    80003b2e:	06050593          	addi	a1,a0,96
    80003b32:	40dc                	lw	a5,4(s1)
    80003b34:	8bbd                	andi	a5,a5,15
    80003b36:	079a                	slli	a5,a5,0x6
    80003b38:	95be                	add	a1,a1,a5
    ip->type = dip->type;
    80003b3a:	00059783          	lh	a5,0(a1)
    80003b3e:	04f49623          	sh	a5,76(s1)
    ip->major = dip->major;
    80003b42:	00259783          	lh	a5,2(a1)
    80003b46:	04f49723          	sh	a5,78(s1)
    ip->minor = dip->minor;
    80003b4a:	00459783          	lh	a5,4(a1)
    80003b4e:	04f49823          	sh	a5,80(s1)
    ip->nlink = dip->nlink;
    80003b52:	00659783          	lh	a5,6(a1)
    80003b56:	04f49923          	sh	a5,82(s1)
    ip->size = dip->size;
    80003b5a:	459c                	lw	a5,8(a1)
    80003b5c:	c8fc                	sw	a5,84(s1)
    memmove(ip->addrs, dip->addrs, sizeof(ip->addrs));
    80003b5e:	03400613          	li	a2,52
    80003b62:	05b1                	addi	a1,a1,12
    80003b64:	05848513          	addi	a0,s1,88
    80003b68:	ffffd097          	auipc	ra,0xffffd
    80003b6c:	2ae080e7          	jalr	686(ra) # 80000e16 <memmove>
    brelse(bp);
    80003b70:	854a                	mv	a0,s2
    80003b72:	00000097          	auipc	ra,0x0
    80003b76:	876080e7          	jalr	-1930(ra) # 800033e8 <brelse>
    ip->valid = 1;
    80003b7a:	4785                	li	a5,1
    80003b7c:	c4bc                	sw	a5,72(s1)
    if(ip->type == 0)
    80003b7e:	04c49783          	lh	a5,76(s1)
    80003b82:	fbb5                	bnez	a5,80003af6 <ilock+0x24>
      panic("ilock: no type");
    80003b84:	00005517          	auipc	a0,0x5
    80003b88:	cc450513          	addi	a0,a0,-828 # 80008848 <syscall_name+0x1a8>
    80003b8c:	ffffd097          	auipc	ra,0xffffd
    80003b90:	9b8080e7          	jalr	-1608(ra) # 80000544 <panic>

0000000080003b94 <iunlock>:
{
    80003b94:	1101                	addi	sp,sp,-32
    80003b96:	ec06                	sd	ra,24(sp)
    80003b98:	e822                	sd	s0,16(sp)
    80003b9a:	e426                	sd	s1,8(sp)
    80003b9c:	e04a                	sd	s2,0(sp)
    80003b9e:	1000                	addi	s0,sp,32
  if(ip == 0 || !holdingsleep(&ip->lock) || ip->ref < 1)
    80003ba0:	c905                	beqz	a0,80003bd0 <iunlock+0x3c>
    80003ba2:	84aa                	mv	s1,a0
    80003ba4:	01050913          	addi	s2,a0,16
    80003ba8:	854a                	mv	a0,s2
    80003baa:	00001097          	auipc	ra,0x1
    80003bae:	c7c080e7          	jalr	-900(ra) # 80004826 <holdingsleep>
    80003bb2:	cd19                	beqz	a0,80003bd0 <iunlock+0x3c>
    80003bb4:	449c                	lw	a5,8(s1)
    80003bb6:	00f05d63          	blez	a5,80003bd0 <iunlock+0x3c>
  releasesleep(&ip->lock);
    80003bba:	854a                	mv	a0,s2
    80003bbc:	00001097          	auipc	ra,0x1
    80003bc0:	c26080e7          	jalr	-986(ra) # 800047e2 <releasesleep>
}
    80003bc4:	60e2                	ld	ra,24(sp)
    80003bc6:	6442                	ld	s0,16(sp)
    80003bc8:	64a2                	ld	s1,8(sp)
    80003bca:	6902                	ld	s2,0(sp)
    80003bcc:	6105                	addi	sp,sp,32
    80003bce:	8082                	ret
    panic("iunlock");
    80003bd0:	00005517          	auipc	a0,0x5
    80003bd4:	c8850513          	addi	a0,a0,-888 # 80008858 <syscall_name+0x1b8>
    80003bd8:	ffffd097          	auipc	ra,0xffffd
    80003bdc:	96c080e7          	jalr	-1684(ra) # 80000544 <panic>

0000000080003be0 <itrunc>:

// Truncate inode (discard contents).
// Caller must hold ip->lock.
void
itrunc(struct inode *ip)
{
    80003be0:	7179                	addi	sp,sp,-48
    80003be2:	f406                	sd	ra,40(sp)
    80003be4:	f022                	sd	s0,32(sp)
    80003be6:	ec26                	sd	s1,24(sp)
    80003be8:	e84a                	sd	s2,16(sp)
    80003bea:	e44e                	sd	s3,8(sp)
    80003bec:	e052                	sd	s4,0(sp)
    80003bee:	1800                	addi	s0,sp,48
    80003bf0:	89aa                	mv	s3,a0
  int i, j;
  struct buf *bp;
  uint *a;

  for(i = 0; i < NDIRECT; i++){
    80003bf2:	05850493          	addi	s1,a0,88
    80003bf6:	08850913          	addi	s2,a0,136
    80003bfa:	a021                	j	80003c02 <itrunc+0x22>
    80003bfc:	0491                	addi	s1,s1,4
    80003bfe:	01248d63          	beq	s1,s2,80003c18 <itrunc+0x38>
    if(ip->addrs[i]){
    80003c02:	408c                	lw	a1,0(s1)
    80003c04:	dde5                	beqz	a1,80003bfc <itrunc+0x1c>
      bfree(ip->dev, ip->addrs[i]);
    80003c06:	0009a503          	lw	a0,0(s3)
    80003c0a:	00000097          	auipc	ra,0x0
    80003c0e:	8f4080e7          	jalr	-1804(ra) # 800034fe <bfree>
      ip->addrs[i] = 0;
    80003c12:	0004a023          	sw	zero,0(s1)
    80003c16:	b7dd                	j	80003bfc <itrunc+0x1c>
    }
  }

  if(ip->addrs[NDIRECT]){
    80003c18:	0889a583          	lw	a1,136(s3)
    80003c1c:	e185                	bnez	a1,80003c3c <itrunc+0x5c>
    brelse(bp);
    bfree(ip->dev, ip->addrs[NDIRECT]);
    ip->addrs[NDIRECT] = 0;
  }

  ip->size = 0;
    80003c1e:	0409aa23          	sw	zero,84(s3)
  iupdate(ip);
    80003c22:	854e                	mv	a0,s3
    80003c24:	00000097          	auipc	ra,0x0
    80003c28:	de4080e7          	jalr	-540(ra) # 80003a08 <iupdate>
}
    80003c2c:	70a2                	ld	ra,40(sp)
    80003c2e:	7402                	ld	s0,32(sp)
    80003c30:	64e2                	ld	s1,24(sp)
    80003c32:	6942                	ld	s2,16(sp)
    80003c34:	69a2                	ld	s3,8(sp)
    80003c36:	6a02                	ld	s4,0(sp)
    80003c38:	6145                	addi	sp,sp,48
    80003c3a:	8082                	ret
    bp = bread(ip->dev, ip->addrs[NDIRECT]);
    80003c3c:	0009a503          	lw	a0,0(s3)
    80003c40:	fffff097          	auipc	ra,0xfffff
    80003c44:	678080e7          	jalr	1656(ra) # 800032b8 <bread>
    80003c48:	8a2a                	mv	s4,a0
    for(j = 0; j < NINDIRECT; j++){
    80003c4a:	06050493          	addi	s1,a0,96
    80003c4e:	46050913          	addi	s2,a0,1120
    80003c52:	a811                	j	80003c66 <itrunc+0x86>
        bfree(ip->dev, a[j]);
    80003c54:	0009a503          	lw	a0,0(s3)
    80003c58:	00000097          	auipc	ra,0x0
    80003c5c:	8a6080e7          	jalr	-1882(ra) # 800034fe <bfree>
    for(j = 0; j < NINDIRECT; j++){
    80003c60:	0491                	addi	s1,s1,4
    80003c62:	01248563          	beq	s1,s2,80003c6c <itrunc+0x8c>
      if(a[j])
    80003c66:	408c                	lw	a1,0(s1)
    80003c68:	dde5                	beqz	a1,80003c60 <itrunc+0x80>
    80003c6a:	b7ed                	j	80003c54 <itrunc+0x74>
    brelse(bp);
    80003c6c:	8552                	mv	a0,s4
    80003c6e:	fffff097          	auipc	ra,0xfffff
    80003c72:	77a080e7          	jalr	1914(ra) # 800033e8 <brelse>
    bfree(ip->dev, ip->addrs[NDIRECT]);
    80003c76:	0889a583          	lw	a1,136(s3)
    80003c7a:	0009a503          	lw	a0,0(s3)
    80003c7e:	00000097          	auipc	ra,0x0
    80003c82:	880080e7          	jalr	-1920(ra) # 800034fe <bfree>
    ip->addrs[NDIRECT] = 0;
    80003c86:	0809a423          	sw	zero,136(s3)
    80003c8a:	bf51                	j	80003c1e <itrunc+0x3e>

0000000080003c8c <iput>:
{
    80003c8c:	1101                	addi	sp,sp,-32
    80003c8e:	ec06                	sd	ra,24(sp)
    80003c90:	e822                	sd	s0,16(sp)
    80003c92:	e426                	sd	s1,8(sp)
    80003c94:	e04a                	sd	s2,0(sp)
    80003c96:	1000                	addi	s0,sp,32
    80003c98:	84aa                	mv	s1,a0
  acquire(&itable.lock);
    80003c9a:	0001c517          	auipc	a0,0x1c
    80003c9e:	d8650513          	addi	a0,a0,-634 # 8001fa20 <itable>
    80003ca2:	ffffd097          	auipc	ra,0xffffd
    80003ca6:	f6c080e7          	jalr	-148(ra) # 80000c0e <acquire>
  if(ip->ref == 1 && ip->valid && ip->nlink == 0){
    80003caa:	4498                	lw	a4,8(s1)
    80003cac:	4785                	li	a5,1
    80003cae:	02f70363          	beq	a4,a5,80003cd4 <iput+0x48>
  ip->ref--;
    80003cb2:	449c                	lw	a5,8(s1)
    80003cb4:	37fd                	addiw	a5,a5,-1
    80003cb6:	c49c                	sw	a5,8(s1)
  release(&itable.lock);
    80003cb8:	0001c517          	auipc	a0,0x1c
    80003cbc:	d6850513          	addi	a0,a0,-664 # 8001fa20 <itable>
    80003cc0:	ffffd097          	auipc	ra,0xffffd
    80003cc4:	0a8080e7          	jalr	168(ra) # 80000d68 <release>
}
    80003cc8:	60e2                	ld	ra,24(sp)
    80003cca:	6442                	ld	s0,16(sp)
    80003ccc:	64a2                	ld	s1,8(sp)
    80003cce:	6902                	ld	s2,0(sp)
    80003cd0:	6105                	addi	sp,sp,32
    80003cd2:	8082                	ret
  if(ip->ref == 1 && ip->valid && ip->nlink == 0){
    80003cd4:	44bc                	lw	a5,72(s1)
    80003cd6:	dff1                	beqz	a5,80003cb2 <iput+0x26>
    80003cd8:	05249783          	lh	a5,82(s1)
    80003cdc:	fbf9                	bnez	a5,80003cb2 <iput+0x26>
    acquiresleep(&ip->lock);
    80003cde:	01048913          	addi	s2,s1,16
    80003ce2:	854a                	mv	a0,s2
    80003ce4:	00001097          	auipc	ra,0x1
    80003ce8:	aa8080e7          	jalr	-1368(ra) # 8000478c <acquiresleep>
    release(&itable.lock);
    80003cec:	0001c517          	auipc	a0,0x1c
    80003cf0:	d3450513          	addi	a0,a0,-716 # 8001fa20 <itable>
    80003cf4:	ffffd097          	auipc	ra,0xffffd
    80003cf8:	074080e7          	jalr	116(ra) # 80000d68 <release>
    itrunc(ip);
    80003cfc:	8526                	mv	a0,s1
    80003cfe:	00000097          	auipc	ra,0x0
    80003d02:	ee2080e7          	jalr	-286(ra) # 80003be0 <itrunc>
    ip->type = 0;
    80003d06:	04049623          	sh	zero,76(s1)
    iupdate(ip);
    80003d0a:	8526                	mv	a0,s1
    80003d0c:	00000097          	auipc	ra,0x0
    80003d10:	cfc080e7          	jalr	-772(ra) # 80003a08 <iupdate>
    ip->valid = 0;
    80003d14:	0404a423          	sw	zero,72(s1)
    releasesleep(&ip->lock);
    80003d18:	854a                	mv	a0,s2
    80003d1a:	00001097          	auipc	ra,0x1
    80003d1e:	ac8080e7          	jalr	-1336(ra) # 800047e2 <releasesleep>
    acquire(&itable.lock);
    80003d22:	0001c517          	auipc	a0,0x1c
    80003d26:	cfe50513          	addi	a0,a0,-770 # 8001fa20 <itable>
    80003d2a:	ffffd097          	auipc	ra,0xffffd
    80003d2e:	ee4080e7          	jalr	-284(ra) # 80000c0e <acquire>
    80003d32:	b741                	j	80003cb2 <iput+0x26>

0000000080003d34 <iunlockput>:
{
    80003d34:	1101                	addi	sp,sp,-32
    80003d36:	ec06                	sd	ra,24(sp)
    80003d38:	e822                	sd	s0,16(sp)
    80003d3a:	e426                	sd	s1,8(sp)
    80003d3c:	1000                	addi	s0,sp,32
    80003d3e:	84aa                	mv	s1,a0
  iunlock(ip);
    80003d40:	00000097          	auipc	ra,0x0
    80003d44:	e54080e7          	jalr	-428(ra) # 80003b94 <iunlock>
  iput(ip);
    80003d48:	8526                	mv	a0,s1
    80003d4a:	00000097          	auipc	ra,0x0
    80003d4e:	f42080e7          	jalr	-190(ra) # 80003c8c <iput>
}
    80003d52:	60e2                	ld	ra,24(sp)
    80003d54:	6442                	ld	s0,16(sp)
    80003d56:	64a2                	ld	s1,8(sp)
    80003d58:	6105                	addi	sp,sp,32
    80003d5a:	8082                	ret

0000000080003d5c <stati>:

// Copy stat information from inode.
// Caller must hold ip->lock.
void
stati(struct inode *ip, struct stat *st)
{
    80003d5c:	1141                	addi	sp,sp,-16
    80003d5e:	e422                	sd	s0,8(sp)
    80003d60:	0800                	addi	s0,sp,16
  st->dev = ip->dev;
    80003d62:	411c                	lw	a5,0(a0)
    80003d64:	c19c                	sw	a5,0(a1)
  st->ino = ip->inum;
    80003d66:	415c                	lw	a5,4(a0)
    80003d68:	c1dc                	sw	a5,4(a1)
  st->type = ip->type;
    80003d6a:	04c51783          	lh	a5,76(a0)
    80003d6e:	00f59423          	sh	a5,8(a1)
  st->nlink = ip->nlink;
    80003d72:	05251783          	lh	a5,82(a0)
    80003d76:	00f59523          	sh	a5,10(a1)
  st->size = ip->size;
    80003d7a:	05456783          	lwu	a5,84(a0)
    80003d7e:	e99c                	sd	a5,16(a1)
}
    80003d80:	6422                	ld	s0,8(sp)
    80003d82:	0141                	addi	sp,sp,16
    80003d84:	8082                	ret

0000000080003d86 <readi>:
readi(struct inode *ip, int user_dst, uint64 dst, uint off, uint n)
{
  uint tot, m;
  struct buf *bp;

  if(off > ip->size || off + n < off)
    80003d86:	497c                	lw	a5,84(a0)
    80003d88:	0ed7e963          	bltu	a5,a3,80003e7a <readi+0xf4>
{
    80003d8c:	7159                	addi	sp,sp,-112
    80003d8e:	f486                	sd	ra,104(sp)
    80003d90:	f0a2                	sd	s0,96(sp)
    80003d92:	eca6                	sd	s1,88(sp)
    80003d94:	e8ca                	sd	s2,80(sp)
    80003d96:	e4ce                	sd	s3,72(sp)
    80003d98:	e0d2                	sd	s4,64(sp)
    80003d9a:	fc56                	sd	s5,56(sp)
    80003d9c:	f85a                	sd	s6,48(sp)
    80003d9e:	f45e                	sd	s7,40(sp)
    80003da0:	f062                	sd	s8,32(sp)
    80003da2:	ec66                	sd	s9,24(sp)
    80003da4:	e86a                	sd	s10,16(sp)
    80003da6:	e46e                	sd	s11,8(sp)
    80003da8:	1880                	addi	s0,sp,112
    80003daa:	8b2a                	mv	s6,a0
    80003dac:	8bae                	mv	s7,a1
    80003dae:	8a32                	mv	s4,a2
    80003db0:	84b6                	mv	s1,a3
    80003db2:	8aba                	mv	s5,a4
  if(off > ip->size || off + n < off)
    80003db4:	9f35                	addw	a4,a4,a3
    return 0;
    80003db6:	4501                	li	a0,0
  if(off > ip->size || off + n < off)
    80003db8:	0ad76063          	bltu	a4,a3,80003e58 <readi+0xd2>
  if(off + n > ip->size)
    80003dbc:	00e7f463          	bgeu	a5,a4,80003dc4 <readi+0x3e>
    n = ip->size - off;
    80003dc0:	40d78abb          	subw	s5,a5,a3

  for(tot=0; tot<n; tot+=m, off+=m, dst+=m){
    80003dc4:	0a0a8963          	beqz	s5,80003e76 <readi+0xf0>
    80003dc8:	4981                	li	s3,0
    uint addr = bmap(ip, off/BSIZE);
    if(addr == 0)
      break;
    bp = bread(ip->dev, addr);
    m = min(n - tot, BSIZE - off%BSIZE);
    80003dca:	40000c93          	li	s9,1024
    if(either_copyout(user_dst, dst, bp->data + (off % BSIZE), m) == -1) {
    80003dce:	5c7d                	li	s8,-1
    80003dd0:	a82d                	j	80003e0a <readi+0x84>
    80003dd2:	020d1d93          	slli	s11,s10,0x20
    80003dd6:	020ddd93          	srli	s11,s11,0x20
    80003dda:	06090613          	addi	a2,s2,96
    80003dde:	86ee                	mv	a3,s11
    80003de0:	963a                	add	a2,a2,a4
    80003de2:	85d2                	mv	a1,s4
    80003de4:	855e                	mv	a0,s7
    80003de6:	fffff097          	auipc	ra,0xfffff
    80003dea:	8a2080e7          	jalr	-1886(ra) # 80002688 <either_copyout>
    80003dee:	05850d63          	beq	a0,s8,80003e48 <readi+0xc2>
      brelse(bp);
      tot = -1;
      break;
    }
    brelse(bp);
    80003df2:	854a                	mv	a0,s2
    80003df4:	fffff097          	auipc	ra,0xfffff
    80003df8:	5f4080e7          	jalr	1524(ra) # 800033e8 <brelse>
  for(tot=0; tot<n; tot+=m, off+=m, dst+=m){
    80003dfc:	013d09bb          	addw	s3,s10,s3
    80003e00:	009d04bb          	addw	s1,s10,s1
    80003e04:	9a6e                	add	s4,s4,s11
    80003e06:	0559f763          	bgeu	s3,s5,80003e54 <readi+0xce>
    uint addr = bmap(ip, off/BSIZE);
    80003e0a:	00a4d59b          	srliw	a1,s1,0xa
    80003e0e:	855a                	mv	a0,s6
    80003e10:	00000097          	auipc	ra,0x0
    80003e14:	8a2080e7          	jalr	-1886(ra) # 800036b2 <bmap>
    80003e18:	0005059b          	sext.w	a1,a0
    if(addr == 0)
    80003e1c:	cd85                	beqz	a1,80003e54 <readi+0xce>
    bp = bread(ip->dev, addr);
    80003e1e:	000b2503          	lw	a0,0(s6)
    80003e22:	fffff097          	auipc	ra,0xfffff
    80003e26:	496080e7          	jalr	1174(ra) # 800032b8 <bread>
    80003e2a:	892a                	mv	s2,a0
    m = min(n - tot, BSIZE - off%BSIZE);
    80003e2c:	3ff4f713          	andi	a4,s1,1023
    80003e30:	40ec87bb          	subw	a5,s9,a4
    80003e34:	413a86bb          	subw	a3,s5,s3
    80003e38:	8d3e                	mv	s10,a5
    80003e3a:	2781                	sext.w	a5,a5
    80003e3c:	0006861b          	sext.w	a2,a3
    80003e40:	f8f679e3          	bgeu	a2,a5,80003dd2 <readi+0x4c>
    80003e44:	8d36                	mv	s10,a3
    80003e46:	b771                	j	80003dd2 <readi+0x4c>
      brelse(bp);
    80003e48:	854a                	mv	a0,s2
    80003e4a:	fffff097          	auipc	ra,0xfffff
    80003e4e:	59e080e7          	jalr	1438(ra) # 800033e8 <brelse>
      tot = -1;
    80003e52:	59fd                	li	s3,-1
  }
  return tot;
    80003e54:	0009851b          	sext.w	a0,s3
}
    80003e58:	70a6                	ld	ra,104(sp)
    80003e5a:	7406                	ld	s0,96(sp)
    80003e5c:	64e6                	ld	s1,88(sp)
    80003e5e:	6946                	ld	s2,80(sp)
    80003e60:	69a6                	ld	s3,72(sp)
    80003e62:	6a06                	ld	s4,64(sp)
    80003e64:	7ae2                	ld	s5,56(sp)
    80003e66:	7b42                	ld	s6,48(sp)
    80003e68:	7ba2                	ld	s7,40(sp)
    80003e6a:	7c02                	ld	s8,32(sp)
    80003e6c:	6ce2                	ld	s9,24(sp)
    80003e6e:	6d42                	ld	s10,16(sp)
    80003e70:	6da2                	ld	s11,8(sp)
    80003e72:	6165                	addi	sp,sp,112
    80003e74:	8082                	ret
  for(tot=0; tot<n; tot+=m, off+=m, dst+=m){
    80003e76:	89d6                	mv	s3,s5
    80003e78:	bff1                	j	80003e54 <readi+0xce>
    return 0;
    80003e7a:	4501                	li	a0,0
}
    80003e7c:	8082                	ret

0000000080003e7e <writei>:
writei(struct inode *ip, int user_src, uint64 src, uint off, uint n)
{
  uint tot, m;
  struct buf *bp;

  if(off > ip->size || off + n < off)
    80003e7e:	497c                	lw	a5,84(a0)
    80003e80:	10d7e863          	bltu	a5,a3,80003f90 <writei+0x112>
{
    80003e84:	7159                	addi	sp,sp,-112
    80003e86:	f486                	sd	ra,104(sp)
    80003e88:	f0a2                	sd	s0,96(sp)
    80003e8a:	eca6                	sd	s1,88(sp)
    80003e8c:	e8ca                	sd	s2,80(sp)
    80003e8e:	e4ce                	sd	s3,72(sp)
    80003e90:	e0d2                	sd	s4,64(sp)
    80003e92:	fc56                	sd	s5,56(sp)
    80003e94:	f85a                	sd	s6,48(sp)
    80003e96:	f45e                	sd	s7,40(sp)
    80003e98:	f062                	sd	s8,32(sp)
    80003e9a:	ec66                	sd	s9,24(sp)
    80003e9c:	e86a                	sd	s10,16(sp)
    80003e9e:	e46e                	sd	s11,8(sp)
    80003ea0:	1880                	addi	s0,sp,112
    80003ea2:	8aaa                	mv	s5,a0
    80003ea4:	8bae                	mv	s7,a1
    80003ea6:	8a32                	mv	s4,a2
    80003ea8:	8936                	mv	s2,a3
    80003eaa:	8b3a                	mv	s6,a4
  if(off > ip->size || off + n < off)
    80003eac:	00e687bb          	addw	a5,a3,a4
    80003eb0:	0ed7e263          	bltu	a5,a3,80003f94 <writei+0x116>
    return -1;
  if(off + n > MAXFILE*BSIZE)
    80003eb4:	00043737          	lui	a4,0x43
    80003eb8:	0ef76063          	bltu	a4,a5,80003f98 <writei+0x11a>
    return -1;

  for(tot=0; tot<n; tot+=m, off+=m, src+=m){
    80003ebc:	0c0b0863          	beqz	s6,80003f8c <writei+0x10e>
    80003ec0:	4981                	li	s3,0
    uint addr = bmap(ip, off/BSIZE);
    if(addr == 0)
      break;
    bp = bread(ip->dev, addr);
    m = min(n - tot, BSIZE - off%BSIZE);
    80003ec2:	40000c93          	li	s9,1024
    if(either_copyin(bp->data + (off % BSIZE), user_src, src, m) == -1) {
    80003ec6:	5c7d                	li	s8,-1
    80003ec8:	a091                	j	80003f0c <writei+0x8e>
    80003eca:	020d1d93          	slli	s11,s10,0x20
    80003ece:	020ddd93          	srli	s11,s11,0x20
    80003ed2:	06048513          	addi	a0,s1,96
    80003ed6:	86ee                	mv	a3,s11
    80003ed8:	8652                	mv	a2,s4
    80003eda:	85de                	mv	a1,s7
    80003edc:	953a                	add	a0,a0,a4
    80003ede:	fffff097          	auipc	ra,0xfffff
    80003ee2:	800080e7          	jalr	-2048(ra) # 800026de <either_copyin>
    80003ee6:	07850263          	beq	a0,s8,80003f4a <writei+0xcc>
      brelse(bp);
      break;
    }
    log_write(bp);
    80003eea:	8526                	mv	a0,s1
    80003eec:	00000097          	auipc	ra,0x0
    80003ef0:	780080e7          	jalr	1920(ra) # 8000466c <log_write>
    brelse(bp);
    80003ef4:	8526                	mv	a0,s1
    80003ef6:	fffff097          	auipc	ra,0xfffff
    80003efa:	4f2080e7          	jalr	1266(ra) # 800033e8 <brelse>
  for(tot=0; tot<n; tot+=m, off+=m, src+=m){
    80003efe:	013d09bb          	addw	s3,s10,s3
    80003f02:	012d093b          	addw	s2,s10,s2
    80003f06:	9a6e                	add	s4,s4,s11
    80003f08:	0569f663          	bgeu	s3,s6,80003f54 <writei+0xd6>
    uint addr = bmap(ip, off/BSIZE);
    80003f0c:	00a9559b          	srliw	a1,s2,0xa
    80003f10:	8556                	mv	a0,s5
    80003f12:	fffff097          	auipc	ra,0xfffff
    80003f16:	7a0080e7          	jalr	1952(ra) # 800036b2 <bmap>
    80003f1a:	0005059b          	sext.w	a1,a0
    if(addr == 0)
    80003f1e:	c99d                	beqz	a1,80003f54 <writei+0xd6>
    bp = bread(ip->dev, addr);
    80003f20:	000aa503          	lw	a0,0(s5)
    80003f24:	fffff097          	auipc	ra,0xfffff
    80003f28:	394080e7          	jalr	916(ra) # 800032b8 <bread>
    80003f2c:	84aa                	mv	s1,a0
    m = min(n - tot, BSIZE - off%BSIZE);
    80003f2e:	3ff97713          	andi	a4,s2,1023
    80003f32:	40ec87bb          	subw	a5,s9,a4
    80003f36:	413b06bb          	subw	a3,s6,s3
    80003f3a:	8d3e                	mv	s10,a5
    80003f3c:	2781                	sext.w	a5,a5
    80003f3e:	0006861b          	sext.w	a2,a3
    80003f42:	f8f674e3          	bgeu	a2,a5,80003eca <writei+0x4c>
    80003f46:	8d36                	mv	s10,a3
    80003f48:	b749                	j	80003eca <writei+0x4c>
      brelse(bp);
    80003f4a:	8526                	mv	a0,s1
    80003f4c:	fffff097          	auipc	ra,0xfffff
    80003f50:	49c080e7          	jalr	1180(ra) # 800033e8 <brelse>
  }

  if(off > ip->size)
    80003f54:	054aa783          	lw	a5,84(s5)
    80003f58:	0127f463          	bgeu	a5,s2,80003f60 <writei+0xe2>
    ip->size = off;
    80003f5c:	052aaa23          	sw	s2,84(s5)

  // write the i-node back to disk even if the size didn't change
  // because the loop above might have called bmap() and added a new
  // block to ip->addrs[].
  iupdate(ip);
    80003f60:	8556                	mv	a0,s5
    80003f62:	00000097          	auipc	ra,0x0
    80003f66:	aa6080e7          	jalr	-1370(ra) # 80003a08 <iupdate>

  return tot;
    80003f6a:	0009851b          	sext.w	a0,s3
}
    80003f6e:	70a6                	ld	ra,104(sp)
    80003f70:	7406                	ld	s0,96(sp)
    80003f72:	64e6                	ld	s1,88(sp)
    80003f74:	6946                	ld	s2,80(sp)
    80003f76:	69a6                	ld	s3,72(sp)
    80003f78:	6a06                	ld	s4,64(sp)
    80003f7a:	7ae2                	ld	s5,56(sp)
    80003f7c:	7b42                	ld	s6,48(sp)
    80003f7e:	7ba2                	ld	s7,40(sp)
    80003f80:	7c02                	ld	s8,32(sp)
    80003f82:	6ce2                	ld	s9,24(sp)
    80003f84:	6d42                	ld	s10,16(sp)
    80003f86:	6da2                	ld	s11,8(sp)
    80003f88:	6165                	addi	sp,sp,112
    80003f8a:	8082                	ret
  for(tot=0; tot<n; tot+=m, off+=m, src+=m){
    80003f8c:	89da                	mv	s3,s6
    80003f8e:	bfc9                	j	80003f60 <writei+0xe2>
    return -1;
    80003f90:	557d                	li	a0,-1
}
    80003f92:	8082                	ret
    return -1;
    80003f94:	557d                	li	a0,-1
    80003f96:	bfe1                	j	80003f6e <writei+0xf0>
    return -1;
    80003f98:	557d                	li	a0,-1
    80003f9a:	bfd1                	j	80003f6e <writei+0xf0>

0000000080003f9c <namecmp>:

// Directories

int
namecmp(const char *s, const char *t)
{
    80003f9c:	1141                	addi	sp,sp,-16
    80003f9e:	e406                	sd	ra,8(sp)
    80003fa0:	e022                	sd	s0,0(sp)
    80003fa2:	0800                	addi	s0,sp,16
  return strncmp(s, t, DIRSIZ);
    80003fa4:	4639                	li	a2,14
    80003fa6:	ffffd097          	auipc	ra,0xffffd
    80003faa:	ee8080e7          	jalr	-280(ra) # 80000e8e <strncmp>
}
    80003fae:	60a2                	ld	ra,8(sp)
    80003fb0:	6402                	ld	s0,0(sp)
    80003fb2:	0141                	addi	sp,sp,16
    80003fb4:	8082                	ret

0000000080003fb6 <dirlookup>:

// Look for a directory entry in a directory.
// If found, set *poff to byte offset of entry.
struct inode*
dirlookup(struct inode *dp, char *name, uint *poff)
{
    80003fb6:	7139                	addi	sp,sp,-64
    80003fb8:	fc06                	sd	ra,56(sp)
    80003fba:	f822                	sd	s0,48(sp)
    80003fbc:	f426                	sd	s1,40(sp)
    80003fbe:	f04a                	sd	s2,32(sp)
    80003fc0:	ec4e                	sd	s3,24(sp)
    80003fc2:	e852                	sd	s4,16(sp)
    80003fc4:	0080                	addi	s0,sp,64
  uint off, inum;
  struct dirent de;

  if(dp->type != T_DIR)
    80003fc6:	04c51703          	lh	a4,76(a0)
    80003fca:	4785                	li	a5,1
    80003fcc:	00f71a63          	bne	a4,a5,80003fe0 <dirlookup+0x2a>
    80003fd0:	892a                	mv	s2,a0
    80003fd2:	89ae                	mv	s3,a1
    80003fd4:	8a32                	mv	s4,a2
    panic("dirlookup not DIR");

  for(off = 0; off < dp->size; off += sizeof(de)){
    80003fd6:	497c                	lw	a5,84(a0)
    80003fd8:	4481                	li	s1,0
      inum = de.inum;
      return iget(dp->dev, inum);
    }
  }

  return 0;
    80003fda:	4501                	li	a0,0
  for(off = 0; off < dp->size; off += sizeof(de)){
    80003fdc:	e79d                	bnez	a5,8000400a <dirlookup+0x54>
    80003fde:	a8a5                	j	80004056 <dirlookup+0xa0>
    panic("dirlookup not DIR");
    80003fe0:	00005517          	auipc	a0,0x5
    80003fe4:	88050513          	addi	a0,a0,-1920 # 80008860 <syscall_name+0x1c0>
    80003fe8:	ffffc097          	auipc	ra,0xffffc
    80003fec:	55c080e7          	jalr	1372(ra) # 80000544 <panic>
      panic("dirlookup read");
    80003ff0:	00005517          	auipc	a0,0x5
    80003ff4:	88850513          	addi	a0,a0,-1912 # 80008878 <syscall_name+0x1d8>
    80003ff8:	ffffc097          	auipc	ra,0xffffc
    80003ffc:	54c080e7          	jalr	1356(ra) # 80000544 <panic>
  for(off = 0; off < dp->size; off += sizeof(de)){
    80004000:	24c1                	addiw	s1,s1,16
    80004002:	05492783          	lw	a5,84(s2)
    80004006:	04f4f763          	bgeu	s1,a5,80004054 <dirlookup+0x9e>
    if(readi(dp, 0, (uint64)&de, off, sizeof(de)) != sizeof(de))
    8000400a:	4741                	li	a4,16
    8000400c:	86a6                	mv	a3,s1
    8000400e:	fc040613          	addi	a2,s0,-64
    80004012:	4581                	li	a1,0
    80004014:	854a                	mv	a0,s2
    80004016:	00000097          	auipc	ra,0x0
    8000401a:	d70080e7          	jalr	-656(ra) # 80003d86 <readi>
    8000401e:	47c1                	li	a5,16
    80004020:	fcf518e3          	bne	a0,a5,80003ff0 <dirlookup+0x3a>
    if(de.inum == 0)
    80004024:	fc045783          	lhu	a5,-64(s0)
    80004028:	dfe1                	beqz	a5,80004000 <dirlookup+0x4a>
    if(namecmp(name, de.name) == 0){
    8000402a:	fc240593          	addi	a1,s0,-62
    8000402e:	854e                	mv	a0,s3
    80004030:	00000097          	auipc	ra,0x0
    80004034:	f6c080e7          	jalr	-148(ra) # 80003f9c <namecmp>
    80004038:	f561                	bnez	a0,80004000 <dirlookup+0x4a>
      if(poff)
    8000403a:	000a0463          	beqz	s4,80004042 <dirlookup+0x8c>
        *poff = off;
    8000403e:	009a2023          	sw	s1,0(s4)
      return iget(dp->dev, inum);
    80004042:	fc045583          	lhu	a1,-64(s0)
    80004046:	00092503          	lw	a0,0(s2)
    8000404a:	fffff097          	auipc	ra,0xfffff
    8000404e:	750080e7          	jalr	1872(ra) # 8000379a <iget>
    80004052:	a011                	j	80004056 <dirlookup+0xa0>
  return 0;
    80004054:	4501                	li	a0,0
}
    80004056:	70e2                	ld	ra,56(sp)
    80004058:	7442                	ld	s0,48(sp)
    8000405a:	74a2                	ld	s1,40(sp)
    8000405c:	7902                	ld	s2,32(sp)
    8000405e:	69e2                	ld	s3,24(sp)
    80004060:	6a42                	ld	s4,16(sp)
    80004062:	6121                	addi	sp,sp,64
    80004064:	8082                	ret

0000000080004066 <namex>:
// If parent != 0, return the inode for the parent and copy the final
// path element into name, which must have room for DIRSIZ bytes.
// Must be called inside a transaction since it calls iput().
static struct inode*
namex(char *path, int nameiparent, char *name)
{
    80004066:	711d                	addi	sp,sp,-96
    80004068:	ec86                	sd	ra,88(sp)
    8000406a:	e8a2                	sd	s0,80(sp)
    8000406c:	e4a6                	sd	s1,72(sp)
    8000406e:	e0ca                	sd	s2,64(sp)
    80004070:	fc4e                	sd	s3,56(sp)
    80004072:	f852                	sd	s4,48(sp)
    80004074:	f456                	sd	s5,40(sp)
    80004076:	f05a                	sd	s6,32(sp)
    80004078:	ec5e                	sd	s7,24(sp)
    8000407a:	e862                	sd	s8,16(sp)
    8000407c:	e466                	sd	s9,8(sp)
    8000407e:	1080                	addi	s0,sp,96
    80004080:	84aa                	mv	s1,a0
    80004082:	8b2e                	mv	s6,a1
    80004084:	8ab2                	mv	s5,a2
  struct inode *ip, *next;

  if(*path == '/')
    80004086:	00054703          	lbu	a4,0(a0)
    8000408a:	02f00793          	li	a5,47
    8000408e:	02f70363          	beq	a4,a5,800040b4 <namex+0x4e>
    ip = iget(ROOTDEV, ROOTINO);
  else
    ip = idup(myproc()->cwd);
    80004092:	ffffe097          	auipc	ra,0xffffe
    80004096:	a04080e7          	jalr	-1532(ra) # 80001a96 <myproc>
    8000409a:	16053503          	ld	a0,352(a0)
    8000409e:	00000097          	auipc	ra,0x0
    800040a2:	9f6080e7          	jalr	-1546(ra) # 80003a94 <idup>
    800040a6:	89aa                	mv	s3,a0
  while(*path == '/')
    800040a8:	02f00913          	li	s2,47
  len = path - s;
    800040ac:	4b81                	li	s7,0
  if(len >= DIRSIZ)
    800040ae:	4cb5                	li	s9,13

  while((path = skipelem(path, name)) != 0){
    ilock(ip);
    if(ip->type != T_DIR){
    800040b0:	4c05                	li	s8,1
    800040b2:	a865                	j	8000416a <namex+0x104>
    ip = iget(ROOTDEV, ROOTINO);
    800040b4:	4585                	li	a1,1
    800040b6:	4505                	li	a0,1
    800040b8:	fffff097          	auipc	ra,0xfffff
    800040bc:	6e2080e7          	jalr	1762(ra) # 8000379a <iget>
    800040c0:	89aa                	mv	s3,a0
    800040c2:	b7dd                	j	800040a8 <namex+0x42>
      iunlockput(ip);
    800040c4:	854e                	mv	a0,s3
    800040c6:	00000097          	auipc	ra,0x0
    800040ca:	c6e080e7          	jalr	-914(ra) # 80003d34 <iunlockput>
      return 0;
    800040ce:	4981                	li	s3,0
  if(nameiparent){
    iput(ip);
    return 0;
  }
  return ip;
}
    800040d0:	854e                	mv	a0,s3
    800040d2:	60e6                	ld	ra,88(sp)
    800040d4:	6446                	ld	s0,80(sp)
    800040d6:	64a6                	ld	s1,72(sp)
    800040d8:	6906                	ld	s2,64(sp)
    800040da:	79e2                	ld	s3,56(sp)
    800040dc:	7a42                	ld	s4,48(sp)
    800040de:	7aa2                	ld	s5,40(sp)
    800040e0:	7b02                	ld	s6,32(sp)
    800040e2:	6be2                	ld	s7,24(sp)
    800040e4:	6c42                	ld	s8,16(sp)
    800040e6:	6ca2                	ld	s9,8(sp)
    800040e8:	6125                	addi	sp,sp,96
    800040ea:	8082                	ret
      iunlock(ip);
    800040ec:	854e                	mv	a0,s3
    800040ee:	00000097          	auipc	ra,0x0
    800040f2:	aa6080e7          	jalr	-1370(ra) # 80003b94 <iunlock>
      return ip;
    800040f6:	bfe9                	j	800040d0 <namex+0x6a>
      iunlockput(ip);
    800040f8:	854e                	mv	a0,s3
    800040fa:	00000097          	auipc	ra,0x0
    800040fe:	c3a080e7          	jalr	-966(ra) # 80003d34 <iunlockput>
      return 0;
    80004102:	89d2                	mv	s3,s4
    80004104:	b7f1                	j	800040d0 <namex+0x6a>
  len = path - s;
    80004106:	40b48633          	sub	a2,s1,a1
    8000410a:	00060a1b          	sext.w	s4,a2
  if(len >= DIRSIZ)
    8000410e:	094cd463          	bge	s9,s4,80004196 <namex+0x130>
    memmove(name, s, DIRSIZ);
    80004112:	4639                	li	a2,14
    80004114:	8556                	mv	a0,s5
    80004116:	ffffd097          	auipc	ra,0xffffd
    8000411a:	d00080e7          	jalr	-768(ra) # 80000e16 <memmove>
  while(*path == '/')
    8000411e:	0004c783          	lbu	a5,0(s1)
    80004122:	01279763          	bne	a5,s2,80004130 <namex+0xca>
    path++;
    80004126:	0485                	addi	s1,s1,1
  while(*path == '/')
    80004128:	0004c783          	lbu	a5,0(s1)
    8000412c:	ff278de3          	beq	a5,s2,80004126 <namex+0xc0>
    ilock(ip);
    80004130:	854e                	mv	a0,s3
    80004132:	00000097          	auipc	ra,0x0
    80004136:	9a0080e7          	jalr	-1632(ra) # 80003ad2 <ilock>
    if(ip->type != T_DIR){
    8000413a:	04c99783          	lh	a5,76(s3)
    8000413e:	f98793e3          	bne	a5,s8,800040c4 <namex+0x5e>
    if(nameiparent && *path == '\0'){
    80004142:	000b0563          	beqz	s6,8000414c <namex+0xe6>
    80004146:	0004c783          	lbu	a5,0(s1)
    8000414a:	d3cd                	beqz	a5,800040ec <namex+0x86>
    if((next = dirlookup(ip, name, 0)) == 0){
    8000414c:	865e                	mv	a2,s7
    8000414e:	85d6                	mv	a1,s5
    80004150:	854e                	mv	a0,s3
    80004152:	00000097          	auipc	ra,0x0
    80004156:	e64080e7          	jalr	-412(ra) # 80003fb6 <dirlookup>
    8000415a:	8a2a                	mv	s4,a0
    8000415c:	dd51                	beqz	a0,800040f8 <namex+0x92>
    iunlockput(ip);
    8000415e:	854e                	mv	a0,s3
    80004160:	00000097          	auipc	ra,0x0
    80004164:	bd4080e7          	jalr	-1068(ra) # 80003d34 <iunlockput>
    ip = next;
    80004168:	89d2                	mv	s3,s4
  while(*path == '/')
    8000416a:	0004c783          	lbu	a5,0(s1)
    8000416e:	05279763          	bne	a5,s2,800041bc <namex+0x156>
    path++;
    80004172:	0485                	addi	s1,s1,1
  while(*path == '/')
    80004174:	0004c783          	lbu	a5,0(s1)
    80004178:	ff278de3          	beq	a5,s2,80004172 <namex+0x10c>
  if(*path == 0)
    8000417c:	c79d                	beqz	a5,800041aa <namex+0x144>
    path++;
    8000417e:	85a6                	mv	a1,s1
  len = path - s;
    80004180:	8a5e                	mv	s4,s7
    80004182:	865e                	mv	a2,s7
  while(*path != '/' && *path != 0)
    80004184:	01278963          	beq	a5,s2,80004196 <namex+0x130>
    80004188:	dfbd                	beqz	a5,80004106 <namex+0xa0>
    path++;
    8000418a:	0485                	addi	s1,s1,1
  while(*path != '/' && *path != 0)
    8000418c:	0004c783          	lbu	a5,0(s1)
    80004190:	ff279ce3          	bne	a5,s2,80004188 <namex+0x122>
    80004194:	bf8d                	j	80004106 <namex+0xa0>
    memmove(name, s, len);
    80004196:	2601                	sext.w	a2,a2
    80004198:	8556                	mv	a0,s5
    8000419a:	ffffd097          	auipc	ra,0xffffd
    8000419e:	c7c080e7          	jalr	-900(ra) # 80000e16 <memmove>
    name[len] = 0;
    800041a2:	9a56                	add	s4,s4,s5
    800041a4:	000a0023          	sb	zero,0(s4)
    800041a8:	bf9d                	j	8000411e <namex+0xb8>
  if(nameiparent){
    800041aa:	f20b03e3          	beqz	s6,800040d0 <namex+0x6a>
    iput(ip);
    800041ae:	854e                	mv	a0,s3
    800041b0:	00000097          	auipc	ra,0x0
    800041b4:	adc080e7          	jalr	-1316(ra) # 80003c8c <iput>
    return 0;
    800041b8:	4981                	li	s3,0
    800041ba:	bf19                	j	800040d0 <namex+0x6a>
  if(*path == 0)
    800041bc:	d7fd                	beqz	a5,800041aa <namex+0x144>
  while(*path != '/' && *path != 0)
    800041be:	0004c783          	lbu	a5,0(s1)
    800041c2:	85a6                	mv	a1,s1
    800041c4:	b7d1                	j	80004188 <namex+0x122>

00000000800041c6 <dirlink>:
{
    800041c6:	7139                	addi	sp,sp,-64
    800041c8:	fc06                	sd	ra,56(sp)
    800041ca:	f822                	sd	s0,48(sp)
    800041cc:	f426                	sd	s1,40(sp)
    800041ce:	f04a                	sd	s2,32(sp)
    800041d0:	ec4e                	sd	s3,24(sp)
    800041d2:	e852                	sd	s4,16(sp)
    800041d4:	0080                	addi	s0,sp,64
    800041d6:	892a                	mv	s2,a0
    800041d8:	8a2e                	mv	s4,a1
    800041da:	89b2                	mv	s3,a2
  if((ip = dirlookup(dp, name, 0)) != 0){
    800041dc:	4601                	li	a2,0
    800041de:	00000097          	auipc	ra,0x0
    800041e2:	dd8080e7          	jalr	-552(ra) # 80003fb6 <dirlookup>
    800041e6:	e93d                	bnez	a0,8000425c <dirlink+0x96>
  for(off = 0; off < dp->size; off += sizeof(de)){
    800041e8:	05492483          	lw	s1,84(s2)
    800041ec:	c49d                	beqz	s1,8000421a <dirlink+0x54>
    800041ee:	4481                	li	s1,0
    if(readi(dp, 0, (uint64)&de, off, sizeof(de)) != sizeof(de))
    800041f0:	4741                	li	a4,16
    800041f2:	86a6                	mv	a3,s1
    800041f4:	fc040613          	addi	a2,s0,-64
    800041f8:	4581                	li	a1,0
    800041fa:	854a                	mv	a0,s2
    800041fc:	00000097          	auipc	ra,0x0
    80004200:	b8a080e7          	jalr	-1142(ra) # 80003d86 <readi>
    80004204:	47c1                	li	a5,16
    80004206:	06f51163          	bne	a0,a5,80004268 <dirlink+0xa2>
    if(de.inum == 0)
    8000420a:	fc045783          	lhu	a5,-64(s0)
    8000420e:	c791                	beqz	a5,8000421a <dirlink+0x54>
  for(off = 0; off < dp->size; off += sizeof(de)){
    80004210:	24c1                	addiw	s1,s1,16
    80004212:	05492783          	lw	a5,84(s2)
    80004216:	fcf4ede3          	bltu	s1,a5,800041f0 <dirlink+0x2a>
  strncpy(de.name, name, DIRSIZ);
    8000421a:	4639                	li	a2,14
    8000421c:	85d2                	mv	a1,s4
    8000421e:	fc240513          	addi	a0,s0,-62
    80004222:	ffffd097          	auipc	ra,0xffffd
    80004226:	ca8080e7          	jalr	-856(ra) # 80000eca <strncpy>
  de.inum = inum;
    8000422a:	fd341023          	sh	s3,-64(s0)
  if(writei(dp, 0, (uint64)&de, off, sizeof(de)) != sizeof(de))
    8000422e:	4741                	li	a4,16
    80004230:	86a6                	mv	a3,s1
    80004232:	fc040613          	addi	a2,s0,-64
    80004236:	4581                	li	a1,0
    80004238:	854a                	mv	a0,s2
    8000423a:	00000097          	auipc	ra,0x0
    8000423e:	c44080e7          	jalr	-956(ra) # 80003e7e <writei>
    80004242:	1541                	addi	a0,a0,-16
    80004244:	00a03533          	snez	a0,a0
    80004248:	40a00533          	neg	a0,a0
}
    8000424c:	70e2                	ld	ra,56(sp)
    8000424e:	7442                	ld	s0,48(sp)
    80004250:	74a2                	ld	s1,40(sp)
    80004252:	7902                	ld	s2,32(sp)
    80004254:	69e2                	ld	s3,24(sp)
    80004256:	6a42                	ld	s4,16(sp)
    80004258:	6121                	addi	sp,sp,64
    8000425a:	8082                	ret
    iput(ip);
    8000425c:	00000097          	auipc	ra,0x0
    80004260:	a30080e7          	jalr	-1488(ra) # 80003c8c <iput>
    return -1;
    80004264:	557d                	li	a0,-1
    80004266:	b7dd                	j	8000424c <dirlink+0x86>
      panic("dirlink read");
    80004268:	00004517          	auipc	a0,0x4
    8000426c:	62050513          	addi	a0,a0,1568 # 80008888 <syscall_name+0x1e8>
    80004270:	ffffc097          	auipc	ra,0xffffc
    80004274:	2d4080e7          	jalr	724(ra) # 80000544 <panic>

0000000080004278 <namei>:

struct inode*
namei(char *path)
{
    80004278:	1101                	addi	sp,sp,-32
    8000427a:	ec06                	sd	ra,24(sp)
    8000427c:	e822                	sd	s0,16(sp)
    8000427e:	1000                	addi	s0,sp,32
  char name[DIRSIZ];
  return namex(path, 0, name);
    80004280:	fe040613          	addi	a2,s0,-32
    80004284:	4581                	li	a1,0
    80004286:	00000097          	auipc	ra,0x0
    8000428a:	de0080e7          	jalr	-544(ra) # 80004066 <namex>
}
    8000428e:	60e2                	ld	ra,24(sp)
    80004290:	6442                	ld	s0,16(sp)
    80004292:	6105                	addi	sp,sp,32
    80004294:	8082                	ret

0000000080004296 <nameiparent>:

struct inode*
nameiparent(char *path, char *name)
{
    80004296:	1141                	addi	sp,sp,-16
    80004298:	e406                	sd	ra,8(sp)
    8000429a:	e022                	sd	s0,0(sp)
    8000429c:	0800                	addi	s0,sp,16
    8000429e:	862e                	mv	a2,a1
  return namex(path, 1, name);
    800042a0:	4585                	li	a1,1
    800042a2:	00000097          	auipc	ra,0x0
    800042a6:	dc4080e7          	jalr	-572(ra) # 80004066 <namex>
}
    800042aa:	60a2                	ld	ra,8(sp)
    800042ac:	6402                	ld	s0,0(sp)
    800042ae:	0141                	addi	sp,sp,16
    800042b0:	8082                	ret

00000000800042b2 <write_head>:
// Write in-memory log header to disk.
// This is the true point at which the
// current transaction commits.
static void
write_head(void)
{
    800042b2:	1101                	addi	sp,sp,-32
    800042b4:	ec06                	sd	ra,24(sp)
    800042b6:	e822                	sd	s0,16(sp)
    800042b8:	e426                	sd	s1,8(sp)
    800042ba:	e04a                	sd	s2,0(sp)
    800042bc:	1000                	addi	s0,sp,32
  struct buf *buf = bread(log.dev, log.start);
    800042be:	0001d917          	auipc	s2,0x1d
    800042c2:	3a290913          	addi	s2,s2,930 # 80021660 <log>
    800042c6:	02092583          	lw	a1,32(s2)
    800042ca:	03092503          	lw	a0,48(s2)
    800042ce:	fffff097          	auipc	ra,0xfffff
    800042d2:	fea080e7          	jalr	-22(ra) # 800032b8 <bread>
    800042d6:	84aa                	mv	s1,a0
  struct logheader *hb = (struct logheader *) (buf->data);
  int i;
  hb->n = log.lh.n;
    800042d8:	03492683          	lw	a3,52(s2)
    800042dc:	d134                	sw	a3,96(a0)
  for (i = 0; i < log.lh.n; i++) {
    800042de:	02d05763          	blez	a3,8000430c <write_head+0x5a>
    800042e2:	0001d797          	auipc	a5,0x1d
    800042e6:	3b678793          	addi	a5,a5,950 # 80021698 <log+0x38>
    800042ea:	06450713          	addi	a4,a0,100
    800042ee:	36fd                	addiw	a3,a3,-1
    800042f0:	1682                	slli	a3,a3,0x20
    800042f2:	9281                	srli	a3,a3,0x20
    800042f4:	068a                	slli	a3,a3,0x2
    800042f6:	0001d617          	auipc	a2,0x1d
    800042fa:	3a660613          	addi	a2,a2,934 # 8002169c <log+0x3c>
    800042fe:	96b2                	add	a3,a3,a2
    hb->block[i] = log.lh.block[i];
    80004300:	4390                	lw	a2,0(a5)
    80004302:	c310                	sw	a2,0(a4)
  for (i = 0; i < log.lh.n; i++) {
    80004304:	0791                	addi	a5,a5,4
    80004306:	0711                	addi	a4,a4,4
    80004308:	fed79ce3          	bne	a5,a3,80004300 <write_head+0x4e>
  }
  bwrite(buf);
    8000430c:	8526                	mv	a0,s1
    8000430e:	fffff097          	auipc	ra,0xfffff
    80004312:	09c080e7          	jalr	156(ra) # 800033aa <bwrite>
  brelse(buf);
    80004316:	8526                	mv	a0,s1
    80004318:	fffff097          	auipc	ra,0xfffff
    8000431c:	0d0080e7          	jalr	208(ra) # 800033e8 <brelse>
}
    80004320:	60e2                	ld	ra,24(sp)
    80004322:	6442                	ld	s0,16(sp)
    80004324:	64a2                	ld	s1,8(sp)
    80004326:	6902                	ld	s2,0(sp)
    80004328:	6105                	addi	sp,sp,32
    8000432a:	8082                	ret

000000008000432c <install_trans>:
  for (tail = 0; tail < log.lh.n; tail++) {
    8000432c:	0001d797          	auipc	a5,0x1d
    80004330:	3687a783          	lw	a5,872(a5) # 80021694 <log+0x34>
    80004334:	0af05d63          	blez	a5,800043ee <install_trans+0xc2>
{
    80004338:	7139                	addi	sp,sp,-64
    8000433a:	fc06                	sd	ra,56(sp)
    8000433c:	f822                	sd	s0,48(sp)
    8000433e:	f426                	sd	s1,40(sp)
    80004340:	f04a                	sd	s2,32(sp)
    80004342:	ec4e                	sd	s3,24(sp)
    80004344:	e852                	sd	s4,16(sp)
    80004346:	e456                	sd	s5,8(sp)
    80004348:	e05a                	sd	s6,0(sp)
    8000434a:	0080                	addi	s0,sp,64
    8000434c:	8b2a                	mv	s6,a0
    8000434e:	0001da97          	auipc	s5,0x1d
    80004352:	34aa8a93          	addi	s5,s5,842 # 80021698 <log+0x38>
  for (tail = 0; tail < log.lh.n; tail++) {
    80004356:	4a01                	li	s4,0
    struct buf *lbuf = bread(log.dev, log.start+tail+1); // read log block
    80004358:	0001d997          	auipc	s3,0x1d
    8000435c:	30898993          	addi	s3,s3,776 # 80021660 <log>
    80004360:	a035                	j	8000438c <install_trans+0x60>
      bunpin(dbuf);
    80004362:	8526                	mv	a0,s1
    80004364:	fffff097          	auipc	ra,0xfffff
    80004368:	15e080e7          	jalr	350(ra) # 800034c2 <bunpin>
    brelse(lbuf);
    8000436c:	854a                	mv	a0,s2
    8000436e:	fffff097          	auipc	ra,0xfffff
    80004372:	07a080e7          	jalr	122(ra) # 800033e8 <brelse>
    brelse(dbuf);
    80004376:	8526                	mv	a0,s1
    80004378:	fffff097          	auipc	ra,0xfffff
    8000437c:	070080e7          	jalr	112(ra) # 800033e8 <brelse>
  for (tail = 0; tail < log.lh.n; tail++) {
    80004380:	2a05                	addiw	s4,s4,1
    80004382:	0a91                	addi	s5,s5,4
    80004384:	0349a783          	lw	a5,52(s3)
    80004388:	04fa5963          	bge	s4,a5,800043da <install_trans+0xae>
    struct buf *lbuf = bread(log.dev, log.start+tail+1); // read log block
    8000438c:	0209a583          	lw	a1,32(s3)
    80004390:	014585bb          	addw	a1,a1,s4
    80004394:	2585                	addiw	a1,a1,1
    80004396:	0309a503          	lw	a0,48(s3)
    8000439a:	fffff097          	auipc	ra,0xfffff
    8000439e:	f1e080e7          	jalr	-226(ra) # 800032b8 <bread>
    800043a2:	892a                	mv	s2,a0
    struct buf *dbuf = bread(log.dev, log.lh.block[tail]); // read dst
    800043a4:	000aa583          	lw	a1,0(s5)
    800043a8:	0309a503          	lw	a0,48(s3)
    800043ac:	fffff097          	auipc	ra,0xfffff
    800043b0:	f0c080e7          	jalr	-244(ra) # 800032b8 <bread>
    800043b4:	84aa                	mv	s1,a0
    memmove(dbuf->data, lbuf->data, BSIZE);  // copy block to dst
    800043b6:	40000613          	li	a2,1024
    800043ba:	06090593          	addi	a1,s2,96
    800043be:	06050513          	addi	a0,a0,96
    800043c2:	ffffd097          	auipc	ra,0xffffd
    800043c6:	a54080e7          	jalr	-1452(ra) # 80000e16 <memmove>
    bwrite(dbuf);  // write dst to disk
    800043ca:	8526                	mv	a0,s1
    800043cc:	fffff097          	auipc	ra,0xfffff
    800043d0:	fde080e7          	jalr	-34(ra) # 800033aa <bwrite>
    if(recovering == 0)
    800043d4:	f80b1ce3          	bnez	s6,8000436c <install_trans+0x40>
    800043d8:	b769                	j	80004362 <install_trans+0x36>
}
    800043da:	70e2                	ld	ra,56(sp)
    800043dc:	7442                	ld	s0,48(sp)
    800043de:	74a2                	ld	s1,40(sp)
    800043e0:	7902                	ld	s2,32(sp)
    800043e2:	69e2                	ld	s3,24(sp)
    800043e4:	6a42                	ld	s4,16(sp)
    800043e6:	6aa2                	ld	s5,8(sp)
    800043e8:	6b02                	ld	s6,0(sp)
    800043ea:	6121                	addi	sp,sp,64
    800043ec:	8082                	ret
    800043ee:	8082                	ret

00000000800043f0 <initlog>:
{
    800043f0:	7179                	addi	sp,sp,-48
    800043f2:	f406                	sd	ra,40(sp)
    800043f4:	f022                	sd	s0,32(sp)
    800043f6:	ec26                	sd	s1,24(sp)
    800043f8:	e84a                	sd	s2,16(sp)
    800043fa:	e44e                	sd	s3,8(sp)
    800043fc:	1800                	addi	s0,sp,48
    800043fe:	892a                	mv	s2,a0
    80004400:	89ae                	mv	s3,a1
  initlock(&log.lock, "log");
    80004402:	0001d497          	auipc	s1,0x1d
    80004406:	25e48493          	addi	s1,s1,606 # 80021660 <log>
    8000440a:	00004597          	auipc	a1,0x4
    8000440e:	48e58593          	addi	a1,a1,1166 # 80008898 <syscall_name+0x1f8>
    80004412:	8526                	mv	a0,s1
    80004414:	ffffc097          	auipc	ra,0xffffc
    80004418:	790080e7          	jalr	1936(ra) # 80000ba4 <initlock>
  log.start = sb->logstart;
    8000441c:	0149a583          	lw	a1,20(s3)
    80004420:	d08c                	sw	a1,32(s1)
  log.size = sb->nlog;
    80004422:	0109a783          	lw	a5,16(s3)
    80004426:	d0dc                	sw	a5,36(s1)
  log.dev = dev;
    80004428:	0324a823          	sw	s2,48(s1)
  struct buf *buf = bread(log.dev, log.start);
    8000442c:	854a                	mv	a0,s2
    8000442e:	fffff097          	auipc	ra,0xfffff
    80004432:	e8a080e7          	jalr	-374(ra) # 800032b8 <bread>
  log.lh.n = lh->n;
    80004436:	513c                	lw	a5,96(a0)
    80004438:	d8dc                	sw	a5,52(s1)
  for (i = 0; i < log.lh.n; i++) {
    8000443a:	02f05563          	blez	a5,80004464 <initlog+0x74>
    8000443e:	06450713          	addi	a4,a0,100
    80004442:	0001d697          	auipc	a3,0x1d
    80004446:	25668693          	addi	a3,a3,598 # 80021698 <log+0x38>
    8000444a:	37fd                	addiw	a5,a5,-1
    8000444c:	1782                	slli	a5,a5,0x20
    8000444e:	9381                	srli	a5,a5,0x20
    80004450:	078a                	slli	a5,a5,0x2
    80004452:	06850613          	addi	a2,a0,104
    80004456:	97b2                	add	a5,a5,a2
    log.lh.block[i] = lh->block[i];
    80004458:	4310                	lw	a2,0(a4)
    8000445a:	c290                	sw	a2,0(a3)
  for (i = 0; i < log.lh.n; i++) {
    8000445c:	0711                	addi	a4,a4,4
    8000445e:	0691                	addi	a3,a3,4
    80004460:	fef71ce3          	bne	a4,a5,80004458 <initlog+0x68>
  brelse(buf);
    80004464:	fffff097          	auipc	ra,0xfffff
    80004468:	f84080e7          	jalr	-124(ra) # 800033e8 <brelse>

static void
recover_from_log(void)
{
  read_head();
  install_trans(1); // if committed, copy from log to disk
    8000446c:	4505                	li	a0,1
    8000446e:	00000097          	auipc	ra,0x0
    80004472:	ebe080e7          	jalr	-322(ra) # 8000432c <install_trans>
  log.lh.n = 0;
    80004476:	0001d797          	auipc	a5,0x1d
    8000447a:	2007af23          	sw	zero,542(a5) # 80021694 <log+0x34>
  write_head(); // clear the log
    8000447e:	00000097          	auipc	ra,0x0
    80004482:	e34080e7          	jalr	-460(ra) # 800042b2 <write_head>
}
    80004486:	70a2                	ld	ra,40(sp)
    80004488:	7402                	ld	s0,32(sp)
    8000448a:	64e2                	ld	s1,24(sp)
    8000448c:	6942                	ld	s2,16(sp)
    8000448e:	69a2                	ld	s3,8(sp)
    80004490:	6145                	addi	sp,sp,48
    80004492:	8082                	ret

0000000080004494 <begin_op>:
}

// called at the start of each FS system call.
void
begin_op(void)
{
    80004494:	1101                	addi	sp,sp,-32
    80004496:	ec06                	sd	ra,24(sp)
    80004498:	e822                	sd	s0,16(sp)
    8000449a:	e426                	sd	s1,8(sp)
    8000449c:	e04a                	sd	s2,0(sp)
    8000449e:	1000                	addi	s0,sp,32
  acquire(&log.lock);
    800044a0:	0001d517          	auipc	a0,0x1d
    800044a4:	1c050513          	addi	a0,a0,448 # 80021660 <log>
    800044a8:	ffffc097          	auipc	ra,0xffffc
    800044ac:	766080e7          	jalr	1894(ra) # 80000c0e <acquire>
  while(1){
    if(log.committing){
    800044b0:	0001d497          	auipc	s1,0x1d
    800044b4:	1b048493          	addi	s1,s1,432 # 80021660 <log>
      sleep(&log, &log.lock);
    } else if(log.lh.n + (log.outstanding+1)*MAXOPBLOCKS > LOGSIZE){
    800044b8:	4979                	li	s2,30
    800044ba:	a039                	j	800044c8 <begin_op+0x34>
      sleep(&log, &log.lock);
    800044bc:	85a6                	mv	a1,s1
    800044be:	8526                	mv	a0,s1
    800044c0:	ffffe097          	auipc	ra,0xffffe
    800044c4:	dc0080e7          	jalr	-576(ra) # 80002280 <sleep>
    if(log.committing){
    800044c8:	54dc                	lw	a5,44(s1)
    800044ca:	fbed                	bnez	a5,800044bc <begin_op+0x28>
    } else if(log.lh.n + (log.outstanding+1)*MAXOPBLOCKS > LOGSIZE){
    800044cc:	549c                	lw	a5,40(s1)
    800044ce:	0017871b          	addiw	a4,a5,1
    800044d2:	0007069b          	sext.w	a3,a4
    800044d6:	0027179b          	slliw	a5,a4,0x2
    800044da:	9fb9                	addw	a5,a5,a4
    800044dc:	0017979b          	slliw	a5,a5,0x1
    800044e0:	58d8                	lw	a4,52(s1)
    800044e2:	9fb9                	addw	a5,a5,a4
    800044e4:	00f95963          	bge	s2,a5,800044f6 <begin_op+0x62>
      // this op might exhaust log space; wait for commit.
      sleep(&log, &log.lock);
    800044e8:	85a6                	mv	a1,s1
    800044ea:	8526                	mv	a0,s1
    800044ec:	ffffe097          	auipc	ra,0xffffe
    800044f0:	d94080e7          	jalr	-620(ra) # 80002280 <sleep>
    800044f4:	bfd1                	j	800044c8 <begin_op+0x34>
    } else {
      log.outstanding += 1;
    800044f6:	0001d517          	auipc	a0,0x1d
    800044fa:	16a50513          	addi	a0,a0,362 # 80021660 <log>
    800044fe:	d514                	sw	a3,40(a0)
      release(&log.lock);
    80004500:	ffffd097          	auipc	ra,0xffffd
    80004504:	868080e7          	jalr	-1944(ra) # 80000d68 <release>
      break;
    }
  }
}
    80004508:	60e2                	ld	ra,24(sp)
    8000450a:	6442                	ld	s0,16(sp)
    8000450c:	64a2                	ld	s1,8(sp)
    8000450e:	6902                	ld	s2,0(sp)
    80004510:	6105                	addi	sp,sp,32
    80004512:	8082                	ret

0000000080004514 <end_op>:

// called at the end of each FS system call.
// commits if this was the last outstanding operation.
void
end_op(void)
{
    80004514:	7139                	addi	sp,sp,-64
    80004516:	fc06                	sd	ra,56(sp)
    80004518:	f822                	sd	s0,48(sp)
    8000451a:	f426                	sd	s1,40(sp)
    8000451c:	f04a                	sd	s2,32(sp)
    8000451e:	ec4e                	sd	s3,24(sp)
    80004520:	e852                	sd	s4,16(sp)
    80004522:	e456                	sd	s5,8(sp)
    80004524:	0080                	addi	s0,sp,64
  int do_commit = 0;

  acquire(&log.lock);
    80004526:	0001d497          	auipc	s1,0x1d
    8000452a:	13a48493          	addi	s1,s1,314 # 80021660 <log>
    8000452e:	8526                	mv	a0,s1
    80004530:	ffffc097          	auipc	ra,0xffffc
    80004534:	6de080e7          	jalr	1758(ra) # 80000c0e <acquire>
  log.outstanding -= 1;
    80004538:	549c                	lw	a5,40(s1)
    8000453a:	37fd                	addiw	a5,a5,-1
    8000453c:	0007891b          	sext.w	s2,a5
    80004540:	d49c                	sw	a5,40(s1)
  if(log.committing)
    80004542:	54dc                	lw	a5,44(s1)
    80004544:	efb9                	bnez	a5,800045a2 <end_op+0x8e>
    panic("log.committing");
  if(log.outstanding == 0){
    80004546:	06091663          	bnez	s2,800045b2 <end_op+0x9e>
    do_commit = 1;
    log.committing = 1;
    8000454a:	0001d497          	auipc	s1,0x1d
    8000454e:	11648493          	addi	s1,s1,278 # 80021660 <log>
    80004552:	4785                	li	a5,1
    80004554:	d4dc                	sw	a5,44(s1)
    // begin_op() may be waiting for log space,
    // and decrementing log.outstanding has decreased
    // the amount of reserved space.
    wakeup(&log);
  }
  release(&log.lock);
    80004556:	8526                	mv	a0,s1
    80004558:	ffffd097          	auipc	ra,0xffffd
    8000455c:	810080e7          	jalr	-2032(ra) # 80000d68 <release>
}

static void
commit()
{
  if (log.lh.n > 0) {
    80004560:	58dc                	lw	a5,52(s1)
    80004562:	06f04763          	bgtz	a5,800045d0 <end_op+0xbc>
    acquire(&log.lock);
    80004566:	0001d497          	auipc	s1,0x1d
    8000456a:	0fa48493          	addi	s1,s1,250 # 80021660 <log>
    8000456e:	8526                	mv	a0,s1
    80004570:	ffffc097          	auipc	ra,0xffffc
    80004574:	69e080e7          	jalr	1694(ra) # 80000c0e <acquire>
    log.committing = 0;
    80004578:	0204a623          	sw	zero,44(s1)
    wakeup(&log);
    8000457c:	8526                	mv	a0,s1
    8000457e:	ffffe097          	auipc	ra,0xffffe
    80004582:	d66080e7          	jalr	-666(ra) # 800022e4 <wakeup>
    release(&log.lock);
    80004586:	8526                	mv	a0,s1
    80004588:	ffffc097          	auipc	ra,0xffffc
    8000458c:	7e0080e7          	jalr	2016(ra) # 80000d68 <release>
}
    80004590:	70e2                	ld	ra,56(sp)
    80004592:	7442                	ld	s0,48(sp)
    80004594:	74a2                	ld	s1,40(sp)
    80004596:	7902                	ld	s2,32(sp)
    80004598:	69e2                	ld	s3,24(sp)
    8000459a:	6a42                	ld	s4,16(sp)
    8000459c:	6aa2                	ld	s5,8(sp)
    8000459e:	6121                	addi	sp,sp,64
    800045a0:	8082                	ret
    panic("log.committing");
    800045a2:	00004517          	auipc	a0,0x4
    800045a6:	2fe50513          	addi	a0,a0,766 # 800088a0 <syscall_name+0x200>
    800045aa:	ffffc097          	auipc	ra,0xffffc
    800045ae:	f9a080e7          	jalr	-102(ra) # 80000544 <panic>
    wakeup(&log);
    800045b2:	0001d497          	auipc	s1,0x1d
    800045b6:	0ae48493          	addi	s1,s1,174 # 80021660 <log>
    800045ba:	8526                	mv	a0,s1
    800045bc:	ffffe097          	auipc	ra,0xffffe
    800045c0:	d28080e7          	jalr	-728(ra) # 800022e4 <wakeup>
  release(&log.lock);
    800045c4:	8526                	mv	a0,s1
    800045c6:	ffffc097          	auipc	ra,0xffffc
    800045ca:	7a2080e7          	jalr	1954(ra) # 80000d68 <release>
  if(do_commit){
    800045ce:	b7c9                	j	80004590 <end_op+0x7c>
  for (tail = 0; tail < log.lh.n; tail++) {
    800045d0:	0001da97          	auipc	s5,0x1d
    800045d4:	0c8a8a93          	addi	s5,s5,200 # 80021698 <log+0x38>
    struct buf *to = bread(log.dev, log.start+tail+1); // log block
    800045d8:	0001da17          	auipc	s4,0x1d
    800045dc:	088a0a13          	addi	s4,s4,136 # 80021660 <log>
    800045e0:	020a2583          	lw	a1,32(s4)
    800045e4:	012585bb          	addw	a1,a1,s2
    800045e8:	2585                	addiw	a1,a1,1
    800045ea:	030a2503          	lw	a0,48(s4)
    800045ee:	fffff097          	auipc	ra,0xfffff
    800045f2:	cca080e7          	jalr	-822(ra) # 800032b8 <bread>
    800045f6:	84aa                	mv	s1,a0
    struct buf *from = bread(log.dev, log.lh.block[tail]); // cache block
    800045f8:	000aa583          	lw	a1,0(s5)
    800045fc:	030a2503          	lw	a0,48(s4)
    80004600:	fffff097          	auipc	ra,0xfffff
    80004604:	cb8080e7          	jalr	-840(ra) # 800032b8 <bread>
    80004608:	89aa                	mv	s3,a0
    memmove(to->data, from->data, BSIZE);
    8000460a:	40000613          	li	a2,1024
    8000460e:	06050593          	addi	a1,a0,96
    80004612:	06048513          	addi	a0,s1,96
    80004616:	ffffd097          	auipc	ra,0xffffd
    8000461a:	800080e7          	jalr	-2048(ra) # 80000e16 <memmove>
    bwrite(to);  // write the log
    8000461e:	8526                	mv	a0,s1
    80004620:	fffff097          	auipc	ra,0xfffff
    80004624:	d8a080e7          	jalr	-630(ra) # 800033aa <bwrite>
    brelse(from);
    80004628:	854e                	mv	a0,s3
    8000462a:	fffff097          	auipc	ra,0xfffff
    8000462e:	dbe080e7          	jalr	-578(ra) # 800033e8 <brelse>
    brelse(to);
    80004632:	8526                	mv	a0,s1
    80004634:	fffff097          	auipc	ra,0xfffff
    80004638:	db4080e7          	jalr	-588(ra) # 800033e8 <brelse>
  for (tail = 0; tail < log.lh.n; tail++) {
    8000463c:	2905                	addiw	s2,s2,1
    8000463e:	0a91                	addi	s5,s5,4
    80004640:	034a2783          	lw	a5,52(s4)
    80004644:	f8f94ee3          	blt	s2,a5,800045e0 <end_op+0xcc>
    write_log();     // Write modified blocks from cache to log
    write_head();    // Write header to disk -- the real commit
    80004648:	00000097          	auipc	ra,0x0
    8000464c:	c6a080e7          	jalr	-918(ra) # 800042b2 <write_head>
    install_trans(0); // Now install writes to home locations
    80004650:	4501                	li	a0,0
    80004652:	00000097          	auipc	ra,0x0
    80004656:	cda080e7          	jalr	-806(ra) # 8000432c <install_trans>
    log.lh.n = 0;
    8000465a:	0001d797          	auipc	a5,0x1d
    8000465e:	0207ad23          	sw	zero,58(a5) # 80021694 <log+0x34>
    write_head();    // Erase the transaction from the log
    80004662:	00000097          	auipc	ra,0x0
    80004666:	c50080e7          	jalr	-944(ra) # 800042b2 <write_head>
    8000466a:	bdf5                	j	80004566 <end_op+0x52>

000000008000466c <log_write>:
//   modify bp->data[]
//   log_write(bp)
//   brelse(bp)
void
log_write(struct buf *b)
{
    8000466c:	1101                	addi	sp,sp,-32
    8000466e:	ec06                	sd	ra,24(sp)
    80004670:	e822                	sd	s0,16(sp)
    80004672:	e426                	sd	s1,8(sp)
    80004674:	e04a                	sd	s2,0(sp)
    80004676:	1000                	addi	s0,sp,32
    80004678:	84aa                	mv	s1,a0
  int i;

  acquire(&log.lock);
    8000467a:	0001d917          	auipc	s2,0x1d
    8000467e:	fe690913          	addi	s2,s2,-26 # 80021660 <log>
    80004682:	854a                	mv	a0,s2
    80004684:	ffffc097          	auipc	ra,0xffffc
    80004688:	58a080e7          	jalr	1418(ra) # 80000c0e <acquire>
  if (log.lh.n >= LOGSIZE || log.lh.n >= log.size - 1)
    8000468c:	03492603          	lw	a2,52(s2)
    80004690:	47f5                	li	a5,29
    80004692:	06c7c563          	blt	a5,a2,800046fc <log_write+0x90>
    80004696:	0001d797          	auipc	a5,0x1d
    8000469a:	fee7a783          	lw	a5,-18(a5) # 80021684 <log+0x24>
    8000469e:	37fd                	addiw	a5,a5,-1
    800046a0:	04f65e63          	bge	a2,a5,800046fc <log_write+0x90>
    panic("too big a transaction");
  if (log.outstanding < 1)
    800046a4:	0001d797          	auipc	a5,0x1d
    800046a8:	fe47a783          	lw	a5,-28(a5) # 80021688 <log+0x28>
    800046ac:	06f05063          	blez	a5,8000470c <log_write+0xa0>
    panic("log_write outside of trans");

  for (i = 0; i < log.lh.n; i++) {
    800046b0:	4781                	li	a5,0
    800046b2:	06c05563          	blez	a2,8000471c <log_write+0xb0>
    if (log.lh.block[i] == b->blockno)   // log absorption
    800046b6:	44cc                	lw	a1,12(s1)
    800046b8:	0001d717          	auipc	a4,0x1d
    800046bc:	fe070713          	addi	a4,a4,-32 # 80021698 <log+0x38>
  for (i = 0; i < log.lh.n; i++) {
    800046c0:	4781                	li	a5,0
    if (log.lh.block[i] == b->blockno)   // log absorption
    800046c2:	4314                	lw	a3,0(a4)
    800046c4:	04b68c63          	beq	a3,a1,8000471c <log_write+0xb0>
  for (i = 0; i < log.lh.n; i++) {
    800046c8:	2785                	addiw	a5,a5,1
    800046ca:	0711                	addi	a4,a4,4
    800046cc:	fef61be3          	bne	a2,a5,800046c2 <log_write+0x56>
      break;
  }
  log.lh.block[i] = b->blockno;
    800046d0:	0631                	addi	a2,a2,12
    800046d2:	060a                	slli	a2,a2,0x2
    800046d4:	0001d797          	auipc	a5,0x1d
    800046d8:	f8c78793          	addi	a5,a5,-116 # 80021660 <log>
    800046dc:	963e                	add	a2,a2,a5
    800046de:	44dc                	lw	a5,12(s1)
    800046e0:	c61c                	sw	a5,8(a2)
  if (i == log.lh.n) {  // Add new block to log?
    bpin(b);
    800046e2:	8526                	mv	a0,s1
    800046e4:	fffff097          	auipc	ra,0xfffff
    800046e8:	da2080e7          	jalr	-606(ra) # 80003486 <bpin>
    log.lh.n++;
    800046ec:	0001d717          	auipc	a4,0x1d
    800046f0:	f7470713          	addi	a4,a4,-140 # 80021660 <log>
    800046f4:	5b5c                	lw	a5,52(a4)
    800046f6:	2785                	addiw	a5,a5,1
    800046f8:	db5c                	sw	a5,52(a4)
    800046fa:	a835                	j	80004736 <log_write+0xca>
    panic("too big a transaction");
    800046fc:	00004517          	auipc	a0,0x4
    80004700:	1b450513          	addi	a0,a0,436 # 800088b0 <syscall_name+0x210>
    80004704:	ffffc097          	auipc	ra,0xffffc
    80004708:	e40080e7          	jalr	-448(ra) # 80000544 <panic>
    panic("log_write outside of trans");
    8000470c:	00004517          	auipc	a0,0x4
    80004710:	1bc50513          	addi	a0,a0,444 # 800088c8 <syscall_name+0x228>
    80004714:	ffffc097          	auipc	ra,0xffffc
    80004718:	e30080e7          	jalr	-464(ra) # 80000544 <panic>
  log.lh.block[i] = b->blockno;
    8000471c:	00c78713          	addi	a4,a5,12
    80004720:	00271693          	slli	a3,a4,0x2
    80004724:	0001d717          	auipc	a4,0x1d
    80004728:	f3c70713          	addi	a4,a4,-196 # 80021660 <log>
    8000472c:	9736                	add	a4,a4,a3
    8000472e:	44d4                	lw	a3,12(s1)
    80004730:	c714                	sw	a3,8(a4)
  if (i == log.lh.n) {  // Add new block to log?
    80004732:	faf608e3          	beq	a2,a5,800046e2 <log_write+0x76>
  }
  release(&log.lock);
    80004736:	0001d517          	auipc	a0,0x1d
    8000473a:	f2a50513          	addi	a0,a0,-214 # 80021660 <log>
    8000473e:	ffffc097          	auipc	ra,0xffffc
    80004742:	62a080e7          	jalr	1578(ra) # 80000d68 <release>
}
    80004746:	60e2                	ld	ra,24(sp)
    80004748:	6442                	ld	s0,16(sp)
    8000474a:	64a2                	ld	s1,8(sp)
    8000474c:	6902                	ld	s2,0(sp)
    8000474e:	6105                	addi	sp,sp,32
    80004750:	8082                	ret

0000000080004752 <initsleeplock>:
#include "proc.h"
#include "sleeplock.h"

void
initsleeplock(struct sleeplock *lk, char *name)
{
    80004752:	1101                	addi	sp,sp,-32
    80004754:	ec06                	sd	ra,24(sp)
    80004756:	e822                	sd	s0,16(sp)
    80004758:	e426                	sd	s1,8(sp)
    8000475a:	e04a                	sd	s2,0(sp)
    8000475c:	1000                	addi	s0,sp,32
    8000475e:	84aa                	mv	s1,a0
    80004760:	892e                	mv	s2,a1
  initlock(&lk->lk, "sleep lock");
    80004762:	00004597          	auipc	a1,0x4
    80004766:	18658593          	addi	a1,a1,390 # 800088e8 <syscall_name+0x248>
    8000476a:	0521                	addi	a0,a0,8
    8000476c:	ffffc097          	auipc	ra,0xffffc
    80004770:	438080e7          	jalr	1080(ra) # 80000ba4 <initlock>
  lk->name = name;
    80004774:	0324b423          	sd	s2,40(s1)
  lk->locked = 0;
    80004778:	0004a023          	sw	zero,0(s1)
  lk->pid = 0;
    8000477c:	0204a823          	sw	zero,48(s1)
}
    80004780:	60e2                	ld	ra,24(sp)
    80004782:	6442                	ld	s0,16(sp)
    80004784:	64a2                	ld	s1,8(sp)
    80004786:	6902                	ld	s2,0(sp)
    80004788:	6105                	addi	sp,sp,32
    8000478a:	8082                	ret

000000008000478c <acquiresleep>:

void
acquiresleep(struct sleeplock *lk)
{
    8000478c:	1101                	addi	sp,sp,-32
    8000478e:	ec06                	sd	ra,24(sp)
    80004790:	e822                	sd	s0,16(sp)
    80004792:	e426                	sd	s1,8(sp)
    80004794:	e04a                	sd	s2,0(sp)
    80004796:	1000                	addi	s0,sp,32
    80004798:	84aa                	mv	s1,a0
  acquire(&lk->lk);
    8000479a:	00850913          	addi	s2,a0,8
    8000479e:	854a                	mv	a0,s2
    800047a0:	ffffc097          	auipc	ra,0xffffc
    800047a4:	46e080e7          	jalr	1134(ra) # 80000c0e <acquire>
  while (lk->locked) {
    800047a8:	409c                	lw	a5,0(s1)
    800047aa:	cb89                	beqz	a5,800047bc <acquiresleep+0x30>
    sleep(lk, &lk->lk);
    800047ac:	85ca                	mv	a1,s2
    800047ae:	8526                	mv	a0,s1
    800047b0:	ffffe097          	auipc	ra,0xffffe
    800047b4:	ad0080e7          	jalr	-1328(ra) # 80002280 <sleep>
  while (lk->locked) {
    800047b8:	409c                	lw	a5,0(s1)
    800047ba:	fbed                	bnez	a5,800047ac <acquiresleep+0x20>
  }
  lk->locked = 1;
    800047bc:	4785                	li	a5,1
    800047be:	c09c                	sw	a5,0(s1)
  lk->pid = myproc()->pid;
    800047c0:	ffffd097          	auipc	ra,0xffffd
    800047c4:	2d6080e7          	jalr	726(ra) # 80001a96 <myproc>
    800047c8:	5d1c                	lw	a5,56(a0)
    800047ca:	d89c                	sw	a5,48(s1)
  release(&lk->lk);
    800047cc:	854a                	mv	a0,s2
    800047ce:	ffffc097          	auipc	ra,0xffffc
    800047d2:	59a080e7          	jalr	1434(ra) # 80000d68 <release>
}
    800047d6:	60e2                	ld	ra,24(sp)
    800047d8:	6442                	ld	s0,16(sp)
    800047da:	64a2                	ld	s1,8(sp)
    800047dc:	6902                	ld	s2,0(sp)
    800047de:	6105                	addi	sp,sp,32
    800047e0:	8082                	ret

00000000800047e2 <releasesleep>:

void
releasesleep(struct sleeplock *lk)
{
    800047e2:	1101                	addi	sp,sp,-32
    800047e4:	ec06                	sd	ra,24(sp)
    800047e6:	e822                	sd	s0,16(sp)
    800047e8:	e426                	sd	s1,8(sp)
    800047ea:	e04a                	sd	s2,0(sp)
    800047ec:	1000                	addi	s0,sp,32
    800047ee:	84aa                	mv	s1,a0
  acquire(&lk->lk);
    800047f0:	00850913          	addi	s2,a0,8
    800047f4:	854a                	mv	a0,s2
    800047f6:	ffffc097          	auipc	ra,0xffffc
    800047fa:	418080e7          	jalr	1048(ra) # 80000c0e <acquire>
  lk->locked = 0;
    800047fe:	0004a023          	sw	zero,0(s1)
  lk->pid = 0;
    80004802:	0204a823          	sw	zero,48(s1)
  wakeup(lk);
    80004806:	8526                	mv	a0,s1
    80004808:	ffffe097          	auipc	ra,0xffffe
    8000480c:	adc080e7          	jalr	-1316(ra) # 800022e4 <wakeup>
  release(&lk->lk);
    80004810:	854a                	mv	a0,s2
    80004812:	ffffc097          	auipc	ra,0xffffc
    80004816:	556080e7          	jalr	1366(ra) # 80000d68 <release>
}
    8000481a:	60e2                	ld	ra,24(sp)
    8000481c:	6442                	ld	s0,16(sp)
    8000481e:	64a2                	ld	s1,8(sp)
    80004820:	6902                	ld	s2,0(sp)
    80004822:	6105                	addi	sp,sp,32
    80004824:	8082                	ret

0000000080004826 <holdingsleep>:

int
holdingsleep(struct sleeplock *lk)
{
    80004826:	7179                	addi	sp,sp,-48
    80004828:	f406                	sd	ra,40(sp)
    8000482a:	f022                	sd	s0,32(sp)
    8000482c:	ec26                	sd	s1,24(sp)
    8000482e:	e84a                	sd	s2,16(sp)
    80004830:	e44e                	sd	s3,8(sp)
    80004832:	1800                	addi	s0,sp,48
    80004834:	84aa                	mv	s1,a0
  int r;
  
  acquire(&lk->lk);
    80004836:	00850913          	addi	s2,a0,8
    8000483a:	854a                	mv	a0,s2
    8000483c:	ffffc097          	auipc	ra,0xffffc
    80004840:	3d2080e7          	jalr	978(ra) # 80000c0e <acquire>
  r = lk->locked && (lk->pid == myproc()->pid);
    80004844:	409c                	lw	a5,0(s1)
    80004846:	ef99                	bnez	a5,80004864 <holdingsleep+0x3e>
    80004848:	4481                	li	s1,0
  release(&lk->lk);
    8000484a:	854a                	mv	a0,s2
    8000484c:	ffffc097          	auipc	ra,0xffffc
    80004850:	51c080e7          	jalr	1308(ra) # 80000d68 <release>
  return r;
}
    80004854:	8526                	mv	a0,s1
    80004856:	70a2                	ld	ra,40(sp)
    80004858:	7402                	ld	s0,32(sp)
    8000485a:	64e2                	ld	s1,24(sp)
    8000485c:	6942                	ld	s2,16(sp)
    8000485e:	69a2                	ld	s3,8(sp)
    80004860:	6145                	addi	sp,sp,48
    80004862:	8082                	ret
  r = lk->locked && (lk->pid == myproc()->pid);
    80004864:	0304a983          	lw	s3,48(s1)
    80004868:	ffffd097          	auipc	ra,0xffffd
    8000486c:	22e080e7          	jalr	558(ra) # 80001a96 <myproc>
    80004870:	5d04                	lw	s1,56(a0)
    80004872:	413484b3          	sub	s1,s1,s3
    80004876:	0014b493          	seqz	s1,s1
    8000487a:	bfc1                	j	8000484a <holdingsleep+0x24>

000000008000487c <fileinit>:
  struct file file[NFILE];
} ftable;

void
fileinit(void)
{
    8000487c:	1141                	addi	sp,sp,-16
    8000487e:	e406                	sd	ra,8(sp)
    80004880:	e022                	sd	s0,0(sp)
    80004882:	0800                	addi	s0,sp,16
  initlock(&ftable.lock, "ftable");
    80004884:	00004597          	auipc	a1,0x4
    80004888:	07458593          	addi	a1,a1,116 # 800088f8 <syscall_name+0x258>
    8000488c:	0001d517          	auipc	a0,0x1d
    80004890:	f2450513          	addi	a0,a0,-220 # 800217b0 <ftable>
    80004894:	ffffc097          	auipc	ra,0xffffc
    80004898:	310080e7          	jalr	784(ra) # 80000ba4 <initlock>
}
    8000489c:	60a2                	ld	ra,8(sp)
    8000489e:	6402                	ld	s0,0(sp)
    800048a0:	0141                	addi	sp,sp,16
    800048a2:	8082                	ret

00000000800048a4 <filealloc>:

// Allocate a file structure.
struct file*
filealloc(void)
{
    800048a4:	1101                	addi	sp,sp,-32
    800048a6:	ec06                	sd	ra,24(sp)
    800048a8:	e822                	sd	s0,16(sp)
    800048aa:	e426                	sd	s1,8(sp)
    800048ac:	1000                	addi	s0,sp,32
  struct file *f;

  acquire(&ftable.lock);
    800048ae:	0001d517          	auipc	a0,0x1d
    800048b2:	f0250513          	addi	a0,a0,-254 # 800217b0 <ftable>
    800048b6:	ffffc097          	auipc	ra,0xffffc
    800048ba:	358080e7          	jalr	856(ra) # 80000c0e <acquire>
  for(f = ftable.file; f < ftable.file + NFILE; f++){
    800048be:	0001d497          	auipc	s1,0x1d
    800048c2:	f1248493          	addi	s1,s1,-238 # 800217d0 <ftable+0x20>
    800048c6:	0001e717          	auipc	a4,0x1e
    800048ca:	eaa70713          	addi	a4,a4,-342 # 80022770 <disk>
    if(f->ref == 0){
    800048ce:	40dc                	lw	a5,4(s1)
    800048d0:	cf99                	beqz	a5,800048ee <filealloc+0x4a>
  for(f = ftable.file; f < ftable.file + NFILE; f++){
    800048d2:	02848493          	addi	s1,s1,40
    800048d6:	fee49ce3          	bne	s1,a4,800048ce <filealloc+0x2a>
      f->ref = 1;
      release(&ftable.lock);
      return f;
    }
  }
  release(&ftable.lock);
    800048da:	0001d517          	auipc	a0,0x1d
    800048de:	ed650513          	addi	a0,a0,-298 # 800217b0 <ftable>
    800048e2:	ffffc097          	auipc	ra,0xffffc
    800048e6:	486080e7          	jalr	1158(ra) # 80000d68 <release>
  return 0;
    800048ea:	4481                	li	s1,0
    800048ec:	a819                	j	80004902 <filealloc+0x5e>
      f->ref = 1;
    800048ee:	4785                	li	a5,1
    800048f0:	c0dc                	sw	a5,4(s1)
      release(&ftable.lock);
    800048f2:	0001d517          	auipc	a0,0x1d
    800048f6:	ebe50513          	addi	a0,a0,-322 # 800217b0 <ftable>
    800048fa:	ffffc097          	auipc	ra,0xffffc
    800048fe:	46e080e7          	jalr	1134(ra) # 80000d68 <release>
}
    80004902:	8526                	mv	a0,s1
    80004904:	60e2                	ld	ra,24(sp)
    80004906:	6442                	ld	s0,16(sp)
    80004908:	64a2                	ld	s1,8(sp)
    8000490a:	6105                	addi	sp,sp,32
    8000490c:	8082                	ret

000000008000490e <filedup>:

// Increment ref count for file f.
struct file*
filedup(struct file *f)
{
    8000490e:	1101                	addi	sp,sp,-32
    80004910:	ec06                	sd	ra,24(sp)
    80004912:	e822                	sd	s0,16(sp)
    80004914:	e426                	sd	s1,8(sp)
    80004916:	1000                	addi	s0,sp,32
    80004918:	84aa                	mv	s1,a0
  acquire(&ftable.lock);
    8000491a:	0001d517          	auipc	a0,0x1d
    8000491e:	e9650513          	addi	a0,a0,-362 # 800217b0 <ftable>
    80004922:	ffffc097          	auipc	ra,0xffffc
    80004926:	2ec080e7          	jalr	748(ra) # 80000c0e <acquire>
  if(f->ref < 1)
    8000492a:	40dc                	lw	a5,4(s1)
    8000492c:	02f05263          	blez	a5,80004950 <filedup+0x42>
    panic("filedup");
  f->ref++;
    80004930:	2785                	addiw	a5,a5,1
    80004932:	c0dc                	sw	a5,4(s1)
  release(&ftable.lock);
    80004934:	0001d517          	auipc	a0,0x1d
    80004938:	e7c50513          	addi	a0,a0,-388 # 800217b0 <ftable>
    8000493c:	ffffc097          	auipc	ra,0xffffc
    80004940:	42c080e7          	jalr	1068(ra) # 80000d68 <release>
  return f;
}
    80004944:	8526                	mv	a0,s1
    80004946:	60e2                	ld	ra,24(sp)
    80004948:	6442                	ld	s0,16(sp)
    8000494a:	64a2                	ld	s1,8(sp)
    8000494c:	6105                	addi	sp,sp,32
    8000494e:	8082                	ret
    panic("filedup");
    80004950:	00004517          	auipc	a0,0x4
    80004954:	fb050513          	addi	a0,a0,-80 # 80008900 <syscall_name+0x260>
    80004958:	ffffc097          	auipc	ra,0xffffc
    8000495c:	bec080e7          	jalr	-1044(ra) # 80000544 <panic>

0000000080004960 <fileclose>:

// Close file f.  (Decrement ref count, close when reaches 0.)
void
fileclose(struct file *f)
{
    80004960:	7139                	addi	sp,sp,-64
    80004962:	fc06                	sd	ra,56(sp)
    80004964:	f822                	sd	s0,48(sp)
    80004966:	f426                	sd	s1,40(sp)
    80004968:	f04a                	sd	s2,32(sp)
    8000496a:	ec4e                	sd	s3,24(sp)
    8000496c:	e852                	sd	s4,16(sp)
    8000496e:	e456                	sd	s5,8(sp)
    80004970:	0080                	addi	s0,sp,64
    80004972:	84aa                	mv	s1,a0
  struct file ff;

  acquire(&ftable.lock);
    80004974:	0001d517          	auipc	a0,0x1d
    80004978:	e3c50513          	addi	a0,a0,-452 # 800217b0 <ftable>
    8000497c:	ffffc097          	auipc	ra,0xffffc
    80004980:	292080e7          	jalr	658(ra) # 80000c0e <acquire>
  if(f->ref < 1)
    80004984:	40dc                	lw	a5,4(s1)
    80004986:	06f05163          	blez	a5,800049e8 <fileclose+0x88>
    panic("fileclose");
  if(--f->ref > 0){
    8000498a:	37fd                	addiw	a5,a5,-1
    8000498c:	0007871b          	sext.w	a4,a5
    80004990:	c0dc                	sw	a5,4(s1)
    80004992:	06e04363          	bgtz	a4,800049f8 <fileclose+0x98>
    release(&ftable.lock);
    return;
  }
  ff = *f;
    80004996:	0004a903          	lw	s2,0(s1)
    8000499a:	0094ca83          	lbu	s5,9(s1)
    8000499e:	0104ba03          	ld	s4,16(s1)
    800049a2:	0184b983          	ld	s3,24(s1)
  f->ref = 0;
    800049a6:	0004a223          	sw	zero,4(s1)
  f->type = FD_NONE;
    800049aa:	0004a023          	sw	zero,0(s1)
  release(&ftable.lock);
    800049ae:	0001d517          	auipc	a0,0x1d
    800049b2:	e0250513          	addi	a0,a0,-510 # 800217b0 <ftable>
    800049b6:	ffffc097          	auipc	ra,0xffffc
    800049ba:	3b2080e7          	jalr	946(ra) # 80000d68 <release>

  if(ff.type == FD_PIPE){
    800049be:	4785                	li	a5,1
    800049c0:	04f90d63          	beq	s2,a5,80004a1a <fileclose+0xba>
    pipeclose(ff.pipe, ff.writable);
  } else if(ff.type == FD_INODE || ff.type == FD_DEVICE){
    800049c4:	3979                	addiw	s2,s2,-2
    800049c6:	4785                	li	a5,1
    800049c8:	0527e063          	bltu	a5,s2,80004a08 <fileclose+0xa8>
    begin_op();
    800049cc:	00000097          	auipc	ra,0x0
    800049d0:	ac8080e7          	jalr	-1336(ra) # 80004494 <begin_op>
    iput(ff.ip);
    800049d4:	854e                	mv	a0,s3
    800049d6:	fffff097          	auipc	ra,0xfffff
    800049da:	2b6080e7          	jalr	694(ra) # 80003c8c <iput>
    end_op();
    800049de:	00000097          	auipc	ra,0x0
    800049e2:	b36080e7          	jalr	-1226(ra) # 80004514 <end_op>
    800049e6:	a00d                	j	80004a08 <fileclose+0xa8>
    panic("fileclose");
    800049e8:	00004517          	auipc	a0,0x4
    800049ec:	f2050513          	addi	a0,a0,-224 # 80008908 <syscall_name+0x268>
    800049f0:	ffffc097          	auipc	ra,0xffffc
    800049f4:	b54080e7          	jalr	-1196(ra) # 80000544 <panic>
    release(&ftable.lock);
    800049f8:	0001d517          	auipc	a0,0x1d
    800049fc:	db850513          	addi	a0,a0,-584 # 800217b0 <ftable>
    80004a00:	ffffc097          	auipc	ra,0xffffc
    80004a04:	368080e7          	jalr	872(ra) # 80000d68 <release>
  }
}
    80004a08:	70e2                	ld	ra,56(sp)
    80004a0a:	7442                	ld	s0,48(sp)
    80004a0c:	74a2                	ld	s1,40(sp)
    80004a0e:	7902                	ld	s2,32(sp)
    80004a10:	69e2                	ld	s3,24(sp)
    80004a12:	6a42                	ld	s4,16(sp)
    80004a14:	6aa2                	ld	s5,8(sp)
    80004a16:	6121                	addi	sp,sp,64
    80004a18:	8082                	ret
    pipeclose(ff.pipe, ff.writable);
    80004a1a:	85d6                	mv	a1,s5
    80004a1c:	8552                	mv	a0,s4
    80004a1e:	00000097          	auipc	ra,0x0
    80004a22:	34c080e7          	jalr	844(ra) # 80004d6a <pipeclose>
    80004a26:	b7cd                	j	80004a08 <fileclose+0xa8>

0000000080004a28 <filestat>:

// Get metadata about file f.
// addr is a user virtual address, pointing to a struct stat.
int
filestat(struct file *f, uint64 addr)
{
    80004a28:	715d                	addi	sp,sp,-80
    80004a2a:	e486                	sd	ra,72(sp)
    80004a2c:	e0a2                	sd	s0,64(sp)
    80004a2e:	fc26                	sd	s1,56(sp)
    80004a30:	f84a                	sd	s2,48(sp)
    80004a32:	f44e                	sd	s3,40(sp)
    80004a34:	0880                	addi	s0,sp,80
    80004a36:	84aa                	mv	s1,a0
    80004a38:	89ae                	mv	s3,a1
  struct proc *p = myproc();
    80004a3a:	ffffd097          	auipc	ra,0xffffd
    80004a3e:	05c080e7          	jalr	92(ra) # 80001a96 <myproc>
  struct stat st;
  
  if(f->type == FD_INODE || f->type == FD_DEVICE){
    80004a42:	409c                	lw	a5,0(s1)
    80004a44:	37f9                	addiw	a5,a5,-2
    80004a46:	4705                	li	a4,1
    80004a48:	04f76763          	bltu	a4,a5,80004a96 <filestat+0x6e>
    80004a4c:	892a                	mv	s2,a0
    ilock(f->ip);
    80004a4e:	6c88                	ld	a0,24(s1)
    80004a50:	fffff097          	auipc	ra,0xfffff
    80004a54:	082080e7          	jalr	130(ra) # 80003ad2 <ilock>
    stati(f->ip, &st);
    80004a58:	fb840593          	addi	a1,s0,-72
    80004a5c:	6c88                	ld	a0,24(s1)
    80004a5e:	fffff097          	auipc	ra,0xfffff
    80004a62:	2fe080e7          	jalr	766(ra) # 80003d5c <stati>
    iunlock(f->ip);
    80004a66:	6c88                	ld	a0,24(s1)
    80004a68:	fffff097          	auipc	ra,0xfffff
    80004a6c:	12c080e7          	jalr	300(ra) # 80003b94 <iunlock>
    if(copyout(p->pagetable, addr, (char *)&st, sizeof(st)) < 0)
    80004a70:	46e1                	li	a3,24
    80004a72:	fb840613          	addi	a2,s0,-72
    80004a76:	85ce                	mv	a1,s3
    80004a78:	06093503          	ld	a0,96(s2)
    80004a7c:	ffffd097          	auipc	ra,0xffffd
    80004a80:	cd8080e7          	jalr	-808(ra) # 80001754 <copyout>
    80004a84:	41f5551b          	sraiw	a0,a0,0x1f
      return -1;
    return 0;
  }
  return -1;
}
    80004a88:	60a6                	ld	ra,72(sp)
    80004a8a:	6406                	ld	s0,64(sp)
    80004a8c:	74e2                	ld	s1,56(sp)
    80004a8e:	7942                	ld	s2,48(sp)
    80004a90:	79a2                	ld	s3,40(sp)
    80004a92:	6161                	addi	sp,sp,80
    80004a94:	8082                	ret
  return -1;
    80004a96:	557d                	li	a0,-1
    80004a98:	bfc5                	j	80004a88 <filestat+0x60>

0000000080004a9a <fileread>:

// Read from file f.
// addr is a user virtual address.
int
fileread(struct file *f, uint64 addr, int n)
{
    80004a9a:	7179                	addi	sp,sp,-48
    80004a9c:	f406                	sd	ra,40(sp)
    80004a9e:	f022                	sd	s0,32(sp)
    80004aa0:	ec26                	sd	s1,24(sp)
    80004aa2:	e84a                	sd	s2,16(sp)
    80004aa4:	e44e                	sd	s3,8(sp)
    80004aa6:	1800                	addi	s0,sp,48
  int r = 0;

  if(f->readable == 0)
    80004aa8:	00854783          	lbu	a5,8(a0)
    80004aac:	c3d5                	beqz	a5,80004b50 <fileread+0xb6>
    80004aae:	84aa                	mv	s1,a0
    80004ab0:	89ae                	mv	s3,a1
    80004ab2:	8932                	mv	s2,a2
    return -1;

  if(f->type == FD_PIPE){
    80004ab4:	411c                	lw	a5,0(a0)
    80004ab6:	4705                	li	a4,1
    80004ab8:	04e78963          	beq	a5,a4,80004b0a <fileread+0x70>
    r = piperead(f->pipe, addr, n);
  } else if(f->type == FD_DEVICE){
    80004abc:	470d                	li	a4,3
    80004abe:	04e78d63          	beq	a5,a4,80004b18 <fileread+0x7e>
    if(f->major < 0 || f->major >= NDEV || !devsw[f->major].read)
      return -1;
    r = devsw[f->major].read(1, addr, n);
  } else if(f->type == FD_INODE){
    80004ac2:	4709                	li	a4,2
    80004ac4:	06e79e63          	bne	a5,a4,80004b40 <fileread+0xa6>
    ilock(f->ip);
    80004ac8:	6d08                	ld	a0,24(a0)
    80004aca:	fffff097          	auipc	ra,0xfffff
    80004ace:	008080e7          	jalr	8(ra) # 80003ad2 <ilock>
    if((r = readi(f->ip, 1, addr, f->off, n)) > 0)
    80004ad2:	874a                	mv	a4,s2
    80004ad4:	5094                	lw	a3,32(s1)
    80004ad6:	864e                	mv	a2,s3
    80004ad8:	4585                	li	a1,1
    80004ada:	6c88                	ld	a0,24(s1)
    80004adc:	fffff097          	auipc	ra,0xfffff
    80004ae0:	2aa080e7          	jalr	682(ra) # 80003d86 <readi>
    80004ae4:	892a                	mv	s2,a0
    80004ae6:	00a05563          	blez	a0,80004af0 <fileread+0x56>
      f->off += r;
    80004aea:	509c                	lw	a5,32(s1)
    80004aec:	9fa9                	addw	a5,a5,a0
    80004aee:	d09c                	sw	a5,32(s1)
    iunlock(f->ip);
    80004af0:	6c88                	ld	a0,24(s1)
    80004af2:	fffff097          	auipc	ra,0xfffff
    80004af6:	0a2080e7          	jalr	162(ra) # 80003b94 <iunlock>
  } else {
    panic("fileread");
  }

  return r;
}
    80004afa:	854a                	mv	a0,s2
    80004afc:	70a2                	ld	ra,40(sp)
    80004afe:	7402                	ld	s0,32(sp)
    80004b00:	64e2                	ld	s1,24(sp)
    80004b02:	6942                	ld	s2,16(sp)
    80004b04:	69a2                	ld	s3,8(sp)
    80004b06:	6145                	addi	sp,sp,48
    80004b08:	8082                	ret
    r = piperead(f->pipe, addr, n);
    80004b0a:	6908                	ld	a0,16(a0)
    80004b0c:	00000097          	auipc	ra,0x0
    80004b10:	3ce080e7          	jalr	974(ra) # 80004eda <piperead>
    80004b14:	892a                	mv	s2,a0
    80004b16:	b7d5                	j	80004afa <fileread+0x60>
    if(f->major < 0 || f->major >= NDEV || !devsw[f->major].read)
    80004b18:	02451783          	lh	a5,36(a0)
    80004b1c:	03079693          	slli	a3,a5,0x30
    80004b20:	92c1                	srli	a3,a3,0x30
    80004b22:	4725                	li	a4,9
    80004b24:	02d76863          	bltu	a4,a3,80004b54 <fileread+0xba>
    80004b28:	0792                	slli	a5,a5,0x4
    80004b2a:	0001d717          	auipc	a4,0x1d
    80004b2e:	be670713          	addi	a4,a4,-1050 # 80021710 <devsw>
    80004b32:	97ba                	add	a5,a5,a4
    80004b34:	639c                	ld	a5,0(a5)
    80004b36:	c38d                	beqz	a5,80004b58 <fileread+0xbe>
    r = devsw[f->major].read(1, addr, n);
    80004b38:	4505                	li	a0,1
    80004b3a:	9782                	jalr	a5
    80004b3c:	892a                	mv	s2,a0
    80004b3e:	bf75                	j	80004afa <fileread+0x60>
    panic("fileread");
    80004b40:	00004517          	auipc	a0,0x4
    80004b44:	dd850513          	addi	a0,a0,-552 # 80008918 <syscall_name+0x278>
    80004b48:	ffffc097          	auipc	ra,0xffffc
    80004b4c:	9fc080e7          	jalr	-1540(ra) # 80000544 <panic>
    return -1;
    80004b50:	597d                	li	s2,-1
    80004b52:	b765                	j	80004afa <fileread+0x60>
      return -1;
    80004b54:	597d                	li	s2,-1
    80004b56:	b755                	j	80004afa <fileread+0x60>
    80004b58:	597d                	li	s2,-1
    80004b5a:	b745                	j	80004afa <fileread+0x60>

0000000080004b5c <filewrite>:

// Write to file f.
// addr is a user virtual address.
int
filewrite(struct file *f, uint64 addr, int n)
{
    80004b5c:	715d                	addi	sp,sp,-80
    80004b5e:	e486                	sd	ra,72(sp)
    80004b60:	e0a2                	sd	s0,64(sp)
    80004b62:	fc26                	sd	s1,56(sp)
    80004b64:	f84a                	sd	s2,48(sp)
    80004b66:	f44e                	sd	s3,40(sp)
    80004b68:	f052                	sd	s4,32(sp)
    80004b6a:	ec56                	sd	s5,24(sp)
    80004b6c:	e85a                	sd	s6,16(sp)
    80004b6e:	e45e                	sd	s7,8(sp)
    80004b70:	e062                	sd	s8,0(sp)
    80004b72:	0880                	addi	s0,sp,80
  int r, ret = 0;

  if(f->writable == 0)
    80004b74:	00954783          	lbu	a5,9(a0)
    80004b78:	10078663          	beqz	a5,80004c84 <filewrite+0x128>
    80004b7c:	892a                	mv	s2,a0
    80004b7e:	8aae                	mv	s5,a1
    80004b80:	8a32                	mv	s4,a2
    return -1;

  if(f->type == FD_PIPE){
    80004b82:	411c                	lw	a5,0(a0)
    80004b84:	4705                	li	a4,1
    80004b86:	02e78263          	beq	a5,a4,80004baa <filewrite+0x4e>
    ret = pipewrite(f->pipe, addr, n);
  } else if(f->type == FD_DEVICE){
    80004b8a:	470d                	li	a4,3
    80004b8c:	02e78663          	beq	a5,a4,80004bb8 <filewrite+0x5c>
    if(f->major < 0 || f->major >= NDEV || !devsw[f->major].write)
      return -1;
    ret = devsw[f->major].write(1, addr, n);
  } else if(f->type == FD_INODE){
    80004b90:	4709                	li	a4,2
    80004b92:	0ee79163          	bne	a5,a4,80004c74 <filewrite+0x118>
    // and 2 blocks of slop for non-aligned writes.
    // this really belongs lower down, since writei()
    // might be writing a device like the console.
    int max = ((MAXOPBLOCKS-1-1-2) / 2) * BSIZE;
    int i = 0;
    while(i < n){
    80004b96:	0ac05d63          	blez	a2,80004c50 <filewrite+0xf4>
    int i = 0;
    80004b9a:	4981                	li	s3,0
    80004b9c:	6b05                	lui	s6,0x1
    80004b9e:	c00b0b13          	addi	s6,s6,-1024 # c00 <_entry-0x7ffff400>
    80004ba2:	6b85                	lui	s7,0x1
    80004ba4:	c00b8b9b          	addiw	s7,s7,-1024
    80004ba8:	a861                	j	80004c40 <filewrite+0xe4>
    ret = pipewrite(f->pipe, addr, n);
    80004baa:	6908                	ld	a0,16(a0)
    80004bac:	00000097          	auipc	ra,0x0
    80004bb0:	22e080e7          	jalr	558(ra) # 80004dda <pipewrite>
    80004bb4:	8a2a                	mv	s4,a0
    80004bb6:	a045                	j	80004c56 <filewrite+0xfa>
    if(f->major < 0 || f->major >= NDEV || !devsw[f->major].write)
    80004bb8:	02451783          	lh	a5,36(a0)
    80004bbc:	03079693          	slli	a3,a5,0x30
    80004bc0:	92c1                	srli	a3,a3,0x30
    80004bc2:	4725                	li	a4,9
    80004bc4:	0cd76263          	bltu	a4,a3,80004c88 <filewrite+0x12c>
    80004bc8:	0792                	slli	a5,a5,0x4
    80004bca:	0001d717          	auipc	a4,0x1d
    80004bce:	b4670713          	addi	a4,a4,-1210 # 80021710 <devsw>
    80004bd2:	97ba                	add	a5,a5,a4
    80004bd4:	679c                	ld	a5,8(a5)
    80004bd6:	cbdd                	beqz	a5,80004c8c <filewrite+0x130>
    ret = devsw[f->major].write(1, addr, n);
    80004bd8:	4505                	li	a0,1
    80004bda:	9782                	jalr	a5
    80004bdc:	8a2a                	mv	s4,a0
    80004bde:	a8a5                	j	80004c56 <filewrite+0xfa>
    80004be0:	00048c1b          	sext.w	s8,s1
      int n1 = n - i;
      if(n1 > max)
        n1 = max;

      begin_op();
    80004be4:	00000097          	auipc	ra,0x0
    80004be8:	8b0080e7          	jalr	-1872(ra) # 80004494 <begin_op>
      ilock(f->ip);
    80004bec:	01893503          	ld	a0,24(s2)
    80004bf0:	fffff097          	auipc	ra,0xfffff
    80004bf4:	ee2080e7          	jalr	-286(ra) # 80003ad2 <ilock>
      if ((r = writei(f->ip, 1, addr + i, f->off, n1)) > 0)
    80004bf8:	8762                	mv	a4,s8
    80004bfa:	02092683          	lw	a3,32(s2)
    80004bfe:	01598633          	add	a2,s3,s5
    80004c02:	4585                	li	a1,1
    80004c04:	01893503          	ld	a0,24(s2)
    80004c08:	fffff097          	auipc	ra,0xfffff
    80004c0c:	276080e7          	jalr	630(ra) # 80003e7e <writei>
    80004c10:	84aa                	mv	s1,a0
    80004c12:	00a05763          	blez	a0,80004c20 <filewrite+0xc4>
        f->off += r;
    80004c16:	02092783          	lw	a5,32(s2)
    80004c1a:	9fa9                	addw	a5,a5,a0
    80004c1c:	02f92023          	sw	a5,32(s2)
      iunlock(f->ip);
    80004c20:	01893503          	ld	a0,24(s2)
    80004c24:	fffff097          	auipc	ra,0xfffff
    80004c28:	f70080e7          	jalr	-144(ra) # 80003b94 <iunlock>
      end_op();
    80004c2c:	00000097          	auipc	ra,0x0
    80004c30:	8e8080e7          	jalr	-1816(ra) # 80004514 <end_op>

      if(r != n1){
    80004c34:	009c1f63          	bne	s8,s1,80004c52 <filewrite+0xf6>
        // error from writei
        break;
      }
      i += r;
    80004c38:	013489bb          	addw	s3,s1,s3
    while(i < n){
    80004c3c:	0149db63          	bge	s3,s4,80004c52 <filewrite+0xf6>
      int n1 = n - i;
    80004c40:	413a07bb          	subw	a5,s4,s3
      if(n1 > max)
    80004c44:	84be                	mv	s1,a5
    80004c46:	2781                	sext.w	a5,a5
    80004c48:	f8fb5ce3          	bge	s6,a5,80004be0 <filewrite+0x84>
    80004c4c:	84de                	mv	s1,s7
    80004c4e:	bf49                	j	80004be0 <filewrite+0x84>
    int i = 0;
    80004c50:	4981                	li	s3,0
    }
    ret = (i == n ? n : -1);
    80004c52:	013a1f63          	bne	s4,s3,80004c70 <filewrite+0x114>
  } else {
    panic("filewrite");
  }

  return ret;
}
    80004c56:	8552                	mv	a0,s4
    80004c58:	60a6                	ld	ra,72(sp)
    80004c5a:	6406                	ld	s0,64(sp)
    80004c5c:	74e2                	ld	s1,56(sp)
    80004c5e:	7942                	ld	s2,48(sp)
    80004c60:	79a2                	ld	s3,40(sp)
    80004c62:	7a02                	ld	s4,32(sp)
    80004c64:	6ae2                	ld	s5,24(sp)
    80004c66:	6b42                	ld	s6,16(sp)
    80004c68:	6ba2                	ld	s7,8(sp)
    80004c6a:	6c02                	ld	s8,0(sp)
    80004c6c:	6161                	addi	sp,sp,80
    80004c6e:	8082                	ret
    ret = (i == n ? n : -1);
    80004c70:	5a7d                	li	s4,-1
    80004c72:	b7d5                	j	80004c56 <filewrite+0xfa>
    panic("filewrite");
    80004c74:	00004517          	auipc	a0,0x4
    80004c78:	cb450513          	addi	a0,a0,-844 # 80008928 <syscall_name+0x288>
    80004c7c:	ffffc097          	auipc	ra,0xffffc
    80004c80:	8c8080e7          	jalr	-1848(ra) # 80000544 <panic>
    return -1;
    80004c84:	5a7d                	li	s4,-1
    80004c86:	bfc1                	j	80004c56 <filewrite+0xfa>
      return -1;
    80004c88:	5a7d                	li	s4,-1
    80004c8a:	b7f1                	j	80004c56 <filewrite+0xfa>
    80004c8c:	5a7d                	li	s4,-1
    80004c8e:	b7e1                	j	80004c56 <filewrite+0xfa>

0000000080004c90 <pipealloc>:
  int writeopen;  // write fd is still open
};

int
pipealloc(struct file **f0, struct file **f1)
{
    80004c90:	7179                	addi	sp,sp,-48
    80004c92:	f406                	sd	ra,40(sp)
    80004c94:	f022                	sd	s0,32(sp)
    80004c96:	ec26                	sd	s1,24(sp)
    80004c98:	e84a                	sd	s2,16(sp)
    80004c9a:	e44e                	sd	s3,8(sp)
    80004c9c:	e052                	sd	s4,0(sp)
    80004c9e:	1800                	addi	s0,sp,48
    80004ca0:	84aa                	mv	s1,a0
    80004ca2:	8a2e                	mv	s4,a1
  struct pipe *pi;

  pi = 0;
  *f0 = *f1 = 0;
    80004ca4:	0005b023          	sd	zero,0(a1)
    80004ca8:	00053023          	sd	zero,0(a0)
  if((*f0 = filealloc()) == 0 || (*f1 = filealloc()) == 0)
    80004cac:	00000097          	auipc	ra,0x0
    80004cb0:	bf8080e7          	jalr	-1032(ra) # 800048a4 <filealloc>
    80004cb4:	e088                	sd	a0,0(s1)
    80004cb6:	c551                	beqz	a0,80004d42 <pipealloc+0xb2>
    80004cb8:	00000097          	auipc	ra,0x0
    80004cbc:	bec080e7          	jalr	-1044(ra) # 800048a4 <filealloc>
    80004cc0:	00aa3023          	sd	a0,0(s4)
    80004cc4:	c92d                	beqz	a0,80004d36 <pipealloc+0xa6>
    goto bad;
  if((pi = (struct pipe*)kalloc()) == 0)
    80004cc6:	ffffc097          	auipc	ra,0xffffc
    80004cca:	e34080e7          	jalr	-460(ra) # 80000afa <kalloc>
    80004cce:	892a                	mv	s2,a0
    80004cd0:	c125                	beqz	a0,80004d30 <pipealloc+0xa0>
    goto bad;
  pi->readopen = 1;
    80004cd2:	4985                	li	s3,1
    80004cd4:	23352423          	sw	s3,552(a0)
  pi->writeopen = 1;
    80004cd8:	23352623          	sw	s3,556(a0)
  pi->nwrite = 0;
    80004cdc:	22052223          	sw	zero,548(a0)
  pi->nread = 0;
    80004ce0:	22052023          	sw	zero,544(a0)
  initlock(&pi->lock, "pipe");
    80004ce4:	00004597          	auipc	a1,0x4
    80004ce8:	82458593          	addi	a1,a1,-2012 # 80008508 <states.1747+0x1a0>
    80004cec:	ffffc097          	auipc	ra,0xffffc
    80004cf0:	eb8080e7          	jalr	-328(ra) # 80000ba4 <initlock>
  (*f0)->type = FD_PIPE;
    80004cf4:	609c                	ld	a5,0(s1)
    80004cf6:	0137a023          	sw	s3,0(a5)
  (*f0)->readable = 1;
    80004cfa:	609c                	ld	a5,0(s1)
    80004cfc:	01378423          	sb	s3,8(a5)
  (*f0)->writable = 0;
    80004d00:	609c                	ld	a5,0(s1)
    80004d02:	000784a3          	sb	zero,9(a5)
  (*f0)->pipe = pi;
    80004d06:	609c                	ld	a5,0(s1)
    80004d08:	0127b823          	sd	s2,16(a5)
  (*f1)->type = FD_PIPE;
    80004d0c:	000a3783          	ld	a5,0(s4)
    80004d10:	0137a023          	sw	s3,0(a5)
  (*f1)->readable = 0;
    80004d14:	000a3783          	ld	a5,0(s4)
    80004d18:	00078423          	sb	zero,8(a5)
  (*f1)->writable = 1;
    80004d1c:	000a3783          	ld	a5,0(s4)
    80004d20:	013784a3          	sb	s3,9(a5)
  (*f1)->pipe = pi;
    80004d24:	000a3783          	ld	a5,0(s4)
    80004d28:	0127b823          	sd	s2,16(a5)
  return 0;
    80004d2c:	4501                	li	a0,0
    80004d2e:	a025                	j	80004d56 <pipealloc+0xc6>

 bad:
  if(pi)
    kfree((char*)pi);
  if(*f0)
    80004d30:	6088                	ld	a0,0(s1)
    80004d32:	e501                	bnez	a0,80004d3a <pipealloc+0xaa>
    80004d34:	a039                	j	80004d42 <pipealloc+0xb2>
    80004d36:	6088                	ld	a0,0(s1)
    80004d38:	c51d                	beqz	a0,80004d66 <pipealloc+0xd6>
    fileclose(*f0);
    80004d3a:	00000097          	auipc	ra,0x0
    80004d3e:	c26080e7          	jalr	-986(ra) # 80004960 <fileclose>
  if(*f1)
    80004d42:	000a3783          	ld	a5,0(s4)
    fileclose(*f1);
  return -1;
    80004d46:	557d                	li	a0,-1
  if(*f1)
    80004d48:	c799                	beqz	a5,80004d56 <pipealloc+0xc6>
    fileclose(*f1);
    80004d4a:	853e                	mv	a0,a5
    80004d4c:	00000097          	auipc	ra,0x0
    80004d50:	c14080e7          	jalr	-1004(ra) # 80004960 <fileclose>
  return -1;
    80004d54:	557d                	li	a0,-1
}
    80004d56:	70a2                	ld	ra,40(sp)
    80004d58:	7402                	ld	s0,32(sp)
    80004d5a:	64e2                	ld	s1,24(sp)
    80004d5c:	6942                	ld	s2,16(sp)
    80004d5e:	69a2                	ld	s3,8(sp)
    80004d60:	6a02                	ld	s4,0(sp)
    80004d62:	6145                	addi	sp,sp,48
    80004d64:	8082                	ret
  return -1;
    80004d66:	557d                	li	a0,-1
    80004d68:	b7fd                	j	80004d56 <pipealloc+0xc6>

0000000080004d6a <pipeclose>:

void
pipeclose(struct pipe *pi, int writable)
{
    80004d6a:	1101                	addi	sp,sp,-32
    80004d6c:	ec06                	sd	ra,24(sp)
    80004d6e:	e822                	sd	s0,16(sp)
    80004d70:	e426                	sd	s1,8(sp)
    80004d72:	e04a                	sd	s2,0(sp)
    80004d74:	1000                	addi	s0,sp,32
    80004d76:	84aa                	mv	s1,a0
    80004d78:	892e                	mv	s2,a1
  acquire(&pi->lock);
    80004d7a:	ffffc097          	auipc	ra,0xffffc
    80004d7e:	e94080e7          	jalr	-364(ra) # 80000c0e <acquire>
  if(writable){
    80004d82:	02090d63          	beqz	s2,80004dbc <pipeclose+0x52>
    pi->writeopen = 0;
    80004d86:	2204a623          	sw	zero,556(s1)
    wakeup(&pi->nread);
    80004d8a:	22048513          	addi	a0,s1,544
    80004d8e:	ffffd097          	auipc	ra,0xffffd
    80004d92:	556080e7          	jalr	1366(ra) # 800022e4 <wakeup>
  } else {
    pi->readopen = 0;
    wakeup(&pi->nwrite);
  }
  if(pi->readopen == 0 && pi->writeopen == 0){
    80004d96:	2284b783          	ld	a5,552(s1)
    80004d9a:	eb95                	bnez	a5,80004dce <pipeclose+0x64>
    release(&pi->lock);
    80004d9c:	8526                	mv	a0,s1
    80004d9e:	ffffc097          	auipc	ra,0xffffc
    80004da2:	fca080e7          	jalr	-54(ra) # 80000d68 <release>
    kfree((char*)pi);
    80004da6:	8526                	mv	a0,s1
    80004da8:	ffffc097          	auipc	ra,0xffffc
    80004dac:	c56080e7          	jalr	-938(ra) # 800009fe <kfree>
  } else
    release(&pi->lock);
}
    80004db0:	60e2                	ld	ra,24(sp)
    80004db2:	6442                	ld	s0,16(sp)
    80004db4:	64a2                	ld	s1,8(sp)
    80004db6:	6902                	ld	s2,0(sp)
    80004db8:	6105                	addi	sp,sp,32
    80004dba:	8082                	ret
    pi->readopen = 0;
    80004dbc:	2204a423          	sw	zero,552(s1)
    wakeup(&pi->nwrite);
    80004dc0:	22448513          	addi	a0,s1,548
    80004dc4:	ffffd097          	auipc	ra,0xffffd
    80004dc8:	520080e7          	jalr	1312(ra) # 800022e4 <wakeup>
    80004dcc:	b7e9                	j	80004d96 <pipeclose+0x2c>
    release(&pi->lock);
    80004dce:	8526                	mv	a0,s1
    80004dd0:	ffffc097          	auipc	ra,0xffffc
    80004dd4:	f98080e7          	jalr	-104(ra) # 80000d68 <release>
}
    80004dd8:	bfe1                	j	80004db0 <pipeclose+0x46>

0000000080004dda <pipewrite>:

int
pipewrite(struct pipe *pi, uint64 addr, int n)
{
    80004dda:	7159                	addi	sp,sp,-112
    80004ddc:	f486                	sd	ra,104(sp)
    80004dde:	f0a2                	sd	s0,96(sp)
    80004de0:	eca6                	sd	s1,88(sp)
    80004de2:	e8ca                	sd	s2,80(sp)
    80004de4:	e4ce                	sd	s3,72(sp)
    80004de6:	e0d2                	sd	s4,64(sp)
    80004de8:	fc56                	sd	s5,56(sp)
    80004dea:	f85a                	sd	s6,48(sp)
    80004dec:	f45e                	sd	s7,40(sp)
    80004dee:	f062                	sd	s8,32(sp)
    80004df0:	ec66                	sd	s9,24(sp)
    80004df2:	1880                	addi	s0,sp,112
    80004df4:	84aa                	mv	s1,a0
    80004df6:	8aae                	mv	s5,a1
    80004df8:	8a32                	mv	s4,a2
  int i = 0;
  struct proc *pr = myproc();
    80004dfa:	ffffd097          	auipc	ra,0xffffd
    80004dfe:	c9c080e7          	jalr	-868(ra) # 80001a96 <myproc>
    80004e02:	89aa                	mv	s3,a0

  acquire(&pi->lock);
    80004e04:	8526                	mv	a0,s1
    80004e06:	ffffc097          	auipc	ra,0xffffc
    80004e0a:	e08080e7          	jalr	-504(ra) # 80000c0e <acquire>
  while(i < n){
    80004e0e:	0d405463          	blez	s4,80004ed6 <pipewrite+0xfc>
    80004e12:	8ba6                	mv	s7,s1
  int i = 0;
    80004e14:	4901                	li	s2,0
    if(pi->nwrite == pi->nread + PIPESIZE){ //DOC: pipewrite-full
      wakeup(&pi->nread);
      sleep(&pi->nwrite, &pi->lock);
    } else {
      char ch;
      if(copyin(pr->pagetable, &ch, addr + i, 1) == -1)
    80004e16:	5b7d                	li	s6,-1
      wakeup(&pi->nread);
    80004e18:	22048c93          	addi	s9,s1,544
      sleep(&pi->nwrite, &pi->lock);
    80004e1c:	22448c13          	addi	s8,s1,548
    80004e20:	a08d                	j	80004e82 <pipewrite+0xa8>
      release(&pi->lock);
    80004e22:	8526                	mv	a0,s1
    80004e24:	ffffc097          	auipc	ra,0xffffc
    80004e28:	f44080e7          	jalr	-188(ra) # 80000d68 <release>
      return -1;
    80004e2c:	597d                	li	s2,-1
  }
  wakeup(&pi->nread);
  release(&pi->lock);

  return i;
}
    80004e2e:	854a                	mv	a0,s2
    80004e30:	70a6                	ld	ra,104(sp)
    80004e32:	7406                	ld	s0,96(sp)
    80004e34:	64e6                	ld	s1,88(sp)
    80004e36:	6946                	ld	s2,80(sp)
    80004e38:	69a6                	ld	s3,72(sp)
    80004e3a:	6a06                	ld	s4,64(sp)
    80004e3c:	7ae2                	ld	s5,56(sp)
    80004e3e:	7b42                	ld	s6,48(sp)
    80004e40:	7ba2                	ld	s7,40(sp)
    80004e42:	7c02                	ld	s8,32(sp)
    80004e44:	6ce2                	ld	s9,24(sp)
    80004e46:	6165                	addi	sp,sp,112
    80004e48:	8082                	ret
      wakeup(&pi->nread);
    80004e4a:	8566                	mv	a0,s9
    80004e4c:	ffffd097          	auipc	ra,0xffffd
    80004e50:	498080e7          	jalr	1176(ra) # 800022e4 <wakeup>
      sleep(&pi->nwrite, &pi->lock);
    80004e54:	85de                	mv	a1,s7
    80004e56:	8562                	mv	a0,s8
    80004e58:	ffffd097          	auipc	ra,0xffffd
    80004e5c:	428080e7          	jalr	1064(ra) # 80002280 <sleep>
    80004e60:	a839                	j	80004e7e <pipewrite+0xa4>
      pi->data[pi->nwrite++ % PIPESIZE] = ch;
    80004e62:	2244a783          	lw	a5,548(s1)
    80004e66:	0017871b          	addiw	a4,a5,1
    80004e6a:	22e4a223          	sw	a4,548(s1)
    80004e6e:	1ff7f793          	andi	a5,a5,511
    80004e72:	97a6                	add	a5,a5,s1
    80004e74:	f9f44703          	lbu	a4,-97(s0)
    80004e78:	02e78023          	sb	a4,32(a5)
      i++;
    80004e7c:	2905                	addiw	s2,s2,1
  while(i < n){
    80004e7e:	05495063          	bge	s2,s4,80004ebe <pipewrite+0xe4>
    if(pi->readopen == 0 || killed(pr)){
    80004e82:	2284a783          	lw	a5,552(s1)
    80004e86:	dfd1                	beqz	a5,80004e22 <pipewrite+0x48>
    80004e88:	854e                	mv	a0,s3
    80004e8a:	ffffd097          	auipc	ra,0xffffd
    80004e8e:	69e080e7          	jalr	1694(ra) # 80002528 <killed>
    80004e92:	f941                	bnez	a0,80004e22 <pipewrite+0x48>
    if(pi->nwrite == pi->nread + PIPESIZE){ //DOC: pipewrite-full
    80004e94:	2204a783          	lw	a5,544(s1)
    80004e98:	2244a703          	lw	a4,548(s1)
    80004e9c:	2007879b          	addiw	a5,a5,512
    80004ea0:	faf705e3          	beq	a4,a5,80004e4a <pipewrite+0x70>
      if(copyin(pr->pagetable, &ch, addr + i, 1) == -1)
    80004ea4:	4685                	li	a3,1
    80004ea6:	01590633          	add	a2,s2,s5
    80004eaa:	f9f40593          	addi	a1,s0,-97
    80004eae:	0609b503          	ld	a0,96(s3)
    80004eb2:	ffffd097          	auipc	ra,0xffffd
    80004eb6:	92e080e7          	jalr	-1746(ra) # 800017e0 <copyin>
    80004eba:	fb6514e3          	bne	a0,s6,80004e62 <pipewrite+0x88>
  wakeup(&pi->nread);
    80004ebe:	22048513          	addi	a0,s1,544
    80004ec2:	ffffd097          	auipc	ra,0xffffd
    80004ec6:	422080e7          	jalr	1058(ra) # 800022e4 <wakeup>
  release(&pi->lock);
    80004eca:	8526                	mv	a0,s1
    80004ecc:	ffffc097          	auipc	ra,0xffffc
    80004ed0:	e9c080e7          	jalr	-356(ra) # 80000d68 <release>
  return i;
    80004ed4:	bfa9                	j	80004e2e <pipewrite+0x54>
  int i = 0;
    80004ed6:	4901                	li	s2,0
    80004ed8:	b7dd                	j	80004ebe <pipewrite+0xe4>

0000000080004eda <piperead>:

int
piperead(struct pipe *pi, uint64 addr, int n)
{
    80004eda:	715d                	addi	sp,sp,-80
    80004edc:	e486                	sd	ra,72(sp)
    80004ede:	e0a2                	sd	s0,64(sp)
    80004ee0:	fc26                	sd	s1,56(sp)
    80004ee2:	f84a                	sd	s2,48(sp)
    80004ee4:	f44e                	sd	s3,40(sp)
    80004ee6:	f052                	sd	s4,32(sp)
    80004ee8:	ec56                	sd	s5,24(sp)
    80004eea:	e85a                	sd	s6,16(sp)
    80004eec:	0880                	addi	s0,sp,80
    80004eee:	84aa                	mv	s1,a0
    80004ef0:	892e                	mv	s2,a1
    80004ef2:	8ab2                	mv	s5,a2
  int i;
  struct proc *pr = myproc();
    80004ef4:	ffffd097          	auipc	ra,0xffffd
    80004ef8:	ba2080e7          	jalr	-1118(ra) # 80001a96 <myproc>
    80004efc:	8a2a                	mv	s4,a0
  char ch;

  acquire(&pi->lock);
    80004efe:	8b26                	mv	s6,s1
    80004f00:	8526                	mv	a0,s1
    80004f02:	ffffc097          	auipc	ra,0xffffc
    80004f06:	d0c080e7          	jalr	-756(ra) # 80000c0e <acquire>
  while(pi->nread == pi->nwrite && pi->writeopen){  //DOC: pipe-empty
    80004f0a:	2204a703          	lw	a4,544(s1)
    80004f0e:	2244a783          	lw	a5,548(s1)
    if(killed(pr)){
      release(&pi->lock);
      return -1;
    }
    sleep(&pi->nread, &pi->lock); //DOC: piperead-sleep
    80004f12:	22048993          	addi	s3,s1,544
  while(pi->nread == pi->nwrite && pi->writeopen){  //DOC: pipe-empty
    80004f16:	02f71763          	bne	a4,a5,80004f44 <piperead+0x6a>
    80004f1a:	22c4a783          	lw	a5,556(s1)
    80004f1e:	c39d                	beqz	a5,80004f44 <piperead+0x6a>
    if(killed(pr)){
    80004f20:	8552                	mv	a0,s4
    80004f22:	ffffd097          	auipc	ra,0xffffd
    80004f26:	606080e7          	jalr	1542(ra) # 80002528 <killed>
    80004f2a:	e941                	bnez	a0,80004fba <piperead+0xe0>
    sleep(&pi->nread, &pi->lock); //DOC: piperead-sleep
    80004f2c:	85da                	mv	a1,s6
    80004f2e:	854e                	mv	a0,s3
    80004f30:	ffffd097          	auipc	ra,0xffffd
    80004f34:	350080e7          	jalr	848(ra) # 80002280 <sleep>
  while(pi->nread == pi->nwrite && pi->writeopen){  //DOC: pipe-empty
    80004f38:	2204a703          	lw	a4,544(s1)
    80004f3c:	2244a783          	lw	a5,548(s1)
    80004f40:	fcf70de3          	beq	a4,a5,80004f1a <piperead+0x40>
  }
  for(i = 0; i < n; i++){  //DOC: piperead-copy
    80004f44:	09505263          	blez	s5,80004fc8 <piperead+0xee>
    80004f48:	4981                	li	s3,0
    if(pi->nread == pi->nwrite)
      break;
    ch = pi->data[pi->nread++ % PIPESIZE];
    if(copyout(pr->pagetable, addr + i, &ch, 1) == -1)
    80004f4a:	5b7d                	li	s6,-1
    if(pi->nread == pi->nwrite)
    80004f4c:	2204a783          	lw	a5,544(s1)
    80004f50:	2244a703          	lw	a4,548(s1)
    80004f54:	02f70d63          	beq	a4,a5,80004f8e <piperead+0xb4>
    ch = pi->data[pi->nread++ % PIPESIZE];
    80004f58:	0017871b          	addiw	a4,a5,1
    80004f5c:	22e4a023          	sw	a4,544(s1)
    80004f60:	1ff7f793          	andi	a5,a5,511
    80004f64:	97a6                	add	a5,a5,s1
    80004f66:	0207c783          	lbu	a5,32(a5)
    80004f6a:	faf40fa3          	sb	a5,-65(s0)
    if(copyout(pr->pagetable, addr + i, &ch, 1) == -1)
    80004f6e:	4685                	li	a3,1
    80004f70:	fbf40613          	addi	a2,s0,-65
    80004f74:	85ca                	mv	a1,s2
    80004f76:	060a3503          	ld	a0,96(s4)
    80004f7a:	ffffc097          	auipc	ra,0xffffc
    80004f7e:	7da080e7          	jalr	2010(ra) # 80001754 <copyout>
    80004f82:	01650663          	beq	a0,s6,80004f8e <piperead+0xb4>
  for(i = 0; i < n; i++){  //DOC: piperead-copy
    80004f86:	2985                	addiw	s3,s3,1
    80004f88:	0905                	addi	s2,s2,1
    80004f8a:	fd3a91e3          	bne	s5,s3,80004f4c <piperead+0x72>
      break;
  }
  wakeup(&pi->nwrite);  //DOC: piperead-wakeup
    80004f8e:	22448513          	addi	a0,s1,548
    80004f92:	ffffd097          	auipc	ra,0xffffd
    80004f96:	352080e7          	jalr	850(ra) # 800022e4 <wakeup>
  release(&pi->lock);
    80004f9a:	8526                	mv	a0,s1
    80004f9c:	ffffc097          	auipc	ra,0xffffc
    80004fa0:	dcc080e7          	jalr	-564(ra) # 80000d68 <release>
  return i;
}
    80004fa4:	854e                	mv	a0,s3
    80004fa6:	60a6                	ld	ra,72(sp)
    80004fa8:	6406                	ld	s0,64(sp)
    80004faa:	74e2                	ld	s1,56(sp)
    80004fac:	7942                	ld	s2,48(sp)
    80004fae:	79a2                	ld	s3,40(sp)
    80004fb0:	7a02                	ld	s4,32(sp)
    80004fb2:	6ae2                	ld	s5,24(sp)
    80004fb4:	6b42                	ld	s6,16(sp)
    80004fb6:	6161                	addi	sp,sp,80
    80004fb8:	8082                	ret
      release(&pi->lock);
    80004fba:	8526                	mv	a0,s1
    80004fbc:	ffffc097          	auipc	ra,0xffffc
    80004fc0:	dac080e7          	jalr	-596(ra) # 80000d68 <release>
      return -1;
    80004fc4:	59fd                	li	s3,-1
    80004fc6:	bff9                	j	80004fa4 <piperead+0xca>
  for(i = 0; i < n; i++){  //DOC: piperead-copy
    80004fc8:	4981                	li	s3,0
    80004fca:	b7d1                	j	80004f8e <piperead+0xb4>

0000000080004fcc <flags2perm>:
#include "elf.h"

static int loadseg(pde_t *, uint64, struct inode *, uint, uint);

int flags2perm(int flags)
{
    80004fcc:	1141                	addi	sp,sp,-16
    80004fce:	e422                	sd	s0,8(sp)
    80004fd0:	0800                	addi	s0,sp,16
    80004fd2:	87aa                	mv	a5,a0
    int perm = 0;
    if(flags & 0x1)
    80004fd4:	8905                	andi	a0,a0,1
    80004fd6:	c111                	beqz	a0,80004fda <flags2perm+0xe>
      perm = PTE_X;
    80004fd8:	4521                	li	a0,8
    if(flags & 0x2)
    80004fda:	8b89                	andi	a5,a5,2
    80004fdc:	c399                	beqz	a5,80004fe2 <flags2perm+0x16>
      perm |= PTE_W;
    80004fde:	00456513          	ori	a0,a0,4
    return perm;
}
    80004fe2:	6422                	ld	s0,8(sp)
    80004fe4:	0141                	addi	sp,sp,16
    80004fe6:	8082                	ret

0000000080004fe8 <exec>:

int
exec(char *path, char **argv)
{
    80004fe8:	df010113          	addi	sp,sp,-528
    80004fec:	20113423          	sd	ra,520(sp)
    80004ff0:	20813023          	sd	s0,512(sp)
    80004ff4:	ffa6                	sd	s1,504(sp)
    80004ff6:	fbca                	sd	s2,496(sp)
    80004ff8:	f7ce                	sd	s3,488(sp)
    80004ffa:	f3d2                	sd	s4,480(sp)
    80004ffc:	efd6                	sd	s5,472(sp)
    80004ffe:	ebda                	sd	s6,464(sp)
    80005000:	e7de                	sd	s7,456(sp)
    80005002:	e3e2                	sd	s8,448(sp)
    80005004:	ff66                	sd	s9,440(sp)
    80005006:	fb6a                	sd	s10,432(sp)
    80005008:	f76e                	sd	s11,424(sp)
    8000500a:	0c00                	addi	s0,sp,528
    8000500c:	84aa                	mv	s1,a0
    8000500e:	dea43c23          	sd	a0,-520(s0)
    80005012:	e0b43023          	sd	a1,-512(s0)
  uint64 argc, sz = 0, sp, ustack[MAXARG], stackbase;
  struct elfhdr elf;
  struct inode *ip;
  struct proghdr ph;
  pagetable_t pagetable = 0, oldpagetable;
  struct proc *p = myproc();
    80005016:	ffffd097          	auipc	ra,0xffffd
    8000501a:	a80080e7          	jalr	-1408(ra) # 80001a96 <myproc>
    8000501e:	892a                	mv	s2,a0

  begin_op();
    80005020:	fffff097          	auipc	ra,0xfffff
    80005024:	474080e7          	jalr	1140(ra) # 80004494 <begin_op>

  if((ip = namei(path)) == 0){
    80005028:	8526                	mv	a0,s1
    8000502a:	fffff097          	auipc	ra,0xfffff
    8000502e:	24e080e7          	jalr	590(ra) # 80004278 <namei>
    80005032:	c92d                	beqz	a0,800050a4 <exec+0xbc>
    80005034:	84aa                	mv	s1,a0
    end_op();
    return -1;
  }
  ilock(ip);
    80005036:	fffff097          	auipc	ra,0xfffff
    8000503a:	a9c080e7          	jalr	-1380(ra) # 80003ad2 <ilock>

  // Check ELF header
  if(readi(ip, 0, (uint64)&elf, 0, sizeof(elf)) != sizeof(elf))
    8000503e:	04000713          	li	a4,64
    80005042:	4681                	li	a3,0
    80005044:	e5040613          	addi	a2,s0,-432
    80005048:	4581                	li	a1,0
    8000504a:	8526                	mv	a0,s1
    8000504c:	fffff097          	auipc	ra,0xfffff
    80005050:	d3a080e7          	jalr	-710(ra) # 80003d86 <readi>
    80005054:	04000793          	li	a5,64
    80005058:	00f51a63          	bne	a0,a5,8000506c <exec+0x84>
    goto bad;

  if(elf.magic != ELF_MAGIC)
    8000505c:	e5042703          	lw	a4,-432(s0)
    80005060:	464c47b7          	lui	a5,0x464c4
    80005064:	57f78793          	addi	a5,a5,1407 # 464c457f <_entry-0x39b3ba81>
    80005068:	04f70463          	beq	a4,a5,800050b0 <exec+0xc8>

 bad:
  if(pagetable)
    proc_freepagetable(pagetable, sz);
  if(ip){
    iunlockput(ip);
    8000506c:	8526                	mv	a0,s1
    8000506e:	fffff097          	auipc	ra,0xfffff
    80005072:	cc6080e7          	jalr	-826(ra) # 80003d34 <iunlockput>
    end_op();
    80005076:	fffff097          	auipc	ra,0xfffff
    8000507a:	49e080e7          	jalr	1182(ra) # 80004514 <end_op>
  }
  return -1;
    8000507e:	557d                	li	a0,-1
}
    80005080:	20813083          	ld	ra,520(sp)
    80005084:	20013403          	ld	s0,512(sp)
    80005088:	74fe                	ld	s1,504(sp)
    8000508a:	795e                	ld	s2,496(sp)
    8000508c:	79be                	ld	s3,488(sp)
    8000508e:	7a1e                	ld	s4,480(sp)
    80005090:	6afe                	ld	s5,472(sp)
    80005092:	6b5e                	ld	s6,464(sp)
    80005094:	6bbe                	ld	s7,456(sp)
    80005096:	6c1e                	ld	s8,448(sp)
    80005098:	7cfa                	ld	s9,440(sp)
    8000509a:	7d5a                	ld	s10,432(sp)
    8000509c:	7dba                	ld	s11,424(sp)
    8000509e:	21010113          	addi	sp,sp,528
    800050a2:	8082                	ret
    end_op();
    800050a4:	fffff097          	auipc	ra,0xfffff
    800050a8:	470080e7          	jalr	1136(ra) # 80004514 <end_op>
    return -1;
    800050ac:	557d                	li	a0,-1
    800050ae:	bfc9                	j	80005080 <exec+0x98>
  if((pagetable = proc_pagetable(p)) == 0)
    800050b0:	854a                	mv	a0,s2
    800050b2:	ffffd097          	auipc	ra,0xffffd
    800050b6:	aa8080e7          	jalr	-1368(ra) # 80001b5a <proc_pagetable>
    800050ba:	8baa                	mv	s7,a0
    800050bc:	d945                	beqz	a0,8000506c <exec+0x84>
  for(i=0, off=elf.phoff; i<elf.phnum; i++, off+=sizeof(ph)){
    800050be:	e7042983          	lw	s3,-400(s0)
    800050c2:	e8845783          	lhu	a5,-376(s0)
    800050c6:	c7ad                	beqz	a5,80005130 <exec+0x148>
  uint64 argc, sz = 0, sp, ustack[MAXARG], stackbase;
    800050c8:	4a01                	li	s4,0
  for(i=0, off=elf.phoff; i<elf.phnum; i++, off+=sizeof(ph)){
    800050ca:	4b01                	li	s6,0
    if(ph.vaddr % PGSIZE != 0)
    800050cc:	6c85                	lui	s9,0x1
    800050ce:	fffc8793          	addi	a5,s9,-1 # fff <_entry-0x7ffff001>
    800050d2:	def43823          	sd	a5,-528(s0)
    800050d6:	ac0d                	j	80005308 <exec+0x320>
  uint64 pa;

  for(i = 0; i < sz; i += PGSIZE){
    pa = walkaddr(pagetable, va + i);
    if(pa == 0)
      panic("loadseg: address should exist");
    800050d8:	00004517          	auipc	a0,0x4
    800050dc:	86050513          	addi	a0,a0,-1952 # 80008938 <syscall_name+0x298>
    800050e0:	ffffb097          	auipc	ra,0xffffb
    800050e4:	464080e7          	jalr	1124(ra) # 80000544 <panic>
    if(sz - i < PGSIZE)
      n = sz - i;
    else
      n = PGSIZE;
    if(readi(ip, 0, (uint64)pa, offset+i, n) != n)
    800050e8:	8756                	mv	a4,s5
    800050ea:	012d86bb          	addw	a3,s11,s2
    800050ee:	4581                	li	a1,0
    800050f0:	8526                	mv	a0,s1
    800050f2:	fffff097          	auipc	ra,0xfffff
    800050f6:	c94080e7          	jalr	-876(ra) # 80003d86 <readi>
    800050fa:	2501                	sext.w	a0,a0
    800050fc:	1aaa9a63          	bne	s5,a0,800052b0 <exec+0x2c8>
  for(i = 0; i < sz; i += PGSIZE){
    80005100:	6785                	lui	a5,0x1
    80005102:	0127893b          	addw	s2,a5,s2
    80005106:	77fd                	lui	a5,0xfffff
    80005108:	01478a3b          	addw	s4,a5,s4
    8000510c:	1f897563          	bgeu	s2,s8,800052f6 <exec+0x30e>
    pa = walkaddr(pagetable, va + i);
    80005110:	02091593          	slli	a1,s2,0x20
    80005114:	9181                	srli	a1,a1,0x20
    80005116:	95ea                	add	a1,a1,s10
    80005118:	855e                	mv	a0,s7
    8000511a:	ffffc097          	auipc	ra,0xffffc
    8000511e:	02e080e7          	jalr	46(ra) # 80001148 <walkaddr>
    80005122:	862a                	mv	a2,a0
    if(pa == 0)
    80005124:	d955                	beqz	a0,800050d8 <exec+0xf0>
      n = PGSIZE;
    80005126:	8ae6                	mv	s5,s9
    if(sz - i < PGSIZE)
    80005128:	fd9a70e3          	bgeu	s4,s9,800050e8 <exec+0x100>
      n = sz - i;
    8000512c:	8ad2                	mv	s5,s4
    8000512e:	bf6d                	j	800050e8 <exec+0x100>
  uint64 argc, sz = 0, sp, ustack[MAXARG], stackbase;
    80005130:	4a01                	li	s4,0
  iunlockput(ip);
    80005132:	8526                	mv	a0,s1
    80005134:	fffff097          	auipc	ra,0xfffff
    80005138:	c00080e7          	jalr	-1024(ra) # 80003d34 <iunlockput>
  end_op();
    8000513c:	fffff097          	auipc	ra,0xfffff
    80005140:	3d8080e7          	jalr	984(ra) # 80004514 <end_op>
  p = myproc();
    80005144:	ffffd097          	auipc	ra,0xffffd
    80005148:	952080e7          	jalr	-1710(ra) # 80001a96 <myproc>
    8000514c:	8aaa                	mv	s5,a0
  uint64 oldsz = p->sz;
    8000514e:	05853d03          	ld	s10,88(a0)
  sz = PGROUNDUP(sz);
    80005152:	6785                	lui	a5,0x1
    80005154:	17fd                	addi	a5,a5,-1
    80005156:	9a3e                	add	s4,s4,a5
    80005158:	757d                	lui	a0,0xfffff
    8000515a:	00aa77b3          	and	a5,s4,a0
    8000515e:	e0f43423          	sd	a5,-504(s0)
  if((sz1 = uvmalloc(pagetable, sz, sz + 2*PGSIZE, PTE_W)) == 0)
    80005162:	4691                	li	a3,4
    80005164:	6609                	lui	a2,0x2
    80005166:	963e                	add	a2,a2,a5
    80005168:	85be                	mv	a1,a5
    8000516a:	855e                	mv	a0,s7
    8000516c:	ffffc097          	auipc	ra,0xffffc
    80005170:	390080e7          	jalr	912(ra) # 800014fc <uvmalloc>
    80005174:	8b2a                	mv	s6,a0
  ip = 0;
    80005176:	4481                	li	s1,0
  if((sz1 = uvmalloc(pagetable, sz, sz + 2*PGSIZE, PTE_W)) == 0)
    80005178:	12050c63          	beqz	a0,800052b0 <exec+0x2c8>
  uvmclear(pagetable, sz-2*PGSIZE);
    8000517c:	75f9                	lui	a1,0xffffe
    8000517e:	95aa                	add	a1,a1,a0
    80005180:	855e                	mv	a0,s7
    80005182:	ffffc097          	auipc	ra,0xffffc
    80005186:	5a0080e7          	jalr	1440(ra) # 80001722 <uvmclear>
  stackbase = sp - PGSIZE;
    8000518a:	7c7d                	lui	s8,0xfffff
    8000518c:	9c5a                	add	s8,s8,s6
  for(argc = 0; argv[argc]; argc++) {
    8000518e:	e0043783          	ld	a5,-512(s0)
    80005192:	6388                	ld	a0,0(a5)
    80005194:	c535                	beqz	a0,80005200 <exec+0x218>
    80005196:	e9040993          	addi	s3,s0,-368
    8000519a:	f9040c93          	addi	s9,s0,-112
  sp = sz;
    8000519e:	895a                	mv	s2,s6
    sp -= strlen(argv[argc]) + 1;
    800051a0:	ffffc097          	auipc	ra,0xffffc
    800051a4:	d9a080e7          	jalr	-614(ra) # 80000f3a <strlen>
    800051a8:	2505                	addiw	a0,a0,1
    800051aa:	40a90933          	sub	s2,s2,a0
    sp -= sp % 16; // riscv sp must be 16-byte aligned
    800051ae:	ff097913          	andi	s2,s2,-16
    if(sp < stackbase)
    800051b2:	13896663          	bltu	s2,s8,800052de <exec+0x2f6>
    if(copyout(pagetable, sp, argv[argc], strlen(argv[argc]) + 1) < 0)
    800051b6:	e0043d83          	ld	s11,-512(s0)
    800051ba:	000dba03          	ld	s4,0(s11)
    800051be:	8552                	mv	a0,s4
    800051c0:	ffffc097          	auipc	ra,0xffffc
    800051c4:	d7a080e7          	jalr	-646(ra) # 80000f3a <strlen>
    800051c8:	0015069b          	addiw	a3,a0,1
    800051cc:	8652                	mv	a2,s4
    800051ce:	85ca                	mv	a1,s2
    800051d0:	855e                	mv	a0,s7
    800051d2:	ffffc097          	auipc	ra,0xffffc
    800051d6:	582080e7          	jalr	1410(ra) # 80001754 <copyout>
    800051da:	10054663          	bltz	a0,800052e6 <exec+0x2fe>
    ustack[argc] = sp;
    800051de:	0129b023          	sd	s2,0(s3)
  for(argc = 0; argv[argc]; argc++) {
    800051e2:	0485                	addi	s1,s1,1
    800051e4:	008d8793          	addi	a5,s11,8
    800051e8:	e0f43023          	sd	a5,-512(s0)
    800051ec:	008db503          	ld	a0,8(s11)
    800051f0:	c911                	beqz	a0,80005204 <exec+0x21c>
    if(argc >= MAXARG)
    800051f2:	09a1                	addi	s3,s3,8
    800051f4:	fb3c96e3          	bne	s9,s3,800051a0 <exec+0x1b8>
  sz = sz1;
    800051f8:	e1643423          	sd	s6,-504(s0)
  ip = 0;
    800051fc:	4481                	li	s1,0
    800051fe:	a84d                	j	800052b0 <exec+0x2c8>
  sp = sz;
    80005200:	895a                	mv	s2,s6
  for(argc = 0; argv[argc]; argc++) {
    80005202:	4481                	li	s1,0
  ustack[argc] = 0;
    80005204:	00349793          	slli	a5,s1,0x3
    80005208:	f9040713          	addi	a4,s0,-112
    8000520c:	97ba                	add	a5,a5,a4
    8000520e:	f007b023          	sd	zero,-256(a5) # f00 <_entry-0x7ffff100>
  sp -= (argc+1) * sizeof(uint64);
    80005212:	00148693          	addi	a3,s1,1
    80005216:	068e                	slli	a3,a3,0x3
    80005218:	40d90933          	sub	s2,s2,a3
  sp -= sp % 16;
    8000521c:	ff097913          	andi	s2,s2,-16
  if(sp < stackbase)
    80005220:	01897663          	bgeu	s2,s8,8000522c <exec+0x244>
  sz = sz1;
    80005224:	e1643423          	sd	s6,-504(s0)
  ip = 0;
    80005228:	4481                	li	s1,0
    8000522a:	a059                	j	800052b0 <exec+0x2c8>
  if(copyout(pagetable, sp, (char *)ustack, (argc+1)*sizeof(uint64)) < 0)
    8000522c:	e9040613          	addi	a2,s0,-368
    80005230:	85ca                	mv	a1,s2
    80005232:	855e                	mv	a0,s7
    80005234:	ffffc097          	auipc	ra,0xffffc
    80005238:	520080e7          	jalr	1312(ra) # 80001754 <copyout>
    8000523c:	0a054963          	bltz	a0,800052ee <exec+0x306>
  p->trapframe->a1 = sp;
    80005240:	068ab783          	ld	a5,104(s5)
    80005244:	0727bc23          	sd	s2,120(a5)
  for(last=s=path; *s; s++)
    80005248:	df843783          	ld	a5,-520(s0)
    8000524c:	0007c703          	lbu	a4,0(a5)
    80005250:	cf11                	beqz	a4,8000526c <exec+0x284>
    80005252:	0785                	addi	a5,a5,1
    if(*s == '/')
    80005254:	02f00693          	li	a3,47
    80005258:	a039                	j	80005266 <exec+0x27e>
      last = s+1;
    8000525a:	def43c23          	sd	a5,-520(s0)
  for(last=s=path; *s; s++)
    8000525e:	0785                	addi	a5,a5,1
    80005260:	fff7c703          	lbu	a4,-1(a5)
    80005264:	c701                	beqz	a4,8000526c <exec+0x284>
    if(*s == '/')
    80005266:	fed71ce3          	bne	a4,a3,8000525e <exec+0x276>
    8000526a:	bfc5                	j	8000525a <exec+0x272>
  safestrcpy(p->name, last, sizeof(p->name));
    8000526c:	4641                	li	a2,16
    8000526e:	df843583          	ld	a1,-520(s0)
    80005272:	168a8513          	addi	a0,s5,360
    80005276:	ffffc097          	auipc	ra,0xffffc
    8000527a:	c92080e7          	jalr	-878(ra) # 80000f08 <safestrcpy>
  oldpagetable = p->pagetable;
    8000527e:	060ab503          	ld	a0,96(s5)
  p->pagetable = pagetable;
    80005282:	077ab023          	sd	s7,96(s5)
  p->sz = sz;
    80005286:	056abc23          	sd	s6,88(s5)
  p->trapframe->epc = elf.entry;  // initial program counter = main
    8000528a:	068ab783          	ld	a5,104(s5)
    8000528e:	e6843703          	ld	a4,-408(s0)
    80005292:	ef98                	sd	a4,24(a5)
  p->trapframe->sp = sp; // initial stack pointer
    80005294:	068ab783          	ld	a5,104(s5)
    80005298:	0327b823          	sd	s2,48(a5)
  proc_freepagetable(oldpagetable, oldsz);
    8000529c:	85ea                	mv	a1,s10
    8000529e:	ffffd097          	auipc	ra,0xffffd
    800052a2:	958080e7          	jalr	-1704(ra) # 80001bf6 <proc_freepagetable>
  return argc; // this ends up in a0, the first argument to main(argc, argv)
    800052a6:	0004851b          	sext.w	a0,s1
    800052aa:	bbd9                	j	80005080 <exec+0x98>
    800052ac:	e1443423          	sd	s4,-504(s0)
    proc_freepagetable(pagetable, sz);
    800052b0:	e0843583          	ld	a1,-504(s0)
    800052b4:	855e                	mv	a0,s7
    800052b6:	ffffd097          	auipc	ra,0xffffd
    800052ba:	940080e7          	jalr	-1728(ra) # 80001bf6 <proc_freepagetable>
  if(ip){
    800052be:	da0497e3          	bnez	s1,8000506c <exec+0x84>
  return -1;
    800052c2:	557d                	li	a0,-1
    800052c4:	bb75                	j	80005080 <exec+0x98>
    800052c6:	e1443423          	sd	s4,-504(s0)
    800052ca:	b7dd                	j	800052b0 <exec+0x2c8>
    800052cc:	e1443423          	sd	s4,-504(s0)
    800052d0:	b7c5                	j	800052b0 <exec+0x2c8>
    800052d2:	e1443423          	sd	s4,-504(s0)
    800052d6:	bfe9                	j	800052b0 <exec+0x2c8>
    800052d8:	e1443423          	sd	s4,-504(s0)
    800052dc:	bfd1                	j	800052b0 <exec+0x2c8>
  sz = sz1;
    800052de:	e1643423          	sd	s6,-504(s0)
  ip = 0;
    800052e2:	4481                	li	s1,0
    800052e4:	b7f1                	j	800052b0 <exec+0x2c8>
  sz = sz1;
    800052e6:	e1643423          	sd	s6,-504(s0)
  ip = 0;
    800052ea:	4481                	li	s1,0
    800052ec:	b7d1                	j	800052b0 <exec+0x2c8>
  sz = sz1;
    800052ee:	e1643423          	sd	s6,-504(s0)
  ip = 0;
    800052f2:	4481                	li	s1,0
    800052f4:	bf75                	j	800052b0 <exec+0x2c8>
    if((sz1 = uvmalloc(pagetable, sz, ph.vaddr + ph.memsz, flags2perm(ph.flags))) == 0)
    800052f6:	e0843a03          	ld	s4,-504(s0)
  for(i=0, off=elf.phoff; i<elf.phnum; i++, off+=sizeof(ph)){
    800052fa:	2b05                	addiw	s6,s6,1
    800052fc:	0389899b          	addiw	s3,s3,56
    80005300:	e8845783          	lhu	a5,-376(s0)
    80005304:	e2fb57e3          	bge	s6,a5,80005132 <exec+0x14a>
    if(readi(ip, 0, (uint64)&ph, off, sizeof(ph)) != sizeof(ph))
    80005308:	2981                	sext.w	s3,s3
    8000530a:	03800713          	li	a4,56
    8000530e:	86ce                	mv	a3,s3
    80005310:	e1840613          	addi	a2,s0,-488
    80005314:	4581                	li	a1,0
    80005316:	8526                	mv	a0,s1
    80005318:	fffff097          	auipc	ra,0xfffff
    8000531c:	a6e080e7          	jalr	-1426(ra) # 80003d86 <readi>
    80005320:	03800793          	li	a5,56
    80005324:	f8f514e3          	bne	a0,a5,800052ac <exec+0x2c4>
    if(ph.type != ELF_PROG_LOAD)
    80005328:	e1842783          	lw	a5,-488(s0)
    8000532c:	4705                	li	a4,1
    8000532e:	fce796e3          	bne	a5,a4,800052fa <exec+0x312>
    if(ph.memsz < ph.filesz)
    80005332:	e4043903          	ld	s2,-448(s0)
    80005336:	e3843783          	ld	a5,-456(s0)
    8000533a:	f8f966e3          	bltu	s2,a5,800052c6 <exec+0x2de>
    if(ph.vaddr + ph.memsz < ph.vaddr)
    8000533e:	e2843783          	ld	a5,-472(s0)
    80005342:	993e                	add	s2,s2,a5
    80005344:	f8f964e3          	bltu	s2,a5,800052cc <exec+0x2e4>
    if(ph.vaddr % PGSIZE != 0)
    80005348:	df043703          	ld	a4,-528(s0)
    8000534c:	8ff9                	and	a5,a5,a4
    8000534e:	f3d1                	bnez	a5,800052d2 <exec+0x2ea>
    if((sz1 = uvmalloc(pagetable, sz, ph.vaddr + ph.memsz, flags2perm(ph.flags))) == 0)
    80005350:	e1c42503          	lw	a0,-484(s0)
    80005354:	00000097          	auipc	ra,0x0
    80005358:	c78080e7          	jalr	-904(ra) # 80004fcc <flags2perm>
    8000535c:	86aa                	mv	a3,a0
    8000535e:	864a                	mv	a2,s2
    80005360:	85d2                	mv	a1,s4
    80005362:	855e                	mv	a0,s7
    80005364:	ffffc097          	auipc	ra,0xffffc
    80005368:	198080e7          	jalr	408(ra) # 800014fc <uvmalloc>
    8000536c:	e0a43423          	sd	a0,-504(s0)
    80005370:	d525                	beqz	a0,800052d8 <exec+0x2f0>
    if(loadseg(pagetable, ph.vaddr, ip, ph.off, ph.filesz) < 0)
    80005372:	e2843d03          	ld	s10,-472(s0)
    80005376:	e2042d83          	lw	s11,-480(s0)
    8000537a:	e3842c03          	lw	s8,-456(s0)
  for(i = 0; i < sz; i += PGSIZE){
    8000537e:	f60c0ce3          	beqz	s8,800052f6 <exec+0x30e>
    80005382:	8a62                	mv	s4,s8
    80005384:	4901                	li	s2,0
    80005386:	b369                	j	80005110 <exec+0x128>

0000000080005388 <argfd>:

// Fetch the nth word-sized system call argument as a file descriptor
// and return both the descriptor and the corresponding struct file.
static int
argfd(int n, int *pfd, struct file **pf)
{
    80005388:	7179                	addi	sp,sp,-48
    8000538a:	f406                	sd	ra,40(sp)
    8000538c:	f022                	sd	s0,32(sp)
    8000538e:	ec26                	sd	s1,24(sp)
    80005390:	e84a                	sd	s2,16(sp)
    80005392:	1800                	addi	s0,sp,48
    80005394:	892e                	mv	s2,a1
    80005396:	84b2                	mv	s1,a2
  int fd;
  struct file *f;

  argint(n, &fd);
    80005398:	fdc40593          	addi	a1,s0,-36
    8000539c:	ffffe097          	auipc	ra,0xffffe
    800053a0:	ad8080e7          	jalr	-1320(ra) # 80002e74 <argint>
  if(fd < 0 || fd >= NOFILE || (f=myproc()->ofile[fd]) == 0)
    800053a4:	fdc42703          	lw	a4,-36(s0)
    800053a8:	47bd                	li	a5,15
    800053aa:	02e7eb63          	bltu	a5,a4,800053e0 <argfd+0x58>
    800053ae:	ffffc097          	auipc	ra,0xffffc
    800053b2:	6e8080e7          	jalr	1768(ra) # 80001a96 <myproc>
    800053b6:	fdc42703          	lw	a4,-36(s0)
    800053ba:	01c70793          	addi	a5,a4,28
    800053be:	078e                	slli	a5,a5,0x3
    800053c0:	953e                	add	a0,a0,a5
    800053c2:	611c                	ld	a5,0(a0)
    800053c4:	c385                	beqz	a5,800053e4 <argfd+0x5c>
    return -1;
  if(pfd)
    800053c6:	00090463          	beqz	s2,800053ce <argfd+0x46>
    *pfd = fd;
    800053ca:	00e92023          	sw	a4,0(s2)
  if(pf)
    *pf = f;
  return 0;
    800053ce:	4501                	li	a0,0
  if(pf)
    800053d0:	c091                	beqz	s1,800053d4 <argfd+0x4c>
    *pf = f;
    800053d2:	e09c                	sd	a5,0(s1)
}
    800053d4:	70a2                	ld	ra,40(sp)
    800053d6:	7402                	ld	s0,32(sp)
    800053d8:	64e2                	ld	s1,24(sp)
    800053da:	6942                	ld	s2,16(sp)
    800053dc:	6145                	addi	sp,sp,48
    800053de:	8082                	ret
    return -1;
    800053e0:	557d                	li	a0,-1
    800053e2:	bfcd                	j	800053d4 <argfd+0x4c>
    800053e4:	557d                	li	a0,-1
    800053e6:	b7fd                	j	800053d4 <argfd+0x4c>

00000000800053e8 <fdalloc>:

// Allocate a file descriptor for the given file.
// Takes over file reference from caller on success.
static int
fdalloc(struct file *f)
{
    800053e8:	1101                	addi	sp,sp,-32
    800053ea:	ec06                	sd	ra,24(sp)
    800053ec:	e822                	sd	s0,16(sp)
    800053ee:	e426                	sd	s1,8(sp)
    800053f0:	1000                	addi	s0,sp,32
    800053f2:	84aa                	mv	s1,a0
  int fd;
  struct proc *p = myproc();
    800053f4:	ffffc097          	auipc	ra,0xffffc
    800053f8:	6a2080e7          	jalr	1698(ra) # 80001a96 <myproc>
    800053fc:	862a                	mv	a2,a0

  for(fd = 0; fd < NOFILE; fd++){
    800053fe:	0e050793          	addi	a5,a0,224 # fffffffffffff0e0 <end+0xffffffff7ffdc828>
    80005402:	4501                	li	a0,0
    80005404:	46c1                	li	a3,16
    if(p->ofile[fd] == 0){
    80005406:	6398                	ld	a4,0(a5)
    80005408:	cb19                	beqz	a4,8000541e <fdalloc+0x36>
  for(fd = 0; fd < NOFILE; fd++){
    8000540a:	2505                	addiw	a0,a0,1
    8000540c:	07a1                	addi	a5,a5,8
    8000540e:	fed51ce3          	bne	a0,a3,80005406 <fdalloc+0x1e>
      p->ofile[fd] = f;
      return fd;
    }
  }
  return -1;
    80005412:	557d                	li	a0,-1
}
    80005414:	60e2                	ld	ra,24(sp)
    80005416:	6442                	ld	s0,16(sp)
    80005418:	64a2                	ld	s1,8(sp)
    8000541a:	6105                	addi	sp,sp,32
    8000541c:	8082                	ret
      p->ofile[fd] = f;
    8000541e:	01c50793          	addi	a5,a0,28
    80005422:	078e                	slli	a5,a5,0x3
    80005424:	963e                	add	a2,a2,a5
    80005426:	e204                	sd	s1,0(a2)
      return fd;
    80005428:	b7f5                	j	80005414 <fdalloc+0x2c>

000000008000542a <create>:
  return -1;
}

static struct inode*
create(char *path, short type, short major, short minor)
{
    8000542a:	715d                	addi	sp,sp,-80
    8000542c:	e486                	sd	ra,72(sp)
    8000542e:	e0a2                	sd	s0,64(sp)
    80005430:	fc26                	sd	s1,56(sp)
    80005432:	f84a                	sd	s2,48(sp)
    80005434:	f44e                	sd	s3,40(sp)
    80005436:	f052                	sd	s4,32(sp)
    80005438:	ec56                	sd	s5,24(sp)
    8000543a:	e85a                	sd	s6,16(sp)
    8000543c:	0880                	addi	s0,sp,80
    8000543e:	8b2e                	mv	s6,a1
    80005440:	89b2                	mv	s3,a2
    80005442:	8936                	mv	s2,a3
  struct inode *ip, *dp;
  char name[DIRSIZ];

  if((dp = nameiparent(path, name)) == 0)
    80005444:	fb040593          	addi	a1,s0,-80
    80005448:	fffff097          	auipc	ra,0xfffff
    8000544c:	e4e080e7          	jalr	-434(ra) # 80004296 <nameiparent>
    80005450:	84aa                	mv	s1,a0
    80005452:	16050063          	beqz	a0,800055b2 <create+0x188>
    return 0;

  ilock(dp);
    80005456:	ffffe097          	auipc	ra,0xffffe
    8000545a:	67c080e7          	jalr	1660(ra) # 80003ad2 <ilock>

  if((ip = dirlookup(dp, name, 0)) != 0){
    8000545e:	4601                	li	a2,0
    80005460:	fb040593          	addi	a1,s0,-80
    80005464:	8526                	mv	a0,s1
    80005466:	fffff097          	auipc	ra,0xfffff
    8000546a:	b50080e7          	jalr	-1200(ra) # 80003fb6 <dirlookup>
    8000546e:	8aaa                	mv	s5,a0
    80005470:	c931                	beqz	a0,800054c4 <create+0x9a>
    iunlockput(dp);
    80005472:	8526                	mv	a0,s1
    80005474:	fffff097          	auipc	ra,0xfffff
    80005478:	8c0080e7          	jalr	-1856(ra) # 80003d34 <iunlockput>
    ilock(ip);
    8000547c:	8556                	mv	a0,s5
    8000547e:	ffffe097          	auipc	ra,0xffffe
    80005482:	654080e7          	jalr	1620(ra) # 80003ad2 <ilock>
    if(type == T_FILE && (ip->type == T_FILE || ip->type == T_DEVICE))
    80005486:	000b059b          	sext.w	a1,s6
    8000548a:	4789                	li	a5,2
    8000548c:	02f59563          	bne	a1,a5,800054b6 <create+0x8c>
    80005490:	04cad783          	lhu	a5,76(s5)
    80005494:	37f9                	addiw	a5,a5,-2
    80005496:	17c2                	slli	a5,a5,0x30
    80005498:	93c1                	srli	a5,a5,0x30
    8000549a:	4705                	li	a4,1
    8000549c:	00f76d63          	bltu	a4,a5,800054b6 <create+0x8c>
  ip->nlink = 0;
  iupdate(ip);
  iunlockput(ip);
  iunlockput(dp);
  return 0;
}
    800054a0:	8556                	mv	a0,s5
    800054a2:	60a6                	ld	ra,72(sp)
    800054a4:	6406                	ld	s0,64(sp)
    800054a6:	74e2                	ld	s1,56(sp)
    800054a8:	7942                	ld	s2,48(sp)
    800054aa:	79a2                	ld	s3,40(sp)
    800054ac:	7a02                	ld	s4,32(sp)
    800054ae:	6ae2                	ld	s5,24(sp)
    800054b0:	6b42                	ld	s6,16(sp)
    800054b2:	6161                	addi	sp,sp,80
    800054b4:	8082                	ret
    iunlockput(ip);
    800054b6:	8556                	mv	a0,s5
    800054b8:	fffff097          	auipc	ra,0xfffff
    800054bc:	87c080e7          	jalr	-1924(ra) # 80003d34 <iunlockput>
    return 0;
    800054c0:	4a81                	li	s5,0
    800054c2:	bff9                	j	800054a0 <create+0x76>
  if((ip = ialloc(dp->dev, type)) == 0){
    800054c4:	85da                	mv	a1,s6
    800054c6:	4088                	lw	a0,0(s1)
    800054c8:	ffffe097          	auipc	ra,0xffffe
    800054cc:	46e080e7          	jalr	1134(ra) # 80003936 <ialloc>
    800054d0:	8a2a                	mv	s4,a0
    800054d2:	c921                	beqz	a0,80005522 <create+0xf8>
  ilock(ip);
    800054d4:	ffffe097          	auipc	ra,0xffffe
    800054d8:	5fe080e7          	jalr	1534(ra) # 80003ad2 <ilock>
  ip->major = major;
    800054dc:	053a1723          	sh	s3,78(s4)
  ip->minor = minor;
    800054e0:	052a1823          	sh	s2,80(s4)
  ip->nlink = 1;
    800054e4:	4785                	li	a5,1
    800054e6:	04fa1923          	sh	a5,82(s4)
  iupdate(ip);
    800054ea:	8552                	mv	a0,s4
    800054ec:	ffffe097          	auipc	ra,0xffffe
    800054f0:	51c080e7          	jalr	1308(ra) # 80003a08 <iupdate>
  if(type == T_DIR){  // Create . and .. entries.
    800054f4:	000b059b          	sext.w	a1,s6
    800054f8:	4785                	li	a5,1
    800054fa:	02f58b63          	beq	a1,a5,80005530 <create+0x106>
  if(dirlink(dp, name, ip->inum) < 0)
    800054fe:	004a2603          	lw	a2,4(s4)
    80005502:	fb040593          	addi	a1,s0,-80
    80005506:	8526                	mv	a0,s1
    80005508:	fffff097          	auipc	ra,0xfffff
    8000550c:	cbe080e7          	jalr	-834(ra) # 800041c6 <dirlink>
    80005510:	06054f63          	bltz	a0,8000558e <create+0x164>
  iunlockput(dp);
    80005514:	8526                	mv	a0,s1
    80005516:	fffff097          	auipc	ra,0xfffff
    8000551a:	81e080e7          	jalr	-2018(ra) # 80003d34 <iunlockput>
  return ip;
    8000551e:	8ad2                	mv	s5,s4
    80005520:	b741                	j	800054a0 <create+0x76>
    iunlockput(dp);
    80005522:	8526                	mv	a0,s1
    80005524:	fffff097          	auipc	ra,0xfffff
    80005528:	810080e7          	jalr	-2032(ra) # 80003d34 <iunlockput>
    return 0;
    8000552c:	8ad2                	mv	s5,s4
    8000552e:	bf8d                	j	800054a0 <create+0x76>
    if(dirlink(ip, ".", ip->inum) < 0 || dirlink(ip, "..", dp->inum) < 0)
    80005530:	004a2603          	lw	a2,4(s4)
    80005534:	00003597          	auipc	a1,0x3
    80005538:	42458593          	addi	a1,a1,1060 # 80008958 <syscall_name+0x2b8>
    8000553c:	8552                	mv	a0,s4
    8000553e:	fffff097          	auipc	ra,0xfffff
    80005542:	c88080e7          	jalr	-888(ra) # 800041c6 <dirlink>
    80005546:	04054463          	bltz	a0,8000558e <create+0x164>
    8000554a:	40d0                	lw	a2,4(s1)
    8000554c:	00003597          	auipc	a1,0x3
    80005550:	41458593          	addi	a1,a1,1044 # 80008960 <syscall_name+0x2c0>
    80005554:	8552                	mv	a0,s4
    80005556:	fffff097          	auipc	ra,0xfffff
    8000555a:	c70080e7          	jalr	-912(ra) # 800041c6 <dirlink>
    8000555e:	02054863          	bltz	a0,8000558e <create+0x164>
  if(dirlink(dp, name, ip->inum) < 0)
    80005562:	004a2603          	lw	a2,4(s4)
    80005566:	fb040593          	addi	a1,s0,-80
    8000556a:	8526                	mv	a0,s1
    8000556c:	fffff097          	auipc	ra,0xfffff
    80005570:	c5a080e7          	jalr	-934(ra) # 800041c6 <dirlink>
    80005574:	00054d63          	bltz	a0,8000558e <create+0x164>
    dp->nlink++;  // for ".."
    80005578:	0524d783          	lhu	a5,82(s1)
    8000557c:	2785                	addiw	a5,a5,1
    8000557e:	04f49923          	sh	a5,82(s1)
    iupdate(dp);
    80005582:	8526                	mv	a0,s1
    80005584:	ffffe097          	auipc	ra,0xffffe
    80005588:	484080e7          	jalr	1156(ra) # 80003a08 <iupdate>
    8000558c:	b761                	j	80005514 <create+0xea>
  ip->nlink = 0;
    8000558e:	040a1923          	sh	zero,82(s4)
  iupdate(ip);
    80005592:	8552                	mv	a0,s4
    80005594:	ffffe097          	auipc	ra,0xffffe
    80005598:	474080e7          	jalr	1140(ra) # 80003a08 <iupdate>
  iunlockput(ip);
    8000559c:	8552                	mv	a0,s4
    8000559e:	ffffe097          	auipc	ra,0xffffe
    800055a2:	796080e7          	jalr	1942(ra) # 80003d34 <iunlockput>
  iunlockput(dp);
    800055a6:	8526                	mv	a0,s1
    800055a8:	ffffe097          	auipc	ra,0xffffe
    800055ac:	78c080e7          	jalr	1932(ra) # 80003d34 <iunlockput>
  return 0;
    800055b0:	bdc5                	j	800054a0 <create+0x76>
    return 0;
    800055b2:	8aaa                	mv	s5,a0
    800055b4:	b5f5                	j	800054a0 <create+0x76>

00000000800055b6 <sys_dup>:
{
    800055b6:	7179                	addi	sp,sp,-48
    800055b8:	f406                	sd	ra,40(sp)
    800055ba:	f022                	sd	s0,32(sp)
    800055bc:	ec26                	sd	s1,24(sp)
    800055be:	1800                	addi	s0,sp,48
  if(argfd(0, 0, &f) < 0)
    800055c0:	fd840613          	addi	a2,s0,-40
    800055c4:	4581                	li	a1,0
    800055c6:	4501                	li	a0,0
    800055c8:	00000097          	auipc	ra,0x0
    800055cc:	dc0080e7          	jalr	-576(ra) # 80005388 <argfd>
    return -1;
    800055d0:	57fd                	li	a5,-1
  if(argfd(0, 0, &f) < 0)
    800055d2:	02054363          	bltz	a0,800055f8 <sys_dup+0x42>
  if((fd=fdalloc(f)) < 0)
    800055d6:	fd843503          	ld	a0,-40(s0)
    800055da:	00000097          	auipc	ra,0x0
    800055de:	e0e080e7          	jalr	-498(ra) # 800053e8 <fdalloc>
    800055e2:	84aa                	mv	s1,a0
    return -1;
    800055e4:	57fd                	li	a5,-1
  if((fd=fdalloc(f)) < 0)
    800055e6:	00054963          	bltz	a0,800055f8 <sys_dup+0x42>
  filedup(f);
    800055ea:	fd843503          	ld	a0,-40(s0)
    800055ee:	fffff097          	auipc	ra,0xfffff
    800055f2:	320080e7          	jalr	800(ra) # 8000490e <filedup>
  return fd;
    800055f6:	87a6                	mv	a5,s1
}
    800055f8:	853e                	mv	a0,a5
    800055fa:	70a2                	ld	ra,40(sp)
    800055fc:	7402                	ld	s0,32(sp)
    800055fe:	64e2                	ld	s1,24(sp)
    80005600:	6145                	addi	sp,sp,48
    80005602:	8082                	ret

0000000080005604 <sys_read>:
{
    80005604:	7179                	addi	sp,sp,-48
    80005606:	f406                	sd	ra,40(sp)
    80005608:	f022                	sd	s0,32(sp)
    8000560a:	1800                	addi	s0,sp,48
  argaddr(1, &p);
    8000560c:	fd840593          	addi	a1,s0,-40
    80005610:	4505                	li	a0,1
    80005612:	ffffe097          	auipc	ra,0xffffe
    80005616:	882080e7          	jalr	-1918(ra) # 80002e94 <argaddr>
  argint(2, &n);
    8000561a:	fe440593          	addi	a1,s0,-28
    8000561e:	4509                	li	a0,2
    80005620:	ffffe097          	auipc	ra,0xffffe
    80005624:	854080e7          	jalr	-1964(ra) # 80002e74 <argint>
  if(argfd(0, 0, &f) < 0)
    80005628:	fe840613          	addi	a2,s0,-24
    8000562c:	4581                	li	a1,0
    8000562e:	4501                	li	a0,0
    80005630:	00000097          	auipc	ra,0x0
    80005634:	d58080e7          	jalr	-680(ra) # 80005388 <argfd>
    80005638:	87aa                	mv	a5,a0
    return -1;
    8000563a:	557d                	li	a0,-1
  if(argfd(0, 0, &f) < 0)
    8000563c:	0007cc63          	bltz	a5,80005654 <sys_read+0x50>
  return fileread(f, p, n);
    80005640:	fe442603          	lw	a2,-28(s0)
    80005644:	fd843583          	ld	a1,-40(s0)
    80005648:	fe843503          	ld	a0,-24(s0)
    8000564c:	fffff097          	auipc	ra,0xfffff
    80005650:	44e080e7          	jalr	1102(ra) # 80004a9a <fileread>
}
    80005654:	70a2                	ld	ra,40(sp)
    80005656:	7402                	ld	s0,32(sp)
    80005658:	6145                	addi	sp,sp,48
    8000565a:	8082                	ret

000000008000565c <sys_write>:
{
    8000565c:	7179                	addi	sp,sp,-48
    8000565e:	f406                	sd	ra,40(sp)
    80005660:	f022                	sd	s0,32(sp)
    80005662:	1800                	addi	s0,sp,48
  argaddr(1, &p);
    80005664:	fd840593          	addi	a1,s0,-40
    80005668:	4505                	li	a0,1
    8000566a:	ffffe097          	auipc	ra,0xffffe
    8000566e:	82a080e7          	jalr	-2006(ra) # 80002e94 <argaddr>
  argint(2, &n);
    80005672:	fe440593          	addi	a1,s0,-28
    80005676:	4509                	li	a0,2
    80005678:	ffffd097          	auipc	ra,0xffffd
    8000567c:	7fc080e7          	jalr	2044(ra) # 80002e74 <argint>
  if(argfd(0, 0, &f) < 0)
    80005680:	fe840613          	addi	a2,s0,-24
    80005684:	4581                	li	a1,0
    80005686:	4501                	li	a0,0
    80005688:	00000097          	auipc	ra,0x0
    8000568c:	d00080e7          	jalr	-768(ra) # 80005388 <argfd>
    80005690:	87aa                	mv	a5,a0
    return -1;
    80005692:	557d                	li	a0,-1
  if(argfd(0, 0, &f) < 0)
    80005694:	0007cc63          	bltz	a5,800056ac <sys_write+0x50>
  return filewrite(f, p, n);
    80005698:	fe442603          	lw	a2,-28(s0)
    8000569c:	fd843583          	ld	a1,-40(s0)
    800056a0:	fe843503          	ld	a0,-24(s0)
    800056a4:	fffff097          	auipc	ra,0xfffff
    800056a8:	4b8080e7          	jalr	1208(ra) # 80004b5c <filewrite>
}
    800056ac:	70a2                	ld	ra,40(sp)
    800056ae:	7402                	ld	s0,32(sp)
    800056b0:	6145                	addi	sp,sp,48
    800056b2:	8082                	ret

00000000800056b4 <sys_close>:
{
    800056b4:	1101                	addi	sp,sp,-32
    800056b6:	ec06                	sd	ra,24(sp)
    800056b8:	e822                	sd	s0,16(sp)
    800056ba:	1000                	addi	s0,sp,32
  if(argfd(0, &fd, &f) < 0)
    800056bc:	fe040613          	addi	a2,s0,-32
    800056c0:	fec40593          	addi	a1,s0,-20
    800056c4:	4501                	li	a0,0
    800056c6:	00000097          	auipc	ra,0x0
    800056ca:	cc2080e7          	jalr	-830(ra) # 80005388 <argfd>
    return -1;
    800056ce:	57fd                	li	a5,-1
  if(argfd(0, &fd, &f) < 0)
    800056d0:	02054463          	bltz	a0,800056f8 <sys_close+0x44>
  myproc()->ofile[fd] = 0;
    800056d4:	ffffc097          	auipc	ra,0xffffc
    800056d8:	3c2080e7          	jalr	962(ra) # 80001a96 <myproc>
    800056dc:	fec42783          	lw	a5,-20(s0)
    800056e0:	07f1                	addi	a5,a5,28
    800056e2:	078e                	slli	a5,a5,0x3
    800056e4:	97aa                	add	a5,a5,a0
    800056e6:	0007b023          	sd	zero,0(a5)
  fileclose(f);
    800056ea:	fe043503          	ld	a0,-32(s0)
    800056ee:	fffff097          	auipc	ra,0xfffff
    800056f2:	272080e7          	jalr	626(ra) # 80004960 <fileclose>
  return 0;
    800056f6:	4781                	li	a5,0
}
    800056f8:	853e                	mv	a0,a5
    800056fa:	60e2                	ld	ra,24(sp)
    800056fc:	6442                	ld	s0,16(sp)
    800056fe:	6105                	addi	sp,sp,32
    80005700:	8082                	ret

0000000080005702 <sys_fstat>:
{
    80005702:	1101                	addi	sp,sp,-32
    80005704:	ec06                	sd	ra,24(sp)
    80005706:	e822                	sd	s0,16(sp)
    80005708:	1000                	addi	s0,sp,32
  argaddr(1, &st);
    8000570a:	fe040593          	addi	a1,s0,-32
    8000570e:	4505                	li	a0,1
    80005710:	ffffd097          	auipc	ra,0xffffd
    80005714:	784080e7          	jalr	1924(ra) # 80002e94 <argaddr>
  if(argfd(0, 0, &f) < 0)
    80005718:	fe840613          	addi	a2,s0,-24
    8000571c:	4581                	li	a1,0
    8000571e:	4501                	li	a0,0
    80005720:	00000097          	auipc	ra,0x0
    80005724:	c68080e7          	jalr	-920(ra) # 80005388 <argfd>
    80005728:	87aa                	mv	a5,a0
    return -1;
    8000572a:	557d                	li	a0,-1
  if(argfd(0, 0, &f) < 0)
    8000572c:	0007ca63          	bltz	a5,80005740 <sys_fstat+0x3e>
  return filestat(f, st);
    80005730:	fe043583          	ld	a1,-32(s0)
    80005734:	fe843503          	ld	a0,-24(s0)
    80005738:	fffff097          	auipc	ra,0xfffff
    8000573c:	2f0080e7          	jalr	752(ra) # 80004a28 <filestat>
}
    80005740:	60e2                	ld	ra,24(sp)
    80005742:	6442                	ld	s0,16(sp)
    80005744:	6105                	addi	sp,sp,32
    80005746:	8082                	ret

0000000080005748 <sys_link>:
{
    80005748:	7169                	addi	sp,sp,-304
    8000574a:	f606                	sd	ra,296(sp)
    8000574c:	f222                	sd	s0,288(sp)
    8000574e:	ee26                	sd	s1,280(sp)
    80005750:	ea4a                	sd	s2,272(sp)
    80005752:	1a00                	addi	s0,sp,304
  if(argstr(0, old, MAXPATH) < 0 || argstr(1, new, MAXPATH) < 0)
    80005754:	08000613          	li	a2,128
    80005758:	ed040593          	addi	a1,s0,-304
    8000575c:	4501                	li	a0,0
    8000575e:	ffffd097          	auipc	ra,0xffffd
    80005762:	756080e7          	jalr	1878(ra) # 80002eb4 <argstr>
    return -1;
    80005766:	57fd                	li	a5,-1
  if(argstr(0, old, MAXPATH) < 0 || argstr(1, new, MAXPATH) < 0)
    80005768:	10054e63          	bltz	a0,80005884 <sys_link+0x13c>
    8000576c:	08000613          	li	a2,128
    80005770:	f5040593          	addi	a1,s0,-176
    80005774:	4505                	li	a0,1
    80005776:	ffffd097          	auipc	ra,0xffffd
    8000577a:	73e080e7          	jalr	1854(ra) # 80002eb4 <argstr>
    return -1;
    8000577e:	57fd                	li	a5,-1
  if(argstr(0, old, MAXPATH) < 0 || argstr(1, new, MAXPATH) < 0)
    80005780:	10054263          	bltz	a0,80005884 <sys_link+0x13c>
  begin_op();
    80005784:	fffff097          	auipc	ra,0xfffff
    80005788:	d10080e7          	jalr	-752(ra) # 80004494 <begin_op>
  if((ip = namei(old)) == 0){
    8000578c:	ed040513          	addi	a0,s0,-304
    80005790:	fffff097          	auipc	ra,0xfffff
    80005794:	ae8080e7          	jalr	-1304(ra) # 80004278 <namei>
    80005798:	84aa                	mv	s1,a0
    8000579a:	c551                	beqz	a0,80005826 <sys_link+0xde>
  ilock(ip);
    8000579c:	ffffe097          	auipc	ra,0xffffe
    800057a0:	336080e7          	jalr	822(ra) # 80003ad2 <ilock>
  if(ip->type == T_DIR){
    800057a4:	04c49703          	lh	a4,76(s1)
    800057a8:	4785                	li	a5,1
    800057aa:	08f70463          	beq	a4,a5,80005832 <sys_link+0xea>
  ip->nlink++;
    800057ae:	0524d783          	lhu	a5,82(s1)
    800057b2:	2785                	addiw	a5,a5,1
    800057b4:	04f49923          	sh	a5,82(s1)
  iupdate(ip);
    800057b8:	8526                	mv	a0,s1
    800057ba:	ffffe097          	auipc	ra,0xffffe
    800057be:	24e080e7          	jalr	590(ra) # 80003a08 <iupdate>
  iunlock(ip);
    800057c2:	8526                	mv	a0,s1
    800057c4:	ffffe097          	auipc	ra,0xffffe
    800057c8:	3d0080e7          	jalr	976(ra) # 80003b94 <iunlock>
  if((dp = nameiparent(new, name)) == 0)
    800057cc:	fd040593          	addi	a1,s0,-48
    800057d0:	f5040513          	addi	a0,s0,-176
    800057d4:	fffff097          	auipc	ra,0xfffff
    800057d8:	ac2080e7          	jalr	-1342(ra) # 80004296 <nameiparent>
    800057dc:	892a                	mv	s2,a0
    800057de:	c935                	beqz	a0,80005852 <sys_link+0x10a>
  ilock(dp);
    800057e0:	ffffe097          	auipc	ra,0xffffe
    800057e4:	2f2080e7          	jalr	754(ra) # 80003ad2 <ilock>
  if(dp->dev != ip->dev || dirlink(dp, name, ip->inum) < 0){
    800057e8:	00092703          	lw	a4,0(s2)
    800057ec:	409c                	lw	a5,0(s1)
    800057ee:	04f71d63          	bne	a4,a5,80005848 <sys_link+0x100>
    800057f2:	40d0                	lw	a2,4(s1)
    800057f4:	fd040593          	addi	a1,s0,-48
    800057f8:	854a                	mv	a0,s2
    800057fa:	fffff097          	auipc	ra,0xfffff
    800057fe:	9cc080e7          	jalr	-1588(ra) # 800041c6 <dirlink>
    80005802:	04054363          	bltz	a0,80005848 <sys_link+0x100>
  iunlockput(dp);
    80005806:	854a                	mv	a0,s2
    80005808:	ffffe097          	auipc	ra,0xffffe
    8000580c:	52c080e7          	jalr	1324(ra) # 80003d34 <iunlockput>
  iput(ip);
    80005810:	8526                	mv	a0,s1
    80005812:	ffffe097          	auipc	ra,0xffffe
    80005816:	47a080e7          	jalr	1146(ra) # 80003c8c <iput>
  end_op();
    8000581a:	fffff097          	auipc	ra,0xfffff
    8000581e:	cfa080e7          	jalr	-774(ra) # 80004514 <end_op>
  return 0;
    80005822:	4781                	li	a5,0
    80005824:	a085                	j	80005884 <sys_link+0x13c>
    end_op();
    80005826:	fffff097          	auipc	ra,0xfffff
    8000582a:	cee080e7          	jalr	-786(ra) # 80004514 <end_op>
    return -1;
    8000582e:	57fd                	li	a5,-1
    80005830:	a891                	j	80005884 <sys_link+0x13c>
    iunlockput(ip);
    80005832:	8526                	mv	a0,s1
    80005834:	ffffe097          	auipc	ra,0xffffe
    80005838:	500080e7          	jalr	1280(ra) # 80003d34 <iunlockput>
    end_op();
    8000583c:	fffff097          	auipc	ra,0xfffff
    80005840:	cd8080e7          	jalr	-808(ra) # 80004514 <end_op>
    return -1;
    80005844:	57fd                	li	a5,-1
    80005846:	a83d                	j	80005884 <sys_link+0x13c>
    iunlockput(dp);
    80005848:	854a                	mv	a0,s2
    8000584a:	ffffe097          	auipc	ra,0xffffe
    8000584e:	4ea080e7          	jalr	1258(ra) # 80003d34 <iunlockput>
  ilock(ip);
    80005852:	8526                	mv	a0,s1
    80005854:	ffffe097          	auipc	ra,0xffffe
    80005858:	27e080e7          	jalr	638(ra) # 80003ad2 <ilock>
  ip->nlink--;
    8000585c:	0524d783          	lhu	a5,82(s1)
    80005860:	37fd                	addiw	a5,a5,-1
    80005862:	04f49923          	sh	a5,82(s1)
  iupdate(ip);
    80005866:	8526                	mv	a0,s1
    80005868:	ffffe097          	auipc	ra,0xffffe
    8000586c:	1a0080e7          	jalr	416(ra) # 80003a08 <iupdate>
  iunlockput(ip);
    80005870:	8526                	mv	a0,s1
    80005872:	ffffe097          	auipc	ra,0xffffe
    80005876:	4c2080e7          	jalr	1218(ra) # 80003d34 <iunlockput>
  end_op();
    8000587a:	fffff097          	auipc	ra,0xfffff
    8000587e:	c9a080e7          	jalr	-870(ra) # 80004514 <end_op>
  return -1;
    80005882:	57fd                	li	a5,-1
}
    80005884:	853e                	mv	a0,a5
    80005886:	70b2                	ld	ra,296(sp)
    80005888:	7412                	ld	s0,288(sp)
    8000588a:	64f2                	ld	s1,280(sp)
    8000588c:	6952                	ld	s2,272(sp)
    8000588e:	6155                	addi	sp,sp,304
    80005890:	8082                	ret

0000000080005892 <sys_unlink>:
{
    80005892:	7151                	addi	sp,sp,-240
    80005894:	f586                	sd	ra,232(sp)
    80005896:	f1a2                	sd	s0,224(sp)
    80005898:	eda6                	sd	s1,216(sp)
    8000589a:	e9ca                	sd	s2,208(sp)
    8000589c:	e5ce                	sd	s3,200(sp)
    8000589e:	1980                	addi	s0,sp,240
  if(argstr(0, path, MAXPATH) < 0)
    800058a0:	08000613          	li	a2,128
    800058a4:	f3040593          	addi	a1,s0,-208
    800058a8:	4501                	li	a0,0
    800058aa:	ffffd097          	auipc	ra,0xffffd
    800058ae:	60a080e7          	jalr	1546(ra) # 80002eb4 <argstr>
    800058b2:	18054163          	bltz	a0,80005a34 <sys_unlink+0x1a2>
  begin_op();
    800058b6:	fffff097          	auipc	ra,0xfffff
    800058ba:	bde080e7          	jalr	-1058(ra) # 80004494 <begin_op>
  if((dp = nameiparent(path, name)) == 0){
    800058be:	fb040593          	addi	a1,s0,-80
    800058c2:	f3040513          	addi	a0,s0,-208
    800058c6:	fffff097          	auipc	ra,0xfffff
    800058ca:	9d0080e7          	jalr	-1584(ra) # 80004296 <nameiparent>
    800058ce:	84aa                	mv	s1,a0
    800058d0:	c979                	beqz	a0,800059a6 <sys_unlink+0x114>
  ilock(dp);
    800058d2:	ffffe097          	auipc	ra,0xffffe
    800058d6:	200080e7          	jalr	512(ra) # 80003ad2 <ilock>
  if(namecmp(name, ".") == 0 || namecmp(name, "..") == 0)
    800058da:	00003597          	auipc	a1,0x3
    800058de:	07e58593          	addi	a1,a1,126 # 80008958 <syscall_name+0x2b8>
    800058e2:	fb040513          	addi	a0,s0,-80
    800058e6:	ffffe097          	auipc	ra,0xffffe
    800058ea:	6b6080e7          	jalr	1718(ra) # 80003f9c <namecmp>
    800058ee:	14050a63          	beqz	a0,80005a42 <sys_unlink+0x1b0>
    800058f2:	00003597          	auipc	a1,0x3
    800058f6:	06e58593          	addi	a1,a1,110 # 80008960 <syscall_name+0x2c0>
    800058fa:	fb040513          	addi	a0,s0,-80
    800058fe:	ffffe097          	auipc	ra,0xffffe
    80005902:	69e080e7          	jalr	1694(ra) # 80003f9c <namecmp>
    80005906:	12050e63          	beqz	a0,80005a42 <sys_unlink+0x1b0>
  if((ip = dirlookup(dp, name, &off)) == 0)
    8000590a:	f2c40613          	addi	a2,s0,-212
    8000590e:	fb040593          	addi	a1,s0,-80
    80005912:	8526                	mv	a0,s1
    80005914:	ffffe097          	auipc	ra,0xffffe
    80005918:	6a2080e7          	jalr	1698(ra) # 80003fb6 <dirlookup>
    8000591c:	892a                	mv	s2,a0
    8000591e:	12050263          	beqz	a0,80005a42 <sys_unlink+0x1b0>
  ilock(ip);
    80005922:	ffffe097          	auipc	ra,0xffffe
    80005926:	1b0080e7          	jalr	432(ra) # 80003ad2 <ilock>
  if(ip->nlink < 1)
    8000592a:	05291783          	lh	a5,82(s2)
    8000592e:	08f05263          	blez	a5,800059b2 <sys_unlink+0x120>
  if(ip->type == T_DIR && !isdirempty(ip)){
    80005932:	04c91703          	lh	a4,76(s2)
    80005936:	4785                	li	a5,1
    80005938:	08f70563          	beq	a4,a5,800059c2 <sys_unlink+0x130>
  memset(&de, 0, sizeof(de));
    8000593c:	4641                	li	a2,16
    8000593e:	4581                	li	a1,0
    80005940:	fc040513          	addi	a0,s0,-64
    80005944:	ffffb097          	auipc	ra,0xffffb
    80005948:	472080e7          	jalr	1138(ra) # 80000db6 <memset>
  if(writei(dp, 0, (uint64)&de, off, sizeof(de)) != sizeof(de))
    8000594c:	4741                	li	a4,16
    8000594e:	f2c42683          	lw	a3,-212(s0)
    80005952:	fc040613          	addi	a2,s0,-64
    80005956:	4581                	li	a1,0
    80005958:	8526                	mv	a0,s1
    8000595a:	ffffe097          	auipc	ra,0xffffe
    8000595e:	524080e7          	jalr	1316(ra) # 80003e7e <writei>
    80005962:	47c1                	li	a5,16
    80005964:	0af51563          	bne	a0,a5,80005a0e <sys_unlink+0x17c>
  if(ip->type == T_DIR){
    80005968:	04c91703          	lh	a4,76(s2)
    8000596c:	4785                	li	a5,1
    8000596e:	0af70863          	beq	a4,a5,80005a1e <sys_unlink+0x18c>
  iunlockput(dp);
    80005972:	8526                	mv	a0,s1
    80005974:	ffffe097          	auipc	ra,0xffffe
    80005978:	3c0080e7          	jalr	960(ra) # 80003d34 <iunlockput>
  ip->nlink--;
    8000597c:	05295783          	lhu	a5,82(s2)
    80005980:	37fd                	addiw	a5,a5,-1
    80005982:	04f91923          	sh	a5,82(s2)
  iupdate(ip);
    80005986:	854a                	mv	a0,s2
    80005988:	ffffe097          	auipc	ra,0xffffe
    8000598c:	080080e7          	jalr	128(ra) # 80003a08 <iupdate>
  iunlockput(ip);
    80005990:	854a                	mv	a0,s2
    80005992:	ffffe097          	auipc	ra,0xffffe
    80005996:	3a2080e7          	jalr	930(ra) # 80003d34 <iunlockput>
  end_op();
    8000599a:	fffff097          	auipc	ra,0xfffff
    8000599e:	b7a080e7          	jalr	-1158(ra) # 80004514 <end_op>
  return 0;
    800059a2:	4501                	li	a0,0
    800059a4:	a84d                	j	80005a56 <sys_unlink+0x1c4>
    end_op();
    800059a6:	fffff097          	auipc	ra,0xfffff
    800059aa:	b6e080e7          	jalr	-1170(ra) # 80004514 <end_op>
    return -1;
    800059ae:	557d                	li	a0,-1
    800059b0:	a05d                	j	80005a56 <sys_unlink+0x1c4>
    panic("unlink: nlink < 1");
    800059b2:	00003517          	auipc	a0,0x3
    800059b6:	fb650513          	addi	a0,a0,-74 # 80008968 <syscall_name+0x2c8>
    800059ba:	ffffb097          	auipc	ra,0xffffb
    800059be:	b8a080e7          	jalr	-1142(ra) # 80000544 <panic>
  for(off=2*sizeof(de); off<dp->size; off+=sizeof(de)){
    800059c2:	05492703          	lw	a4,84(s2)
    800059c6:	02000793          	li	a5,32
    800059ca:	f6e7f9e3          	bgeu	a5,a4,8000593c <sys_unlink+0xaa>
    800059ce:	02000993          	li	s3,32
    if(readi(dp, 0, (uint64)&de, off, sizeof(de)) != sizeof(de))
    800059d2:	4741                	li	a4,16
    800059d4:	86ce                	mv	a3,s3
    800059d6:	f1840613          	addi	a2,s0,-232
    800059da:	4581                	li	a1,0
    800059dc:	854a                	mv	a0,s2
    800059de:	ffffe097          	auipc	ra,0xffffe
    800059e2:	3a8080e7          	jalr	936(ra) # 80003d86 <readi>
    800059e6:	47c1                	li	a5,16
    800059e8:	00f51b63          	bne	a0,a5,800059fe <sys_unlink+0x16c>
    if(de.inum != 0)
    800059ec:	f1845783          	lhu	a5,-232(s0)
    800059f0:	e7a1                	bnez	a5,80005a38 <sys_unlink+0x1a6>
  for(off=2*sizeof(de); off<dp->size; off+=sizeof(de)){
    800059f2:	29c1                	addiw	s3,s3,16
    800059f4:	05492783          	lw	a5,84(s2)
    800059f8:	fcf9ede3          	bltu	s3,a5,800059d2 <sys_unlink+0x140>
    800059fc:	b781                	j	8000593c <sys_unlink+0xaa>
      panic("isdirempty: readi");
    800059fe:	00003517          	auipc	a0,0x3
    80005a02:	f8250513          	addi	a0,a0,-126 # 80008980 <syscall_name+0x2e0>
    80005a06:	ffffb097          	auipc	ra,0xffffb
    80005a0a:	b3e080e7          	jalr	-1218(ra) # 80000544 <panic>
    panic("unlink: writei");
    80005a0e:	00003517          	auipc	a0,0x3
    80005a12:	f8a50513          	addi	a0,a0,-118 # 80008998 <syscall_name+0x2f8>
    80005a16:	ffffb097          	auipc	ra,0xffffb
    80005a1a:	b2e080e7          	jalr	-1234(ra) # 80000544 <panic>
    dp->nlink--;
    80005a1e:	0524d783          	lhu	a5,82(s1)
    80005a22:	37fd                	addiw	a5,a5,-1
    80005a24:	04f49923          	sh	a5,82(s1)
    iupdate(dp);
    80005a28:	8526                	mv	a0,s1
    80005a2a:	ffffe097          	auipc	ra,0xffffe
    80005a2e:	fde080e7          	jalr	-34(ra) # 80003a08 <iupdate>
    80005a32:	b781                	j	80005972 <sys_unlink+0xe0>
    return -1;
    80005a34:	557d                	li	a0,-1
    80005a36:	a005                	j	80005a56 <sys_unlink+0x1c4>
    iunlockput(ip);
    80005a38:	854a                	mv	a0,s2
    80005a3a:	ffffe097          	auipc	ra,0xffffe
    80005a3e:	2fa080e7          	jalr	762(ra) # 80003d34 <iunlockput>
  iunlockput(dp);
    80005a42:	8526                	mv	a0,s1
    80005a44:	ffffe097          	auipc	ra,0xffffe
    80005a48:	2f0080e7          	jalr	752(ra) # 80003d34 <iunlockput>
  end_op();
    80005a4c:	fffff097          	auipc	ra,0xfffff
    80005a50:	ac8080e7          	jalr	-1336(ra) # 80004514 <end_op>
  return -1;
    80005a54:	557d                	li	a0,-1
}
    80005a56:	70ae                	ld	ra,232(sp)
    80005a58:	740e                	ld	s0,224(sp)
    80005a5a:	64ee                	ld	s1,216(sp)
    80005a5c:	694e                	ld	s2,208(sp)
    80005a5e:	69ae                	ld	s3,200(sp)
    80005a60:	616d                	addi	sp,sp,240
    80005a62:	8082                	ret

0000000080005a64 <sys_open>:

uint64
sys_open(void)
{
    80005a64:	7131                	addi	sp,sp,-192
    80005a66:	fd06                	sd	ra,184(sp)
    80005a68:	f922                	sd	s0,176(sp)
    80005a6a:	f526                	sd	s1,168(sp)
    80005a6c:	f14a                	sd	s2,160(sp)
    80005a6e:	ed4e                	sd	s3,152(sp)
    80005a70:	0180                	addi	s0,sp,192
  int fd, omode;
  struct file *f;
  struct inode *ip;
  int n;

  argint(1, &omode);
    80005a72:	f4c40593          	addi	a1,s0,-180
    80005a76:	4505                	li	a0,1
    80005a78:	ffffd097          	auipc	ra,0xffffd
    80005a7c:	3fc080e7          	jalr	1020(ra) # 80002e74 <argint>
  if((n = argstr(0, path, MAXPATH)) < 0)
    80005a80:	08000613          	li	a2,128
    80005a84:	f5040593          	addi	a1,s0,-176
    80005a88:	4501                	li	a0,0
    80005a8a:	ffffd097          	auipc	ra,0xffffd
    80005a8e:	42a080e7          	jalr	1066(ra) # 80002eb4 <argstr>
    80005a92:	87aa                	mv	a5,a0
    return -1;
    80005a94:	557d                	li	a0,-1
  if((n = argstr(0, path, MAXPATH)) < 0)
    80005a96:	0a07c963          	bltz	a5,80005b48 <sys_open+0xe4>

  begin_op();
    80005a9a:	fffff097          	auipc	ra,0xfffff
    80005a9e:	9fa080e7          	jalr	-1542(ra) # 80004494 <begin_op>

  if(omode & O_CREATE){
    80005aa2:	f4c42783          	lw	a5,-180(s0)
    80005aa6:	2007f793          	andi	a5,a5,512
    80005aaa:	cfc5                	beqz	a5,80005b62 <sys_open+0xfe>
    ip = create(path, T_FILE, 0, 0);
    80005aac:	4681                	li	a3,0
    80005aae:	4601                	li	a2,0
    80005ab0:	4589                	li	a1,2
    80005ab2:	f5040513          	addi	a0,s0,-176
    80005ab6:	00000097          	auipc	ra,0x0
    80005aba:	974080e7          	jalr	-1676(ra) # 8000542a <create>
    80005abe:	84aa                	mv	s1,a0
    if(ip == 0){
    80005ac0:	c959                	beqz	a0,80005b56 <sys_open+0xf2>
      end_op();
      return -1;
    }
  }

  if(ip->type == T_DEVICE && (ip->major < 0 || ip->major >= NDEV)){
    80005ac2:	04c49703          	lh	a4,76(s1)
    80005ac6:	478d                	li	a5,3
    80005ac8:	00f71763          	bne	a4,a5,80005ad6 <sys_open+0x72>
    80005acc:	04e4d703          	lhu	a4,78(s1)
    80005ad0:	47a5                	li	a5,9
    80005ad2:	0ce7ed63          	bltu	a5,a4,80005bac <sys_open+0x148>
    iunlockput(ip);
    end_op();
    return -1;
  }

  if((f = filealloc()) == 0 || (fd = fdalloc(f)) < 0){
    80005ad6:	fffff097          	auipc	ra,0xfffff
    80005ada:	dce080e7          	jalr	-562(ra) # 800048a4 <filealloc>
    80005ade:	89aa                	mv	s3,a0
    80005ae0:	10050363          	beqz	a0,80005be6 <sys_open+0x182>
    80005ae4:	00000097          	auipc	ra,0x0
    80005ae8:	904080e7          	jalr	-1788(ra) # 800053e8 <fdalloc>
    80005aec:	892a                	mv	s2,a0
    80005aee:	0e054763          	bltz	a0,80005bdc <sys_open+0x178>
    iunlockput(ip);
    end_op();
    return -1;
  }

  if(ip->type == T_DEVICE){
    80005af2:	04c49703          	lh	a4,76(s1)
    80005af6:	478d                	li	a5,3
    80005af8:	0cf70563          	beq	a4,a5,80005bc2 <sys_open+0x15e>
    f->type = FD_DEVICE;
    f->major = ip->major;
  } else {
    f->type = FD_INODE;
    80005afc:	4789                	li	a5,2
    80005afe:	00f9a023          	sw	a5,0(s3)
    f->off = 0;
    80005b02:	0209a023          	sw	zero,32(s3)
  }
  f->ip = ip;
    80005b06:	0099bc23          	sd	s1,24(s3)
  f->readable = !(omode & O_WRONLY);
    80005b0a:	f4c42783          	lw	a5,-180(s0)
    80005b0e:	0017c713          	xori	a4,a5,1
    80005b12:	8b05                	andi	a4,a4,1
    80005b14:	00e98423          	sb	a4,8(s3)
  f->writable = (omode & O_WRONLY) || (omode & O_RDWR);
    80005b18:	0037f713          	andi	a4,a5,3
    80005b1c:	00e03733          	snez	a4,a4
    80005b20:	00e984a3          	sb	a4,9(s3)

  if((omode & O_TRUNC) && ip->type == T_FILE){
    80005b24:	4007f793          	andi	a5,a5,1024
    80005b28:	c791                	beqz	a5,80005b34 <sys_open+0xd0>
    80005b2a:	04c49703          	lh	a4,76(s1)
    80005b2e:	4789                	li	a5,2
    80005b30:	0af70063          	beq	a4,a5,80005bd0 <sys_open+0x16c>
    itrunc(ip);
  }

  iunlock(ip);
    80005b34:	8526                	mv	a0,s1
    80005b36:	ffffe097          	auipc	ra,0xffffe
    80005b3a:	05e080e7          	jalr	94(ra) # 80003b94 <iunlock>
  end_op();
    80005b3e:	fffff097          	auipc	ra,0xfffff
    80005b42:	9d6080e7          	jalr	-1578(ra) # 80004514 <end_op>

  return fd;
    80005b46:	854a                	mv	a0,s2
}
    80005b48:	70ea                	ld	ra,184(sp)
    80005b4a:	744a                	ld	s0,176(sp)
    80005b4c:	74aa                	ld	s1,168(sp)
    80005b4e:	790a                	ld	s2,160(sp)
    80005b50:	69ea                	ld	s3,152(sp)
    80005b52:	6129                	addi	sp,sp,192
    80005b54:	8082                	ret
      end_op();
    80005b56:	fffff097          	auipc	ra,0xfffff
    80005b5a:	9be080e7          	jalr	-1602(ra) # 80004514 <end_op>
      return -1;
    80005b5e:	557d                	li	a0,-1
    80005b60:	b7e5                	j	80005b48 <sys_open+0xe4>
    if((ip = namei(path)) == 0){
    80005b62:	f5040513          	addi	a0,s0,-176
    80005b66:	ffffe097          	auipc	ra,0xffffe
    80005b6a:	712080e7          	jalr	1810(ra) # 80004278 <namei>
    80005b6e:	84aa                	mv	s1,a0
    80005b70:	c905                	beqz	a0,80005ba0 <sys_open+0x13c>
    ilock(ip);
    80005b72:	ffffe097          	auipc	ra,0xffffe
    80005b76:	f60080e7          	jalr	-160(ra) # 80003ad2 <ilock>
    if(ip->type == T_DIR && omode != O_RDONLY){
    80005b7a:	04c49703          	lh	a4,76(s1)
    80005b7e:	4785                	li	a5,1
    80005b80:	f4f711e3          	bne	a4,a5,80005ac2 <sys_open+0x5e>
    80005b84:	f4c42783          	lw	a5,-180(s0)
    80005b88:	d7b9                	beqz	a5,80005ad6 <sys_open+0x72>
      iunlockput(ip);
    80005b8a:	8526                	mv	a0,s1
    80005b8c:	ffffe097          	auipc	ra,0xffffe
    80005b90:	1a8080e7          	jalr	424(ra) # 80003d34 <iunlockput>
      end_op();
    80005b94:	fffff097          	auipc	ra,0xfffff
    80005b98:	980080e7          	jalr	-1664(ra) # 80004514 <end_op>
      return -1;
    80005b9c:	557d                	li	a0,-1
    80005b9e:	b76d                	j	80005b48 <sys_open+0xe4>
      end_op();
    80005ba0:	fffff097          	auipc	ra,0xfffff
    80005ba4:	974080e7          	jalr	-1676(ra) # 80004514 <end_op>
      return -1;
    80005ba8:	557d                	li	a0,-1
    80005baa:	bf79                	j	80005b48 <sys_open+0xe4>
    iunlockput(ip);
    80005bac:	8526                	mv	a0,s1
    80005bae:	ffffe097          	auipc	ra,0xffffe
    80005bb2:	186080e7          	jalr	390(ra) # 80003d34 <iunlockput>
    end_op();
    80005bb6:	fffff097          	auipc	ra,0xfffff
    80005bba:	95e080e7          	jalr	-1698(ra) # 80004514 <end_op>
    return -1;
    80005bbe:	557d                	li	a0,-1
    80005bc0:	b761                	j	80005b48 <sys_open+0xe4>
    f->type = FD_DEVICE;
    80005bc2:	00f9a023          	sw	a5,0(s3)
    f->major = ip->major;
    80005bc6:	04e49783          	lh	a5,78(s1)
    80005bca:	02f99223          	sh	a5,36(s3)
    80005bce:	bf25                	j	80005b06 <sys_open+0xa2>
    itrunc(ip);
    80005bd0:	8526                	mv	a0,s1
    80005bd2:	ffffe097          	auipc	ra,0xffffe
    80005bd6:	00e080e7          	jalr	14(ra) # 80003be0 <itrunc>
    80005bda:	bfa9                	j	80005b34 <sys_open+0xd0>
      fileclose(f);
    80005bdc:	854e                	mv	a0,s3
    80005bde:	fffff097          	auipc	ra,0xfffff
    80005be2:	d82080e7          	jalr	-638(ra) # 80004960 <fileclose>
    iunlockput(ip);
    80005be6:	8526                	mv	a0,s1
    80005be8:	ffffe097          	auipc	ra,0xffffe
    80005bec:	14c080e7          	jalr	332(ra) # 80003d34 <iunlockput>
    end_op();
    80005bf0:	fffff097          	auipc	ra,0xfffff
    80005bf4:	924080e7          	jalr	-1756(ra) # 80004514 <end_op>
    return -1;
    80005bf8:	557d                	li	a0,-1
    80005bfa:	b7b9                	j	80005b48 <sys_open+0xe4>

0000000080005bfc <sys_mkdir>:

uint64
sys_mkdir(void)
{
    80005bfc:	7175                	addi	sp,sp,-144
    80005bfe:	e506                	sd	ra,136(sp)
    80005c00:	e122                	sd	s0,128(sp)
    80005c02:	0900                	addi	s0,sp,144
  char path[MAXPATH];
  struct inode *ip;

  begin_op();
    80005c04:	fffff097          	auipc	ra,0xfffff
    80005c08:	890080e7          	jalr	-1904(ra) # 80004494 <begin_op>
  if(argstr(0, path, MAXPATH) < 0 || (ip = create(path, T_DIR, 0, 0)) == 0){
    80005c0c:	08000613          	li	a2,128
    80005c10:	f7040593          	addi	a1,s0,-144
    80005c14:	4501                	li	a0,0
    80005c16:	ffffd097          	auipc	ra,0xffffd
    80005c1a:	29e080e7          	jalr	670(ra) # 80002eb4 <argstr>
    80005c1e:	02054963          	bltz	a0,80005c50 <sys_mkdir+0x54>
    80005c22:	4681                	li	a3,0
    80005c24:	4601                	li	a2,0
    80005c26:	4585                	li	a1,1
    80005c28:	f7040513          	addi	a0,s0,-144
    80005c2c:	fffff097          	auipc	ra,0xfffff
    80005c30:	7fe080e7          	jalr	2046(ra) # 8000542a <create>
    80005c34:	cd11                	beqz	a0,80005c50 <sys_mkdir+0x54>
    end_op();
    return -1;
  }
  iunlockput(ip);
    80005c36:	ffffe097          	auipc	ra,0xffffe
    80005c3a:	0fe080e7          	jalr	254(ra) # 80003d34 <iunlockput>
  end_op();
    80005c3e:	fffff097          	auipc	ra,0xfffff
    80005c42:	8d6080e7          	jalr	-1834(ra) # 80004514 <end_op>
  return 0;
    80005c46:	4501                	li	a0,0
}
    80005c48:	60aa                	ld	ra,136(sp)
    80005c4a:	640a                	ld	s0,128(sp)
    80005c4c:	6149                	addi	sp,sp,144
    80005c4e:	8082                	ret
    end_op();
    80005c50:	fffff097          	auipc	ra,0xfffff
    80005c54:	8c4080e7          	jalr	-1852(ra) # 80004514 <end_op>
    return -1;
    80005c58:	557d                	li	a0,-1
    80005c5a:	b7fd                	j	80005c48 <sys_mkdir+0x4c>

0000000080005c5c <sys_mknod>:

uint64
sys_mknod(void)
{
    80005c5c:	7135                	addi	sp,sp,-160
    80005c5e:	ed06                	sd	ra,152(sp)
    80005c60:	e922                	sd	s0,144(sp)
    80005c62:	1100                	addi	s0,sp,160
  struct inode *ip;
  char path[MAXPATH];
  int major, minor;

  begin_op();
    80005c64:	fffff097          	auipc	ra,0xfffff
    80005c68:	830080e7          	jalr	-2000(ra) # 80004494 <begin_op>
  argint(1, &major);
    80005c6c:	f6c40593          	addi	a1,s0,-148
    80005c70:	4505                	li	a0,1
    80005c72:	ffffd097          	auipc	ra,0xffffd
    80005c76:	202080e7          	jalr	514(ra) # 80002e74 <argint>
  argint(2, &minor);
    80005c7a:	f6840593          	addi	a1,s0,-152
    80005c7e:	4509                	li	a0,2
    80005c80:	ffffd097          	auipc	ra,0xffffd
    80005c84:	1f4080e7          	jalr	500(ra) # 80002e74 <argint>
  if((argstr(0, path, MAXPATH)) < 0 ||
    80005c88:	08000613          	li	a2,128
    80005c8c:	f7040593          	addi	a1,s0,-144
    80005c90:	4501                	li	a0,0
    80005c92:	ffffd097          	auipc	ra,0xffffd
    80005c96:	222080e7          	jalr	546(ra) # 80002eb4 <argstr>
    80005c9a:	02054b63          	bltz	a0,80005cd0 <sys_mknod+0x74>
     (ip = create(path, T_DEVICE, major, minor)) == 0){
    80005c9e:	f6841683          	lh	a3,-152(s0)
    80005ca2:	f6c41603          	lh	a2,-148(s0)
    80005ca6:	458d                	li	a1,3
    80005ca8:	f7040513          	addi	a0,s0,-144
    80005cac:	fffff097          	auipc	ra,0xfffff
    80005cb0:	77e080e7          	jalr	1918(ra) # 8000542a <create>
  if((argstr(0, path, MAXPATH)) < 0 ||
    80005cb4:	cd11                	beqz	a0,80005cd0 <sys_mknod+0x74>
    end_op();
    return -1;
  }
  iunlockput(ip);
    80005cb6:	ffffe097          	auipc	ra,0xffffe
    80005cba:	07e080e7          	jalr	126(ra) # 80003d34 <iunlockput>
  end_op();
    80005cbe:	fffff097          	auipc	ra,0xfffff
    80005cc2:	856080e7          	jalr	-1962(ra) # 80004514 <end_op>
  return 0;
    80005cc6:	4501                	li	a0,0
}
    80005cc8:	60ea                	ld	ra,152(sp)
    80005cca:	644a                	ld	s0,144(sp)
    80005ccc:	610d                	addi	sp,sp,160
    80005cce:	8082                	ret
    end_op();
    80005cd0:	fffff097          	auipc	ra,0xfffff
    80005cd4:	844080e7          	jalr	-1980(ra) # 80004514 <end_op>
    return -1;
    80005cd8:	557d                	li	a0,-1
    80005cda:	b7fd                	j	80005cc8 <sys_mknod+0x6c>

0000000080005cdc <sys_chdir>:

uint64
sys_chdir(void)
{
    80005cdc:	7135                	addi	sp,sp,-160
    80005cde:	ed06                	sd	ra,152(sp)
    80005ce0:	e922                	sd	s0,144(sp)
    80005ce2:	e526                	sd	s1,136(sp)
    80005ce4:	e14a                	sd	s2,128(sp)
    80005ce6:	1100                	addi	s0,sp,160
  char path[MAXPATH];
  struct inode *ip;
  struct proc *p = myproc();
    80005ce8:	ffffc097          	auipc	ra,0xffffc
    80005cec:	dae080e7          	jalr	-594(ra) # 80001a96 <myproc>
    80005cf0:	892a                	mv	s2,a0
  
  begin_op();
    80005cf2:	ffffe097          	auipc	ra,0xffffe
    80005cf6:	7a2080e7          	jalr	1954(ra) # 80004494 <begin_op>
  if(argstr(0, path, MAXPATH) < 0 || (ip = namei(path)) == 0){
    80005cfa:	08000613          	li	a2,128
    80005cfe:	f6040593          	addi	a1,s0,-160
    80005d02:	4501                	li	a0,0
    80005d04:	ffffd097          	auipc	ra,0xffffd
    80005d08:	1b0080e7          	jalr	432(ra) # 80002eb4 <argstr>
    80005d0c:	04054b63          	bltz	a0,80005d62 <sys_chdir+0x86>
    80005d10:	f6040513          	addi	a0,s0,-160
    80005d14:	ffffe097          	auipc	ra,0xffffe
    80005d18:	564080e7          	jalr	1380(ra) # 80004278 <namei>
    80005d1c:	84aa                	mv	s1,a0
    80005d1e:	c131                	beqz	a0,80005d62 <sys_chdir+0x86>
    end_op();
    return -1;
  }
  ilock(ip);
    80005d20:	ffffe097          	auipc	ra,0xffffe
    80005d24:	db2080e7          	jalr	-590(ra) # 80003ad2 <ilock>
  if(ip->type != T_DIR){
    80005d28:	04c49703          	lh	a4,76(s1)
    80005d2c:	4785                	li	a5,1
    80005d2e:	04f71063          	bne	a4,a5,80005d6e <sys_chdir+0x92>
    iunlockput(ip);
    end_op();
    return -1;
  }
  iunlock(ip);
    80005d32:	8526                	mv	a0,s1
    80005d34:	ffffe097          	auipc	ra,0xffffe
    80005d38:	e60080e7          	jalr	-416(ra) # 80003b94 <iunlock>
  iput(p->cwd);
    80005d3c:	16093503          	ld	a0,352(s2)
    80005d40:	ffffe097          	auipc	ra,0xffffe
    80005d44:	f4c080e7          	jalr	-180(ra) # 80003c8c <iput>
  end_op();
    80005d48:	ffffe097          	auipc	ra,0xffffe
    80005d4c:	7cc080e7          	jalr	1996(ra) # 80004514 <end_op>
  p->cwd = ip;
    80005d50:	16993023          	sd	s1,352(s2)
  return 0;
    80005d54:	4501                	li	a0,0
}
    80005d56:	60ea                	ld	ra,152(sp)
    80005d58:	644a                	ld	s0,144(sp)
    80005d5a:	64aa                	ld	s1,136(sp)
    80005d5c:	690a                	ld	s2,128(sp)
    80005d5e:	610d                	addi	sp,sp,160
    80005d60:	8082                	ret
    end_op();
    80005d62:	ffffe097          	auipc	ra,0xffffe
    80005d66:	7b2080e7          	jalr	1970(ra) # 80004514 <end_op>
    return -1;
    80005d6a:	557d                	li	a0,-1
    80005d6c:	b7ed                	j	80005d56 <sys_chdir+0x7a>
    iunlockput(ip);
    80005d6e:	8526                	mv	a0,s1
    80005d70:	ffffe097          	auipc	ra,0xffffe
    80005d74:	fc4080e7          	jalr	-60(ra) # 80003d34 <iunlockput>
    end_op();
    80005d78:	ffffe097          	auipc	ra,0xffffe
    80005d7c:	79c080e7          	jalr	1948(ra) # 80004514 <end_op>
    return -1;
    80005d80:	557d                	li	a0,-1
    80005d82:	bfd1                	j	80005d56 <sys_chdir+0x7a>

0000000080005d84 <sys_exec>:

uint64
sys_exec(void)
{
    80005d84:	7145                	addi	sp,sp,-464
    80005d86:	e786                	sd	ra,456(sp)
    80005d88:	e3a2                	sd	s0,448(sp)
    80005d8a:	ff26                	sd	s1,440(sp)
    80005d8c:	fb4a                	sd	s2,432(sp)
    80005d8e:	f74e                	sd	s3,424(sp)
    80005d90:	f352                	sd	s4,416(sp)
    80005d92:	ef56                	sd	s5,408(sp)
    80005d94:	0b80                	addi	s0,sp,464
  char path[MAXPATH], *argv[MAXARG];
  int i;
  uint64 uargv, uarg;

  argaddr(1, &uargv);
    80005d96:	e3840593          	addi	a1,s0,-456
    80005d9a:	4505                	li	a0,1
    80005d9c:	ffffd097          	auipc	ra,0xffffd
    80005da0:	0f8080e7          	jalr	248(ra) # 80002e94 <argaddr>
  if(argstr(0, path, MAXPATH) < 0) {
    80005da4:	08000613          	li	a2,128
    80005da8:	f4040593          	addi	a1,s0,-192
    80005dac:	4501                	li	a0,0
    80005dae:	ffffd097          	auipc	ra,0xffffd
    80005db2:	106080e7          	jalr	262(ra) # 80002eb4 <argstr>
    80005db6:	87aa                	mv	a5,a0
    return -1;
    80005db8:	557d                	li	a0,-1
  if(argstr(0, path, MAXPATH) < 0) {
    80005dba:	0c07c263          	bltz	a5,80005e7e <sys_exec+0xfa>
  }
  memset(argv, 0, sizeof(argv));
    80005dbe:	10000613          	li	a2,256
    80005dc2:	4581                	li	a1,0
    80005dc4:	e4040513          	addi	a0,s0,-448
    80005dc8:	ffffb097          	auipc	ra,0xffffb
    80005dcc:	fee080e7          	jalr	-18(ra) # 80000db6 <memset>
  for(i=0;; i++){
    if(i >= NELEM(argv)){
    80005dd0:	e4040493          	addi	s1,s0,-448
  memset(argv, 0, sizeof(argv));
    80005dd4:	89a6                	mv	s3,s1
    80005dd6:	4901                	li	s2,0
    if(i >= NELEM(argv)){
    80005dd8:	02000a13          	li	s4,32
    80005ddc:	00090a9b          	sext.w	s5,s2
      goto bad;
    }
    if(fetchaddr(uargv+sizeof(uint64)*i, (uint64*)&uarg) < 0){
    80005de0:	00391513          	slli	a0,s2,0x3
    80005de4:	e3040593          	addi	a1,s0,-464
    80005de8:	e3843783          	ld	a5,-456(s0)
    80005dec:	953e                	add	a0,a0,a5
    80005dee:	ffffd097          	auipc	ra,0xffffd
    80005df2:	fe8080e7          	jalr	-24(ra) # 80002dd6 <fetchaddr>
    80005df6:	02054a63          	bltz	a0,80005e2a <sys_exec+0xa6>
      goto bad;
    }
    if(uarg == 0){
    80005dfa:	e3043783          	ld	a5,-464(s0)
    80005dfe:	c3b9                	beqz	a5,80005e44 <sys_exec+0xc0>
      argv[i] = 0;
      break;
    }
    argv[i] = kalloc();
    80005e00:	ffffb097          	auipc	ra,0xffffb
    80005e04:	cfa080e7          	jalr	-774(ra) # 80000afa <kalloc>
    80005e08:	85aa                	mv	a1,a0
    80005e0a:	00a9b023          	sd	a0,0(s3)
    if(argv[i] == 0)
    80005e0e:	cd11                	beqz	a0,80005e2a <sys_exec+0xa6>
      goto bad;
    if(fetchstr(uarg, argv[i], PGSIZE) < 0)
    80005e10:	6605                	lui	a2,0x1
    80005e12:	e3043503          	ld	a0,-464(s0)
    80005e16:	ffffd097          	auipc	ra,0xffffd
    80005e1a:	012080e7          	jalr	18(ra) # 80002e28 <fetchstr>
    80005e1e:	00054663          	bltz	a0,80005e2a <sys_exec+0xa6>
    if(i >= NELEM(argv)){
    80005e22:	0905                	addi	s2,s2,1
    80005e24:	09a1                	addi	s3,s3,8
    80005e26:	fb491be3          	bne	s2,s4,80005ddc <sys_exec+0x58>
    kfree(argv[i]);

  return ret;

 bad:
  for(i = 0; i < NELEM(argv) && argv[i] != 0; i++)
    80005e2a:	10048913          	addi	s2,s1,256
    80005e2e:	6088                	ld	a0,0(s1)
    80005e30:	c531                	beqz	a0,80005e7c <sys_exec+0xf8>
    kfree(argv[i]);
    80005e32:	ffffb097          	auipc	ra,0xffffb
    80005e36:	bcc080e7          	jalr	-1076(ra) # 800009fe <kfree>
  for(i = 0; i < NELEM(argv) && argv[i] != 0; i++)
    80005e3a:	04a1                	addi	s1,s1,8
    80005e3c:	ff2499e3          	bne	s1,s2,80005e2e <sys_exec+0xaa>
  return -1;
    80005e40:	557d                	li	a0,-1
    80005e42:	a835                	j	80005e7e <sys_exec+0xfa>
      argv[i] = 0;
    80005e44:	0a8e                	slli	s5,s5,0x3
    80005e46:	fc040793          	addi	a5,s0,-64
    80005e4a:	9abe                	add	s5,s5,a5
    80005e4c:	e80ab023          	sd	zero,-384(s5)
  int ret = exec(path, argv);
    80005e50:	e4040593          	addi	a1,s0,-448
    80005e54:	f4040513          	addi	a0,s0,-192
    80005e58:	fffff097          	auipc	ra,0xfffff
    80005e5c:	190080e7          	jalr	400(ra) # 80004fe8 <exec>
    80005e60:	892a                	mv	s2,a0
  for(i = 0; i < NELEM(argv) && argv[i] != 0; i++)
    80005e62:	10048993          	addi	s3,s1,256
    80005e66:	6088                	ld	a0,0(s1)
    80005e68:	c901                	beqz	a0,80005e78 <sys_exec+0xf4>
    kfree(argv[i]);
    80005e6a:	ffffb097          	auipc	ra,0xffffb
    80005e6e:	b94080e7          	jalr	-1132(ra) # 800009fe <kfree>
  for(i = 0; i < NELEM(argv) && argv[i] != 0; i++)
    80005e72:	04a1                	addi	s1,s1,8
    80005e74:	ff3499e3          	bne	s1,s3,80005e66 <sys_exec+0xe2>
  return ret;
    80005e78:	854a                	mv	a0,s2
    80005e7a:	a011                	j	80005e7e <sys_exec+0xfa>
  return -1;
    80005e7c:	557d                	li	a0,-1
}
    80005e7e:	60be                	ld	ra,456(sp)
    80005e80:	641e                	ld	s0,448(sp)
    80005e82:	74fa                	ld	s1,440(sp)
    80005e84:	795a                	ld	s2,432(sp)
    80005e86:	79ba                	ld	s3,424(sp)
    80005e88:	7a1a                	ld	s4,416(sp)
    80005e8a:	6afa                	ld	s5,408(sp)
    80005e8c:	6179                	addi	sp,sp,464
    80005e8e:	8082                	ret

0000000080005e90 <sys_pipe>:

uint64
sys_pipe(void)
{
    80005e90:	7139                	addi	sp,sp,-64
    80005e92:	fc06                	sd	ra,56(sp)
    80005e94:	f822                	sd	s0,48(sp)
    80005e96:	f426                	sd	s1,40(sp)
    80005e98:	0080                	addi	s0,sp,64
  uint64 fdarray; // user pointer to array of two integers
  struct file *rf, *wf;
  int fd0, fd1;
  struct proc *p = myproc();
    80005e9a:	ffffc097          	auipc	ra,0xffffc
    80005e9e:	bfc080e7          	jalr	-1028(ra) # 80001a96 <myproc>
    80005ea2:	84aa                	mv	s1,a0

  argaddr(0, &fdarray);
    80005ea4:	fd840593          	addi	a1,s0,-40
    80005ea8:	4501                	li	a0,0
    80005eaa:	ffffd097          	auipc	ra,0xffffd
    80005eae:	fea080e7          	jalr	-22(ra) # 80002e94 <argaddr>
  if(pipealloc(&rf, &wf) < 0)
    80005eb2:	fc840593          	addi	a1,s0,-56
    80005eb6:	fd040513          	addi	a0,s0,-48
    80005eba:	fffff097          	auipc	ra,0xfffff
    80005ebe:	dd6080e7          	jalr	-554(ra) # 80004c90 <pipealloc>
    return -1;
    80005ec2:	57fd                	li	a5,-1
  if(pipealloc(&rf, &wf) < 0)
    80005ec4:	0c054463          	bltz	a0,80005f8c <sys_pipe+0xfc>
  fd0 = -1;
    80005ec8:	fcf42223          	sw	a5,-60(s0)
  if((fd0 = fdalloc(rf)) < 0 || (fd1 = fdalloc(wf)) < 0){
    80005ecc:	fd043503          	ld	a0,-48(s0)
    80005ed0:	fffff097          	auipc	ra,0xfffff
    80005ed4:	518080e7          	jalr	1304(ra) # 800053e8 <fdalloc>
    80005ed8:	fca42223          	sw	a0,-60(s0)
    80005edc:	08054b63          	bltz	a0,80005f72 <sys_pipe+0xe2>
    80005ee0:	fc843503          	ld	a0,-56(s0)
    80005ee4:	fffff097          	auipc	ra,0xfffff
    80005ee8:	504080e7          	jalr	1284(ra) # 800053e8 <fdalloc>
    80005eec:	fca42023          	sw	a0,-64(s0)
    80005ef0:	06054863          	bltz	a0,80005f60 <sys_pipe+0xd0>
      p->ofile[fd0] = 0;
    fileclose(rf);
    fileclose(wf);
    return -1;
  }
  if(copyout(p->pagetable, fdarray, (char*)&fd0, sizeof(fd0)) < 0 ||
    80005ef4:	4691                	li	a3,4
    80005ef6:	fc440613          	addi	a2,s0,-60
    80005efa:	fd843583          	ld	a1,-40(s0)
    80005efe:	70a8                	ld	a0,96(s1)
    80005f00:	ffffc097          	auipc	ra,0xffffc
    80005f04:	854080e7          	jalr	-1964(ra) # 80001754 <copyout>
    80005f08:	02054063          	bltz	a0,80005f28 <sys_pipe+0x98>
     copyout(p->pagetable, fdarray+sizeof(fd0), (char *)&fd1, sizeof(fd1)) < 0){
    80005f0c:	4691                	li	a3,4
    80005f0e:	fc040613          	addi	a2,s0,-64
    80005f12:	fd843583          	ld	a1,-40(s0)
    80005f16:	0591                	addi	a1,a1,4
    80005f18:	70a8                	ld	a0,96(s1)
    80005f1a:	ffffc097          	auipc	ra,0xffffc
    80005f1e:	83a080e7          	jalr	-1990(ra) # 80001754 <copyout>
    p->ofile[fd1] = 0;
    fileclose(rf);
    fileclose(wf);
    return -1;
  }
  return 0;
    80005f22:	4781                	li	a5,0
  if(copyout(p->pagetable, fdarray, (char*)&fd0, sizeof(fd0)) < 0 ||
    80005f24:	06055463          	bgez	a0,80005f8c <sys_pipe+0xfc>
    p->ofile[fd0] = 0;
    80005f28:	fc442783          	lw	a5,-60(s0)
    80005f2c:	07f1                	addi	a5,a5,28
    80005f2e:	078e                	slli	a5,a5,0x3
    80005f30:	97a6                	add	a5,a5,s1
    80005f32:	0007b023          	sd	zero,0(a5)
    p->ofile[fd1] = 0;
    80005f36:	fc042503          	lw	a0,-64(s0)
    80005f3a:	0571                	addi	a0,a0,28
    80005f3c:	050e                	slli	a0,a0,0x3
    80005f3e:	94aa                	add	s1,s1,a0
    80005f40:	0004b023          	sd	zero,0(s1)
    fileclose(rf);
    80005f44:	fd043503          	ld	a0,-48(s0)
    80005f48:	fffff097          	auipc	ra,0xfffff
    80005f4c:	a18080e7          	jalr	-1512(ra) # 80004960 <fileclose>
    fileclose(wf);
    80005f50:	fc843503          	ld	a0,-56(s0)
    80005f54:	fffff097          	auipc	ra,0xfffff
    80005f58:	a0c080e7          	jalr	-1524(ra) # 80004960 <fileclose>
    return -1;
    80005f5c:	57fd                	li	a5,-1
    80005f5e:	a03d                	j	80005f8c <sys_pipe+0xfc>
    if(fd0 >= 0)
    80005f60:	fc442783          	lw	a5,-60(s0)
    80005f64:	0007c763          	bltz	a5,80005f72 <sys_pipe+0xe2>
      p->ofile[fd0] = 0;
    80005f68:	07f1                	addi	a5,a5,28
    80005f6a:	078e                	slli	a5,a5,0x3
    80005f6c:	94be                	add	s1,s1,a5
    80005f6e:	0004b023          	sd	zero,0(s1)
    fileclose(rf);
    80005f72:	fd043503          	ld	a0,-48(s0)
    80005f76:	fffff097          	auipc	ra,0xfffff
    80005f7a:	9ea080e7          	jalr	-1558(ra) # 80004960 <fileclose>
    fileclose(wf);
    80005f7e:	fc843503          	ld	a0,-56(s0)
    80005f82:	fffff097          	auipc	ra,0xfffff
    80005f86:	9de080e7          	jalr	-1570(ra) # 80004960 <fileclose>
    return -1;
    80005f8a:	57fd                	li	a5,-1
}
    80005f8c:	853e                	mv	a0,a5
    80005f8e:	70e2                	ld	ra,56(sp)
    80005f90:	7442                	ld	s0,48(sp)
    80005f92:	74a2                	ld	s1,40(sp)
    80005f94:	6121                	addi	sp,sp,64
    80005f96:	8082                	ret
	...

0000000080005fa0 <kernelvec>:
    80005fa0:	7111                	addi	sp,sp,-256
    80005fa2:	e006                	sd	ra,0(sp)
    80005fa4:	e40a                	sd	sp,8(sp)
    80005fa6:	e80e                	sd	gp,16(sp)
    80005fa8:	ec12                	sd	tp,24(sp)
    80005faa:	f016                	sd	t0,32(sp)
    80005fac:	f41a                	sd	t1,40(sp)
    80005fae:	f81e                	sd	t2,48(sp)
    80005fb0:	fc22                	sd	s0,56(sp)
    80005fb2:	e0a6                	sd	s1,64(sp)
    80005fb4:	e4aa                	sd	a0,72(sp)
    80005fb6:	e8ae                	sd	a1,80(sp)
    80005fb8:	ecb2                	sd	a2,88(sp)
    80005fba:	f0b6                	sd	a3,96(sp)
    80005fbc:	f4ba                	sd	a4,104(sp)
    80005fbe:	f8be                	sd	a5,112(sp)
    80005fc0:	fcc2                	sd	a6,120(sp)
    80005fc2:	e146                	sd	a7,128(sp)
    80005fc4:	e54a                	sd	s2,136(sp)
    80005fc6:	e94e                	sd	s3,144(sp)
    80005fc8:	ed52                	sd	s4,152(sp)
    80005fca:	f156                	sd	s5,160(sp)
    80005fcc:	f55a                	sd	s6,168(sp)
    80005fce:	f95e                	sd	s7,176(sp)
    80005fd0:	fd62                	sd	s8,184(sp)
    80005fd2:	e1e6                	sd	s9,192(sp)
    80005fd4:	e5ea                	sd	s10,200(sp)
    80005fd6:	e9ee                	sd	s11,208(sp)
    80005fd8:	edf2                	sd	t3,216(sp)
    80005fda:	f1f6                	sd	t4,224(sp)
    80005fdc:	f5fa                	sd	t5,232(sp)
    80005fde:	f9fe                	sd	t6,240(sp)
    80005fe0:	cc3fc0ef          	jal	ra,80002ca2 <kerneltrap>
    80005fe4:	6082                	ld	ra,0(sp)
    80005fe6:	6122                	ld	sp,8(sp)
    80005fe8:	61c2                	ld	gp,16(sp)
    80005fea:	7282                	ld	t0,32(sp)
    80005fec:	7322                	ld	t1,40(sp)
    80005fee:	73c2                	ld	t2,48(sp)
    80005ff0:	7462                	ld	s0,56(sp)
    80005ff2:	6486                	ld	s1,64(sp)
    80005ff4:	6526                	ld	a0,72(sp)
    80005ff6:	65c6                	ld	a1,80(sp)
    80005ff8:	6666                	ld	a2,88(sp)
    80005ffa:	7686                	ld	a3,96(sp)
    80005ffc:	7726                	ld	a4,104(sp)
    80005ffe:	77c6                	ld	a5,112(sp)
    80006000:	7866                	ld	a6,120(sp)
    80006002:	688a                	ld	a7,128(sp)
    80006004:	692a                	ld	s2,136(sp)
    80006006:	69ca                	ld	s3,144(sp)
    80006008:	6a6a                	ld	s4,152(sp)
    8000600a:	7a8a                	ld	s5,160(sp)
    8000600c:	7b2a                	ld	s6,168(sp)
    8000600e:	7bca                	ld	s7,176(sp)
    80006010:	7c6a                	ld	s8,184(sp)
    80006012:	6c8e                	ld	s9,192(sp)
    80006014:	6d2e                	ld	s10,200(sp)
    80006016:	6dce                	ld	s11,208(sp)
    80006018:	6e6e                	ld	t3,216(sp)
    8000601a:	7e8e                	ld	t4,224(sp)
    8000601c:	7f2e                	ld	t5,232(sp)
    8000601e:	7fce                	ld	t6,240(sp)
    80006020:	6111                	addi	sp,sp,256
    80006022:	10200073          	sret
    80006026:	00000013          	nop
    8000602a:	00000013          	nop
    8000602e:	0001                	nop

0000000080006030 <timervec>:
    80006030:	34051573          	csrrw	a0,mscratch,a0
    80006034:	e10c                	sd	a1,0(a0)
    80006036:	e510                	sd	a2,8(a0)
    80006038:	e914                	sd	a3,16(a0)
    8000603a:	6d0c                	ld	a1,24(a0)
    8000603c:	7110                	ld	a2,32(a0)
    8000603e:	6194                	ld	a3,0(a1)
    80006040:	96b2                	add	a3,a3,a2
    80006042:	e194                	sd	a3,0(a1)
    80006044:	4589                	li	a1,2
    80006046:	14459073          	csrw	sip,a1
    8000604a:	6914                	ld	a3,16(a0)
    8000604c:	6510                	ld	a2,8(a0)
    8000604e:	610c                	ld	a1,0(a0)
    80006050:	34051573          	csrrw	a0,mscratch,a0
    80006054:	30200073          	mret
	...

000000008000605a <plicinit>:
// the riscv Platform Level Interrupt Controller (PLIC).
//

void
plicinit(void)
{
    8000605a:	1141                	addi	sp,sp,-16
    8000605c:	e422                	sd	s0,8(sp)
    8000605e:	0800                	addi	s0,sp,16
  // set desired IRQ priorities non-zero (otherwise disabled).
  *(uint32*)(PLIC + UART0_IRQ*4) = 1;
    80006060:	0c0007b7          	lui	a5,0xc000
    80006064:	4705                	li	a4,1
    80006066:	d798                	sw	a4,40(a5)
  *(uint32*)(PLIC + VIRTIO0_IRQ*4) = 1;
    80006068:	c3d8                	sw	a4,4(a5)
}
    8000606a:	6422                	ld	s0,8(sp)
    8000606c:	0141                	addi	sp,sp,16
    8000606e:	8082                	ret

0000000080006070 <plicinithart>:

void
plicinithart(void)
{
    80006070:	1141                	addi	sp,sp,-16
    80006072:	e406                	sd	ra,8(sp)
    80006074:	e022                	sd	s0,0(sp)
    80006076:	0800                	addi	s0,sp,16
  int hart = cpuid();
    80006078:	ffffc097          	auipc	ra,0xffffc
    8000607c:	9f2080e7          	jalr	-1550(ra) # 80001a6a <cpuid>
  
  // set enable bits for this hart's S-mode
  // for the uart and virtio disk.
  *(uint32*)PLIC_SENABLE(hart) = (1 << UART0_IRQ) | (1 << VIRTIO0_IRQ);
    80006080:	0085171b          	slliw	a4,a0,0x8
    80006084:	0c0027b7          	lui	a5,0xc002
    80006088:	97ba                	add	a5,a5,a4
    8000608a:	40200713          	li	a4,1026
    8000608e:	08e7a023          	sw	a4,128(a5) # c002080 <_entry-0x73ffdf80>

  // set this hart's S-mode priority threshold to 0.
  *(uint32*)PLIC_SPRIORITY(hart) = 0;
    80006092:	00d5151b          	slliw	a0,a0,0xd
    80006096:	0c2017b7          	lui	a5,0xc201
    8000609a:	953e                	add	a0,a0,a5
    8000609c:	00052023          	sw	zero,0(a0)
}
    800060a0:	60a2                	ld	ra,8(sp)
    800060a2:	6402                	ld	s0,0(sp)
    800060a4:	0141                	addi	sp,sp,16
    800060a6:	8082                	ret

00000000800060a8 <plic_claim>:

// ask the PLIC what interrupt we should serve.
int
plic_claim(void)
{
    800060a8:	1141                	addi	sp,sp,-16
    800060aa:	e406                	sd	ra,8(sp)
    800060ac:	e022                	sd	s0,0(sp)
    800060ae:	0800                	addi	s0,sp,16
  int hart = cpuid();
    800060b0:	ffffc097          	auipc	ra,0xffffc
    800060b4:	9ba080e7          	jalr	-1606(ra) # 80001a6a <cpuid>
  int irq = *(uint32*)PLIC_SCLAIM(hart);
    800060b8:	00d5179b          	slliw	a5,a0,0xd
    800060bc:	0c201537          	lui	a0,0xc201
    800060c0:	953e                	add	a0,a0,a5
  return irq;
}
    800060c2:	4148                	lw	a0,4(a0)
    800060c4:	60a2                	ld	ra,8(sp)
    800060c6:	6402                	ld	s0,0(sp)
    800060c8:	0141                	addi	sp,sp,16
    800060ca:	8082                	ret

00000000800060cc <plic_complete>:

// tell the PLIC we've served this IRQ.
void
plic_complete(int irq)
{
    800060cc:	1101                	addi	sp,sp,-32
    800060ce:	ec06                	sd	ra,24(sp)
    800060d0:	e822                	sd	s0,16(sp)
    800060d2:	e426                	sd	s1,8(sp)
    800060d4:	1000                	addi	s0,sp,32
    800060d6:	84aa                	mv	s1,a0
  int hart = cpuid();
    800060d8:	ffffc097          	auipc	ra,0xffffc
    800060dc:	992080e7          	jalr	-1646(ra) # 80001a6a <cpuid>
  *(uint32*)PLIC_SCLAIM(hart) = irq;
    800060e0:	00d5151b          	slliw	a0,a0,0xd
    800060e4:	0c2017b7          	lui	a5,0xc201
    800060e8:	97aa                	add	a5,a5,a0
    800060ea:	c3c4                	sw	s1,4(a5)
}
    800060ec:	60e2                	ld	ra,24(sp)
    800060ee:	6442                	ld	s0,16(sp)
    800060f0:	64a2                	ld	s1,8(sp)
    800060f2:	6105                	addi	sp,sp,32
    800060f4:	8082                	ret

00000000800060f6 <free_desc>:
}

// mark a descriptor as free.
static void
free_desc(int i)
{
    800060f6:	1141                	addi	sp,sp,-16
    800060f8:	e406                	sd	ra,8(sp)
    800060fa:	e022                	sd	s0,0(sp)
    800060fc:	0800                	addi	s0,sp,16
  if(i >= NUM)
    800060fe:	479d                	li	a5,7
    80006100:	04a7cc63          	blt	a5,a0,80006158 <free_desc+0x62>
    panic("free_desc 1");
  if(disk.free[i])
    80006104:	0001c797          	auipc	a5,0x1c
    80006108:	66c78793          	addi	a5,a5,1644 # 80022770 <disk>
    8000610c:	97aa                	add	a5,a5,a0
    8000610e:	0187c783          	lbu	a5,24(a5)
    80006112:	ebb9                	bnez	a5,80006168 <free_desc+0x72>
    panic("free_desc 2");
  disk.desc[i].addr = 0;
    80006114:	00451613          	slli	a2,a0,0x4
    80006118:	0001c797          	auipc	a5,0x1c
    8000611c:	65878793          	addi	a5,a5,1624 # 80022770 <disk>
    80006120:	6394                	ld	a3,0(a5)
    80006122:	96b2                	add	a3,a3,a2
    80006124:	0006b023          	sd	zero,0(a3)
  disk.desc[i].len = 0;
    80006128:	6398                	ld	a4,0(a5)
    8000612a:	9732                	add	a4,a4,a2
    8000612c:	00072423          	sw	zero,8(a4)
  disk.desc[i].flags = 0;
    80006130:	00071623          	sh	zero,12(a4)
  disk.desc[i].next = 0;
    80006134:	00071723          	sh	zero,14(a4)
  disk.free[i] = 1;
    80006138:	953e                	add	a0,a0,a5
    8000613a:	4785                	li	a5,1
    8000613c:	00f50c23          	sb	a5,24(a0) # c201018 <_entry-0x73dfefe8>
  wakeup(&disk.free[0]);
    80006140:	0001c517          	auipc	a0,0x1c
    80006144:	64850513          	addi	a0,a0,1608 # 80022788 <disk+0x18>
    80006148:	ffffc097          	auipc	ra,0xffffc
    8000614c:	19c080e7          	jalr	412(ra) # 800022e4 <wakeup>
}
    80006150:	60a2                	ld	ra,8(sp)
    80006152:	6402                	ld	s0,0(sp)
    80006154:	0141                	addi	sp,sp,16
    80006156:	8082                	ret
    panic("free_desc 1");
    80006158:	00003517          	auipc	a0,0x3
    8000615c:	85050513          	addi	a0,a0,-1968 # 800089a8 <syscall_name+0x308>
    80006160:	ffffa097          	auipc	ra,0xffffa
    80006164:	3e4080e7          	jalr	996(ra) # 80000544 <panic>
    panic("free_desc 2");
    80006168:	00003517          	auipc	a0,0x3
    8000616c:	85050513          	addi	a0,a0,-1968 # 800089b8 <syscall_name+0x318>
    80006170:	ffffa097          	auipc	ra,0xffffa
    80006174:	3d4080e7          	jalr	980(ra) # 80000544 <panic>

0000000080006178 <virtio_disk_init>:
{
    80006178:	1101                	addi	sp,sp,-32
    8000617a:	ec06                	sd	ra,24(sp)
    8000617c:	e822                	sd	s0,16(sp)
    8000617e:	e426                	sd	s1,8(sp)
    80006180:	e04a                	sd	s2,0(sp)
    80006182:	1000                	addi	s0,sp,32
  initlock(&disk.vdisk_lock, "virtio_disk");
    80006184:	00003597          	auipc	a1,0x3
    80006188:	84458593          	addi	a1,a1,-1980 # 800089c8 <syscall_name+0x328>
    8000618c:	0001c517          	auipc	a0,0x1c
    80006190:	70c50513          	addi	a0,a0,1804 # 80022898 <disk+0x128>
    80006194:	ffffb097          	auipc	ra,0xffffb
    80006198:	a10080e7          	jalr	-1520(ra) # 80000ba4 <initlock>
  if(*R(VIRTIO_MMIO_MAGIC_VALUE) != 0x74726976 ||
    8000619c:	100017b7          	lui	a5,0x10001
    800061a0:	4398                	lw	a4,0(a5)
    800061a2:	2701                	sext.w	a4,a4
    800061a4:	747277b7          	lui	a5,0x74727
    800061a8:	97678793          	addi	a5,a5,-1674 # 74726976 <_entry-0xb8d968a>
    800061ac:	14f71e63          	bne	a4,a5,80006308 <virtio_disk_init+0x190>
     *R(VIRTIO_MMIO_VERSION) != 2 ||
    800061b0:	100017b7          	lui	a5,0x10001
    800061b4:	43dc                	lw	a5,4(a5)
    800061b6:	2781                	sext.w	a5,a5
  if(*R(VIRTIO_MMIO_MAGIC_VALUE) != 0x74726976 ||
    800061b8:	4709                	li	a4,2
    800061ba:	14e79763          	bne	a5,a4,80006308 <virtio_disk_init+0x190>
     *R(VIRTIO_MMIO_DEVICE_ID) != 2 ||
    800061be:	100017b7          	lui	a5,0x10001
    800061c2:	479c                	lw	a5,8(a5)
    800061c4:	2781                	sext.w	a5,a5
     *R(VIRTIO_MMIO_VERSION) != 2 ||
    800061c6:	14e79163          	bne	a5,a4,80006308 <virtio_disk_init+0x190>
     *R(VIRTIO_MMIO_VENDOR_ID) != 0x554d4551){
    800061ca:	100017b7          	lui	a5,0x10001
    800061ce:	47d8                	lw	a4,12(a5)
    800061d0:	2701                	sext.w	a4,a4
     *R(VIRTIO_MMIO_DEVICE_ID) != 2 ||
    800061d2:	554d47b7          	lui	a5,0x554d4
    800061d6:	55178793          	addi	a5,a5,1361 # 554d4551 <_entry-0x2ab2baaf>
    800061da:	12f71763          	bne	a4,a5,80006308 <virtio_disk_init+0x190>
  *R(VIRTIO_MMIO_STATUS) = status;
    800061de:	100017b7          	lui	a5,0x10001
    800061e2:	0607a823          	sw	zero,112(a5) # 10001070 <_entry-0x6fffef90>
  *R(VIRTIO_MMIO_STATUS) = status;
    800061e6:	4705                	li	a4,1
    800061e8:	dbb8                	sw	a4,112(a5)
  *R(VIRTIO_MMIO_STATUS) = status;
    800061ea:	470d                	li	a4,3
    800061ec:	dbb8                	sw	a4,112(a5)
  uint64 features = *R(VIRTIO_MMIO_DEVICE_FEATURES);
    800061ee:	4b94                	lw	a3,16(a5)
  features &= ~(1 << VIRTIO_RING_F_INDIRECT_DESC);
    800061f0:	c7ffe737          	lui	a4,0xc7ffe
    800061f4:	75f70713          	addi	a4,a4,1887 # ffffffffc7ffe75f <end+0xffffffff47fdbea7>
    800061f8:	8f75                	and	a4,a4,a3
  *R(VIRTIO_MMIO_DRIVER_FEATURES) = features;
    800061fa:	2701                	sext.w	a4,a4
    800061fc:	d398                	sw	a4,32(a5)
  *R(VIRTIO_MMIO_STATUS) = status;
    800061fe:	472d                	li	a4,11
    80006200:	dbb8                	sw	a4,112(a5)
  status = *R(VIRTIO_MMIO_STATUS);
    80006202:	0707a903          	lw	s2,112(a5)
    80006206:	2901                	sext.w	s2,s2
  if(!(status & VIRTIO_CONFIG_S_FEATURES_OK))
    80006208:	00897793          	andi	a5,s2,8
    8000620c:	10078663          	beqz	a5,80006318 <virtio_disk_init+0x1a0>
  *R(VIRTIO_MMIO_QUEUE_SEL) = 0;
    80006210:	100017b7          	lui	a5,0x10001
    80006214:	0207a823          	sw	zero,48(a5) # 10001030 <_entry-0x6fffefd0>
  if(*R(VIRTIO_MMIO_QUEUE_READY))
    80006218:	43fc                	lw	a5,68(a5)
    8000621a:	2781                	sext.w	a5,a5
    8000621c:	10079663          	bnez	a5,80006328 <virtio_disk_init+0x1b0>
  uint32 max = *R(VIRTIO_MMIO_QUEUE_NUM_MAX);
    80006220:	100017b7          	lui	a5,0x10001
    80006224:	5bdc                	lw	a5,52(a5)
    80006226:	2781                	sext.w	a5,a5
  if(max == 0)
    80006228:	10078863          	beqz	a5,80006338 <virtio_disk_init+0x1c0>
  if(max < NUM)
    8000622c:	471d                	li	a4,7
    8000622e:	10f77d63          	bgeu	a4,a5,80006348 <virtio_disk_init+0x1d0>
  disk.desc = kalloc();
    80006232:	ffffb097          	auipc	ra,0xffffb
    80006236:	8c8080e7          	jalr	-1848(ra) # 80000afa <kalloc>
    8000623a:	0001c497          	auipc	s1,0x1c
    8000623e:	53648493          	addi	s1,s1,1334 # 80022770 <disk>
    80006242:	e088                	sd	a0,0(s1)
  disk.avail = kalloc();
    80006244:	ffffb097          	auipc	ra,0xffffb
    80006248:	8b6080e7          	jalr	-1866(ra) # 80000afa <kalloc>
    8000624c:	e488                	sd	a0,8(s1)
  disk.used = kalloc();
    8000624e:	ffffb097          	auipc	ra,0xffffb
    80006252:	8ac080e7          	jalr	-1876(ra) # 80000afa <kalloc>
    80006256:	87aa                	mv	a5,a0
    80006258:	e888                	sd	a0,16(s1)
  if(!disk.desc || !disk.avail || !disk.used)
    8000625a:	6088                	ld	a0,0(s1)
    8000625c:	cd75                	beqz	a0,80006358 <virtio_disk_init+0x1e0>
    8000625e:	0001c717          	auipc	a4,0x1c
    80006262:	51a73703          	ld	a4,1306(a4) # 80022778 <disk+0x8>
    80006266:	cb6d                	beqz	a4,80006358 <virtio_disk_init+0x1e0>
    80006268:	cbe5                	beqz	a5,80006358 <virtio_disk_init+0x1e0>
  memset(disk.desc, 0, PGSIZE);
    8000626a:	6605                	lui	a2,0x1
    8000626c:	4581                	li	a1,0
    8000626e:	ffffb097          	auipc	ra,0xffffb
    80006272:	b48080e7          	jalr	-1208(ra) # 80000db6 <memset>
  memset(disk.avail, 0, PGSIZE);
    80006276:	0001c497          	auipc	s1,0x1c
    8000627a:	4fa48493          	addi	s1,s1,1274 # 80022770 <disk>
    8000627e:	6605                	lui	a2,0x1
    80006280:	4581                	li	a1,0
    80006282:	6488                	ld	a0,8(s1)
    80006284:	ffffb097          	auipc	ra,0xffffb
    80006288:	b32080e7          	jalr	-1230(ra) # 80000db6 <memset>
  memset(disk.used, 0, PGSIZE);
    8000628c:	6605                	lui	a2,0x1
    8000628e:	4581                	li	a1,0
    80006290:	6888                	ld	a0,16(s1)
    80006292:	ffffb097          	auipc	ra,0xffffb
    80006296:	b24080e7          	jalr	-1244(ra) # 80000db6 <memset>
  *R(VIRTIO_MMIO_QUEUE_NUM) = NUM;
    8000629a:	100017b7          	lui	a5,0x10001
    8000629e:	4721                	li	a4,8
    800062a0:	df98                	sw	a4,56(a5)
  *R(VIRTIO_MMIO_QUEUE_DESC_LOW) = (uint64)disk.desc;
    800062a2:	4098                	lw	a4,0(s1)
    800062a4:	08e7a023          	sw	a4,128(a5) # 10001080 <_entry-0x6fffef80>
  *R(VIRTIO_MMIO_QUEUE_DESC_HIGH) = (uint64)disk.desc >> 32;
    800062a8:	40d8                	lw	a4,4(s1)
    800062aa:	08e7a223          	sw	a4,132(a5)
  *R(VIRTIO_MMIO_DRIVER_DESC_LOW) = (uint64)disk.avail;
    800062ae:	6498                	ld	a4,8(s1)
    800062b0:	0007069b          	sext.w	a3,a4
    800062b4:	08d7a823          	sw	a3,144(a5)
  *R(VIRTIO_MMIO_DRIVER_DESC_HIGH) = (uint64)disk.avail >> 32;
    800062b8:	9701                	srai	a4,a4,0x20
    800062ba:	08e7aa23          	sw	a4,148(a5)
  *R(VIRTIO_MMIO_DEVICE_DESC_LOW) = (uint64)disk.used;
    800062be:	6898                	ld	a4,16(s1)
    800062c0:	0007069b          	sext.w	a3,a4
    800062c4:	0ad7a023          	sw	a3,160(a5)
  *R(VIRTIO_MMIO_DEVICE_DESC_HIGH) = (uint64)disk.used >> 32;
    800062c8:	9701                	srai	a4,a4,0x20
    800062ca:	0ae7a223          	sw	a4,164(a5)
  *R(VIRTIO_MMIO_QUEUE_READY) = 0x1;
    800062ce:	4685                	li	a3,1
    800062d0:	c3f4                	sw	a3,68(a5)
    disk.free[i] = 1;
    800062d2:	4705                	li	a4,1
    800062d4:	00d48c23          	sb	a3,24(s1)
    800062d8:	00e48ca3          	sb	a4,25(s1)
    800062dc:	00e48d23          	sb	a4,26(s1)
    800062e0:	00e48da3          	sb	a4,27(s1)
    800062e4:	00e48e23          	sb	a4,28(s1)
    800062e8:	00e48ea3          	sb	a4,29(s1)
    800062ec:	00e48f23          	sb	a4,30(s1)
    800062f0:	00e48fa3          	sb	a4,31(s1)
  status |= VIRTIO_CONFIG_S_DRIVER_OK;
    800062f4:	00496913          	ori	s2,s2,4
  *R(VIRTIO_MMIO_STATUS) = status;
    800062f8:	0727a823          	sw	s2,112(a5)
}
    800062fc:	60e2                	ld	ra,24(sp)
    800062fe:	6442                	ld	s0,16(sp)
    80006300:	64a2                	ld	s1,8(sp)
    80006302:	6902                	ld	s2,0(sp)
    80006304:	6105                	addi	sp,sp,32
    80006306:	8082                	ret
    panic("could not find virtio disk");
    80006308:	00002517          	auipc	a0,0x2
    8000630c:	6d050513          	addi	a0,a0,1744 # 800089d8 <syscall_name+0x338>
    80006310:	ffffa097          	auipc	ra,0xffffa
    80006314:	234080e7          	jalr	564(ra) # 80000544 <panic>
    panic("virtio disk FEATURES_OK unset");
    80006318:	00002517          	auipc	a0,0x2
    8000631c:	6e050513          	addi	a0,a0,1760 # 800089f8 <syscall_name+0x358>
    80006320:	ffffa097          	auipc	ra,0xffffa
    80006324:	224080e7          	jalr	548(ra) # 80000544 <panic>
    panic("virtio disk should not be ready");
    80006328:	00002517          	auipc	a0,0x2
    8000632c:	6f050513          	addi	a0,a0,1776 # 80008a18 <syscall_name+0x378>
    80006330:	ffffa097          	auipc	ra,0xffffa
    80006334:	214080e7          	jalr	532(ra) # 80000544 <panic>
    panic("virtio disk has no queue 0");
    80006338:	00002517          	auipc	a0,0x2
    8000633c:	70050513          	addi	a0,a0,1792 # 80008a38 <syscall_name+0x398>
    80006340:	ffffa097          	auipc	ra,0xffffa
    80006344:	204080e7          	jalr	516(ra) # 80000544 <panic>
    panic("virtio disk max queue too short");
    80006348:	00002517          	auipc	a0,0x2
    8000634c:	71050513          	addi	a0,a0,1808 # 80008a58 <syscall_name+0x3b8>
    80006350:	ffffa097          	auipc	ra,0xffffa
    80006354:	1f4080e7          	jalr	500(ra) # 80000544 <panic>
    panic("virtio disk kalloc");
    80006358:	00002517          	auipc	a0,0x2
    8000635c:	72050513          	addi	a0,a0,1824 # 80008a78 <syscall_name+0x3d8>
    80006360:	ffffa097          	auipc	ra,0xffffa
    80006364:	1e4080e7          	jalr	484(ra) # 80000544 <panic>

0000000080006368 <virtio_disk_rw>:
  return 0;
}

void
virtio_disk_rw(struct buf *b, int write)
{
    80006368:	7159                	addi	sp,sp,-112
    8000636a:	f486                	sd	ra,104(sp)
    8000636c:	f0a2                	sd	s0,96(sp)
    8000636e:	eca6                	sd	s1,88(sp)
    80006370:	e8ca                	sd	s2,80(sp)
    80006372:	e4ce                	sd	s3,72(sp)
    80006374:	e0d2                	sd	s4,64(sp)
    80006376:	fc56                	sd	s5,56(sp)
    80006378:	f85a                	sd	s6,48(sp)
    8000637a:	f45e                	sd	s7,40(sp)
    8000637c:	f062                	sd	s8,32(sp)
    8000637e:	ec66                	sd	s9,24(sp)
    80006380:	e86a                	sd	s10,16(sp)
    80006382:	1880                	addi	s0,sp,112
    80006384:	892a                	mv	s2,a0
    80006386:	8d2e                	mv	s10,a1
  uint64 sector = b->blockno * (BSIZE / 512);
    80006388:	00c52c83          	lw	s9,12(a0)
    8000638c:	001c9c9b          	slliw	s9,s9,0x1
    80006390:	1c82                	slli	s9,s9,0x20
    80006392:	020cdc93          	srli	s9,s9,0x20

  acquire(&disk.vdisk_lock);
    80006396:	0001c517          	auipc	a0,0x1c
    8000639a:	50250513          	addi	a0,a0,1282 # 80022898 <disk+0x128>
    8000639e:	ffffb097          	auipc	ra,0xffffb
    800063a2:	870080e7          	jalr	-1936(ra) # 80000c0e <acquire>
  for(int i = 0; i < 3; i++){
    800063a6:	4981                	li	s3,0
  for(int i = 0; i < NUM; i++){
    800063a8:	4ba1                	li	s7,8
      disk.free[i] = 0;
    800063aa:	0001cb17          	auipc	s6,0x1c
    800063ae:	3c6b0b13          	addi	s6,s6,966 # 80022770 <disk>
  for(int i = 0; i < 3; i++){
    800063b2:	4a8d                	li	s5,3
  for(int i = 0; i < NUM; i++){
    800063b4:	8a4e                	mv	s4,s3
  int idx[3];
  while(1){
    if(alloc3_desc(idx) == 0) {
      break;
    }
    sleep(&disk.free[0], &disk.vdisk_lock);
    800063b6:	0001cc17          	auipc	s8,0x1c
    800063ba:	4e2c0c13          	addi	s8,s8,1250 # 80022898 <disk+0x128>
    800063be:	a8b5                	j	8000643a <virtio_disk_rw+0xd2>
      disk.free[i] = 0;
    800063c0:	00fb06b3          	add	a3,s6,a5
    800063c4:	00068c23          	sb	zero,24(a3)
    idx[i] = alloc_desc();
    800063c8:	c21c                	sw	a5,0(a2)
    if(idx[i] < 0){
    800063ca:	0207c563          	bltz	a5,800063f4 <virtio_disk_rw+0x8c>
  for(int i = 0; i < 3; i++){
    800063ce:	2485                	addiw	s1,s1,1
    800063d0:	0711                	addi	a4,a4,4
    800063d2:	1f548a63          	beq	s1,s5,800065c6 <virtio_disk_rw+0x25e>
    idx[i] = alloc_desc();
    800063d6:	863a                	mv	a2,a4
  for(int i = 0; i < NUM; i++){
    800063d8:	0001c697          	auipc	a3,0x1c
    800063dc:	39868693          	addi	a3,a3,920 # 80022770 <disk>
    800063e0:	87d2                	mv	a5,s4
    if(disk.free[i]){
    800063e2:	0186c583          	lbu	a1,24(a3)
    800063e6:	fde9                	bnez	a1,800063c0 <virtio_disk_rw+0x58>
  for(int i = 0; i < NUM; i++){
    800063e8:	2785                	addiw	a5,a5,1
    800063ea:	0685                	addi	a3,a3,1
    800063ec:	ff779be3          	bne	a5,s7,800063e2 <virtio_disk_rw+0x7a>
    idx[i] = alloc_desc();
    800063f0:	57fd                	li	a5,-1
    800063f2:	c21c                	sw	a5,0(a2)
      for(int j = 0; j < i; j++)
    800063f4:	02905a63          	blez	s1,80006428 <virtio_disk_rw+0xc0>
        free_desc(idx[j]);
    800063f8:	f9042503          	lw	a0,-112(s0)
    800063fc:	00000097          	auipc	ra,0x0
    80006400:	cfa080e7          	jalr	-774(ra) # 800060f6 <free_desc>
      for(int j = 0; j < i; j++)
    80006404:	4785                	li	a5,1
    80006406:	0297d163          	bge	a5,s1,80006428 <virtio_disk_rw+0xc0>
        free_desc(idx[j]);
    8000640a:	f9442503          	lw	a0,-108(s0)
    8000640e:	00000097          	auipc	ra,0x0
    80006412:	ce8080e7          	jalr	-792(ra) # 800060f6 <free_desc>
      for(int j = 0; j < i; j++)
    80006416:	4789                	li	a5,2
    80006418:	0097d863          	bge	a5,s1,80006428 <virtio_disk_rw+0xc0>
        free_desc(idx[j]);
    8000641c:	f9842503          	lw	a0,-104(s0)
    80006420:	00000097          	auipc	ra,0x0
    80006424:	cd6080e7          	jalr	-810(ra) # 800060f6 <free_desc>
    sleep(&disk.free[0], &disk.vdisk_lock);
    80006428:	85e2                	mv	a1,s8
    8000642a:	0001c517          	auipc	a0,0x1c
    8000642e:	35e50513          	addi	a0,a0,862 # 80022788 <disk+0x18>
    80006432:	ffffc097          	auipc	ra,0xffffc
    80006436:	e4e080e7          	jalr	-434(ra) # 80002280 <sleep>
  for(int i = 0; i < 3; i++){
    8000643a:	f9040713          	addi	a4,s0,-112
    8000643e:	84ce                	mv	s1,s3
    80006440:	bf59                	j	800063d6 <virtio_disk_rw+0x6e>
  // qemu's virtio-blk.c reads them.

  struct virtio_blk_req *buf0 = &disk.ops[idx[0]];

  if(write)
    buf0->type = VIRTIO_BLK_T_OUT; // write the disk
    80006442:	00a60793          	addi	a5,a2,10 # 100a <_entry-0x7fffeff6>
    80006446:	00479693          	slli	a3,a5,0x4
    8000644a:	0001c797          	auipc	a5,0x1c
    8000644e:	32678793          	addi	a5,a5,806 # 80022770 <disk>
    80006452:	97b6                	add	a5,a5,a3
    80006454:	4685                	li	a3,1
    80006456:	c794                	sw	a3,8(a5)
  else
    buf0->type = VIRTIO_BLK_T_IN; // read the disk
  buf0->reserved = 0;
    80006458:	0001c597          	auipc	a1,0x1c
    8000645c:	31858593          	addi	a1,a1,792 # 80022770 <disk>
    80006460:	00a60793          	addi	a5,a2,10
    80006464:	0792                	slli	a5,a5,0x4
    80006466:	97ae                	add	a5,a5,a1
    80006468:	0007a623          	sw	zero,12(a5)
  buf0->sector = sector;
    8000646c:	0197b823          	sd	s9,16(a5)

  disk.desc[idx[0]].addr = (uint64) buf0;
    80006470:	f6070693          	addi	a3,a4,-160
    80006474:	619c                	ld	a5,0(a1)
    80006476:	97b6                	add	a5,a5,a3
    80006478:	e388                	sd	a0,0(a5)
  disk.desc[idx[0]].len = sizeof(struct virtio_blk_req);
    8000647a:	6188                	ld	a0,0(a1)
    8000647c:	96aa                	add	a3,a3,a0
    8000647e:	47c1                	li	a5,16
    80006480:	c69c                	sw	a5,8(a3)
  disk.desc[idx[0]].flags = VRING_DESC_F_NEXT;
    80006482:	4785                	li	a5,1
    80006484:	00f69623          	sh	a5,12(a3)
  disk.desc[idx[0]].next = idx[1];
    80006488:	f9442783          	lw	a5,-108(s0)
    8000648c:	00f69723          	sh	a5,14(a3)

  disk.desc[idx[1]].addr = (uint64) b->data;
    80006490:	0792                	slli	a5,a5,0x4
    80006492:	953e                	add	a0,a0,a5
    80006494:	06090693          	addi	a3,s2,96
    80006498:	e114                	sd	a3,0(a0)
  disk.desc[idx[1]].len = BSIZE;
    8000649a:	6188                	ld	a0,0(a1)
    8000649c:	97aa                	add	a5,a5,a0
    8000649e:	40000693          	li	a3,1024
    800064a2:	c794                	sw	a3,8(a5)
  if(write)
    800064a4:	100d0d63          	beqz	s10,800065be <virtio_disk_rw+0x256>
    disk.desc[idx[1]].flags = 0; // device reads b->data
    800064a8:	00079623          	sh	zero,12(a5)
  else
    disk.desc[idx[1]].flags = VRING_DESC_F_WRITE; // device writes b->data
  disk.desc[idx[1]].flags |= VRING_DESC_F_NEXT;
    800064ac:	00c7d683          	lhu	a3,12(a5)
    800064b0:	0016e693          	ori	a3,a3,1
    800064b4:	00d79623          	sh	a3,12(a5)
  disk.desc[idx[1]].next = idx[2];
    800064b8:	f9842583          	lw	a1,-104(s0)
    800064bc:	00b79723          	sh	a1,14(a5)

  disk.info[idx[0]].status = 0xff; // device writes 0 on success
    800064c0:	0001c697          	auipc	a3,0x1c
    800064c4:	2b068693          	addi	a3,a3,688 # 80022770 <disk>
    800064c8:	00260793          	addi	a5,a2,2
    800064cc:	0792                	slli	a5,a5,0x4
    800064ce:	97b6                	add	a5,a5,a3
    800064d0:	587d                	li	a6,-1
    800064d2:	01078823          	sb	a6,16(a5)
  disk.desc[idx[2]].addr = (uint64) &disk.info[idx[0]].status;
    800064d6:	0592                	slli	a1,a1,0x4
    800064d8:	952e                	add	a0,a0,a1
    800064da:	f9070713          	addi	a4,a4,-112
    800064de:	9736                	add	a4,a4,a3
    800064e0:	e118                	sd	a4,0(a0)
  disk.desc[idx[2]].len = 1;
    800064e2:	6298                	ld	a4,0(a3)
    800064e4:	972e                	add	a4,a4,a1
    800064e6:	4585                	li	a1,1
    800064e8:	c70c                	sw	a1,8(a4)
  disk.desc[idx[2]].flags = VRING_DESC_F_WRITE; // device writes the status
    800064ea:	4509                	li	a0,2
    800064ec:	00a71623          	sh	a0,12(a4)
  disk.desc[idx[2]].next = 0;
    800064f0:	00071723          	sh	zero,14(a4)

  // record struct buf for virtio_disk_intr().
  b->disk = 1;
    800064f4:	00b92223          	sw	a1,4(s2)
  disk.info[idx[0]].b = b;
    800064f8:	0127b423          	sd	s2,8(a5)

  // tell the device the first index in our chain of descriptors.
  disk.avail->ring[disk.avail->idx % NUM] = idx[0];
    800064fc:	6698                	ld	a4,8(a3)
    800064fe:	00275783          	lhu	a5,2(a4)
    80006502:	8b9d                	andi	a5,a5,7
    80006504:	0786                	slli	a5,a5,0x1
    80006506:	97ba                	add	a5,a5,a4
    80006508:	00c79223          	sh	a2,4(a5)

  __sync_synchronize();
    8000650c:	0ff0000f          	fence

  // tell the device another avail ring entry is available.
  disk.avail->idx += 1; // not % NUM ...
    80006510:	6698                	ld	a4,8(a3)
    80006512:	00275783          	lhu	a5,2(a4)
    80006516:	2785                	addiw	a5,a5,1
    80006518:	00f71123          	sh	a5,2(a4)

  __sync_synchronize();
    8000651c:	0ff0000f          	fence

  *R(VIRTIO_MMIO_QUEUE_NOTIFY) = 0; // value is queue number
    80006520:	100017b7          	lui	a5,0x10001
    80006524:	0407a823          	sw	zero,80(a5) # 10001050 <_entry-0x6fffefb0>

  // Wait for virtio_disk_intr() to say request has finished.
  while(b->disk == 1) {
    80006528:	00492703          	lw	a4,4(s2)
    8000652c:	4785                	li	a5,1
    8000652e:	02f71163          	bne	a4,a5,80006550 <virtio_disk_rw+0x1e8>
    sleep(b, &disk.vdisk_lock);
    80006532:	0001c997          	auipc	s3,0x1c
    80006536:	36698993          	addi	s3,s3,870 # 80022898 <disk+0x128>
  while(b->disk == 1) {
    8000653a:	4485                	li	s1,1
    sleep(b, &disk.vdisk_lock);
    8000653c:	85ce                	mv	a1,s3
    8000653e:	854a                	mv	a0,s2
    80006540:	ffffc097          	auipc	ra,0xffffc
    80006544:	d40080e7          	jalr	-704(ra) # 80002280 <sleep>
  while(b->disk == 1) {
    80006548:	00492783          	lw	a5,4(s2)
    8000654c:	fe9788e3          	beq	a5,s1,8000653c <virtio_disk_rw+0x1d4>
  }

  disk.info[idx[0]].b = 0;
    80006550:	f9042903          	lw	s2,-112(s0)
    80006554:	00290793          	addi	a5,s2,2
    80006558:	00479713          	slli	a4,a5,0x4
    8000655c:	0001c797          	auipc	a5,0x1c
    80006560:	21478793          	addi	a5,a5,532 # 80022770 <disk>
    80006564:	97ba                	add	a5,a5,a4
    80006566:	0007b423          	sd	zero,8(a5)
    int flag = disk.desc[i].flags;
    8000656a:	0001c997          	auipc	s3,0x1c
    8000656e:	20698993          	addi	s3,s3,518 # 80022770 <disk>
    80006572:	00491713          	slli	a4,s2,0x4
    80006576:	0009b783          	ld	a5,0(s3)
    8000657a:	97ba                	add	a5,a5,a4
    8000657c:	00c7d483          	lhu	s1,12(a5)
    int nxt = disk.desc[i].next;
    80006580:	854a                	mv	a0,s2
    80006582:	00e7d903          	lhu	s2,14(a5)
    free_desc(i);
    80006586:	00000097          	auipc	ra,0x0
    8000658a:	b70080e7          	jalr	-1168(ra) # 800060f6 <free_desc>
    if(flag & VRING_DESC_F_NEXT)
    8000658e:	8885                	andi	s1,s1,1
    80006590:	f0ed                	bnez	s1,80006572 <virtio_disk_rw+0x20a>
  free_chain(idx[0]);

  release(&disk.vdisk_lock);
    80006592:	0001c517          	auipc	a0,0x1c
    80006596:	30650513          	addi	a0,a0,774 # 80022898 <disk+0x128>
    8000659a:	ffffa097          	auipc	ra,0xffffa
    8000659e:	7ce080e7          	jalr	1998(ra) # 80000d68 <release>
}
    800065a2:	70a6                	ld	ra,104(sp)
    800065a4:	7406                	ld	s0,96(sp)
    800065a6:	64e6                	ld	s1,88(sp)
    800065a8:	6946                	ld	s2,80(sp)
    800065aa:	69a6                	ld	s3,72(sp)
    800065ac:	6a06                	ld	s4,64(sp)
    800065ae:	7ae2                	ld	s5,56(sp)
    800065b0:	7b42                	ld	s6,48(sp)
    800065b2:	7ba2                	ld	s7,40(sp)
    800065b4:	7c02                	ld	s8,32(sp)
    800065b6:	6ce2                	ld	s9,24(sp)
    800065b8:	6d42                	ld	s10,16(sp)
    800065ba:	6165                	addi	sp,sp,112
    800065bc:	8082                	ret
    disk.desc[idx[1]].flags = VRING_DESC_F_WRITE; // device writes b->data
    800065be:	4689                	li	a3,2
    800065c0:	00d79623          	sh	a3,12(a5)
    800065c4:	b5e5                	j	800064ac <virtio_disk_rw+0x144>
  struct virtio_blk_req *buf0 = &disk.ops[idx[0]];
    800065c6:	f9042603          	lw	a2,-112(s0)
    800065ca:	00a60713          	addi	a4,a2,10
    800065ce:	0712                	slli	a4,a4,0x4
    800065d0:	0001c517          	auipc	a0,0x1c
    800065d4:	1a850513          	addi	a0,a0,424 # 80022778 <disk+0x8>
    800065d8:	953a                	add	a0,a0,a4
  if(write)
    800065da:	e60d14e3          	bnez	s10,80006442 <virtio_disk_rw+0xda>
    buf0->type = VIRTIO_BLK_T_IN; // read the disk
    800065de:	00a60793          	addi	a5,a2,10
    800065e2:	00479693          	slli	a3,a5,0x4
    800065e6:	0001c797          	auipc	a5,0x1c
    800065ea:	18a78793          	addi	a5,a5,394 # 80022770 <disk>
    800065ee:	97b6                	add	a5,a5,a3
    800065f0:	0007a423          	sw	zero,8(a5)
    800065f4:	b595                	j	80006458 <virtio_disk_rw+0xf0>

00000000800065f6 <virtio_disk_intr>:

void
virtio_disk_intr()
{
    800065f6:	1101                	addi	sp,sp,-32
    800065f8:	ec06                	sd	ra,24(sp)
    800065fa:	e822                	sd	s0,16(sp)
    800065fc:	e426                	sd	s1,8(sp)
    800065fe:	1000                	addi	s0,sp,32
  acquire(&disk.vdisk_lock);
    80006600:	0001c497          	auipc	s1,0x1c
    80006604:	17048493          	addi	s1,s1,368 # 80022770 <disk>
    80006608:	0001c517          	auipc	a0,0x1c
    8000660c:	29050513          	addi	a0,a0,656 # 80022898 <disk+0x128>
    80006610:	ffffa097          	auipc	ra,0xffffa
    80006614:	5fe080e7          	jalr	1534(ra) # 80000c0e <acquire>
  // we've seen this interrupt, which the following line does.
  // this may race with the device writing new entries to
  // the "used" ring, in which case we may process the new
  // completion entries in this interrupt, and have nothing to do
  // in the next interrupt, which is harmless.
  *R(VIRTIO_MMIO_INTERRUPT_ACK) = *R(VIRTIO_MMIO_INTERRUPT_STATUS) & 0x3;
    80006618:	10001737          	lui	a4,0x10001
    8000661c:	533c                	lw	a5,96(a4)
    8000661e:	8b8d                	andi	a5,a5,3
    80006620:	d37c                	sw	a5,100(a4)

  __sync_synchronize();
    80006622:	0ff0000f          	fence

  // the device increments disk.used->idx when it
  // adds an entry to the used ring.

  while(disk.used_idx != disk.used->idx){
    80006626:	689c                	ld	a5,16(s1)
    80006628:	0204d703          	lhu	a4,32(s1)
    8000662c:	0027d783          	lhu	a5,2(a5)
    80006630:	04f70863          	beq	a4,a5,80006680 <virtio_disk_intr+0x8a>
    __sync_synchronize();
    80006634:	0ff0000f          	fence
    int id = disk.used->ring[disk.used_idx % NUM].id;
    80006638:	6898                	ld	a4,16(s1)
    8000663a:	0204d783          	lhu	a5,32(s1)
    8000663e:	8b9d                	andi	a5,a5,7
    80006640:	078e                	slli	a5,a5,0x3
    80006642:	97ba                	add	a5,a5,a4
    80006644:	43dc                	lw	a5,4(a5)

    if(disk.info[id].status != 0)
    80006646:	00278713          	addi	a4,a5,2
    8000664a:	0712                	slli	a4,a4,0x4
    8000664c:	9726                	add	a4,a4,s1
    8000664e:	01074703          	lbu	a4,16(a4) # 10001010 <_entry-0x6fffeff0>
    80006652:	e721                	bnez	a4,8000669a <virtio_disk_intr+0xa4>
      panic("virtio_disk_intr status");

    struct buf *b = disk.info[id].b;
    80006654:	0789                	addi	a5,a5,2
    80006656:	0792                	slli	a5,a5,0x4
    80006658:	97a6                	add	a5,a5,s1
    8000665a:	6788                	ld	a0,8(a5)
    b->disk = 0;   // disk is done with buf
    8000665c:	00052223          	sw	zero,4(a0)
    wakeup(b);
    80006660:	ffffc097          	auipc	ra,0xffffc
    80006664:	c84080e7          	jalr	-892(ra) # 800022e4 <wakeup>

    disk.used_idx += 1;
    80006668:	0204d783          	lhu	a5,32(s1)
    8000666c:	2785                	addiw	a5,a5,1
    8000666e:	17c2                	slli	a5,a5,0x30
    80006670:	93c1                	srli	a5,a5,0x30
    80006672:	02f49023          	sh	a5,32(s1)
  while(disk.used_idx != disk.used->idx){
    80006676:	6898                	ld	a4,16(s1)
    80006678:	00275703          	lhu	a4,2(a4)
    8000667c:	faf71ce3          	bne	a4,a5,80006634 <virtio_disk_intr+0x3e>
  }

  release(&disk.vdisk_lock);
    80006680:	0001c517          	auipc	a0,0x1c
    80006684:	21850513          	addi	a0,a0,536 # 80022898 <disk+0x128>
    80006688:	ffffa097          	auipc	ra,0xffffa
    8000668c:	6e0080e7          	jalr	1760(ra) # 80000d68 <release>
}
    80006690:	60e2                	ld	ra,24(sp)
    80006692:	6442                	ld	s0,16(sp)
    80006694:	64a2                	ld	s1,8(sp)
    80006696:	6105                	addi	sp,sp,32
    80006698:	8082                	ret
      panic("virtio_disk_intr status");
    8000669a:	00002517          	auipc	a0,0x2
    8000669e:	3f650513          	addi	a0,a0,1014 # 80008a90 <syscall_name+0x3f0>
    800066a2:	ffffa097          	auipc	ra,0xffffa
    800066a6:	ea2080e7          	jalr	-350(ra) # 80000544 <panic>
	...

0000000080007000 <_trampoline>:
    80007000:	14051073          	csrw	sscratch,a0
    80007004:	02000537          	lui	a0,0x2000
    80007008:	357d                	addiw	a0,a0,-1
    8000700a:	0536                	slli	a0,a0,0xd
    8000700c:	02153423          	sd	ra,40(a0) # 2000028 <_entry-0x7dffffd8>
    80007010:	02253823          	sd	sp,48(a0)
    80007014:	02353c23          	sd	gp,56(a0)
    80007018:	04453023          	sd	tp,64(a0)
    8000701c:	04553423          	sd	t0,72(a0)
    80007020:	04653823          	sd	t1,80(a0)
    80007024:	04753c23          	sd	t2,88(a0)
    80007028:	f120                	sd	s0,96(a0)
    8000702a:	f524                	sd	s1,104(a0)
    8000702c:	fd2c                	sd	a1,120(a0)
    8000702e:	e150                	sd	a2,128(a0)
    80007030:	e554                	sd	a3,136(a0)
    80007032:	e958                	sd	a4,144(a0)
    80007034:	ed5c                	sd	a5,152(a0)
    80007036:	0b053023          	sd	a6,160(a0)
    8000703a:	0b153423          	sd	a7,168(a0)
    8000703e:	0b253823          	sd	s2,176(a0)
    80007042:	0b353c23          	sd	s3,184(a0)
    80007046:	0d453023          	sd	s4,192(a0)
    8000704a:	0d553423          	sd	s5,200(a0)
    8000704e:	0d653823          	sd	s6,208(a0)
    80007052:	0d753c23          	sd	s7,216(a0)
    80007056:	0f853023          	sd	s8,224(a0)
    8000705a:	0f953423          	sd	s9,232(a0)
    8000705e:	0fa53823          	sd	s10,240(a0)
    80007062:	0fb53c23          	sd	s11,248(a0)
    80007066:	11c53023          	sd	t3,256(a0)
    8000706a:	11d53423          	sd	t4,264(a0)
    8000706e:	11e53823          	sd	t5,272(a0)
    80007072:	11f53c23          	sd	t6,280(a0)
    80007076:	140022f3          	csrr	t0,sscratch
    8000707a:	06553823          	sd	t0,112(a0)
    8000707e:	00853103          	ld	sp,8(a0)
    80007082:	02053203          	ld	tp,32(a0)
    80007086:	01053283          	ld	t0,16(a0)
    8000708a:	00053303          	ld	t1,0(a0)
    8000708e:	12000073          	sfence.vma
    80007092:	18031073          	csrw	satp,t1
    80007096:	12000073          	sfence.vma
    8000709a:	8282                	jr	t0

000000008000709c <userret>:
    8000709c:	12000073          	sfence.vma
    800070a0:	18051073          	csrw	satp,a0
    800070a4:	12000073          	sfence.vma
    800070a8:	02000537          	lui	a0,0x2000
    800070ac:	357d                	addiw	a0,a0,-1
    800070ae:	0536                	slli	a0,a0,0xd
    800070b0:	02853083          	ld	ra,40(a0) # 2000028 <_entry-0x7dffffd8>
    800070b4:	03053103          	ld	sp,48(a0)
    800070b8:	03853183          	ld	gp,56(a0)
    800070bc:	04053203          	ld	tp,64(a0)
    800070c0:	04853283          	ld	t0,72(a0)
    800070c4:	05053303          	ld	t1,80(a0)
    800070c8:	05853383          	ld	t2,88(a0)
    800070cc:	7120                	ld	s0,96(a0)
    800070ce:	7524                	ld	s1,104(a0)
    800070d0:	7d2c                	ld	a1,120(a0)
    800070d2:	6150                	ld	a2,128(a0)
    800070d4:	6554                	ld	a3,136(a0)
    800070d6:	6958                	ld	a4,144(a0)
    800070d8:	6d5c                	ld	a5,152(a0)
    800070da:	0a053803          	ld	a6,160(a0)
    800070de:	0a853883          	ld	a7,168(a0)
    800070e2:	0b053903          	ld	s2,176(a0)
    800070e6:	0b853983          	ld	s3,184(a0)
    800070ea:	0c053a03          	ld	s4,192(a0)
    800070ee:	0c853a83          	ld	s5,200(a0)
    800070f2:	0d053b03          	ld	s6,208(a0)
    800070f6:	0d853b83          	ld	s7,216(a0)
    800070fa:	0e053c03          	ld	s8,224(a0)
    800070fe:	0e853c83          	ld	s9,232(a0)
    80007102:	0f053d03          	ld	s10,240(a0)
    80007106:	0f853d83          	ld	s11,248(a0)
    8000710a:	10053e03          	ld	t3,256(a0)
    8000710e:	10853e83          	ld	t4,264(a0)
    80007112:	11053f03          	ld	t5,272(a0)
    80007116:	11853f83          	ld	t6,280(a0)
    8000711a:	7928                	ld	a0,112(a0)
    8000711c:	10200073          	sret
	...
